﻿using System;
using System.Collections.Generic;
using System.Web;
using SYS_Core.aControl;
using System.Configuration;
using System.Data;
using System.Net;
using System.Net.Http;
using System.Web.Http;
using System.Web.Http.Cors;
using SYS_Core.aBiz;
using System.Threading.Tasks;
using System.IO;
using Newtonsoft.Json;
using System.Net.Http.Headers;
using Oracle.ManagedDataAccess.Client;
using RandomSolutions;
using System.Collections;
using SYSCore.Attributes;

namespace SYS_Core.Controllers
{
    [EnableCors("*", "*", "*")]
    [RoutePrefix("api/wPMS")]

    public class PMSController : ApiController
    {

        string oradb = "Data Source=(DESCRIPTION ="
                + "(ADDRESS = (PROTOCOL = TCP)(HOST = "
                + ConfigurationManager.AppSettings["ORCServer"] + ")(PORT = 1521))"
                + "(CONNECT_DATA =" + "(SERVER = DEDICATED)"
                + "(SERVICE_NAME = " + ConfigurationManager.AppSettings["ORCService"] + ")));"
                + "User Id=" + ConfigurationManager.AppSettings["ORCUser"] + ";"
                + "Password=" + ConfigurationManager.AppSettings["ORCPassword"] + ";";

        private DBOracle oOracledb = new DBOracle();
        private String gSQL = "";

        #region General

        [HttpGet, Route("GetSnapData/{spName}")]
        [Authorize]
        public IHttpActionResult GetSnapData(string spName)
        {
            DataSet ds = new DataSet();

            ds = oOracledb.SqlQueryDS(spName);
            return Json(DTFM.convertToList(ds));
        }

        //[HttpGet, Route("GetVendorCode")]
        //[Authorize]
        //public IHttpActionResult GetVendorCode()
        //{
        //    DataSet ds = new DataSet();

        //    gSQL = "sp_NP_MT_VENDOR_CODE";
        //    ds = oOracledb.SqlQueryDS(gSQL);
        //    return Json(DTFM.convertToList(ds));
        //}

        [HttpGet, Route("GetVendorCode/{vendorcode}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult GetVendorCode(string vendorcode, int noofshowrec)
        {
            DataSet ds = new DataSet();

            vendorcode = ismoUtil.escapeCharacter(vendorcode);

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "sp_NP_MT_VENDOR_CODE_ByID";
            cmd.Parameters.Add("p_VENDOR_CODE", OracleDbType.Varchar2).Value = vendorcode != null && vendorcode == "null" ? "" : vendorcode;
            cmd.Parameters.Add("p_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
            cmd.Parameters.Add("c_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpGet, Route("LookupVendorCodeForPlan/{vendorcode}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult LookupVendorCodeForPlan(string vendorcode, int noofshowrec)
        {
            DataSet ds = new DataSet();

            vendorcode = ismoUtil.escapeCharacter(vendorcode);

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_MT_VENDOR_PLAN_BY_ID";
            cmd.Parameters.Add("p_VENDOR_CODE", OracleDbType.Varchar2).Value = vendorcode != null && vendorcode == "null" ? "" : vendorcode;
            cmd.Parameters.Add("p_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
            cmd.Parameters.Add("c_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));

        }
        /*Create by BF for SNPR008_M
         *Create Date 14M11Y2016
         */
        [HttpGet, Route("GetGroupPartNo/{groupPartNo}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult GetGroupPartNo(string groupPartNo, int noofshowrec)
        {
            DataSet ds = new DataSet();

            groupPartNo = ismoUtil.escapeCharacter(groupPartNo);

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "sp_NP_MT_Group_Part_No_ByID";
            cmd.Parameters.Add("p_GROUP_PART_NO", OracleDbType.Varchar2).Value = groupPartNo;
            cmd.Parameters.Add("p_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
            cmd.Parameters.Add("c_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }
        [HttpGet, Route("GetVendorStaff/{staffID}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult GetVendorStaff(string staffID, int noofshowrec)
        {
            DataSet ds = new DataSet();

            staffID = ismoUtil.escapeCharacter(staffID);

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "sp_NP_MT_Vendor_Staff_ByID";
            cmd.Parameters.Add("p_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("p_STAFF_ID", OracleDbType.Varchar2).Value = staffID == "NULL" ? (object)DBNull.Value : staffID;
            cmd.Parameters.Add("p_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
            cmd.Parameters.Add("c_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpGet, Route("GetVendorUserStaff/{staffID}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult GetVendorUserStaff(string staffID, int noofshowrec)
        {
            DataSet ds = new DataSet();

            staffID = ismoUtil.escapeCharacter(staffID);

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_MT_USER_STAFF_BYID";
            cmd.Parameters.Add("p_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("p_STAFF_ID", OracleDbType.Varchar2).Value = staffID == "NULL" ? (object)DBNull.Value : staffID;
            cmd.Parameters.Add("p_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
            cmd.Parameters.Add("c_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpGet, Route("GetVendorStaffTeam/{teamId}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult GetVendorStaffTeam(string teamId, int noofshowrec)
        {
            DataSet ds = new DataSet();

            teamId = ismoUtil.escapeCharacter(teamId);

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_MT_VENDOR_STAFF_TEAM";
            cmd.Parameters.Add("p_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_TEAM_ID", OracleDbType.Varchar2).Value = teamId == "NULL" ? (object)DBNull.Value : teamId;
            cmd.Parameters.Add("p_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
            cmd.Parameters.Add("c_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        //create by BF For SNPR008_FBO
        //create by BF For SNSQ088
        //create date: 17M12Y2019
        //Note: Show Part No,it have been PO.
        [HttpGet, Route("GetIndentDetailPartNo/{partNo}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult GetIndentDetailPartNo(string partNo, int noofshowrec)
        {
            DataSet ds = new DataSet();

            partNo = ismoUtil.escapeCharacter(partNo);

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNSQ088_OrderPartNo";
            cmd.Parameters.Add("p_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("p_PART_NO", OracleDbType.Varchar2).Value = partNo;
            cmd.Parameters.Add("p_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
            cmd.Parameters.Add("c_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }


        //NINE
        [HttpGet, Route("GetPartCode/{partCode}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult GetPartCode(string partCode, int noofshowrec)
        {
            DataSet ds = new DataSet();

            partCode = ismoUtil.escapeCharacter(partCode);

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_MT_PART_CODE";
            cmd.Parameters.Add("p_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("p_PART_CODE", OracleDbType.Varchar2).Value = (partCode != null && partCode == "null" ? "" : partCode);
            cmd.Parameters.Add("p_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
            cmd.Parameters.Add("c_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }
        //END NINE



        //end create by BF.

        //BF Modify 23M12Y2019

        //end create by BF.

        [HttpGet, Route("GetPartNo/{partNo}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult GetPartNo(string partNo, int noofshowrec)
        {
            DataSet ds = new DataSet();

            partNo = ismoUtil.escapeCharacter(partNo);

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "sp_NP_MT_Part_No_ByID";
            cmd.Parameters.Add("p_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("p_PART_NO", OracleDbType.Varchar2).Value = (partNo != null && partNo == "null" ? "" : partNo);
            cmd.Parameters.Add("p_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
            cmd.Parameters.Add("c_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpGet, Route("GetPartInfo/{partNo}")]
        [Authorize]
        public IHttpActionResult GetPartInfo(string partNo)
        {
            DataSet ds = new DataSet();

            partNo = ismoUtil.escapeCharacter(partNo);

            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_GET_PART_INFO";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = partNo;
                cmd.Parameters.Add("C_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));

            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "GetPartInfo");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpPost, Route("GetPartNo/{partNo}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult GetPartNo(string partNo, int noofshowrec, [FromBody] dynamic pParam)
        {
            DataSet ds = new DataSet();

            partNo = ismoUtil.escapeCharacter(partNo);

            OracleCommand cmd = new OracleCommand();
            if (pParam["GROUP_PART"] == null || pParam["GROUP_PART"] == "")
            {
                cmd.CommandText = "sp_NP_MT_Part_No_ByVendor";
            }
            else
            {
                cmd.CommandText = "sp_NP_MT_Group_PART_ByVendor";
            }
            cmd.Parameters.Add("p_PART_NO", OracleDbType.Varchar2).Value = (partNo != null && partNo == "null" ? "" : partNo);
            cmd.Parameters.Add("p_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
            cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pParam["VENDOR_CODE"];
            cmd.Parameters.Add("c_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpGet, Route("GetStaffInchargeG6/{staffID}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult GetStaffInchargeG6(string staffID, int noofshowrec)
        {
            DataSet ds = new DataSet();

            staffID = ismoUtil.escapeCharacter(staffID);

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "sp_NP_MT_Staff_InchargeG6_ByID";
            cmd.Parameters.Add("p_STAFF_ID", OracleDbType.Varchar2).Value = staffID.ToUpper() == "NULL" ? (object)DBNull.Value : staffID;
            cmd.Parameters.Add("p_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
            cmd.Parameters.Add("c_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }


        [HttpGet, Route("GetInvoice/{pInvNo}/{pShowRec}")]
        [Authorize]
        public IHttpActionResult GetInvoice(string pInvNo, int pShowRec)
        {
            DataSet ds = new DataSet();

            pInvNo = ismoUtil.escapeCharacter(pInvNo);

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_GET_INVOICE_NO";
            cmd.Parameters.Add("p_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_INV_NO", OracleDbType.Varchar2).Value = pInvNo;
            cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = pShowRec;
            cmd.Parameters.Add("c_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpGet, Route("GetInvoiceImport/{pInvNo}/{pShowRec}")]
        [Authorize]
        public IHttpActionResult GetInvoiceImport(string pInvNo, int pShowRec)
        {
            DataSet ds = new DataSet();

            pInvNo = ismoUtil.escapeCharacter(pInvNo);

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_GET_INVOICE_NO_IMPORT";
            cmd.Parameters.Add("p_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_INV_NO", OracleDbType.Varchar2).Value = pInvNo;
            cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = pShowRec;
            cmd.Parameters.Add("c_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }


        [HttpGet, Route("GetInvoiceImportRC/{pInvNo}/{pShowRec}")]
        [Authorize]
        public IHttpActionResult GetInvoiceImportRC(string pInvNo, int pShowRec)
        {
            DataSet ds = new DataSet();

            pInvNo = ismoUtil.escapeCharacter(pInvNo);

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_GET_INVOICE_NO_RC";
            cmd.Parameters.Add("p_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_INV_NO", OracleDbType.Varchar2).Value = pInvNo;
            cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = pShowRec;
            cmd.Parameters.Add("c_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpGet, Route("GetPONo/{pPONo}/{pShowRec}")]
        [Authorize]
        public IHttpActionResult GetPONo(string pPONo, int pShowRec)
        {
            DataSet ds = new DataSet();

            pPONo = ismoUtil.escapeCharacter(pPONo);

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_MT_PO_NO_BYID";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_PO_NO", OracleDbType.Varchar2).Value = pPONo;
            cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = pShowRec;
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpGet, Route("GetMainModel/{pModel}")]
        [Authorize]
        public IHttpActionResult GetMainModel(string pModel)
        {
            DataSet ds = new DataSet();

            pModel = ismoUtil.escapeCharacter(pModel);

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_MT_MAIN_MODEL";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_MAIN_MODEL", OracleDbType.Varchar2).Value = pModel.ToUpper() == "NULL" ? (Object)DBNull.Value : pModel;
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));

        }

        [HttpGet, Route("GetJobTypeMaster")]
        [Authorize]
        public IHttpActionResult GetJobTypeMaster()
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            gSQL = "SP_NP_GET_JOB_TYPE_MASTER";

            cmd.CommandText = gSQL;
            cmd.CommandType = CommandType.StoredProcedure;
            cmd.Parameters.Add("PI_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("PO_C_RESULT", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpGet, Route("GetVendorTypeList")]
        [Authorize]
        public IHttpActionResult GetVendorTypeList()
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            gSQL = "SP_NP_GET_VENDOR_TYPE_LIST";

            cmd.CommandText = gSQL;
            cmd.CommandType = CommandType.StoredProcedure;
            cmd.Parameters.Add("PO_C_RESULT", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpGet, Route("GetVendorTypeByVendorCode/{pVendorCode}")]
        [Authorize]
        public IHttpActionResult GetVendorTypeByVendorCode(string pVendorCode)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            gSQL = "SP_NP_GET_VENDOR_TYPE";
            string vendorType = "";

            try
            {
                cmd.CommandText = gSQL;
                cmd.CommandType = CommandType.StoredProcedure;
                cmd.Parameters.Add("PI_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("PI_VENDOR_CODE", OracleDbType.Varchar2).Value = pVendorCode;
                cmd.Parameters.Add("PO_VENDOR_TYPE", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);

                if (ds.Tables.Count > 0)
                {
                    if (ds.Tables[0].Rows.Count > 0)
                    {
                        vendorType = ds.Tables[0].Rows[0][0].ToString();
                    }
                    else
                    {
                        vendorType = "";
                    }

                }
            }
            catch (Exception ex)
            {
                System.Console.WriteLine("Exception: {0}", ex.ToString());
                vendorType = "";
            }

            return Json(vendorType);
        }

        [HttpPost, Route("GetOrderClass/{pOrderClass}/{pShowRec}")]
        [Authorize]
        public IHttpActionResult GetOrderClass(string pOrderClass, int pShowRec, [FromBody] dynamic pOrder)
        {
            DataSet ds = new DataSet();

            pOrderClass = ismoUtil.escapeCharacter(pOrderClass);

            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_MT_ORDER_CLASS";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_JOB_TYPE", OracleDbType.Varchar2).Value = pOrder["JOB_TYPE"];
                cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = pShowRec;
                cmd.Parameters.Add("C_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpGet, Route("GetDeliveryRoute/{pRouteCode}/{pShowRec}")]
        [Authorize]
        public IHttpActionResult GetDeliveryRoute(string pRouteCode, int pShowRec)
        {
            DataSet ds = new DataSet();

            pRouteCode = ismoUtil.escapeCharacter(pRouteCode);

            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_MT_DELIVERY_ROUTE";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_ROUTE_CODE", OracleDbType.Varchar2).Value = (pRouteCode != null && pRouteCode.ToUpper() == "NULL" ? "" : pRouteCode);
                cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = pShowRec;
                cmd.Parameters.Add("C_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpGet, Route("GetTransportCode/{pTransportCode}/{pShowRec}")]
        [Authorize]
        public IHttpActionResult GetTransportCode(string pTransportCode, int pShowRec)
        {
            DataSet ds = new DataSet();

            pTransportCode = ismoUtil.escapeCharacter(pTransportCode);

            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_MT_TRANSPORT";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_TRANSPORT_CODE", OracleDbType.Varchar2).Value = (pTransportCode != null && pTransportCode.ToUpper() == "NULL" ? "" : pTransportCode);
                cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = pShowRec;
                cmd.Parameters.Add("C_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        #endregion

        [HttpGet, Route("GetPartCategory")]
        [Authorize]
        public IHttpActionResult GetPartCategory()
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_MT_PART_CATEGORY";
            cmd.Parameters.Add("pCOMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("c_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        //[HttpGet, Route("GetReasonCodeByJobType/{reasoncode}/{noofshowrec}")]
        //[Authorize]
        //public IHttpActionResult GetReasonCodeByJobType(string reasoncode, int noofshowrec)
        //{
        //    DataSet ds = new DataSet();

        //    reasoncode = ismoUtil.escapeCharacter(reasoncode);

        //    OracleCommand cmd = new OracleCommand();
        //    cmd.CommandText = "SP_NP_MT_REASON_CODE";
        //    cmd.Parameters.Add("p_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
        //    cmd.Parameters.Add("P_REASON_CODE", OracleDbType.Varchar2).Value = reasoncode;
        //    cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
        //    cmd.Parameters.Add("c_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
        //    ds = oOracledb.SqlQueryDS_CMD(cmd);

        //    return Json(DTFM.convertToList(ds));
        //}

        [HttpPost, Route("GetReasonCodeByJobType/{reasoncode}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult GetReasonCodeByJobType(string reasoncode, int noofshowrec, [FromBody] dynamic pParam)
        {
            DataSet ds = new DataSet();

            reasoncode = ismoUtil.escapeCharacter(reasoncode);

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_MT_REASON_CODE";
            cmd.Parameters.Add("p_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_REASON_CODE", OracleDbType.Varchar2).Value = reasoncode.ToUpper() == "NULL" ? (object)DBNull.Value : reasoncode;
            cmd.Parameters.Add("P_JOBTYPE", OracleDbType.Varchar2).Value = pParam["JOB_TYPE"];
            cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
            cmd.Parameters.Add("c_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpGet, Route("GetReasonCodeList/{pJobType}")]
        [Authorize]
        public IHttpActionResult GetReasonCodeList(string pJobType)
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_MT_REASON_CODE";
            cmd.Parameters.Add("p_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_REASON_CODE", OracleDbType.Varchar2).Value = (object)DBNull.Value;
            cmd.Parameters.Add("P_JOBTYPE", OracleDbType.Varchar2).Value = pJobType;
            cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = 500;
            cmd.Parameters.Add("c_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpGet, Route("GetVatCode/{VatCode}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult GetVatCode(string VatCode, int noofshowrec)
        {
            DataSet ds = new DataSet();

            VatCode = ismoUtil.escapeCharacter(VatCode);

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_MT_VAT_CODE";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_CUSTOMER_CODE", OracleDbType.Varchar2).Value = VatCode.ToUpper() == "NULL" ? (object)DBNull.Value : VatCode;
            cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
            cmd.Parameters.Add("c_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpGet, Route("GetCustomerCode/{cusID}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult GetCustomerCode(string cusID, int noofshowrec)
        {
            DataSet ds = new DataSet();

            cusID = ismoUtil.escapeCharacter(cusID);

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_MT_CUSTOMER";
            cmd.Parameters.Add("pCOMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("pCUSTOMER_CODE", OracleDbType.Varchar2).Value = cusID.ToUpper() == "NULL" ? (object)DBNull.Value : cusID;
            cmd.Parameters.Add("pSHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
            cmd.Parameters.Add("c_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpPost, Route("GetCustomerBranch/{branchCode}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult GetCustomerBranch(string branchCode, int noofshowrec, [FromBody] dynamic pCustomer)
        {
            DataSet ds = new DataSet();

            branchCode = ismoUtil.escapeCharacter(branchCode);

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_MT_CUSTOMER_BRANCH";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_CUSTOMER_CODE", OracleDbType.Varchar2).Value = pCustomer["CUSTOMER_CODE"];
            cmd.Parameters.Add("P_BRANCH_CODE", OracleDbType.Varchar2).Value = branchCode.ToUpper() == "NULL" ? (object)DBNull.Value : branchCode;
            cmd.Parameters.Add("P_SHOW_REC", OracleDbType.Int16).Value = noofshowrec;
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }


        [HttpGet, Route("GetInvoiceByVendor/{pInvNo}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult GetInvoiceByVendor(string pInvNo, int noofshowrec)
        {
            DataSet ds = new DataSet();

            pInvNo = ismoUtil.escapeCharacter(pInvNo);

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_MT_INVOICE_NO_BYID";
            cmd.Parameters.Add("p_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_ITM_INV_NO", OracleDbType.Varchar2).Value = pInvNo;
            cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
            cmd.Parameters.Add("c_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpPost, Route("GetInvoiceByVendor/{pInvNo}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult GetInvoiceByVendor(string pInvNo, int noofshowrec, [FromBody] dynamic pParam)
        {
            DataSet ds = new DataSet();

            pInvNo = ismoUtil.escapeCharacter(pInvNo);

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_MT_INVOICE_BYVENDOR";
            cmd.Parameters.Add("p_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_ITM_INV_NO", OracleDbType.Varchar2).Value = pInvNo;
            cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pParam["VENDOR_CODE"];
            cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
            cmd.Parameters.Add("c_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpGet, Route("GetVendorCodeByInvoice/{vendorcode}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult GetVendorCodeByInvoice(string vendorcode, int noofshowrec)
        {
            DataSet ds = new DataSet();

            vendorcode = ismoUtil.escapeCharacter(vendorcode);

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "sp_NP_MT_VENDOR_CODE_ByID";
            cmd.Parameters.Add("p_VENDOR_CODE", OracleDbType.Varchar2).Value = vendorcode != null && vendorcode == "null" ? "" : vendorcode;
            cmd.Parameters.Add("p_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
            cmd.Parameters.Add("c_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpPost, Route("GetVendorCodeByInvoice/{vendorcode}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult GetVendorCodeByInvoice(string vendorcode, int noofshowrec, [FromBody] dynamic pParam)
        {
            DataSet ds = new DataSet();

            vendorcode = ismoUtil.escapeCharacter(vendorcode);

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_MT_VENDOR_BYINVOICE";
            cmd.Parameters.Add("p_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("p_INVOICE_NO", OracleDbType.Varchar2).Value = pParam["INVOICE_NO"];
            cmd.Parameters.Add("p_VENDOR_CODE", OracleDbType.Varchar2).Value = vendorcode != null && vendorcode == "null" ? "" : vendorcode;
            cmd.Parameters.Add("p_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
            cmd.Parameters.Add("c_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }



        [HttpGet, Route("GetPONoByPart/{pPONo}/{pShowRec}")]
        [Authorize]
        public IHttpActionResult GetPONoByPart(string pPONo, int pShowRec)
        {
            DataSet ds = new DataSet();

            pPONo = ismoUtil.escapeCharacter(pPONo);

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_MT_PO_NO_BYID";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_PO_NO", OracleDbType.Varchar2).Value = pPONo;
            cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = pShowRec;
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }


        [HttpPost, Route("GetPONoByPart/{pPONo}/{pShowRec}")]
        [Authorize]
        public IHttpActionResult GetPONoByPart(string pPONo, int pShowRec, [FromBody] dynamic pParam)
        {
            DataSet ds = new DataSet();

            pPONo = ismoUtil.escapeCharacter(pPONo);

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_MT_PO_NO_BYPART";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_PO_NO", OracleDbType.Varchar2).Value = pPONo;
            cmd.Parameters.Add("p_PART_NO", OracleDbType.Varchar2).Value = pParam["PART_NO"];
            cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = pShowRec;
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpGet, Route("GetPartNoByPO/{partNo}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult GetPartNoByPO(string partNo, int noofshowrec)
        {
            DataSet ds = new DataSet();

            partNo = ismoUtil.escapeCharacter(partNo);

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "sp_NP_MT_Part_No_ByID";
            cmd.Parameters.Add("p_PART_NO", OracleDbType.Varchar2).Value = (partNo != null && partNo == "null" ? "" : partNo);
            cmd.Parameters.Add("p_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
            cmd.Parameters.Add("c_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpPost, Route("GetPartNoByPO/{partNo}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult GetPartNoByPO(string partNo, int noofshowrec, [FromBody] dynamic pParam)
        {
            DataSet ds = new DataSet();

            partNo = ismoUtil.escapeCharacter(partNo);

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_MT_PART_NO_BYPO";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = (partNo != null && partNo == "null" ? "" : partNo);
            cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
            cmd.Parameters.Add("P_PO_NO", OracleDbType.Varchar2).Value = pParam["PO_NO"];
            cmd.Parameters.Add("c_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpGet, Route("GetVendorGlobalCode/{vendorglobalcode}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult GetVendorGlobalCode(string vendorglobalcode, int noofshowrec)
        {
            DataSet ds = new DataSet();

            vendorglobalcode = ismoUtil.escapeCharacter(vendorglobalcode);

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_MT_VENDOR_GLOBAL_CODE";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("p_VENDOR_GLOBAL_CODE", OracleDbType.Varchar2).Value = vendorglobalcode != null && vendorglobalcode == "null" ? "" : vendorglobalcode;
            cmd.Parameters.Add("p_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
            cmd.Parameters.Add("c_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpGet, Route("GetSkUser/{skuserid}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult GetSkUser(string skuserid, int noofshowrec)
        {
            DataSet ds = new DataSet();

            skuserid = ismoUtil.escapeCharacter(skuserid);

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_MT_SK_USER";
            cmd.Parameters.Add("P_SK_USER_ID", OracleDbType.Varchar2).Value = skuserid != null && skuserid == "null" ? "" : skuserid;
            cmd.Parameters.Add("p_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
            cmd.Parameters.Add("c_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }


        [HttpGet, Route("GetVendorForVendorCat/{VENDOR_CODE}")]
        [Authorize]
        public IHttpActionResult GetVendorForVendorCat(string VENDOR_CODE)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_MT_VENDOR_CODE_CAT";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = VENDOR_CODE;
            cmd.Parameters.Add("c_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }


        [HttpGet, Route("GetLocation/{location_no}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult GetLocation(string location_no, int noofshowrec)
        {
            DataSet ds = new DataSet();

            location_no = ismoUtil.escapeCharacter(location_no);

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNM033P_GET_LOCATION";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_LOCATION_NO", OracleDbType.Varchar2).Value = location_no;
            cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));
        }


        [HttpGet, Route("GetRackCode/{RACK_CODE}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult GetRackCode(string RACK_CODE, int noofshowrec)
        {
            DataSet ds = new DataSet();

            RACK_CODE = ismoUtil.escapeCharacter(RACK_CODE);

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_MT_RACK_CODE";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_RACK_CODE", OracleDbType.Varchar2).Value = RACK_CODE;
            cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));

        }

        [HttpGet, Route("GetRackGroupCode/{RACK_GROUP_CODE}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult GetRackGroupCode(string RACK_GROUP_CODE, int noofshowrec)
        {
            DataSet ds = new DataSet();

            RACK_GROUP_CODE = ismoUtil.escapeCharacter(RACK_GROUP_CODE);

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_MT_RACK_GROUP_CODE";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_RACK_CODE", OracleDbType.Varchar2).Value = null;
            cmd.Parameters.Add("P_RACK_GROUP_CODE", OracleDbType.Varchar2).Value = RACK_GROUP_CODE == "null" ? (object)DBNull.Value : RACK_GROUP_CODE;
            cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpPost, Route("GetRackGroupCode/{RACK_GROUP_CODE}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult GetRackGroupCode(string RACK_GROUP_CODE, int noofshowrec, [FromBody] dynamic pParam)
        {
            DataSet ds = new DataSet();

            RACK_GROUP_CODE = ismoUtil.escapeCharacter(RACK_GROUP_CODE);

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_MT_RACK_GROUP_CODE";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_RACK_CODE", OracleDbType.Varchar2).Value = pParam["RACK_CODE"];
            cmd.Parameters.Add("P_RACK_GROUP_CODE", OracleDbType.Varchar2).Value = RACK_GROUP_CODE == "null" ? (object)DBNull.Value : RACK_GROUP_CODE;
            //cmd.Parameters.Add("P_RACK_GROUP_CODE", OracleDbType).Value = archar2, RACK_GROUP_CODE;
            cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        //[HttpGet, Route("GetReasonCode/{LOCK_LOCATION}/{noofshowrec}")]
        //[Authorize]
        //public IHttpActionResult GetReasonCode(string LOCK_LOCATION, int noofshowrec)
        //{
        //    DataSet ds = new DataSet();

        //    LOCK_LOCATION = ismoUtil.escapeCharacter(LOCK_LOCATION);

        //    OracleCommand cmd = new OracleCommand();
        //    cmd.CommandText = "SP_NP_MT_REASON_CODE";
        //    cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
        //    cmd.Parameters.Add("P_LOCK_LOCATION", OracleDbType.Varchar2).Value = LOCK_LOCATION;
        //    cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
        //    cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

        //    ds = oOracledb.SqlQueryDS_CMD(cmd);

        //    return Json(DTFM.convertToList(ds));
        //}

        [HttpGet, Route("GetHubCode/{HubCode}/{pShowRec}")]
        [Authorize]
        public IHttpActionResult GetHubCode(string HubCode, int pShowRec)
        {
            DataSet ds = new DataSet();

            HubCode = ismoUtil.escapeCharacter(HubCode);

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_MT_HUB_CODE";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_HUB_CODE", OracleDbType.Varchar2).Value = HubCode;
            cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = pShowRec;
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpGet, Route("GetNextPOSubItemNo/{PO_NO}/{ITEM_NO}")]
        [Authorize]
        public IHttpActionResult GetNextPOSubItemNo(string PO_NO, string ITEM_NO)
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_FIND_SUB_ITEM_BYPO";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_PO_NO", OracleDbType.Varchar2).Value = PO_NO;
            cmd.Parameters.Add("P_ITEM_NO", OracleDbType.Varchar2).Value = ITEM_NO;
            cmd.Parameters.Add("R_SUB_ITEM_NO", OracleDbType.Varchar2, 10).Direction = ParameterDirection.Output;

            cmd = oOracledb.SqlQueryReturnValue(cmd);

            var returnJson = new
            {
                SUB_ITEM_NO = cmd.Parameters["R_SUB_ITEM_NO"].Value.ToString()
            };

            return Json(returnJson);

        }

        [HttpGet, Route("GetPDILocationCode/{locationCode}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult GetPDILocationCode(string locationCode, int noofshowrec)
        {
            DataSet ds = new DataSet();

            locationCode = ismoUtil.escapeCharacter(locationCode);

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_MT_PDI_LOCATION";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_PDI_LOCATION_CODE", OracleDbType.Varchar2).Value = (locationCode != null && locationCode.ToUpper() == "NULL" ? "" : locationCode);
            cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpGet, Route("GetEndItem/{endItem}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult GetEndItem(string endItem, int noofshowrec)
        {
            DataSet ds = new DataSet();

            endItem = ismoUtil.escapeCharacter(endItem);

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_MT_VEHICLE_MODEL";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_END_ITEM_18", OracleDbType.Varchar2).Value = (endItem != null && endItem.ToUpper() == "NULL" ? "" : endItem);
            cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpGet, Route("GetBOMAssemblyPartNo/{partno}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult GetBOMAssemblyPartNo(string partno, int noofshowrec)
        {
            DataSet ds = new DataSet();

            partno = ismoUtil.escapeCharacter(partno);

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_MT_BOM_AS_PART";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = (partno != null && partno.ToUpper() == "NULL" ? "" : partno);
            cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpPost, Route("SNM083_GetExcise")]
        [Authorize]
        public IHttpActionResult SNM083_GetExcise([FromBody] dynamic data)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            gSQL = "SP_NP_MT_EXCISE_MASTER";

            try
            {
                cmd.CommandText = gSQL;
                cmd.CommandType = CommandType.StoredProcedure;
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = data.PART_NO.ToString();
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);
            }
            catch (Exception ex)
            {
                System.Console.WriteLine("Exception: {0}", ex.ToString());
            }

            return Json(DTFM.convertToList(ds));
        }


        [HttpPost, Route("SNM083_ValidateAddExcise")]
        [Authorize]
        public IHttpActionResult SNM083_ValidateAddExcise([FromBody] dynamic data)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            gSQL = "SP_NP_MT_EXCISE_IS_EXISTS";

            try
            {
                cmd.CommandText = gSQL;
                cmd.CommandType = CommandType.StoredProcedure;
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = data["PART_NO"].ToString();
                cmd.Parameters.Add("P_EFFECTIVE_DATE", OracleDbType.Date).Value = Convert.ToDateTime(data["EFFECTIVE_DATE"].ToString());
                cmd.Parameters.Add("P_EXPIRE_DATE", OracleDbType.Date).Value = Convert.ToDateTime(data["DISABLED_DATE"].ToString());
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);
            }
            catch (Exception ex)
            {
                System.Console.WriteLine("Exception: {0}", ex.ToString());
            }

            return Json(DTFM.convertToList(ds));
        }


        [HttpPost, Route("SNM083_AddExcise")]
        [Authorize]
        public IHttpActionResult SNM083_AddExcise([FromBody] dynamic data)
        {
            DataSet ds = new DataSet();
            try
            {

                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_MT_EXCISE_MASTER_ADD";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);

                cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = data["PART_NO"];
                cmd.Parameters.Add("P_CALCULATE_TYPE", OracleDbType.Varchar2).Value = data["CALCULATE_TYPE"];
                cmd.Parameters.Add("P_CAPACITY", OracleDbType.Varchar2).Value = data["CAPACITY"];
                cmd.Parameters.Add("P_EXCISE_RATE", OracleDbType.Varchar2).Value = data["EXCISE_RATE"];

                cmd.Parameters.Add("P_EFFECTIVE_DATE", OracleDbType.Date).Value = Convert.ToDateTime(data["EFFECTIVE_DATE"]);
                cmd.Parameters.Add("P_EXPIRE_DATE", OracleDbType.Date).Value = Convert.ToDateTime(data["DISABLED_DATE"]);
                cmd.Parameters.Add("P_CAPACITY_RATE", OracleDbType.Varchar2).Value = data["CAPACITY_RATE"];
                cmd.Parameters.Add("P_UNIT_TYPE", OracleDbType.Varchar2).Value = data["UNIT_TYPE"];
                cmd.Parameters.Add("P_CREATE_BY", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("cReturn", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);

                if (ds.Tables.Count > 0)
                {
                    if (ds.Tables[0].Rows[0]["STATUS"].ToString() != "DONE")
                    {
                        string errString = "Error : " + ds.Tables[0].Rows[0]["STATUS"].ToString();
                        return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, errString));
                    }
                }
                return Ok("DONE");
            }
            catch (Exception ex)
            {
                return Ok("Error : " + ex.Message);
            }
        }

        [HttpPost, Route("SNM083_UpdateExcise")]
        [Authorize]
        // [RunBatchGuard]
        public IHttpActionResult SNM083_UpdateExcise([FromBody] dynamic data)
        {
            DataSet ds = new DataSet();
            try
            {

                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_MT_EXCISE_MASTER_UPDATE";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);

                cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = data["PART_NO"];
                cmd.Parameters.Add("P_CALCULATE_TYPE", OracleDbType.Varchar2).Value = data["CALCULATE_TYPE"];
                cmd.Parameters.Add("P_CAPACITY", OracleDbType.Varchar2).Value = data["CAPACITY"];
                cmd.Parameters.Add("P_EXCISE_RATE", OracleDbType.Varchar2).Value = data["EXCISE_RATE"];
                cmd.Parameters.Add("P_EFFECTIVE_DATE", OracleDbType.Date).Value = Convert.ToDateTime(data["EFFECTIVE_DATE"]);
                cmd.Parameters.Add("P_EXPIRE_DATE", OracleDbType.Date).Value = Convert.ToDateTime(data["DISABLED_DATE"]);
                cmd.Parameters.Add("P_CAPACITY_RATE", OracleDbType.Varchar2).Value = data["CAPACITY_RATE"];
                cmd.Parameters.Add("P_UNIT_TYPE", OracleDbType.Varchar2).Value = data["UNIT_TYPE"];
                cmd.Parameters.Add("P_CREATE_BY", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("cReturn", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);
                if (ds.Tables.Count > 0)
                {
                    if (ds.Tables[0].Rows[0]["STATUS"].ToString() != "DONE")
                    {
                        string errString = "Error : " + ds.Tables[0].Rows[0]["STATUS"].ToString();
                        return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, errString));
                    }
                }
                return Ok("DONE");
            }
            catch (Exception ex)
            {
                return Ok("Error : " + ex.Message);
            }
        }

        [HttpPost, Route("SNM083_Download")]
        [Authorize]
        public HttpResponseMessage SNM083_Download([FromBody] dynamic param)
        {
            DataSet ds = new DataSet();
            DataTable dt = new DataTable();
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_MT_EXCISE_MASTER";
            cmd.CommandType = CommandType.StoredProcedure;
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = param.PART_NO;
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            ds = oOracledb.SqlQueryDS_CMD(cmd);
            dt = ds.Tables[0];
            var json = JsonConvert.SerializeObject(dt);
            var List1 = JsonConvert.DeserializeObject<List<DataModel.SNM083>>(json);
            HttpResponseMessage response = new HttpResponseMessage(HttpStatusCode.OK);
            string gLocation = "~/tempFile/" + "SNM083" + "/";
            string gWriteLocation = System.Web.HttpContext.Current.Server.MapPath(gLocation);
            FileInfo filePath = new FileInfo(gWriteLocation);
            filePath.Directory.Create();
            string gFileLocation = Path.Combine(gWriteLocation, "SNM083.xlsx");
            string gReturnLocation = Path.Combine(gLocation, "SNM083.xlsx");
            var excel2 = List1.ToExcel("PartExciseInfo");
            byte[] excel = excel2;
            File.WriteAllBytes(gFileLocation, excel);
            string path = HttpContext.Current.Server.MapPath("~/" + gReturnLocation.Substring(1));
            if (!File.Exists(path))
            {
                return Request.CreateErrorResponse(HttpStatusCode.NotFound, "File not found.");
            }
            try
            {
                string mimeType = MimeMapping.GetMimeMapping("SNM083.xlsx");
                StreamContent x = new StreamContent(new FileStream(path, FileMode.Open, FileAccess.Read));
                response.Content = x;
                response.Content.Headers.ContentType = new MediaTypeHeaderValue(mimeType);
                response.Content.Headers.ContentDisposition = new ContentDispositionHeaderValue("attachment");
                response.Content.Headers.ContentDisposition.FileName = "SNM083.xlsx";
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM083_Download");
                return Request.CreateResponse(HttpStatusCode.BadRequest, ex);
            }
            return response;
        }



        [HttpPost, Route("DASH_IC_GetFR")]
        [Authorize]
        public IHttpActionResult DASH_IC_GetFR([FromBody] dynamic data)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            gSQL = "SP_NP_DASH_FR_DAILY";

            try
            {
                cmd.CommandText = gSQL;
                cmd.CommandType = CommandType.StoredProcedure;
                cmd.Parameters.Add("P_START_DATE", OracleDbType.Varchar2).Value = data.START_DATE.ToString();
                cmd.Parameters.Add("P_TO_DATE", OracleDbType.Varchar2).Value = data.TO_DATE.ToString();
                cmd.Parameters.Add("C_RETURN1", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                cmd.Parameters.Add("C_RETURN2", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                cmd.Parameters.Add("C_RETURN3", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);
            }
            catch (Exception ex)
            {
                System.Console.WriteLine("Exception: {0}", ex.ToString());
            }

            return Json(DTFM.convertToList(ds));
        }

        [HttpPost, Route("DASH_IC_GetFR_Staff")]
        [Authorize]
        public IHttpActionResult DASH_IC_GetFR_Staff([FromBody] dynamic data)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            gSQL = "SP_NP_DASH_FR_STAFF";

            try
            {
                cmd.CommandText = gSQL;
                cmd.CommandType = CommandType.StoredProcedure;
                cmd.Parameters.Add("P_START_DATE", OracleDbType.Varchar2).Value = data.START_DATE.ToString();
                cmd.Parameters.Add("P_TO_DATE", OracleDbType.Varchar2).Value = data.TO_DATE.ToString();
                cmd.Parameters.Add("P_STAFF_ID", OracleDbType.Varchar2).Value = data.USER_ID.ToString();
                cmd.Parameters.Add("C_RETURN1", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                cmd.Parameters.Add("C_RETURN2", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                cmd.Parameters.Add("C_RETURN3", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);
            }
            catch (Exception ex)
            {
                System.Console.WriteLine("Exception: {0}", ex.ToString());
            }

            return Json(DTFM.convertToList(ds));
        }

        [HttpPost, Route("DASH_IC_GetFR_VendorType")]
        [Authorize]
        public IHttpActionResult DASH_IC_GetFR_VendorType([FromBody] dynamic data)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            gSQL = "SP_NP_DASH_FR_VENDOR_TYPE";

            try
            {
                cmd.CommandText = gSQL;
                cmd.CommandType = CommandType.StoredProcedure;
                cmd.Parameters.Add("P_START_DATE", OracleDbType.Varchar2).Value = data.START_DATE.ToString();
                cmd.Parameters.Add("P_TO_DATE", OracleDbType.Varchar2).Value = data.TO_DATE.ToString();
                cmd.Parameters.Add("P_VENDOR_TYPE", OracleDbType.Varchar2).Value = data.VENDOR_TYPE.ToString();
                cmd.Parameters.Add("C_RETURN1", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                cmd.Parameters.Add("C_RETURN2", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                cmd.Parameters.Add("C_RETURN3", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);
            }
            catch (Exception ex)
            {
                System.Console.WriteLine("Exception: {0}", ex.ToString());
            }

            return Json(DTFM.convertToList(ds));
        }

        [HttpPost, Route("DASH_IC_GetFR_Team")]
        [Authorize]
        public IHttpActionResult DASH_IC_GetFR_Team([FromBody] dynamic data)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            gSQL = "SP_NP_DASH_FR_TEAM";

            try
            {
                cmd.CommandText = gSQL;
                cmd.CommandType = CommandType.StoredProcedure;
                cmd.Parameters.Add("P_START_DATE", OracleDbType.Varchar2).Value = data.START_DATE.ToString();
                cmd.Parameters.Add("P_TO_DATE", OracleDbType.Varchar2).Value = data.TO_DATE.ToString();
                cmd.Parameters.Add("P_TEAM_ID", OracleDbType.Varchar2).Value = data.TEAM_ID.ToString();
                cmd.Parameters.Add("C_RETURN1", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                cmd.Parameters.Add("C_RETURN2", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                cmd.Parameters.Add("C_RETURN3", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);
            }
            catch (Exception ex)
            {
                System.Console.WriteLine("Exception: {0}", ex.ToString());
            }

            return Json(DTFM.convertToList(ds));
        }

        [HttpPost, Route("DASH_IC_BO_INFO")]
        [Authorize]
        public IHttpActionResult DASH_IC_BO_INFO([FromBody] dynamic data)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            gSQL = "SP_NP_DASH_BO_INFO";

            try
            {
                cmd.CommandText = gSQL;
                cmd.CommandType = CommandType.StoredProcedure;
                cmd.Parameters.Add("P_START_DATE", OracleDbType.Varchar2).Value = data.START_DATE.ToString();
                cmd.Parameters.Add("P_TO_DATE", OracleDbType.Varchar2).Value = data.TO_DATE.ToString();
                cmd.Parameters.Add("P_TYPE", OracleDbType.Varchar2).Value = data.D_TYPE.ToString();
                cmd.Parameters.Add("P_SUBTYPE", OracleDbType.Varchar2).Value = data.SUBTYPE != null ? data.SUBTYPE.ToString() : (Object)DBNull.Value;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);
            }
            catch (Exception ex)
            {
                System.Console.WriteLine("Exception: {0}", ex.ToString());
            }

            return Json(DTFM.convertToList(ds));
        }


        [HttpPost, Route("DASH_IC_DS_INFO")]
        [Authorize]
        public IHttpActionResult DASH_IC_DS_INFO([FromBody] dynamic data)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            gSQL = "SP_NP_DASH_DS_BY_CAT";

            try
            {
                cmd.CommandText = gSQL;
                cmd.CommandType = CommandType.StoredProcedure;
                cmd.Parameters.Add("P_DATA_MONTH", OracleDbType.Varchar2).Value = data.DATA_MONTH.ToString();

                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);
            }
            catch (Exception ex)
            {
                System.Console.WriteLine("Exception: {0}", ex.ToString());
            }

            return Json(DTFM.convertToList(ds));
        }



        [HttpPost, Route("CheckOrderExists")]
        [Authorize]
        public IHttpActionResult CheckOrderExists([FromBody] dynamic data)
        {
            DataSet ds = new DataSet();


            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_CHK_ORDER_EXISTS";
            cmd.Parameters.Add("P_CUSTOMER_CODE", OracleDbType.Varchar2).Value = data.CUSTOMER_CODE;
            cmd.Parameters.Add("P_ORDER_NO", OracleDbType.Varchar2).Value = data.ORDER_NO;
            cmd.Parameters.Add("P_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpGet, Route("GetReportList/{reportFor}")]
        [Authorize]
        public IHttpActionResult GetReportList(string reportFor)
        {
            DataSet ds = new DataSet();
            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_MT_REPORT_LIST";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_REPORT_FOR", OracleDbType.Varchar2).Value = reportFor;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));

            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "GetReportList");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpPost, Route("SNM001P_SavePartMasterDomestic")]
        [Authorize]
        public IHttpActionResult SNM001P_SavePartMasterDomestic([FromBody] dynamic pDataList)
        {
            try
            {
                DataSet ds = new DataSet();

                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNM001P_SAVE_DOM";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = pDataList["PART_NO"];
                cmd.Parameters.Add("P_LOCK_SALES", OracleDbType.Varchar2).Value = pDataList["LOCK_SALES"];
                cmd.Parameters.Add("P_LAST_UPD_PGM", OracleDbType.Varchar2).Value = "SNM001P";
                cmd.Parameters.Add("P_LAST_UPD_BY", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("P_IP_ADDRESS", OracleDbType.Varchar2).Value = "207.1.1.1";                
                cmd.Parameters.Add("C_RETRUN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));

            }

            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM001P_SavePartMasterDomestic");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));

            }
        }

        [HttpPost, Route("SNM001P_M_MC_SavePartMasterDom")]
        [Authorize]
        public IHttpActionResult SNM001P_M_MC_SavePartMasterDom([FromBody] dynamic pDataList)
        {
            try
            {
                DataSet ds = new DataSet();

                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNM001P_M_SAVE_DOM_NEW";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = pDataList["PART_NO"];
                cmd.Parameters.Add("P_PRICING_CODE", OracleDbType.Varchar2).Value = pDataList["PRICING_CODE"];
                cmd.Parameters.Add("P_SPPS", OracleDbType.Varchar2).Value = pDataList["SPPS_NO"];
                cmd.Parameters.Add("P_DESIGN_NOTE", OracleDbType.Varchar2).Value = pDataList["DESIGN_NOTE_NUMBER"];
                cmd.Parameters.Add("P_LOCK_SALES", OracleDbType.Varchar2).Value = pDataList["LOCK_SALES"];
                cmd.Parameters.Add("P_LAST_UPD_PGM", OracleDbType.Varchar2).Value = "SNM001P_M_MC";
                cmd.Parameters.Add("P_LAST_UPD_BY", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("P_IP_ADDRESS", OracleDbType.Varchar2).Value = "207.1.1.1";
                cmd.Parameters.Add("C_RETRUN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));

            }

            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM001P_M_MC_SavePartMasterDomestic");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));

            }
        }

        [HttpGet, Route("SNM001P_M_MC_GetSPPSCode/{SPPSCode}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult SNM001P_M_MC_GetSPPSCode(string SPPSCode, int noofshowrec)
        {
            DataSet ds = new DataSet();

            SPPSCode = ismoUtil.escapeCharacter(SPPSCode);

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNM001P_M_GET_SPPS";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("p_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
            cmd.Parameters.Add("c_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }


        [HttpGet, Route("GetPermissionPartsMaster")]
        [Authorize]
        public IHttpActionResult GetPermissionPartsMaster()
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_MT_PERMISSION_PARTS";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE); ;
            cmd.Parameters.Add("P_SYSTEM_USER",OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
            cmd.Parameters.Add("P_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }



        [HttpGet, Route("GetTrackLog/{type}/{remarks}")]
        [Authorize]
        public IHttpActionResult GetTrackLog(string type, string remarks)
        {
            try
            {
                DataSet ds = new DataSet();
                type = ismoUtil.escapeCharacter(type);
                remarks = ismoUtil.escapeCharacter(remarks);
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_GET_TRACK_LOG";
                cmd.Parameters.Add("P_LOG_TYPE", OracleDbType.Varchar2).Value = type;
                cmd.Parameters.Add("P_REMARKS", OracleDbType.Varchar2).Value = remarks;
                cmd.Parameters.Add("C_RETRUN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "GetTrackLog");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        #region SNM136P

        [HttpGet, Route("SNM136P_GET_PACKAGE/{packageName}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult SNM136P_GET_PACKAGE(string packageName, int noofshowrec)
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNM136P_GET_DATA_PACKAGE";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_PACKAGE_NAME", OracleDbType.Varchar2).Value = packageName.ToUpper() != "NULL" ? packageName : "";
            cmd.Parameters.Add("p_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
            cmd.Parameters.Add("c_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));
        }

        [HttpPost, Route("SNM136P_GET_DATA")]
        [Authorize]
        public IHttpActionResult SNM136P_GET_DATA([FromBody] dynamic pParam)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();

            try
            {
                cmd.CommandText = "SP_NP_SNM136P_GET_DATA";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_PACKAGE_NAME", OracleDbType.Varchar2).Value = pParam.PACKAGE_NAME;
                cmd.Parameters.Add("P_PACKAGE_STATUS", OracleDbType.Varchar2).Value = pParam.PACKAGE_STATUS;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM136P_GET_DATA");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }

        }

        [HttpPost, Route("SNM136P_INSERT")]
        [Authorize]
        // [RunBatchGuard]
        public IHttpActionResult SNM136P_INSERT([FromBody] dynamic pData)
        {
            try
            {
                DataSet ds = new DataSet();
                OracleCommand cmd = new OracleCommand();

                cmd.CommandText = "SP_NP_SNM136P_INSERT";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_PACKAGE_NAME", OracleDbType.Varchar2).Value = pData.PACKAGE_NAME;
                cmd.Parameters.Add("P_PACKAGE_STATUS", OracleDbType.Varchar2).Value = pData.PACKAGE_STATUS;
                cmd.Parameters.Add("P_LAST_UPD_PGM", OracleDbType.Varchar2).Value = "SNM136P";
                cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM136P_INSERT");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpPost, Route("SNM136P_UPDATE")]
        [Authorize]
        // [RunBatchGuard]
        public IHttpActionResult SNM136P_UPDATE([FromBody] dynamic pData)
        {
            try
            {
                DataSet ds = new DataSet();
                OracleCommand cmd = new OracleCommand();

                cmd.CommandText = "SP_NP_SNM136P_UPDATE";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_PACK_NO", OracleDbType.Varchar2).Value = pData.PACK_NO;
                cmd.Parameters.Add("P_PACKAGE_NAME", OracleDbType.Varchar2).Value = pData.PACKAGE_NAME;
                cmd.Parameters.Add("P_PACKAGE_STATUS", OracleDbType.Varchar2).Value = pData.PACKAGE_STATUS;
                cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM136P_UPDATE");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpPost, Route("SNM136P_Delete")]
        [Authorize]
        // [RunBatchGuard]
        public IHttpActionResult SNM136P_Delete([FromBody] dynamic pData)
        {
            try
            {
                DataSet ds = new DataSet();
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNM136P_DELETE";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_PACK_NO", OracleDbType.Varchar2).Value = pData.PACK_NO;
                cmd.Parameters.Add("P_PACKAGE_NAME", OracleDbType.Varchar2).Value = pData.PACKAGE_NAME;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM136P_Delete");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex));
            }
        }
        #endregion

        #region SNM137P

        [HttpGet, Route("SNM137P_GET_PART_NO/{partNo}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult SNM137P_GET_PART_NO(string partNo, int noofshowrec)
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNM137P_GET_PART_NO";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = partNo.ToUpper() != "NULL" ? partNo : "";
            cmd.Parameters.Add("p_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
            cmd.Parameters.Add("c_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));
        }

        [HttpGet, Route("SNM137P_GET_PART_NO_NON_DUP/{partNo}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult SNM137P_GET_PART_NO_NON_DUP(string partNo, int noofshowrec)
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNM137P_GET_PART_NO_NON";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = partNo.ToUpper() != "NULL" ? partNo : "";
            cmd.Parameters.Add("p_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
            cmd.Parameters.Add("c_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));
        }

        [HttpGet, Route("SNM137P_GET_PACKAGE/{packageName}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult SNM137P_GET_PACKAGE(string packageName, int noofshowrec)
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNM137P_GET_PACKAGE";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_PACKAGE_NAME", OracleDbType.Varchar2).Value = packageName.ToUpper() != "NULL" ? packageName : "";
            cmd.Parameters.Add("p_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
            cmd.Parameters.Add("c_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));
        }

        [HttpPost, Route("SNM137P_GET_DATA")]
        [Authorize]
        public IHttpActionResult SNM137P_GET_DATA([FromBody] dynamic pParam)
        {
            try
            {
                DataSet ds = new DataSet();
                OracleCommand cmd = new OracleCommand();

                cmd.CommandText = "SP_NP_SNM137P_GET_DATA";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = pParam.PART_NO;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM137P_GET_DATA");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpPost, Route("SNM137P_INSERT")]
        [Authorize]
        // [RunBatchGuard]
        public IHttpActionResult SNM137P_INSERT([FromBody] dynamic pData)
        {
            try
            {
                DataSet ds = new DataSet();
                OracleCommand cmd = new OracleCommand();

                cmd.CommandText = "SP_NP_SNM137P_INSERT";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = pData.PART_NO;
                cmd.Parameters.Add("P_PACKAGE_QTY", OracleDbType.Varchar2).Value = pData.PACKAGE_QTY;
                cmd.Parameters.Add("P_PACKAGE_UNIT", OracleDbType.Varchar2).Value = pData.PACKAGE_UNIT;
                cmd.Parameters.Add("P_PACKAGE_CAPACITY", OracleDbType.Varchar2).Value = pData.PACKAGE_CAPACITY;
                cmd.Parameters.Add("P_PACKAGE_CAP_NAME", OracleDbType.Varchar2).Value = pData.PACKAGE_CAP_NAME;
                cmd.Parameters.Add("P_DMS_RCV_SALE_UNIT", OracleDbType.Varchar2).Value = pData.DMS_RCV_SALE_UNIT;
                cmd.Parameters.Add("P_DMS_PUR_PACKAGE_NAME", OracleDbType.Varchar2).Value = pData.DMS_PUR_PACKAGE_NAME;
                cmd.Parameters.Add("P_DMS_PUR_PACKAGE_UNIT", OracleDbType.Varchar2).Value = pData.DMS_PUR_PACKAGE_UNIT;
                cmd.Parameters.Add("P_LAST_UPD_PGM", OracleDbType.Varchar2).Value = "SNM137P";
                cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("P_ATTRIBUTE1", OracleDbType.Varchar2).Value = pData.ATTRIBUTE1;
                cmd.Parameters.Add("P_ATTRIBUTE2", OracleDbType.Varchar2).Value = pData.ATTRIBUTE2;
                cmd.Parameters.Add("P_ATTRIBUTE3", OracleDbType.Varchar2).Value = pData.ATTRIBUTE3;
                cmd.Parameters.Add("P_ATTRIBUTE4", OracleDbType.Varchar2).Value = pData.ATTRIBUTE4;
                cmd.Parameters.Add("P_ATTRIBUTE5", OracleDbType.Varchar2).Value = pData.ATTRIBUTE5;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM137P_INSERT");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpPost, Route("SNM137P_UPDATE")]
        [Authorize]
        // [RunBatchGuard]
        public IHttpActionResult SNM137P_UPDATE([FromBody] dynamic pData)
        {
            try
            {
                DataSet ds = new DataSet();
                OracleCommand cmd = new OracleCommand();

                cmd.CommandText = "SP_NP_SNM137P_UPDATE";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = pData.PART_NO;
                cmd.Parameters.Add("P_PACKAGE_UNIT", OracleDbType.Varchar2).Value = pData.PACKAGE_UNIT;
                cmd.Parameters.Add("P_DMS_RCV_SALE_UNIT", OracleDbType.Varchar2).Value = pData.DMS_RCV_SALE_UNIT;
                cmd.Parameters.Add("P_DMS_PUR_PACKAGE_NAME", OracleDbType.Varchar2).Value = pData.DMS_PUR_PACKAGE_NAME;
                cmd.Parameters.Add("P_LAST_UPD_PGM", OracleDbType.Varchar2).Value = "SNM137P";
                cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM137P_UPDATE");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpPost, Route("SNM137P_Delete")]
        [Authorize]
        // [RunBatchGuard]
        public IHttpActionResult SNM137P_Delete([FromBody] dynamic pData)
        {
            try
            {
                DataSet ds = new DataSet();
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNM137P_DELETE";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = pData.PART_NO;
                cmd.Parameters.Add("P_LAST_UPD_PGM", OracleDbType.Varchar2).Value = "SNM137P";
                cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM137P_Delete");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex));
            }
        }
        #endregion
        #region SNM140P

        [HttpGet, Route("SNM140P_GetPartSearch/{partNo}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult SNM137P_GetPartSearch(string partNo, int noofshowrec)
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNM140P_GET_PART_SEARCH";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = partNo.ToUpper() != "NULL" ? partNo : "";
            //cmd.Parameters.Add("p_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
            cmd.Parameters.Add("c_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));
        }

        [HttpGet, Route("SNM140P_GetPartAdd/{partNo}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult SNM140P_GetPartAdd(string partNo, int noofshowrec)
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNM140P_GET_PART_ADD";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = partNo.ToUpper() != "NULL" ? partNo : "";
            //cmd.Parameters.Add("p_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
            cmd.Parameters.Add("c_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));
        }

        [HttpPost, Route("SNM140P_GetData")]
        [Authorize]
        public IHttpActionResult SNM140P_GetData([FromBody] dynamic param)
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNM140P_GET_DATA";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = param.PART_NO;
            cmd.Parameters.Add("c_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));
        }

        [HttpPost, Route("SNM140P_Insert")]
        [Authorize]
        // [RunBatchGuard]
        public IHttpActionResult SNM140P_Insert([FromBody] dynamic param)
        {
            DataSet ds = new DataSet();

            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNM140P_INSERT";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = param.PART_NO;
                cmd.Parameters.Add("P_ISSUE_FLAG", OracleDbType.Varchar2).Value = param.ISSUE_FLAG;
                cmd.Parameters.Add("P_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("R_STATUS", OracleDbType.Varchar2, 1000).Direction = ParameterDirection.Output;
                cmd.Parameters.Add("R_MESSAGE", OracleDbType.Varchar2, 1000).Direction = ParameterDirection.Output;

                cmd = oOracledb.SqlQueryReturnValue(cmd);

                string R_STATUS = cmd.Parameters["R_STATUS"].Value.ToString();
                string R_MESSAGE = cmd.Parameters["R_MESSAGE"].Value.ToString();

                if (R_STATUS == "FAIL")
                {
                    oOracledb.WriteLog("ErrorHandle", R_MESSAGE, "SNM140P_Insert");
                }

                return Json(new { STATUS_MSG = R_STATUS, });
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM140P_Insert");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }

        }

        [HttpPost, Route("SNM140P_Update")]
        [Authorize]
        // [RunBatchGuard]
        public IHttpActionResult SNM140P_Update([FromBody] dynamic param)
        {
            DataSet ds = new DataSet();

            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNM140P_UPDATE";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = param.PART_NO;
                cmd.Parameters.Add("P_ISSUE_FLAG", OracleDbType.Varchar2).Value = param.ISSUE_FLAG;
                cmd.Parameters.Add("P_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("R_STATUS", OracleDbType.Varchar2, 1000).Direction = ParameterDirection.Output;
                cmd.Parameters.Add("R_MESSAGE", OracleDbType.Varchar2, 1000).Direction = ParameterDirection.Output;

                cmd = oOracledb.SqlQueryReturnValue(cmd);

                string R_STATUS = cmd.Parameters["R_STATUS"].Value.ToString();
                string R_MESSAGE = cmd.Parameters["R_MESSAGE"].Value.ToString();

                if (R_STATUS == "FAIL")
                {
                    oOracledb.WriteLog("ErrorHandle", R_MESSAGE, "SNM140P_Update");
                }

                return Json(new { STATUS_MSG = R_STATUS, });
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM140P_Update");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }

        }

        [HttpPost, Route("SNM140P_Delete")]
        [Authorize]
        // [RunBatchGuard]
        public IHttpActionResult SNM140P_Delete([FromBody] dynamic param)
        {
            DataSet ds = new DataSet();

            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNM140P_DELETE";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = param.PART_NO;
                cmd.Parameters.Add("P_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("R_STATUS", OracleDbType.Varchar2, 1000).Direction = ParameterDirection.Output;
                cmd.Parameters.Add("R_MESSAGE", OracleDbType.Varchar2, 1000).Direction = ParameterDirection.Output;

                cmd = oOracledb.SqlQueryReturnValue(cmd);

                string R_STATUS = cmd.Parameters["R_STATUS"].Value.ToString();
                string R_MESSAGE = cmd.Parameters["R_MESSAGE"].Value.ToString();

                if (R_STATUS == "FAIL")
                {
                    oOracledb.WriteLog("ErrorHandle", R_MESSAGE, "SNM140P_Update");
                }

                return Json(new { STATUS_MSG = R_STATUS, });
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM140P_Update");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }

        }

        [HttpPost, Route("SNM140P_UploadFile")]
        [Authorize]
        public async Task<IHttpActionResult> SNM140P_UploadFile(HttpRequestMessage request)
        {

            try
            {
                if (!request.Content.IsMimeMultipartContent())
                {
                    throw new HttpResponseException(HttpStatusCode.UnsupportedMediaType);
                }
                var reqParts = await request.Content.ReadAsMultipartAsync();
                byte[] buffer = null;
                foreach (var file in reqParts.Contents)
                {
                    buffer = file.ReadAsByteArrayAsync().Result;
                }
                MemoryStream stream = new MemoryStream(buffer);
                DataTable dt = new DataTable();
                dt = ValidateData(stream);
                
                return Json(DTFM.convertToList(dt));

            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM140P_UploadFile");
                throw new HttpResponseException(HttpStatusCode.NotAcceptable);
            }

            throw new Exception("Something wrong");
            
        }

        public DataTable ValidateData(MemoryStream stream)
        {
            DataTable dt = new DataTable();
            SystemApiController sys = new SystemApiController();
            dt = sys.ReadDataExcel(stream);
            dt.Columns.Add("SEQ");
            dt.Columns.Add("CHECK");
            dt.Columns.Add("MSG");
            dt.Columns.Add("PART_NAME_EN");
            dt.Columns.Add("VENDOR_CODE");
            dt.Columns.Add("FLAG");
            int iCount = 0;
            Hashtable hTable = new Hashtable();
            OracleCommand cmd = new OracleCommand();
            foreach (DataRow row in dt.Rows)
            {
                
                if (!string.IsNullOrEmpty(row["PART_NO"].ToString()))
                {
                    iCount++;
                    cmd = new OracleCommand();
                    cmd.CommandText = "SP_NP_SNM140P_VALIDATE";
                    cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                    cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = row["PART_NO"].ToString().Trim();
                    cmd.Parameters.Add("R_PART_NAME_EN", OracleDbType.Varchar2, 100).Direction = ParameterDirection.Output;
                    cmd.Parameters.Add("R_VENDOR_CODE", OracleDbType.Varchar2, 10).Direction = ParameterDirection.Output;
                    cmd.Parameters.Add("R_ERROR", OracleDbType.Varchar2, 1000).Direction = ParameterDirection.Output;
                    cmd.Parameters.Add("R_ERROR_FLAG", OracleDbType.Varchar2, 10).Direction = ParameterDirection.Output;

                    cmd = oOracledb.SqlQueryReturnValue(cmd);
                    row["PART_NO"] = row["PART_NO"].ToString().Trim();
                    row["PART_NAME_EN"] = cmd.Parameters["R_PART_NAME_EN"].Value;
                    row["VENDOR_CODE"] = cmd.Parameters["R_VENDOR_CODE"].Value;
                    row["MSG"] = cmd.Parameters["R_ERROR"].Value.ToString() == "null" ? string.Empty : cmd.Parameters["R_ERROR"].Value;
                    row["FLAG"] = cmd.Parameters["R_ERROR_FLAG"].Value;
                    row["SEQ"] = iCount;

                    if (string.IsNullOrEmpty(row["ISSUE_FLAG"].ToString()))
                    {
                        row["MSG"] = "Please input OH or TF in colum ISSUE_FLAG";
                        row["FLAG"] = "Y";
                    }
                    else
                    {
                        if (row["ISSUE_FLAG"].ToString() != "OH" && row["ISSUE_FLAG"].ToString() != "TF")
                        {
                            row["MSG"] = "Please input OH or TF in colum ISSUE_FLAG";
                            row["FLAG"] = "Y";
                        }
                    }

                    if (hTable.Contains(row["PART_NO"].ToString().Trim()))
                    {
                        row["SEQ"] = iCount;
                        row["MSG"] = "Duplicate Part No at Seq " + hTable[row["PART_NO"]];
                        row["FLAG"] = "Y";
                  
                    }
                    else
                    {
                        hTable.Add(row["PART_NO"].ToString().Trim(), iCount);
                    }
                }

            }

            return dt;
        }



        [HttpPost, Route("SNM140P_SaveUpload")]
        [Authorize]
        public IHttpActionResult SNM140P_SaveUpload([FromBody] dynamic[] data)
        {

            DataSet ds = new DataSet();
            DataTable dt = new DataTable();

            OracleCommand cmd = new OracleCommand();
            int iCount = 0;
            try
            {

                foreach (dynamic d in data)
                {
                    iCount++;
                    cmd = new OracleCommand();
                    cmd.CommandText = "SP_NP_SNM140P_SAVE_TEMP";
                    cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                    cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = d["PART_NO"];
                    cmd.Parameters.Add("P_ISSUE_FLAG", OracleDbType.Varchar2).Value = d["ISSUE_FLAG"];
                    cmd.Parameters.Add("P_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                    cmd.Parameters.Add("P_CLEAR_DATA", OracleDbType.Varchar2).Value = iCount == 1 ? "Y" : "N";
                    cmd = oOracledb.SqlQueryReturnValue(cmd);
                }
                cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNM140P_SAVE_UPLOAD";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("R_STATUS", OracleDbType.Varchar2, 50).Direction = ParameterDirection.Output;
                cmd.Parameters.Add("R_MESSAGE", OracleDbType.Varchar2, 50).Direction = ParameterDirection.Output;

                cmd = oOracledb.SqlQueryReturnValue(cmd);
                string r_status = cmd.Parameters["R_STATUS"].Value.ToString();
                string r_msg = cmd.Parameters["R_MESSAGE"].Value.ToString();

                if (r_status != "DONE")
                {
                    oOracledb.WriteLog("ErrorHandle", r_msg, "SNM140P_SaveUpload");
                }

                return Json(new { STATUS = r_status, MESSAGE = r_msg });
            }
            catch (Exception ex)
            {
                //--- Roll back ---
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM140P_SaveUpload");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }

            //return Json(data);
        }


        #endregion
        #region SNM138P

        [HttpGet, Route("SNM138P_GetRegionCode/{regionCode}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult SNM138P_GetRegionCode(string regionCode, int noofshowrec)
        {
            try
            {
                DataSet ds = new DataSet();

                regionCode = ismoUtil.escapeCharacter(regionCode);

                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNM138P_GET_REGION_CODE";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_REGION_CODE", OracleDbType.Varchar2).Value = regionCode.ToUpper() == "NULL" ? (object)DBNull.Value : regionCode;
                cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM138P_GetRegionCode");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }

        }

        [HttpPost, Route("SNM138P_GetData")]
        [Authorize]
        public IHttpActionResult SNM138P_GetData([FromBody] dynamic data)
        {
            try
            {
                DataSet ds = new DataSet();

                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNM138P_GET_DATA";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_COUNTRY_CODE", OracleDbType.Varchar2).Value = data["COUNTRY_CODE"];
                cmd.Parameters.Add("P_REGION_CODE", OracleDbType.Varchar2).Value = data["REGION_CODE"];
                cmd.Parameters.Add("P_REGION_NAME_EN", OracleDbType.Varchar2).Value = data["REGION_NAME_EN"];
                cmd.Parameters.Add("C_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM138P_GetData");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpPost, Route("SNM138P_INSERT")]
        [Authorize]
        public IHttpActionResult SNM138P_INSERT([FromBody] dynamic pData)
        {
            try
            {
                DataSet ds = new DataSet();
                OracleCommand cmd = new OracleCommand();

                cmd.CommandText = "SP_NP_SNM138P_INSERT";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_REGION_CODE", OracleDbType.Varchar2).Value = pData.REGION_CODE;
                cmd.Parameters.Add("P_REGION_NAME_EN", OracleDbType.Varchar2).Value = pData.REGION_NAME_EN;
                cmd.Parameters.Add("P_REGION_NAME_TH", OracleDbType.Varchar2).Value = pData.REGION_NAME_TH;
                cmd.Parameters.Add("P_COUNTRY_CODE", OracleDbType.Varchar2).Value = pData.COUNTRY_CODE;
                cmd.Parameters.Add("P_LAST_UPD_PGM", OracleDbType.Varchar2).Value = "SNM138P";
                cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("P_ATTRIBUTE1", OracleDbType.Varchar2).Value = pData.ATTRIBUTE1;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM138P_INSERT");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpPost, Route("SNM138P_UPDATE")]
        [Authorize]
        public IHttpActionResult SNM138P_UPDATE([FromBody] dynamic pData)
        {
            try
            {
                DataSet ds = new DataSet();
                OracleCommand cmd = new OracleCommand();

                cmd.CommandText = "SP_NP_SNM138P_UPDATE";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_REGION_CODE", OracleDbType.Varchar2).Value = pData.REGION_CODE;
                cmd.Parameters.Add("P_REGION_NAME_EN", OracleDbType.Varchar2).Value = pData.REGION_NAME_EN;
                cmd.Parameters.Add("P_REGION_NAME_TH", OracleDbType.Varchar2).Value = pData.REGION_NAME_TH;
                cmd.Parameters.Add("P_COUNTRY_CODE", OracleDbType.Varchar2).Value = pData.COUNTRY_CODE;
                cmd.Parameters.Add("P_LAST_UPD_PGM", OracleDbType.Varchar2).Value = "SNM138P";
                cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM138P_UPDATE");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpPost, Route("SNM138P_Delete")]
        [Authorize]
        public IHttpActionResult SNM138P_Delete([FromBody] dynamic pDataList)
        {
            try
            {
                DataSet ds = new DataSet();

                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNM138P_DELETE";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_REGION_CODE", OracleDbType.Varchar2).Value = pDataList.REGION_CODE;
                cmd.Parameters.Add("P_COUNTRY_CODE", OracleDbType.Varchar2).Value = pDataList.COUNTRY_CODE;
                cmd.Parameters.Add("P_CREATE_BY", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("P_LAST_UPD_PGM", OracleDbType.Varchar2).Value = "SNM138P";
                cmd.Parameters.Add("P_LAST_UPD_BY", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("P_LAST_IP_ADDR", OracleDbType.Varchar2).Value = HttpContext.Current.Request.UserHostAddress.ToString();
                cmd.Parameters.Add("C_RE", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM138P_Delete");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }

        }

        #endregion
		
		#region SNM139P

        [HttpPost, Route("SNM139P_GET_REGION/{regionCode}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult SNM139P_GET_REGION(string regionCode, int noofshowrec, [FromBody] dynamic Pparam)
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNM139P_GET_REGION";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_REGION_CODE", OracleDbType.Varchar2).Value = regionCode.ToUpper() != "NULL" ? regionCode : "";
            cmd.Parameters.Add("P_COUNTRY_CODE", OracleDbType.Varchar2).Value = Pparam.COUNTRY_CODE;
            cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
            cmd.Parameters.Add("C_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));
        }

        [HttpPost, Route("SNM139P_GET_ZONE_AREA/{zoneAreaCode}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult SNM139P_GET_ZONE_AREA(string zoneAreaCode, int noofshowrec, [FromBody] dynamic Pparam)
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNM139P_GET_ZONE_AREA";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_ZONE_AREA_CODE", OracleDbType.Varchar2).Value = zoneAreaCode.ToUpper() != "NULL" ? zoneAreaCode : "";
            cmd.Parameters.Add("P_COUNTRY_CODE", OracleDbType.Varchar2).Value = Pparam.COUNTRY_CODE;
            cmd.Parameters.Add("P_REGION_CODE", OracleDbType.Varchar2).Value = Pparam.REGION_CODE;
            cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
            cmd.Parameters.Add("C_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));
        }

        [HttpGet, Route("SNM139P_GET_SALESMAN/{param}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult SNM139P_GET_SALESMAN(string param, int noofshowrec)
        {
            DataSet ds = new DataSet();
            param = ismoUtil.escapeCharacter(param);

            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNM139P_GET_SALESMAN";
                cmd.Parameters.Add("p_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_SALESMAN", OracleDbType.Varchar2).Value = param.ToUpper() == "NULL" ? (object)DBNull.Value : param;
                cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "GetSalesMan");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex));
            }
        }

        [HttpPost, Route("SNM139P_GET_DATA")]
        [Authorize]
        public IHttpActionResult SNM139P_GET_DATA([FromBody] dynamic pParam)
        {
            try
            {
                DataSet ds = new DataSet();
                OracleCommand cmd = new OracleCommand();

                cmd.CommandText = "SP_NP_SNM139P_GET_DATA";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_COUNTRY_CODE", OracleDbType.Varchar2).Value = pParam.COUNTRY_CODE;
                cmd.Parameters.Add("P_REGION_CODE", OracleDbType.Varchar2).Value = pParam.REGION_CODE;
                cmd.Parameters.Add("P_ZONE_AREA_CODE", OracleDbType.Varchar2).Value = pParam.ZONE_AREA_CODE;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM139P_GET_DATA");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpPost, Route("SNM139P_INSERT")]
        [Authorize]
        public IHttpActionResult SNM139P_INSERT([FromBody] dynamic pData)
        {
            try
            {
                DataSet ds = new DataSet();
                OracleCommand cmd = new OracleCommand();

                cmd.CommandText = "SP_NP_SNM139P_INSERT";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_REGION_CODE", OracleDbType.Varchar2).Value = pData.REGION_CODE;
                cmd.Parameters.Add("P_COUNTRY_CODE", OracleDbType.Varchar2).Value = pData.COUNTRY_CODE;
                cmd.Parameters.Add("P_ZONE_AREA_CODE", OracleDbType.Varchar2).Value = pData.ZONE_AREA_CODE;
                cmd.Parameters.Add("P_ZONE_AREA_EN", OracleDbType.Varchar2).Value = pData.ZONE_AREA_EN;
                cmd.Parameters.Add("P_ZONE_AREA_TH", OracleDbType.Varchar2).Value = pData.ZONE_AREA_TH;
                cmd.Parameters.Add("P_SALESMAN_CODE", OracleDbType.Varchar2).Value = pData.SALESMAN_CODE;
                cmd.Parameters.Add("P_LAST_UPD_PGM", OracleDbType.Varchar2).Value = "SNM139P";
                cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("P_ATTRIBUTE1", OracleDbType.Varchar2).Value = pData.ATTRIBUTE1;
                cmd.Parameters.Add("P_ATTRIBUTE2", OracleDbType.Varchar2).Value = pData.ATTRIBUTE2;
                cmd.Parameters.Add("P_ATTRIBUTE3", OracleDbType.Varchar2).Value = pData.ATTRIBUTE3;
                cmd.Parameters.Add("P_ATTRIBUTE4", OracleDbType.Varchar2).Value = pData.ATTRIBUTE4;
                cmd.Parameters.Add("P_ATTRIBUTE5", OracleDbType.Varchar2).Value = pData.ATTRIBUTE5;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM139P_INSERT");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpPost, Route("SNM139P_UPDATE")]
        [Authorize]
        public IHttpActionResult SNM139P_UPDATE([FromBody] dynamic pData)
        {
            try
            {
                DataSet ds = new DataSet();
                OracleCommand cmd = new OracleCommand();

                cmd.CommandText = "SP_NP_SNM139P_UPDATE";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_REGION_CODE", OracleDbType.Varchar2).Value = pData.REGION_CODE;
                cmd.Parameters.Add("P_REGION_OLD", OracleDbType.Varchar2).Value = pData.REGION_OLD;
                cmd.Parameters.Add("P_COUNTRY_CODE", OracleDbType.Varchar2).Value = pData.COUNTRY_CODE;
                cmd.Parameters.Add("P_COUNTRY_OLD", OracleDbType.Varchar2).Value = pData.COUNTRY_OLD;
                cmd.Parameters.Add("P_ZONE_AREA_CODE", OracleDbType.Varchar2).Value = pData.ZONE_AREA_CODE;
                cmd.Parameters.Add("P_ZONE_AREA_EN", OracleDbType.Varchar2).Value = pData.ZONE_AREA_EN;
                cmd.Parameters.Add("P_ZONE_AREA_TH", OracleDbType.Varchar2).Value = pData.ZONE_AREA_TH;
                cmd.Parameters.Add("P_SALESMAN_CODE", OracleDbType.Varchar2).Value = pData.SALESMAN_CODE;
                cmd.Parameters.Add("P_LAST_UPD_PGM", OracleDbType.Varchar2).Value = "SNM139P";
                cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM139P_UPDATE");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpPost, Route("SNM139P_DELETE")]
        [Authorize]
        public IHttpActionResult SNM139P_DELETE([FromBody] dynamic pData)
        {
            try
            {
                DataSet ds = new DataSet();
                OracleCommand cmd = new OracleCommand();

                cmd.CommandText = "SP_NP_SNM139P_DELETE";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_ZONE_AREA_CODE", OracleDbType.Varchar2).Value = pData.ZONE_AREA_CODE;
                cmd.Parameters.Add("P_COUNTRY_CODE", OracleDbType.Varchar2).Value = pData.COUNTRY_CODE;
                cmd.Parameters.Add("P_REGION_CODE", OracleDbType.Varchar2).Value = pData.REGION_CODE;
                cmd.Parameters.Add("P_LAST_UPD_PGM", OracleDbType.Varchar2).Value = "SNM139P";
                cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM139P_UPDATE");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        #endregion

        [HttpPost, Route("SADM001_GetData")]
        [Authorize]
        public IHttpActionResult SADM001_GetData([FromBody] dynamic param)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SADM001_GET_DATA";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = param.PART_NO;
            cmd.Parameters.Add("P_YEAR_MONTH", OracleDbType.Varchar2).Value = param.YEAR_MONTH;
            cmd.Parameters.Add("c_Return_1", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            cmd.Parameters.Add("c_Return_2", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            cmd.Parameters.Add("c_Return_3", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            cmd.Parameters.Add("c_Return_4", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            cmd.Parameters.Add("c_Return_5", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));
        }

        [HttpGet, Route("GetCaseNumber/{caseGroup}/{caseNo}")]
        [Authorize]
        public IHttpActionResult GetCaseNumber(string caseGroup, string caseNo)
        {
            try {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_CASE_RUNNING_NUMBER";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_CASE_GROUP", OracleDbType.Varchar2).Value = caseGroup;
                cmd.Parameters.Add("R_CASE_NO", OracleDbType.Varchar2, 5, ParameterDirection.InputOutput).Value = caseNo;
                cmd.Parameters.Add("R_PRINT_DATE", OracleDbType.Date).Direction = ParameterDirection.Output;

                cmd = oOracledb.SqlQueryReturnValue(cmd);

                string caseNumber = cmd.Parameters["R_CASE_NO"].Value.ToString();
                DateTime printDate = Convert.ToDateTime(cmd.Parameters["R_PRINT_DATE"].Value.ToString());
                return Json(new { Result = "Done", CaseNo = caseNumber, PrintDate = printDate });
            }
            catch (OracleException ex)
            {
                if (ex.Number == 20001)
                {
                    string oracleMessage = oOracledb.GetErrorMessage(ex);
                    return Json(new { Result = "Fail", Message = oracleMessage });
                }

                throw (ex);
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "GetCaseNumber");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }

        }
        #region SNM143P

        [HttpPost, Route("SNM143P_GetData")]
        [Authorize]
        public IHttpActionResult SNM143P_GetData([FromBody] dynamic pData)
        {
            try
            {
                DataSet ds = new DataSet();

                OracleCommand cmd = new OracleCommand();

                cmd.CommandText = "SP_NP_SNM143P_GET_DATA";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = pData["PART_NO"];
                cmd.Parameters.Add("C_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            } 
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM143P_GetData");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
            
        }
        
        [HttpPost, Route("SNM143P_Insert")]
        [Authorize]
        public IHttpActionResult SNM143P_Insert([FromBody] dynamic pData)
        {
            try
            {
                DataSet ds = new DataSet();

                OracleCommand cmd = new OracleCommand();

                cmd.CommandText = "SP_NP_SNM143P_INSERT";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = pData["PART_NO"];
                cmd.Parameters.Add("P_LOT_QTY", OracleDbType.Varchar2).Value = pData["LOT_QTY"];
                cmd.Parameters.Add("P_LAST_UPD_PGM", OracleDbType.Varchar2).Value = "SNM143P";
                cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("C_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            } 
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM143P_Insert");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
            
        }

        [HttpPost, Route("SNM143P_Update")]
        [Authorize]
        public IHttpActionResult SNM143P_Update([FromBody] dynamic pData)
        {
            try
            {
                DataSet ds = new DataSet();

                OracleCommand cmd = new OracleCommand();

                cmd.CommandText = "SP_NP_SNM143P_UPDATE";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = pData["PART_NO"];
                cmd.Parameters.Add("P_LOT_QTY", OracleDbType.Varchar2).Value = pData["LOT_QTY"];
                cmd.Parameters.Add("P_LAST_UPD_PGM", OracleDbType.Varchar2).Value = "SNM143P";
                cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("C_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            } 
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM143P_Update");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
            
        }

        [HttpPost, Route("SNM143P_UploadMultiParts")]
        [Authorize]
        public async Task<IHttpActionResult> SNM143P_UploadMultiParts(HttpRequestMessage request)
        {
            if (!request.Content.IsMimeMultipartContent())
            {
                throw new HttpResponseException(HttpStatusCode.UnsupportedMediaType);
            }
            var reqParts = await request.Content.ReadAsMultipartAsync();

            try
            {
                DataSet ds = new DataSet();
                DataTable dt = new DataTable();
                string USER_ID = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                var file = reqParts.Contents[0];

                var buffer = await file.ReadAsByteArrayAsync();
                string gFileName = file.Headers.ContentDisposition.FileName.Trim('\"');
                string name = Path.GetFileNameWithoutExtension(gFileName);
                string ext = Path.GetExtension(gFileName);
                string gFileNameExtend = String.Concat(name, '_', USER_ID, ext);
                string gRootPath = ConfigurationManager.AppSettings["RootSharedPath"].ToString();
                string gUploadLication = System.IO.Path.Combine(gRootPath, "tempFile/SNM143P");
                string gFileLocation = System.IO.Path.Combine(gUploadLication, gFileName);

                DataService.SaveBytesToFileByLocation(buffer
                                                , gUploadLication
                                                , gFileLocation);

                SystemApiController sys = new SystemApiController();
                //dt = sys.ReadDataExcel(gFileLocation);
                dt = SNM143P_ValidateData(gFileLocation);
                return Json(DTFM.convertToList(dt));

            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM143P_UploadFile");
                throw new HttpResponseException(HttpStatusCode.NotAcceptable);
            }

            throw new Exception("Something wrong");

        }

        public DataTable SNM143P_ValidateData(string filelocation)
        {
            DataTable dt = new DataTable();
            SystemApiController sys = new SystemApiController();
            dt = sys.ReadDataExcel(filelocation);
            dt.Columns.Add("SEQ");
            dt.Columns.Add("PART_NAME_EN");
            dt.Columns.Add("MSG");
            dt.Columns.Add("ERR_FLAG");
            dt.Columns.Add("ERR_FLAG_PART");

            int iCount = 0;
            Hashtable hTable = new Hashtable();

            foreach (DataRow row in dt.Rows)
            {

                OracleCommand cmd = new OracleCommand();
                if (!string.IsNullOrEmpty(row["PART_NO"].ToString()))
                {
                    iCount++;

                    try
                    {
                        cmd = new OracleCommand();
                        cmd.CommandText = "SP_NP_SNM143P_VALIDATE_PART";
                        cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                        cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = row["PART_NO"];
                        cmd.Parameters.Add("R_PART_NAME", OracleDbType.Varchar2, 500).Direction = ParameterDirection.Output;
                        cmd.Parameters.Add("R_ERROR_FLAG", OracleDbType.Varchar2, 500).Direction = ParameterDirection.Output;
                        cmd.Parameters.Add("R_ERROR_FLAG_PART_NO", OracleDbType.Varchar2, 500).Direction = ParameterDirection.Output;
                        cmd.Parameters.Add("R_ERROR_MESSAGE", OracleDbType.Varchar2, 1000).Direction = ParameterDirection.Output;                        

                        cmd = oOracledb.SqlQueryReturnValue(cmd);

                        string PART_NAME_EN = cmd.Parameters["R_PART_NAME"].Value.ToString() == "null" ? "" : cmd.Parameters["R_PART_NAME"].Value.ToString();
                        string ERROR_FLAG = cmd.Parameters["R_ERROR_FLAG"].Value.ToString();
                        string ERROR_FLAG_PART_NO = cmd.Parameters["R_ERROR_FLAG_PART_NO"].Value.ToString();

                        //row["MSG"] = cmd.Parameters["C_RETURN_MSG"].Value.ToString();

                        row["SEQ"] = iCount;
                        row["PART_NAME_EN"] = PART_NAME_EN;
                        row["ERR_FLAG"] = ERROR_FLAG;
                        row["ERR_FLAG_PART"] = ERROR_FLAG_PART_NO;

                        if (cmd.Parameters["R_ERROR_MESSAGE"].Value.ToString() == "null")
                        {
                            row["MSG"] = DBNull.Value;
                        }
                        else
                        {
                            row["MSG"] = cmd.Parameters["R_ERROR_MESSAGE"].Value;
                        }

                        int n;
                        bool isNumeric = int.TryParse(row["LOT_QTY"].ToString().Trim(), out n);

                        if (!isNumeric)
                        {
                            if (!string.IsNullOrEmpty(row["MSG"].ToString()))
                            {
                                row["MSG"] = row["MSG"] + " - " + "Lot quantity is not number";
                            }
                            else
                            {
                                row["MSG"] = "Lot quantity is not number";
                            }
                        }

                        if(hTable.Contains(row["PART_NO"].ToString().Trim()))
                        {
                            row["SEQ"] = iCount;
                            row["PART_NAME_EN"] = PART_NAME_EN;
                            row["MSG"] = "Duplicate Part No at Seq " + hTable[row["PART_NO"]];
                            row["ERR_FLAG"] = "Y";
                        }
                        else
                        {
                            hTable.Add(row["PART_NO"].ToString().Trim(), iCount);
                        }
                    } catch (Exception ex)
                    {
                        oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM143P_Validate");
                        throw new HttpResponseException(HttpStatusCode.NotAcceptable);
                    }
                   
                }
                else
                {
                    row["MSG"] = "Part not found";
                }

            }

            return dt;
        }

        [HttpPost, Route("SNM143P_SaveMultipart")]
        [Authorize]
        public IHttpActionResult SNM143P_SaveMultipart([FromBody] dynamic[] param)
        {
            DataSet ds = new DataSet();

            try
            {
                int iCount = 0;
                OracleCommand cmd = new OracleCommand();

                foreach (var detail in param)
                {
                    iCount++;

                    cmd = new OracleCommand();
                    cmd.CommandText = "SP_NP_SNM143P_SAVE_TEMP_MULTI";
                    cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = detail["PART_NO"];
                    cmd.Parameters.Add("P_LOT_QTY", OracleDbType.Varchar2).Value = detail["LOT_QTY"];
                    cmd.Parameters.Add("P_CLEAR_DATA", OracleDbType.Varchar2).Value = iCount == 1 ? "Y" : "N";
                    cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);

                    oOracledb.SqlQueryReturnValue(cmd);

                }

                cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNM143P_INSERT_MULTI";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("R_STATUS", OracleDbType.Varchar2, 1000).Direction = ParameterDirection.Output;
                cmd.Parameters.Add("R_MESSAGE", OracleDbType.Varchar2, 1000).Direction = ParameterDirection.Output;

                cmd = oOracledb.SqlQueryReturnValue(cmd);

                string R_STATUS = cmd.Parameters["R_STATUS"].Value.ToString();
                string R_MESSAGE = cmd.Parameters["R_MESSAGE"].Value.ToString();

                if (R_STATUS == "FAIL")
                {
                    oOracledb.WriteLog("ErrorHandle", R_MESSAGE, "SNM143P_SaveMultipart");
                }

                return Json(new { STATUS_MSG = R_STATUS, });
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM143P_SaveMultipart");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }

        }

        #endregion 
    }


    public class SEARCH_RESULT_MODEL
    {

        public int VENDER_CODE { get; set; }
        public int PART_NO { get; set; }

    }
}