﻿using SYSCore;
using System;
using System.Collections.Generic;
using System.Configuration;
using System.Data;
using System.Globalization;
using System.IO;
using System.Linq;
using System.Net;
using System.Security.Claims;
using System.Security.Principal;
using System.Text;
using System.Web;
using static SYSCore.aControl.EmailSender;

namespace SYS_Core.aControl
{
    public class DataService
    {
        private DBManager odb = new DBManager();
        private String gSQL = "";
        private String mDBName = ConfigurationManager.AppSettings["SysDBName"];
        public static string GenerateUpdateSQL(HttpRequestBase rs, string modifyBy, string pKeyFieldName, string pKeyValue = null)
        {
            string gFieldName = "", gSQL = "";

            for (int i = 0; i <= rs.Form.Count - 1; i++)
            {
                gFieldName = rs.Form.Keys[i];
                if (gFieldName != pKeyFieldName)
                {
                    if (gFieldName != gFieldName.ToUpper())
                    {
                        //Do nothing'
                        //-- Protect the field is not in our database , all our field is upper
                    }
                    else if (gFieldName.Substring(0, 1) == "_")
                    {
                        //Do nothing'
                    }
                    else if (gFieldName == "CREATE_DATE_TIME" || gFieldName == "CREATE_BY") // filter date
                    {
                        //Do nothing'
                    }
                    else if (gFieldName.Length >= 5 && gFieldName.Substring(gFieldName.Length - 5) == "_DATE") // filter date
                    {
                        string gDateStr = rs.Form[i].ToString();

                        gDateStr = DateValidation(gDateStr);

                        if (gDateStr.Length == 0)
                        {
                            gSQL = gSQL + "," + gFieldName + "=NULL";
                        }
                        else if (gDateStr.Length >= 8 && gDateStr.IndexOf('-') > 0)
                        {
                            gSQL = gSQL + "," + gFieldName + "=CONVERT(date,'" + gDateStr + "',120)";
                        }
                        else if (gDateStr.Length >= 8 && gDateStr.IndexOf('/') > 0)
                        {
                            gSQL = gSQL + "," + gFieldName + "=CONVERT(date,'" + gDateStr + "',103)";
                        }

                    }
                    else if (gFieldName == "MODIFY_DATE_TIME" || (gFieldName.Length > 16 && gFieldName.Substring(gFieldName.Length - 16) == "UPDATE_DATE_TIME"))
                    {
                        gSQL = gSQL + "," + gFieldName + " = GETDATE() ";
                    }
                    else if (gFieldName == "MODIFY_BY" || (gFieldName.Length > 9 && gFieldName.Substring(gFieldName.Length - 9) == "UPDATE_BY"))
                    {
                        gSQL = gSQL + "," + gFieldName + "='" + modifyBy + "'";
                    }
                    else
                    {
                        string gValue = rs.Form[i].ToString();
                        if (gValue == "")
                        {
                            gSQL = gSQL + "," + gFieldName + "=NULL";
                        }
                        else
                        {
                            gSQL = gSQL + "," + gFieldName + "='" + gValue + "'";
                        }
                    }
                }
            }
            gSQL = "SET " + gSQL.Substring(1);

            if (pKeyFieldName.Length > 0 && pKeyValue == null)
            {
                gSQL = gSQL + " WHERE " + pKeyFieldName + " = '" + rs.Form[pKeyFieldName].ToString() + "'";
            }
            else if (pKeyFieldName.Length > 0 && pKeyValue.Length > 0)
            {
                gSQL = gSQL + " WHERE " + pKeyFieldName + " = '" + rs.Form[pKeyValue].ToString() + "'";
            }

            return gSQL;
        }

        public static string DateValidation(string dateString)
        {
            DateTime dDateValue;
            if (dateString.Length >= 24 && DateTime.TryParse(dateString.ToString(), out dDateValue))
            {
                return dDateValue.Year + "-" + dDateValue.Month + "-" + dDateValue.Day;
            }
            else
            {
                if (dateString.Length == 0)
                {
                    return "";
                }
                else if (dateString.Length >= 8 && dateString.Length <= 10)
                {
                    return dateString;
                }
                else if (dateString.Length >= 24)
                {
                    dDateValue = DateTime.ParseExact(dateString.Substring(0, 24),
                                "ddd MMM d yyyy HH:mm:ss", CultureInfo.InvariantCulture);

                    return dDateValue.Year + "-" + dDateValue.Month + "-" + dDateValue.Day;
                }
                else
                {
                    return "";
                }
            }
        }

        public static void UploadFileByLocation(HttpPostedFileBase File, String uploadLocation, String fileLocation)
        {
            //Create Directory If not exists
            FileInfo filePath = new FileInfo(uploadLocation);
            filePath.Directory.Create();

            //Save file to Directory
            File.SaveAs(fileLocation);

        }

        public static void DeleteFileByLocation(String fileLocation)
        {
            //Check fileLocation exists
            if (System.IO.File.Exists(fileLocation))
            {
                //Delete file from location
                System.IO.File.Delete(fileLocation);
            }
        }

        public static string MapUploadPath(string fileLocation)
        {
            //NMT QA Server mappath
            string newLocation;
            if (ConfigurationManager.AppSettings["ServerLocation"] == "NMT")
            {
                newLocation = aControl.Cons.SERVER_NAME_PRODUCTION + (fileLocation).Replace("~", "").Replace("/", "\\").Replace("'", "''");
            }
            else if (ConfigurationManager.AppSettings["ServerLocation"] == "QA")
            {
                newLocation = aControl.Cons.SERVER_NAME_QA + (fileLocation).Replace("~", "").Replace("/", "\\").Replace("'", "''");
            }
            else
            {
                newLocation = HttpContext.Current.Server.MapPath(fileLocation);
            }

            return newLocation;
        }

        public static string WriteFile(DataTable pData, string pFieldName, string pCategory, string pFileName)
        {
            string gRootPath = ConfigurationManager.AppSettings["RootSharedPath"].ToString();
            string gLocation =  "~/tempFile/" + pCategory + "/";
            string gWriteLocation = System.Web.HttpContext.Current.Server.MapPath(Path.Combine(gRootPath, gLocation.Replace("~", String.Empty)));

            //Check folder is exists.
            FileInfo filePath = new FileInfo(gWriteLocation);
            filePath.Directory.Create();

            string gFileLocation = Path.Combine(gWriteLocation, pFileName);
            string gReturnLocation = Path.Combine(gLocation, pFileName);

            int iLineCount = 0;
            string gTextFromDB;

            if (pData.Rows.Count > 0)
            {
                using (System.IO.StreamWriter file = new System.IO.StreamWriter(gFileLocation, true))
                {
                    foreach(DataRowView dr in pData.DefaultView)
                    {
                        gTextFromDB = dr[pFieldName].ToString();

                        file.WriteLine(gTextFromDB);
                        dr.Row.Delete();

                        iLineCount++;
                    }
                }
                return gReturnLocation;
            } else
            {
                return "";
            }

        }

        public static void WriteFileToSAP(DataTable dt, string type, string vmetype, string paymenttype)
        {
            DataService dataservice = new DataService();
            string writeLocation = System.Web.HttpContext.Current.Server.MapPath("~/ftp/O/SAP/");
            // string fileName = fileNamePrefix + "_" + DateTime.Now.ToString("yyyyMMddHHmmssfff") + ".DAT";
            string fileName = dataservice.GetFileName(type, vmetype, paymenttype);
            string fileLocation = writeLocation + fileName;

            int lineAmount = 0;
            //string textToFile;
            //byte[] bytes;
            string textFromDB;

            if (dt.Rows.Count > 0)
            {
                //Create Directory If not exists
                FileInfo filePath = new FileInfo(writeLocation);
                filePath.Directory.Create();

                using (System.IO.StreamWriter file = new System.IO.StreamWriter(fileLocation, true))
                {
                    foreach (DataRowView dr in dt.DefaultView)
                    {
                        lineAmount = lineAmount + (int)dr["DETAIL_COUNT"];

                        if (lineAmount <= 990)
                        {
                            textFromDB = dr["TEXT"].ToString();
                            //bytes = ascii.GetBytes(textFromDB);
                            //textToFile = ascii.GetString(bytes);
                            file.WriteLine(textFromDB);
                            dr.Row.Delete();
                        }
                        else
                        {
                            dt.AcceptChanges();
                            WriteFileToSAP(dt, type, vmetype, paymenttype);
                            break;
                        }
                    }
                }


                //Send FTP
                FTPService ftp = new FTPService();
                ftp.AsyncFtpUpLoader(fileName, fileLocation);

            }

        }
        private string GetFileName(string type, string vmetype, string paymenttype)
        {
            DataTable dt = new DataTable();
            gSQL = @"EXEC sp_IF_GetFilename '{0}','{1}','{2}'";
            gSQL = String.Format(gSQL, type, vmetype, paymenttype);
            dt = odb.SqlQuery(gSQL, mDBName);
            string gPrefix = dt.Rows[0]["FILE_PREFIX"].ToString();
            string gPostfix = dt.Rows[0]["FILE_POSTFIX"].ToString();
            string gFileName = gPrefix + DateTime.Now.ToString("yyyyMMddHHmmssfff") + gPostfix;
            return gFileName;
        }
        
        public static string GetIdentity(IPrincipal User, string type)
        {
            var identity = User.Identity as ClaimsIdentity;

            string returnValue = "";
            if (identity.IsAuthenticated)
            {
                returnValue = identity.Claims.FirstOrDefault(x => x.Type == type).Value;
            }

            return returnValue;
        }

        public static void SaveBytesToFileByLocation(Byte[] bytes, String uploadLocation, String fileLocation)
        {

            //Create Directory If not exists
            FileInfo filePath = new FileInfo(fileLocation);
            filePath.Directory.Create();

            //Save file to Directory
            File.WriteAllBytes(fileLocation, bytes);
        }

        public static void SaveBytesToFileByCredentialLocation(byte[] bytes, String fileLocation)
        {
            string SharedPath = ConfigurationManager.AppSettings["ReportSharedPath"];
            string SharedUser = ConfigurationManager.AppSettings["ReportSharedUser"];
            string SharedPassword = ConfigurationManager.AppSettings["ReportSharedPassword"];
            NetworkCredential credential = new NetworkCredential(SharedUser, SharedPassword);
            CredentialCache credentialCache = new CredentialCache
                {
                    { new Uri($@"{SharedPath}"), "Negotiate", credential }
                };

            using (new NetworkConnection(SharedPath, credential))
            {

                string FileLocation = Path.Combine(SharedPath, fileLocation);

                //Create Directory If not exists
                FileInfo filePath = new FileInfo(FileLocation);
                filePath.Directory.Create();

                //Save file to Directory
                File.WriteAllBytes(FileLocation, bytes);
            }



        }


        public static void SaveBytesToFileByCredentialLocation(byte[] bytes,string SharedPath,string SharedUser,string SharedPassword, String fileLocation)
        {
            NetworkCredential credential = new NetworkCredential(SharedUser, SharedPassword);
            CredentialCache credentialCache = new CredentialCache
                {
                    { new Uri($@"{SharedPath}"), "Negotiate", credential }
                };
            using (new NetworkConnection(SharedPath, credential))
            {
                string FileLocation = Path.Combine(SharedPath, fileLocation);
                FileInfo filePath = new FileInfo(FileLocation);
                filePath.Directory.Create();
                File.WriteAllBytes(FileLocation, bytes);
            }
        }
        public static string WriteTSV(DataTable dt,string fileName,string FolderLocation, string fileType)
        {
            bool Succes = false;
            //DataTable dt = new DataTable();
            //dt = ds.Tables[0];
            string gLocation = "~/tempFile/" + FolderLocation + "/";
            string gWriteLocation = System.Web.HttpContext.Current.Server.MapPath(gLocation);

            FileInfo filePath = new FileInfo(gWriteLocation);
            filePath.Directory.Create();
            string gFileLocation = Path.Combine(gWriteLocation, fileName);
            string gReturnLocation = Path.Combine(gLocation, fileName);

            try
            {

                string[] H = HeaderList(fileType);
                StringBuilder sb = new StringBuilder();

                string firstRow = "UYK5F3030	V1.0	Order_Modification";

                sb.AppendLine(firstRow);

                IEnumerable<string> columnNames  =  H.Select(h => h.ToString());
                sb.AppendLine(string.Join("\t", columnNames));
                //StringBuilder sb = new StringBuilder();
                //IEnumerable<string> columnNames = dt.Columns.Cast<DataColumn>().Select(column => column.ColumnName);
                //sb.AppendLine(string.Join("\t", columnNames));

                foreach (DataRow row in dt.Rows)
                {
                    IEnumerable<string> fields = row.ItemArray.Select(field => field.ToString());
                    sb.AppendLine(string.Join("\t", fields));
                }

                File.WriteAllText(gFileLocation, sb.ToString());
        
                Succes = true;
            }
            catch(Exception ex)
            {
                Console.WriteLine(ex);
            }

            if (Succes)
            {
                return gReturnLocation;
            }
            else
            {

                return "";
            }
           
        }


        public static string WriteTSVNoHeader(DataTable dt, string fileName, string FolderLocation)
        {
            bool Succes = false;
            //DataTable dt = new DataTable();
            //dt = ds.Tables[0];
            string gLocation = "~/tempFile/" + FolderLocation + "/";
            string gWriteLocation = System.Web.HttpContext.Current.Server.MapPath(gLocation);

            FileInfo filePath = new FileInfo(gWriteLocation);
            filePath.Directory.Create();
            string gFileLocation = Path.Combine(gWriteLocation, fileName);
            string gReturnLocation = Path.Combine(gLocation, fileName);

            try
            {

                StringBuilder sb = new StringBuilder();
                foreach (DataRow row in dt.Rows)
                {
                    IEnumerable<string> fields = row.ItemArray.Select(field => field.ToString());
                    sb.AppendLine(string.Join("\t", fields));
                }

                File.WriteAllText(gFileLocation, sb.ToString());

                Succes = true;
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex);
            }

            if (Succes)
            {
                return gReturnLocation;
            }
            else
            {

                return "";
            }

        }

        public static string WriteCSV(DataTable dt, string fileName, string FloderLocation,string Header)
        {
            bool Succes = false;
            //DataTable dt = new DataTable();
            //dt = ds.Tables[0];
            string gLocation = "~/tempFile/" + FloderLocation + "/";
            string gWriteLocation = System.Web.HttpContext.Current.Server.MapPath(gLocation);

            FileInfo filePath = new FileInfo(gWriteLocation);
            filePath.Directory.Create();
            string gFileLocation = Path.Combine(gWriteLocation, fileName);
            string gReturnLocation = Path.Combine(gLocation, fileName);

            try
            {

                string[] H = HeaderList(Header);
                StringBuilder sb = new StringBuilder();

               
                IEnumerable<string> columnNames = H.Select(h => h.ToString());
                sb.AppendLine(string.Join(",", columnNames));

                foreach (DataRow row in dt.Rows)
                {
                    for (int i = 0; i < dt.Columns.Count; i++)
                    {

                        sb.Append(CsvEscape(row[i].ToString()));
                        sb.Append(i == dt.Columns.Count - 1 ? "\n" : ",");
                    }
                }

                File.WriteAllText(gFileLocation, sb.ToString());

                Succes = true;
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex);
            }

            if (Succes)
            {
                return gReturnLocation;
            }
            else
            {

                return "";
            }

        }

        public static string WriteCSVNoColumn(DataTable dt, string fileName, string FloderLocation)
        {
            bool Succes = false;
            //DataTable dt = new DataTable();
            //dt = ds.Tables[0];
            string gLocation = "~/tempFile/" + FloderLocation + "/";
            string gWriteLocation = System.Web.HttpContext.Current.Server.MapPath(gLocation);

            FileInfo filePath = new FileInfo(gWriteLocation);
            filePath.Directory.Create();
            string gFileLocation = Path.Combine(gWriteLocation, fileName);
            string gReturnLocation = Path.Combine(gLocation, fileName);

            try
            {             
                StringBuilder sb = new StringBuilder();
                foreach (DataRow row in dt.Rows)
                {

                    var value = row[0] as string;
                    //string fields = row.ItemArray.Select(field => field.ToString());
                    sb.AppendLine(value);
                }

                File.WriteAllText(gFileLocation, sb.ToString());

                Succes = true;
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex);
            }

            if (Succes)
            {
                return gReturnLocation;
            }
            else
            {

                return "";
            }

        }

      public static string CsvEscape(string value)
        {
            if (value.Contains(","))
            {
                return "\"" + value.Replace("\"", "\"\"") + "\"";
            }
            return value;
        }


        public static string[] HeaderList(string header_name)
        {
            string[] HeaderForExport = new string[]{""};


            if (header_name == "SNSE148")
            {

                HeaderForExport = new string[]
                {
                    "Your Code",
                    "Role",
                    "Role Number",
                    "Recommend ID",
                    "Project ID",
                    "Model",
                    "Year",
                    "MAC",
                    "Production",
                    "Sales",
                    "Section",
                    "Part Code",
                    "Part No",
                    "Part Name",
                    "NSC to Order",
                    "Order due Date",
                    "Recommendation Date",
                    "D/S",
                    "Recommended Q'ty",
                    "Self Point Modified Q'ty",
                    "Self Point Reason",
                    "Self Point Reason Message",
                    "Self Point Modification Flag",
                    "Self Point Modification Date",
                    "Downstream Point Country (1)",
                    "Downstream Point Modified Q'ty (1)",
                    "Downstream Point Reason (1)",
                    "Downstream Point Modification Flag (1)",
                    "Downstream Point Modification Date (1)",
                    "Downstream Point Country (2)",
                    "Downstream Point Modified Q'ty (2)",
                    "Downstream Point Reason (2)",
                    "Downstream Point Modification Flag (2)",
                    "Downstream Point Modification Date (2)",
                    "Downstream Point Country (3)",
                    "Downstream Point Modified Q'ty (3)",
                    "Downstream Point Reason (3)",
                    "Downstream Point Modification Flag (3)",
                    "Downstream Point Modification Date (3)",
                    "Downstream Point Country (4)",
                    "Downstream Point Modified Q'ty (4)",
                    "Downstream Point Reason (4)",
                    "Downstream Point Modification Flag (4)",
                    "Downstream Point Modification Date (4)",
                    "Downstream Point Country (5)",
                    "Downstream Point Modified Q'ty (5)",
                    "Downstream Point Reason (5)",
                    "Downstream Point Modification Flag (5)",
                    "Downstream Point Modification Date (5)",
                    "PMS Stock On Hand",
                    "PMS P/O QTY",
                    "PMS B/O QTY",
                    "PMS Average Demand",
                    "Order Point",
                    "Vendor Code",
                    "Group Part No",
                    "Confirm QTY"
                };

                return HeaderForExport;
            }
            else if (header_name == "SNSE148_MPS")
            {

                HeaderForExport = new string[]
                {
                    "Your Code",
                    "Role",
                    "Role Number",
                    "Recommend ID",
                    "Project ID",
                    "Model",
                    "Year",
                    "MAC",
                    "Production",
                    "Sales",
                    "Section",
                    "Part Code",
                    "Part No",
                    "Part Name",
                    "NSC to Order",
                    "Order due Date",
                    "Recommendation Date",
                    "D/S",
                    "Recommended Q'ty",
                    "Self Point Modified Q'ty",
                    "Self Point Reason",
                    "Self Point Modification Flag",
                    "Self Point Modification Date",
                    "Downstream Point Country (1)",
                    "Downstream Point Modified Q'ty (1)",
                    "Downstream Point Reason (1)",
                    "Downstream Point Modification Flag (1)",
                    "Downstream Point Modification Date (1)",
                    "Downstream Point Country (2)",
                    "Downstream Point Modified Q'ty (2)",
                    "Downstream Point Reason (2)",
                    "Downstream Point Modification Flag (2)",
                    "Downstream Point Modification Date (2)",
                    "Downstream Point Country (3)",
                    "Downstream Point Modified Q'ty (3)",
                    "Downstream Point Reason (3)",
                    "Downstream Point Modification Flag (3)",
                    "Downstream Point Modification Date (3)",
                    "Downstream Point Country (4)",
                    "Downstream Point Modified Q'ty (4)",
                    "Downstream Point Reason (4)",
                    "Downstream Point Modification Flag (4)",
                    "Downstream Point Modification Date (4)",
                    "Downstream Point Country (5)",
                    "Downstream Point Modified Q'ty (5)",
                    "Downstream Point Reason (5)",
                    "Downstream Point Modification Flag (5)",
                    "Downstream Point Modification Date (5)"
                };

                return HeaderForExport;
            }
            else if(header_name == "SNSQ040")
            {
                HeaderForExport = new string[]
                   {  "FPO No",
                        "FPO No",
                        "Recommend Id",
                        "Project Id",
                        "Vendor Code",
                        "Vendor Name",
                        "Vendor Type",
                        "Forecasted Qty",
                        "Firm Forecasted Qty",
                        "Tel. & Fax",
                        "E-Mail",
                        "Contact",
                        "SK User ID",
                        "Indent Status"
                       };
                return HeaderForExport;
            }else if(header_name == "SNSE184")
            {
                HeaderForExport = new string[]
                 {    "Seq",
                     "Print Date",
                     "Part No",
                     "Part Name English",
                     "Part Name Thai",
                     "Loc Div",
                     "Current Location",
                     "New Location",
                     "Status No",
                     "Update Flag",
                     "Relocation Qty",
                     "Pick/Pack Qty",
                     "Case No",
                     "Pick/Pack Date",
                     "Shelve Qty",
                     "Shelve Date",
                     "Create Date",
                     "Create By",
                     "Create Program",
                     "Create From File Name",
                     "Last Update Date",
                     "Last Update By",
                     "Last Update Program",
                     "Last Update From File Name"
                     };
                return HeaderForExport;
            }
            else if (header_name == "SNSE202")
            {
                HeaderForExport = new string[]
                 {    "Process Date",
                     "Part No.",
                     "Part Name",
                     "Incoming Q'ty",
                     "Group Average Demand",
                     "Estimate Stock",
                     "Estimate Category",
                     "Suggest Location No.",
                     "Message" 
                     };
                return HeaderForExport;
            }
            else if (header_name == "SNSE202_Part")
            {
                HeaderForExport = new string[] 
                {
                    "GRP",
                     "VENDOR_TYPE",
                     "PART_NO",
                     "PART_CATEGORY",
                     "LAST_SALES_DATE",
                     "NO_SALES_DAY",
                     "TOTAL_OH_QTY",
                     "TOTAL_OH_COST",
                     "ALLOWANCE_AMOUNT"
                     };
                return HeaderForExport;
            }
            else if (header_name == "SNSE202_Type")
            {
                HeaderForExport = new string[]  
                {
                    "GRP",
                     "VENDOR_TYPE",
                     "TOTAL_OH_QTY",
                     "TOTAL_OH_COST",
                     "ALLOWANCE_AMOUNT" 
                     };
                return HeaderForExport;
            }
            else if (header_name == "SNSQ030")
            {
                HeaderForExport = new string[]
                {
                    "Seq.",
                     "Create Date",
                     "Part No",
                     "Part Name",
                     "Local Supplier Code",
                     "Piece Price",
                     "Adopted Date From",
                     "Currency",
                     "Create By",
                     "Last Upd Pgm",
                     "File Name",
                     "Item No"
                     };
                return HeaderForExport;
            }
            else if (header_name == "SNSQ031")
            {
                HeaderForExport = new string[]
                {
                    "Seq.",
                     "Create Date",
                     "Part No",
                     "Part Name",
                     "Local Supplier Code",
                     "Future Price",
                     "Effective Date",
                     "Currency",
                     "Create By",
                     "Last Upd Pgm",
                     "File Name",
                     "Item No"
                     };
                return HeaderForExport;
            }
            else if (header_name == "SNSQ032")
            {
                HeaderForExport = new string[]
                {
                    "Seq.",
                     "Log Date Time",
                     "Log Message",
                     "Status",
                     "Create by",
                     "File Name",
                     "Process Group",
                     "Process Name"
                     };
                return HeaderForExport;
            }

            else if (header_name == "SNSQ038")
            {
                HeaderForExport = new string[]
                {
                    "Seq.","Part Number","English Part Number","Model Series Code","Block","Sale Code","Sale Conditions",
                    "Parent Part Number","Model Info Jpn Id","Model Info Catalog Model","Model Info Model Year",
                    "Model Info Unit System","Pattern Number","Sale Channel N","Sale Channel M","Sale Channel S",
                    "Sale Channel N","Part Code","Japanese Part Number","Description","Squares","Pre List Item",
                    "Squares A","Squares B","New Item Symbol","Adoption Year Month","Abolish Year Month",
                    "Japan Part Letter","Spps,Design Note","Quantity,Drawing Drawing Number","Drawing Drawing Change",
                    "Design Part Name","Part Specification","Former Alternate","Ica Nio 1","Ica Oin 1",
                    "Coeff Jp P","Coeff Others P","Vital Parts","Spc_Bukan","Trim Color 1","Trim Color 2","Trim Color 3",
                    "Trim Color 4","Trim Color 5","Trim Color 6","Trim Color 7","Trim Color 8","Trim Color 9","Trim Color 10",
                    "Genesis Sourcing Code","Genesis Resp Group Code","Establishment Location","Car Production Location",
                    "Unit Production Location","Unit Package P","Net Weight P","New Alternate","Ica Oin 2","Ica Nio 2",
                    "Design Part Name","Ahq Code","Market Code Dm","Market Code El","Market Code Er","Market Code Gl",
                    "Market Code Gr","Market Code Us","Market Code Ca","Market Code Ar","Original Part Number",
                    "Ica Original","Vender Code","Plant Adopt Stat","Section No","L Series Code Eur","Alternate Sourcing Code",
                    "Gsc,Procurement Hub","Destination,Filler","Received Status","Received Type","Upload Status"
                 };
                return HeaderForExport;
            }
            else if (header_name == "SNSE165")
            {
                HeaderForExport = new string[]
                {
                    "Seq","Country Code","Buyer Code","Part Number","Part Name","Pricing Role","Itp Parts Flag","Model Code","GLP",
                    "GLP Currency","GLP Establishment Category","GLP App","Description Code",
                    "Sales Classification Code","New Model Setting Due Date","Price Rivison Setting Due Date",
                    "Purchase FOB Bp","Purchase FOB Sp","Purchase FOB Currency","Purchase FOB Price App",
                    "Purchase FOB Sp Start","Purchase FOB Sp End","Purchase Cost","Purchase Cost Currency",
                    "Purchase Cost Tentative Flag","Into Store Cost","Isc Currency","Selling FOB Bp","Selling FOB Sp",
                    "Selling FOB Currency","Selling FOB Price App","Selling FOB Sp Start","Selling FOB Sp End",
                    "Acc Sv Unique Flag","Reason Code","Vendor Code(Master)","Vendor Type(Master)","Description Code(Master)","Sales Class(Master)",
                    "Update Status","Create By","Create Date","Last Update by Program","Last Update by User","Last Update Date","Message Error"
                 };
                return HeaderForExport;
            }
            else if (header_name == "SNM105P")
            {
                HeaderForExport = new string[]
                    {
                    "Seq.",
                     "Part No.",
                     "New Base Price",
                     "New Retail Price",
                     "New Pricing Code",
                     "New STD Cost",
                     "Vendor Code",
                     "PO No",
                     "New Unit Price PO",
                     "Message"
                     };
                return HeaderForExport;
            }
            else if(header_name == "SNSE144")
            {
                HeaderForExport = new string[]
                {   "company code",
                    "file name",
                    "item no",
                    "Part Number",
                    "Part Name En",
                    "Part Name Th",
                    "Part Code",
                    "Decript Code",
                    "Product Code",
                    "Sale Class",
                    "Tariff Code",
                    "Duty Rate",
                    "Parent Part Number",
                    "Sourcing Code",
                    "GSC",
                    "Vendor Code",
                    "Vendor Type",
                    "Current Vendor Code",
                    "Current Vendor Type",
                    "Pricing Code",
                    "Currency Code",
                    "Catalog Model",
                    "Main Model",
                    "Production Location",
                    "Unit Location",
                    "Hub",
                    "Online Flag",
                    "From Table",
                    "Record Status",
                    "Register Status",
                    "create by",
                    "create date",
                    "last upd pgm",
                    "last upd by",
                    "last upd date",
                    "Packaging Code",
                    "Error Message"
                };
                return HeaderForExport;
            }
            else if (header_name == "SNSQ033")
            {
                HeaderForExport = new string[]
                {
                    "Seq.",
                     "Part Number",
                     "Part Name",
                     "Create Date",
                     "Global Supplier Code",
                     "Local Supplier Code",
                     "Base Price",
                     "Update Date"
                     };
                return HeaderForExport;
            }
            else if (header_name == "SNM135P")
            {
                HeaderForExport = new string[]
                    {
                    "Seq.",
                     "Part No.",
                     "Base Price",
                     "Retail Price",
                     "Standard Cost",
                     "Pricing Code",
                     "Message"
                     };
                return HeaderForExport;
            }
            else if (header_name == "SNM135P_PO")
            {
                HeaderForExport = new string[]
                    {
                     "Seq.",
                     "Part No.",
                     "PO No",
                     "Vendor Code",
                     "PO Unit Price",
                     "Accept Qty",
                     "Net AMT B",
                     "Message"
                     };
                return HeaderForExport;
            }

            return HeaderForExport;
                  
        }

        public static string GetFileStream (string path, string filename)
        {
            string filePath = System.Web.Hosting.HostingEnvironment.MapPath(path);
            Byte[] bytes = File.ReadAllBytes(filePath);
            String file = Convert.ToBase64String(bytes);

            return file;
        }

        public byte[] WriteBytes(List<string> strList)
        {
            byte[] bytes = strList.SelectMany(s => System.Text.Encoding.ASCII.GetBytes(s)).ToArray();
            return bytes;
        }

        public static DataTable ConvertCSVtoDataTable(string strFilePath,string Header)
        {
            DataTable dt = new DataTable();
            using (StreamReader sr = new StreamReader(strFilePath))
            {
                string[] headers = Header.Split(',');
                foreach (string header in headers)
                {
                    dt.Columns.Add(header);
                }
                while (!sr.EndOfStream)
                {
                    string[] rows = sr.ReadLine().Split(',');
                    DataRow dr = dt.NewRow();
                    for (int i = 0; i < headers.Length; i++)
                    {
                        dr[i] = rows[i];
                    }
                    dt.Rows.Add(dr);
                }

            }
            return dt;
        }

        public EmailConfigure GetEmailConfigure(string emailType)
        {
            string gSQL = String.Format("EXEC sp_SYS_Email_Configure '{0}'", emailType);
            DataTable dt = odb.SqlQuery(gSQL, mDBName);

            if (dt.Rows.Count > 0)
            {
                DataRow dr = dt.Rows[0];

                string[] to = dr["EMAIL_TO"].ToString().Split(',');
                string[] cc = dr["EMAIL_CC"].ToString().Split(',');
                string[] bcc = dr["EMAIL_BCC"].ToString().Split(',') ?? null;
                string subject = dr["EMAIL_SUBJECT"].ToString();
                string content = dr["EMAIL_CONTENT"].ToString();
                bool highImportant = dr["EMAIL_IMPORTANCE"].ToString() == "Y";

                EmailConfigure configure = new EmailConfigure(to, cc, bcc, subject, content, null, highImportant);

                return configure;
            }

            throw new Exception("No email configuration.");
        }
    }
}