﻿using Oracle.ManagedDataAccess.Client;
using SYS_Core.aControl;
using System;
using System.Collections.Generic;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Threading.Tasks;
using System.Web;
using System.Web.Http;
using System.Web.Http.Cors;
using System.IO;
using System.Text;
using SYS_Core.aBiz;
using RandomSolutions;
using System.Net.Http.Headers;
using System.Security.Claims;
using System.Collections;
using Newtonsoft.Json;
using SYSCore.Attributes;
using SYSCore.ReportingService;

namespace SYS_Core.Controllers
{
    [EnableCors("*", "*", "*")]
    [RoutePrefix("api/WH")]
    public class WarehouseApiController : ApiController
    {

        private DBOracle oOracledb = new DBOracle();
        private String gSQL = "";
        private DataModel DataModel = new DataModel();

        #region WareHouse Monitering

        [HttpGet, Route("SNWR020_SetTask")]
        public IHttpActionResult SNWR020_SetTask()
        {

            //string context = "0 0/1 0,8,20 ? * MON,TUE,WED,THU,FRI *";
            string context = "0 0/5 * * * ?";
            _ = JobSchedule.CreateJob("Monitoring1", "PMS", context);
            return Ok("Done");
        }


        [HttpGet, Route("SNWR020_DeleteTask")]
        public IHttpActionResult SNWR020_TEST()
        {
            _ = JobSchedule.DeleteJob("Monitoring1", "PMS");
            return Ok("Done");
        }


        [HttpGet, Route("SNWR025_SetTask")]
        public IHttpActionResult SNWR025_SetTask()
        {
            
            //string context = "0 0/1 0,8,20 ? * MON,TUE,WED,THU,FRI *";
            string context = "0 0/5 * * * ?";
            _ = JobSchedule.CreateJob("Monitoring2", "PMS" , context);
            return Ok("Done");
        }


        [HttpGet, Route("SNWR025_DeleteTask")]
        public IHttpActionResult SNWR025_TEST()
        {
            _ = JobSchedule.DeleteJob("Monitoring2", "PMS");
            return Ok("Done");
        }

        #endregion

        #region SNSQ090


        [HttpGet, Route("SNSQ090_GetStaffWH/{staff}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult SNSQ090_GetStaffWH(string staff, int noofshowrec)
        {
            DataSet ds = new DataSet();

            staff = ismoUtil.escapeCharacter(staff);

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNSQ090_STAFF_WH";
            cmd.Parameters.Add("P_STAFF", OracleDbType.Varchar2).Value = staff.ToUpper() == "NULL" ? (object)DBNull.Value : staff;
            cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));
        }


        [HttpPost, Route("SNSQ090_GetData")]
        [Authorize]
        public IHttpActionResult SNSQ090_GetData([FromBody] dynamic param)
        {
            string SpName = string.Empty;
            DataSet ds = new DataSet();
            switch (Int32.Parse(param.CURRENT_TAB.ToString()))
            {
                case 0:
                    SpName = "SP_NP_SNSQ090_TAB1";
                    break;
                case 1:
                    SpName = "SP_NP_SNSQ090_TAB2";
                    break;
                case 2:
                    SpName = "SP_NP_SNSQ090_TAB3";
                    break;
                case 3:
                    SpName = "SP_NP_SNSQ090_TAB4";
                    break;
                default:
                    Console.WriteLine("not found!");
                    break;
            }
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = SpName;
            cmd.Parameters.Add("P_FROM_DATE", OracleDbType.Varchar2).Value = param.FROM_DATE_FORMAT;
            cmd.Parameters.Add("P_TO_DATE", OracleDbType.Varchar2).Value = param.TO_DATE_FORMAT;
            cmd.Parameters.Add("P_DATE_TYPE", OracleDbType.Varchar2).Value = param.DATE_TYPE;
            cmd.Parameters.Add("P_SECTION_CODE", OracleDbType.Varchar2).Value = param.SECTION_CODE;
            cmd.Parameters.Add("P_STAFF_ID", OracleDbType.Varchar2).Value = param.STAFF_ID;
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpPost, Route("SNSQ090Tab1_Download")]
        [Authorize]
        public HttpResponseMessage SNSQ090Tab1_Download(List<DataModel.SNSQ090_Tab1> Data)
        {
            DataTable dt = new DataTable();
            dt = DTFM.ToDatatable(Data);
            var x = SNSQ090_Writefile(dt, "0");
            SystemApiController sys = new SystemApiController();
            var respons = sys.downloadFile(x.Substring(1), "SNSQ090_Tab1");
            return respons;
        }

        [HttpPost, Route("SNSQ090Tab2_Download")]
        [Authorize]
        public HttpResponseMessage SNSQ090Tab2_Download(List<DataModel.SNSQ090_Tab2> Data)
        {
            DataTable dt = new DataTable();
            dt = DTFM.ToDatatable(Data);
            var x = SNSQ090_Writefile(dt, "1");
            SystemApiController sys = new SystemApiController();
            var respons = sys.downloadFile(x.Substring(1), "SNSQ090_Tab2");
            return respons;
        }

        [HttpPost, Route("SNSQ090Tab3_Download")]
        [Authorize]
        public HttpResponseMessage SNSQ090Tab3_Download(List<DataModel.SNSQ090_Tab3> Data)
        {
            DataTable dt = new DataTable();
            dt = DTFM.ToDatatable(Data);
            var x = SNSQ090_Writefile(dt, "2");
            SystemApiController sys = new SystemApiController();
            var respons = sys.downloadFile(x.Substring(1), "SNSQ090_Tab3");
            return respons;
        }


        [HttpPost, Route("SNSQ090Tab4_Download")]
        [Authorize]
        public HttpResponseMessage SNSQ090Tab4_Download(List<DataModel.SNSQ090_Tab4> Data)
        {
            DataTable dt = new DataTable();
            dt = DTFM.ToDatatable(Data);
            var x = SNSQ090_Writefile(dt, "3");
            SystemApiController sys = new SystemApiController();
            var respons = sys.downloadFile(x.Substring(1), "SNSQ090_Tab4");
            return respons;
        }



        private string SNSQ090_Writefile(DataTable dt, string CurrentTab)
        {
            bool Succes = false;
            string fileName = string.Empty;
            string firstRow = string.Empty;
            string[] HeaderForExport = new string[] { "" };
            switch (Int32.Parse(CurrentTab))
            {
                case 0:

                    fileName = "SNSQ090_LocationType";
                    firstRow = ",,,,Productivitie by Item,,,,,,,Productivitie by Qty";
                    HeaderForExport = new string[]
                    {"Seq","Section","Staff ID","Staff Name","Small","Medium","Large","Heavy","2nd","Other","Total Item","Small","Medium","Large","Heavy","2nd","Other","Total Qty"};
                    break;
                case 1:

                    fileName = "SNSQ090_OrderClass";
                    firstRow = ",,,,Productivitie by Item,,,,,,,Productivitie by Qty";
                    HeaderForExport = new string[]
                    {"Seq","Section","Staff ID","Staff Name","Claim","Emerg","Indent","Regular","WS","Oil","Total Item","Claim","Emerg","Indent","Regular","WS","Oil","Total Qty"};
                    break;
                case 2:

                    fileName = "SNSQ090_SaleChannel";
                    firstRow = ",,,,Productivitie by Item,,,,,,,Productivitie by Qty" + "\n" + ",,,,,-----Domestic-----,,,,,,,,,,,-----Export-----,,,,,,,,,,,,-----Domestic-----,,,,,,,,,,,-----Export-----";
                    HeaderForExport = new string[]
                    {"Seq","Section","Staff ID","Staff Name","BKK Car","BKK Part","UPC Car","UPC Part","Other","Air","Sea","Total Item","BKK Car","BKK Part","UPC Car","UPC Part","Other","Air","Sea","Total Qty"};
                    break;
                case 3:

                    fileName = "SNSQ090_Timing";
                    firstRow = ",,,,,Productivitie by Item,,,,,,,,,,,,,,,,,,,,,,,Productivitie by Qty" + "\n" + ",,,,,-----Domestic-----,,,,,,,,,,,-----Export-----,,,,,,,,,,,,-----Domestic-----,,,,,,,,,,,-----Export-----";
                    HeaderForExport = new string[]
                    {"Seq","Section","Staff ID","Staff Name","Order Class","8:00-9:00","9:00-10:00","10:00-11:00","11:00-12:00","12:00-13:00","13:00-14:00","14:00-15:00","15:00-16:00","16:00-17:00","OT", "Total","8:00-9:00","9:00-10:00","10:00-11:00","11:00-12:00","12:00-13:00","13:00-14:00","14:00-15:00"
                    ,"15:00-16:00","16:00-17:00","OT", "Total","Item Total","8:00-9:00","9:00-10:00","10:00-11:00","11:00-12:00","12:00-13:00","13:00-14:00","14:00-15:00","15:00-16:00","16:00-17:00","OT", "Total","8:00-9:00","9:00-10:00","10:00-11:00","11:00-12:00","12:00-13:00","13:00-14:00","14:00-15:00"
                    ,"15:00-16:00","16:00-17:00","OT", "Total,Qty Total"};
                    break;
                default:
                    Console.WriteLine("not found!");
                    break;
            }

            string gLocation = "~/tempFile/" + "SNSQ090" + "/";
            string gWriteLocation = System.Web.HttpContext.Current.Server.MapPath(gLocation);

            FileInfo filePath = new FileInfo(gWriteLocation);
            filePath.Directory.Create();
            string gFileLocation = Path.Combine(gWriteLocation, fileName);
            string gReturnLocation = Path.Combine(gLocation, fileName);

            try
            {

                StringBuilder sb = new StringBuilder();
                sb.AppendLine(firstRow);

                IEnumerable<string> columnNames = HeaderForExport.Select(h => h.ToString());
                sb.AppendLine(string.Join(",", columnNames));

                foreach (DataRow row in dt.Rows)
                {
                    for (int i = 0; i < dt.Columns.Count; i++)
                    {

                        sb.Append(CsvEscape(row[i].ToString()));
                        sb.Append(i == dt.Columns.Count - 1 ? "\n" : ",");
                    }
                }

                File.WriteAllText(gFileLocation, sb.ToString());
                Succes = true;

            }
            catch (Exception ex)
            {
                Console.WriteLine(ex);
            }

            if (Succes)
            {
                return gReturnLocation;
            }
            else
            {

                return "";
            }
        }


        #endregion

        #region SNM016P
        [HttpGet, Route("SNM016P_GetRoute/{route}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult SNM016P_GetRoute(string route, int noofshowrec)
        {
            DataSet ds = new DataSet();

            route = ismoUtil.escapeCharacter(route);

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNM016P_ROUTECODE";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_ROUTECODE", OracleDbType.Varchar2).Value = route.ToUpper() == "NULL" ? (object)DBNull.Value : route;
            cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
            cmd.Parameters.Add("c_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));
        }

        [HttpPost, Route("SNM016P_GetRouteDetail")]
        [Authorize]
        public IHttpActionResult SNM016P_GetRouteDetail([FromBody] dynamic param)
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNM016P_ROUTECODE_DETAIL";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_ROUTECODE", OracleDbType.Varchar2).Value = param.ROUTE_CODE;
            cmd.Parameters.Add("c_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));
        }

        [HttpPost, Route("SNM016P_Insert")]
        [Authorize]
        // [RunBatchGuard]
        public IHttpActionResult SNM016P_Insert([FromBody] dynamic param)
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNM016P_INSERT";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_ROUTE_CODE", OracleDbType.Varchar2).Value = param.ROUTE_CODE;
            cmd.Parameters.Add("P_ROUTE_NAME_EN", OracleDbType.Varchar2).Value = param.ROUTE_NAME_EN;
            cmd.Parameters.Add("P_ROUTE_NAME_TH", OracleDbType.Varchar2).Value = param.ROUTE_NAME_TH;
            cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
            cmd.Parameters.Add("P_PGM", OracleDbType.Varchar2).Value = "SNM016P";
            cmd.Parameters.Add("P_IP", OracleDbType.Varchar2).Value = HttpContext.Current.Request.UserHostAddress.ToString();
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));
        }

        [HttpPost, Route("SNM016P_Update")]
        [Authorize]
        // [RunBatchGuard]
        public IHttpActionResult SNM016P_Update([FromBody] dynamic param)
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNM016P_UPDATE";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_ROUTE_CODE", OracleDbType.Varchar2).Value = param.ROUTE_CODE;
            cmd.Parameters.Add("P_ROUTE_NAME_EN", OracleDbType.Varchar2).Value = param.ROUTE_NAME_EN;
            cmd.Parameters.Add("P_ROUTE_NAME_TH", OracleDbType.Varchar2).Value = param.ROUTE_NAME_TH;
            cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
            cmd.Parameters.Add("P_PGM", OracleDbType.Varchar2).Value = "SNM016P";
            cmd.Parameters.Add("P_IP", OracleDbType.Varchar2).Value = HttpContext.Current.Request.UserHostAddress.ToString();
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));
        }

        [HttpPost, Route("SNM016P_Delete")]
        [Authorize]
        // [RunBatchGuard]
        public IHttpActionResult SNM016P_Delete([FromBody] dynamic param)
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNM016P_DELETE";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_ROUTE_CODE", OracleDbType.Varchar2).Value = param.ROUTE_CODE;
            cmd.Parameters.Add("P_ROUTE_NAME_EN", OracleDbType.Varchar2).Value = param.ROUTE_NAME_EN;
            cmd.Parameters.Add("P_ROUTE_NAME_TH", OracleDbType.Varchar2).Value = param.ROUTE_NAME_TH;
            cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
            cmd.Parameters.Add("P_PGM", OracleDbType.Varchar2).Value = "SNM016P";
            cmd.Parameters.Add("P_IP", OracleDbType.Varchar2).Value = HttpContext.Current.Request.UserHostAddress.ToString();
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));
        }
        #endregion

        #region SNM007P

        [HttpGet, Route("SNM007P_GetTransport/{transport}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult SNM007P_GetTransport(string transport, int noofshowrec)
        {
            DataSet ds = new DataSet();

            transport = ismoUtil.escapeCharacter(transport);

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNM007P_TRANSPORT";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_TRANSPORT", OracleDbType.Varchar2).Value = transport.ToUpper() == "NULL" ? (object)DBNull.Value : transport;
            cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
            cmd.Parameters.Add("c_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));
        }

        [HttpPost, Route("SNM007P_GetTransportDetail")]
        [Authorize]
        public IHttpActionResult SNM007P_GetTransportDetail([FromBody] dynamic param)
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNM007P_TRANSPORT_DETAIL";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_TRANSPORT", OracleDbType.Varchar2).Value = param.TRANSPORT;
            cmd.Parameters.Add("c_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));
        }


        [HttpPost, Route("SNM007P_Insert")]
        [Authorize]
        // [RunBatchGuard]
        public IHttpActionResult SNM007P_Insert([FromBody] dynamic param)
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNM007P_INSERT";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_TRANSPORT_CODE", OracleDbType.Varchar2).Value = param.TRANSPORT_CODE;
            cmd.Parameters.Add("P_TRANS_NAME_EN", OracleDbType.Varchar2).Value = param.TRANS_NAME_EN;
            cmd.Parameters.Add("P_TRANS_NAME_TH", OracleDbType.Varchar2).Value = param.TRANS_NAME_TH;
            cmd.Parameters.Add("P_TRANS_ADDR1", OracleDbType.Varchar2).Value = param.TRANS_ADDR1;
            cmd.Parameters.Add("P_TRANS_ADDR2", OracleDbType.Varchar2).Value = param.TRANS_ADDR2;
            cmd.Parameters.Add("P_TRANS_ADDR3", OracleDbType.Varchar2).Value = param.TRANS_ADDR3;
            cmd.Parameters.Add("P_TRANS_ADDR4", OracleDbType.Varchar2).Value = param.TRANS_ADDR4;
            cmd.Parameters.Add("P_TRANS_CONTACT", OracleDbType.Varchar2).Value = param.TRANS_CONTACT;
            cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
            cmd.Parameters.Add("P_PGM", OracleDbType.Varchar2).Value = "SNM007P";
            cmd.Parameters.Add("P_IP", OracleDbType.Varchar2).Value = HttpContext.Current.Request.UserHostAddress.ToString();
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));
        }

        [HttpPost, Route("SNM007P_Update")]
        [Authorize]
        // [RunBatchGuard]
        public IHttpActionResult SNM007P_Update([FromBody] dynamic param)
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNM007P_UPDATE";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_TRANSPORT_CODE", OracleDbType.Varchar2).Value = param.TRANSPORT_CODE;
            cmd.Parameters.Add("P_TRANS_NAME_EN", OracleDbType.Varchar2).Value = param.TRANS_NAME_EN;
            cmd.Parameters.Add("P_TRANS_NAME_TH", OracleDbType.Varchar2).Value = param.TRANS_NAME_TH;
            cmd.Parameters.Add("P_TRANS_ADDR1", OracleDbType.Varchar2).Value = param.TRANS_ADDR1;
            cmd.Parameters.Add("P_TRANS_ADDR2", OracleDbType.Varchar2).Value = param.TRANS_ADDR2;
            cmd.Parameters.Add("P_TRANS_ADDR3", OracleDbType.Varchar2).Value = param.TRANS_ADDR3;
            cmd.Parameters.Add("P_TRANS_ADDR4", OracleDbType.Varchar2).Value = param.TRANS_ADDR4;
            cmd.Parameters.Add("P_TRANS_CONTACT", OracleDbType.Varchar2).Value = param.TRANS_CONTACT;
            cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
            cmd.Parameters.Add("P_PGM", OracleDbType.Varchar2).Value = "SNM007P";
            cmd.Parameters.Add("P_IP", OracleDbType.Varchar2).Value = HttpContext.Current.Request.UserHostAddress.ToString();
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));
        }


        [HttpPost, Route("SNM007P_Delete")]
        [Authorize]
        // [RunBatchGuard]
        public IHttpActionResult SNM007P_Delete([FromBody] dynamic param)
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNM007P_DELETE";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_TRANSPORT_CODE", OracleDbType.Varchar2).Value = param.TRANSPORT_CODE;
            cmd.Parameters.Add("P_TRANS_NAME_EN", OracleDbType.Varchar2).Value = param.TRANS_NAME_EN;
            cmd.Parameters.Add("P_TRANS_NAME_TH", OracleDbType.Varchar2).Value = param.TRANS_NAME_TH;
            cmd.Parameters.Add("P_TRANS_ADDR1", OracleDbType.Varchar2).Value = param.TRANS_ADDR1;
            cmd.Parameters.Add("P_TRANS_ADDR2", OracleDbType.Varchar2).Value = param.TRANS_ADDR2;
            cmd.Parameters.Add("P_TRANS_ADDR3", OracleDbType.Varchar2).Value = param.TRANS_ADDR3;
            cmd.Parameters.Add("P_TRANS_ADDR4", OracleDbType.Varchar2).Value = param.TRANS_ADDR4;
            cmd.Parameters.Add("P_TRANS_CONTACT", OracleDbType.Varchar2).Value = param.TRANS_CONTACT;
            cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
            cmd.Parameters.Add("P_PGM", OracleDbType.Varchar2).Value = "SNM007P";
            cmd.Parameters.Add("P_IP", OracleDbType.Varchar2).Value = HttpContext.Current.Request.UserHostAddress.ToString();
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));
        }
        #endregion

        #region SNM033

        [HttpPost, Route("SNM033_GetData")]
        [Authorize]
        public IHttpActionResult SNM033_GetData([FromBody] dynamic pData)
        {
            try
            {
                DataSet ds = new DataSet();

                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNM033_GET_DATA";

                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_LOCATOIN_NO", OracleDbType.Varchar2).Value = pData.LOCATION_NO;
                cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = pData.PART_NO;
                cmd.Parameters.Add("P_RACK_CODE", OracleDbType.Varchar2).Value = pData.RACK_CODE;
                cmd.Parameters.Add("P_RACK_GROUP_CODE", OracleDbType.Varchar2).Value = pData.RACK_GROUP_CODE;
                cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int64).Value = pData.SHOW_RECORD;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));

            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM033_GetData");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }


        [HttpPost, Route("SNM033_GetEmptyLocation")]
        [Authorize]
        public IHttpActionResult SNM033_GetEmptyLocation([FromBody] dynamic pData)
        {
            try
            {
                DataSet ds = new DataSet();

                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNM033_EMPTY_LOCATION";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM033_GetEmptyLocation");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }


        [HttpPost, Route("SNM033_Save")]
        [Authorize]
        // [RunBatchGuard]
        public IHttpActionResult SNM033_Save([FromBody] dynamic pDataList)
        {
            try
            {
                DataSet ds = new DataSet();

                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNM033_UPDATE";

                var IP_ADDR = HttpContext.Current.Request.UserHostAddress.ToString();
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_LOCATION_NO", OracleDbType.Varchar2).Value = pDataList.LOCATION_NO.ToString();
                cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = pDataList.PART_NO.ToString();
                cmd.Parameters.Add("P_DIMENSION_MAX", OracleDbType.Varchar2).Value = pDataList.DIMENSION_MAX.ToString();
                cmd.Parameters.Add("P_DIMENSION_MID", OracleDbType.Varchar2).Value = pDataList.DIMENSION_MID.ToString();
                cmd.Parameters.Add("P_DIMENSION_MIN", OracleDbType.Varchar2).Value = pDataList.DIMENSION_MIN.ToString();
                cmd.Parameters.Add("P_RACK_CODE", OracleDbType.Varchar2).Value = pDataList.RACK_CODE.ToString();
                cmd.Parameters.Add("P_RACK_GROUP_CODE", OracleDbType.Varchar2).Value = pDataList.RACK_GROUP_CODE.ToString();
                cmd.Parameters.Add("P_SEQUENCE_NO", OracleDbType.Varchar2).Value = pDataList.SEQUENCE_NO.ToString();
                cmd.Parameters.Add("P_LOCK_LOCATION", OracleDbType.Varchar2).Value = pDataList.LOCK_LOCATION.ToString();
                cmd.Parameters.Add("P_CAPACITY_QTY", OracleDbType.Varchar2).Value = pDataList.CAPACITY_QTY.ToString();
                cmd.Parameters.Add("P_SHELVE_QTY", OracleDbType.Varchar2).Value = pDataList.SHELVE_QTY.ToString();
                cmd.Parameters.Add("P_PART_CATEGORY", OracleDbType.Varchar2).Value = pDataList.PART_CATEGORY.ToString();
                cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("P_IP_ADDR", OracleDbType.Varchar2).Value = IP_ADDR;
                cmd.Parameters.Add("P_LAST_UPD_PGM", OracleDbType.Varchar2).Value = "SNM033";
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM033_Save");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpPost, Route("SNM033_SavePart")]
        [Authorize]
        public IHttpActionResult SNM033_SavePart([FromBody] dynamic pData)
        {

            DataSet ds = new DataSet();

            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNM033_UPDATE_PART";

                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_LOCATOIN_NO", OracleDbType.Varchar2).Value = pData.LOCATION_NO;
                cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = pData.PART_NO;
                cmd.Parameters.Add("P_DIMENSION_MAX", OracleDbType.Varchar2).Value = pData.DIMENSION_MAX;
                cmd.Parameters.Add("P_DIMENSION_MID", OracleDbType.Varchar2).Value = pData.DIMENSION_MID;
                cmd.Parameters.Add("P_DIMENSION_MIN", OracleDbType.Varchar2).Value = pData.DIMENSION_MIN;
                cmd.Parameters.Add("P_LAST_PGM", OracleDbType.Varchar2).Value = "SNM033";
                cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("P_IP_ADDR", OracleDbType.Varchar2).Value = HttpContext.Current.Request.UserHostAddress.ToString();
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM033_SavePart");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }


        [HttpGet, Route("GetLockLocation/{lock_location}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult GetLockLocation(string lock_location, int noofshowrec)
        {
            DataSet ds = new DataSet();

            try
            {
                lock_location = ismoUtil.escapeCharacter(lock_location);

                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNM033_GET_LOCK_LOCATION";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_LOCK_LOCATION", OracleDbType.Varchar2).Value = lock_location == "null" ? (object)DBNull.Value : lock_location;
                cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "GetLockLocation");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpGet, Route("SNM033_GetPartDetail/{part_no}")]
        [Authorize]
        public IHttpActionResult SNM033_GetPartDetail(string part_no)
        {


            try
            {
                DataSet ds = new DataSet();
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNM033_GET_PART_DETAIL";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = part_no;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM033_GetPartDetail");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpGet, Route("SNM033_GetControlSystem/{Location_No}")]
        [Authorize]
        public IHttpActionResult SNM033_GetControlSystem(string Location_No)
        {

            try
            {
                DataSet ds = new DataSet();
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNM033_GET_CONTROL";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_LOCATION_NO", OracleDbType.Varchar2).Value = Location_No;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM033_GetControlSystem");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }
        [HttpPost, Route("SNM033P_ClearPart")]
        [Authorize]
        public IHttpActionResult SNM033P_ClearPart([FromBody] dynamic pData)
        {
            try
            {
                DataSet ds = new DataSet();

                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNM033P_CLEAR_PART";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_LOCATOIN_NO", OracleDbType.Varchar2).Value = pData.LOCATION_NO;
                cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = pData.PART_NO;
                cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("P_IP_ADDR", OracleDbType.Varchar2).Value = HttpContext.Current.Request.UserHostAddress.ToString();
                cmd.Parameters.Add("P_LAST_UPD_PGM", OracleDbType.Varchar2).Value = "SNM033P";
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));

            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM033P_ClearPart");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }
        [HttpPost, Route("SNM033P_UploadFile")]
        [Authorize]
        public async Task<IHttpActionResult> SNM033P_UploadFile(HttpRequestMessage request)
        {
            if (!request.Content.IsMimeMultipartContent())
            {
                throw new HttpResponseException(HttpStatusCode.UnsupportedMediaType);
            }
            var reqParts = await request.Content.ReadAsMultipartAsync();

            try
            {
                DataSet ds = new DataSet();
                DataTable dt = new DataTable();
                string USER_ID = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                var file = reqParts.Contents[0];

                var buffer = await file.ReadAsByteArrayAsync();
                string gFileName = file.Headers.ContentDisposition.FileName.Trim('\"');
                string name = Path.GetFileNameWithoutExtension(gFileName);
                string ext = Path.GetExtension(gFileName);
                string gFileNameExtend = String.Concat(name, '_', USER_ID, ext);
                string gRootPath = ConfigurationManager.AppSettings["RootSharedPath"].ToString();
                string gUploadLication = System.IO.Path.Combine(gRootPath, "tempFile/SNM033P");
                string gFileLocation = System.IO.Path.Combine(gUploadLication, gFileName);

                DataService.SaveBytesToFileByLocation(buffer
                                                , gUploadLication
                                                , gFileLocation);

                SystemApiController sys = new SystemApiController();
                //dt = sys.ReadDataExcel(gFileLocation);
                dt = SNM033P_ValidateData(gFileLocation);
                return Json(DTFM.convertToList(dt));

            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM033P_UploadFile");
                throw new HttpResponseException(HttpStatusCode.NotAcceptable);
            }

            throw new Exception("Something wrong");

        }


        public DataTable SNM033P_ValidateData(string filelocation)
        {
            DataTable dt = new DataTable();
            SystemApiController sys = new SystemApiController();
            dt = sys.ReadDataExcel(filelocation);
            dt.Columns.Add("SEQ");
            dt.Columns.Add("MSG");
            dt.Columns.Add("ERR_FLAG");
            Hashtable hTable = new Hashtable();
            int iCount = 0;

            foreach (DataRow row in dt.Rows)
            {

                OracleCommand cmd = new OracleCommand();
                if (!string.IsNullOrEmpty(row["LOCATION_NO"].ToString()))
                {
                    iCount++;
                    cmd = new OracleCommand();
                    cmd.CommandText = "SP_NP_SNM033P_VALIDATE";
                    cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                    cmd.Parameters.Add("P_LOCATION_NO", OracleDbType.Varchar2).Value = row["LOCATION_NO"];
                    cmd.Parameters.Add("R_ERROR_MESSAGE", OracleDbType.Varchar2, 1000).Direction = ParameterDirection.Output;

                    cmd = oOracledb.SqlQueryReturnValue(cmd);

                    var CHECK = cmd.Parameters["R_ERROR_MESSAGE"].Value.ToString();

                    row["SEQ"] = iCount;
                    if (CHECK == "PASS")
                    {
                        row["MSG"] = DBNull.Value;
                        row["ERR_FLAG"] = "N";
                    }
                    else
                    {
                        row["MSG"] = cmd.Parameters["R_ERROR_MESSAGE"].Value;
                        row["ERR_FLAG"] = "Y";
                    }

                    if (row["LOCATION_NO"].ToString().Length > 10)
                    {
                        row["MSG"] = "Location No cannot mare than 10 charactor";
                        row["ERR_FLAG"] = "Y";
                    }


                    if (hTable.Contains(row["LOCATION_NO"].ToString().Trim()))
                    {
                        //row["SEQ"] = iCount;
                        row["MSG"] = "Duplicate Location No at Seq " + hTable[row["LOCATION_NO"]];
                        row["ERR_FLAG"] = "Y";
                    }
                    else
                    {
                        hTable.Add(row["LOCATION_NO"].ToString().Trim(), iCount);
                    }

                }
            }

            return dt;
        }


        [HttpPost, Route("SNM033P_SaveByUpload")]
        [Authorize]
        public IHttpActionResult SNM033P_SaveByUpload([FromBody] dynamic data)
        {

            DataSet ds = new DataSet();
            DataTable dt = new DataTable();

            OracleCommand cmd = new OracleCommand();
            int iCount = 0;
            try
            {

                foreach (dynamic d in data.DETAIL)
                {
                    iCount++;
                    cmd = new OracleCommand();
                    cmd.CommandText = "SP_NP_SNM033P_SAVE_TEMP";
                    cmd.Parameters.Add("P_LOCATION_NO", OracleDbType.Varchar2).Value = d["LOCATION_NO"];
                    cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = d["PART_NO"];
                    cmd.Parameters.Add("P_TEMP_LOCATION", OracleDbType.Varchar2).Value = d["TEMP_LOCATION"];
                    cmd.Parameters.Add("P_PART_CATEGORY", OracleDbType.Varchar2).Value = d["PART_CATEGORY"];
                    cmd.Parameters.Add("P_RACK_CODE", OracleDbType.Varchar2).Value = d["RACK_CODE"];
                    cmd.Parameters.Add("P_RACKGROUP", OracleDbType.Varchar2).Value = d["RACKGROUP"];
                    cmd.Parameters.Add("P_DIMENSION_MAX", OracleDbType.Varchar2).Value = d["DIMENSION_MAX"];
                    cmd.Parameters.Add("P_DIMENSION_MID", OracleDbType.Varchar2).Value = d["DIMENSION_MID"];
                    cmd.Parameters.Add("P_DIMENSION_MIN", OracleDbType.Varchar2).Value = d["DIMENSION_MIN"];
                    cmd.Parameters.Add("P_LOCK_LOCATE", OracleDbType.Varchar2).Value = d["LOCK_LOCATE"];
                    cmd.Parameters.Add("P_DISTANCE_RECEIVE", OracleDbType.Varchar2).Value = d["DISTANCE_RECEIVE"];
                    cmd.Parameters.Add("P_DISTANCE_DELIVERY", OracleDbType.Varchar2).Value = d["DISTANCE_DELIVERY"];
                    cmd.Parameters.Add("P_CREATE_BY", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                    cmd.Parameters.Add("P_CLEAR_DATA", OracleDbType.Varchar2).Value = iCount == 1 ? "Y" : "N";
                    cmd = oOracledb.SqlQueryReturnValue(cmd);
                }
                cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNM033P_SAVE_BY_UPLOAD";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("P_IP", OracleDbType.Varchar2).Value = HttpContext.Current.Request.UserHostAddress.ToString();
                cmd.Parameters.Add("R_STATUS", OracleDbType.Varchar2, 50).Direction = ParameterDirection.Output;
                cmd.Parameters.Add("R_MESSAGE", OracleDbType.Varchar2, 50).Direction = ParameterDirection.Output;

                cmd = oOracledb.SqlQueryReturnValue(cmd);
                string r_status = cmd.Parameters["R_STATUS"].Value.ToString();
                string r_msg = cmd.Parameters["R_MESSAGE"].Value.ToString();

                if (r_status != "DONE")
                {
                    oOracledb.WriteLog("ErrorHandle", r_msg, "SNM033P_SaveByUpload");
                }

                return Json(new { STATUS = r_status, MESSAGE = r_msg });
            }
            catch (Exception ex)
            {
                //--- Roll back ---
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM033P_SaveByUpload");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }

            //return Json(data);
        }
        #endregion

        #region SNM025P
        [HttpGet, Route("SNM025P_GetRack/{rackcode}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult SNM025P_GetRack(string rackcode, int noofshowrec)
        {
            try
            {
                DataSet ds = new DataSet();

                rackcode = ismoUtil.escapeCharacter(rackcode);

                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNM025P_GETRACK";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_RACK_CODE", OracleDbType.Varchar2).Value = rackcode;
                cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM025P_GetRack");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }
        [HttpGet, Route("SNM025P_GetRack_List/{rackcode=null}")]
        [Authorize]
        public IHttpActionResult SNM025P_GetRack_List(string rackcode = null)
        {
            try
            {
                DataSet ds = new DataSet();

                rackcode = ismoUtil.escapeCharacter(rackcode);

                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNM025P_GETRACK_LIST";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_RACK_CODE", OracleDbType.Varchar2).Value = (rackcode != null && rackcode == "null" ? "" : rackcode);
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM025P_GetRack_List");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpGet, Route("SNM025P_GetRack_Info/{rackcode}")]
        [Authorize]
        public IHttpActionResult SNM025P_GetRack_Info(string rackcode)
        {
            try
            {
                DataSet ds = new DataSet();

                rackcode = ismoUtil.escapeCharacter(rackcode);

                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNM025P_GETRACK_INFO";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_RACK_CODE", OracleDbType.Varchar2).Value = rackcode != "@@@" ? rackcode : null;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM025P_GetRack_Info");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpPost, Route("SNM025P_Rack_Save")]
        [Authorize]
        public IHttpActionResult SNM025P_Rack_Save([FromBody] dynamic pDataList)
        {
            try
            {
                DataSet ds = new DataSet();
                DataTable dt = new DataTable();
                var x = HttpContext.Current.Request.UserHostAddress.ToString();
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNM025P_SAVE";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_RACK_CODE", OracleDbType.Varchar2).Value = pDataList.RACK_CODE;
                cmd.Parameters.Add("P_ITEM_NO", OracleDbType.Varchar2).Value = pDataList.ITEM_NO;
                cmd.Parameters.Add("P_DIMENSION_MAX", OracleDbType.Varchar2).Value = pDataList.DIMENSION_MAX;
                cmd.Parameters.Add("P_DIMENSION_MID", OracleDbType.Varchar2).Value = pDataList.DIMENSION_MID;
                cmd.Parameters.Add("P_DIMENSION_MIN", OracleDbType.Varchar2).Value = pDataList.DIMENSION_MIN;
                cmd.Parameters.Add("P_VOLUMN_MAX", OracleDbType.Varchar2).Value = pDataList.VOLUMN_MAX;
                cmd.Parameters.Add("P_VOLUMN_MIN", OracleDbType.Varchar2).Value = pDataList.VOLUMN_MIN;
                cmd.Parameters.Add("P_CREATE_BY", OracleDbType.Varchar2).Value = pDataList.CREATE_BY;
                cmd.Parameters.Add("P_LAST_UPD_PGM", OracleDbType.Varchar2).Value = "SNM025P";
                cmd.Parameters.Add("P_LAST_UPD_BY", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("P_LAST_IP_ADDR", OracleDbType.Varchar2).Value = pDataList.LAST_IP_ADDR;
                cmd.Parameters.Add("c_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM025P_Rack_Save");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }
        [HttpPost, Route("SNM025P_delete_Rack")]
        [Authorize]
        // [RunBatchGuard]
        public IHttpActionResult SNM025P_delete_Rack([FromBody] dynamic pDataList)
        {
            try
            {
                DataSet ds = new DataSet();
                DataTable dt = new DataTable();
                var x = HttpContext.Current.Request.UserHostAddress.ToString();
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNM025P_DELETE";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_RACK_CODE", OracleDbType.Varchar2).Value = pDataList.RACK_CODE;
                cmd.Parameters.Add("P_CREATE_BY", OracleDbType.Varchar2).Value = pDataList.CREATE_BY;
                cmd.Parameters.Add("P_LAST_UPD_PGM", OracleDbType.Varchar2).Value = "SNM025P";
                cmd.Parameters.Add("P_LAST_UPD_BY", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("P_LAST_IP_ADDR", OracleDbType.Varchar2).Value = pDataList.LAST_IP_ADDR;
                cmd.Parameters.Add("c_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM025P_delete_Rack");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        #endregion

        #region SNM026P
        [HttpPost, Route("SNM026P_GetData")]
        [Authorize]
        public IHttpActionResult SNM026P_GetData([FromBody] dynamic pData)
        {
            try
            {
                DataSet ds = new DataSet();
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNM026P_GETDATA";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_RACK_CODE", OracleDbType.Varchar2).Value = pData.RACK_CODE;
                cmd.Parameters.Add("P_PART_CATEGORY", OracleDbType.Varchar2).Value = pData.PART_CATEGORY;
                cmd.Parameters.Add("cReturn", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM026P_GetData");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpGet, Route("SNM026P_GetRack/{rackcode}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult SNM026P_GetRack(string rackcode, int noofshowrec)
        {
            try
            {
                DataSet ds = new DataSet();

                rackcode = ismoUtil.escapeCharacter(rackcode);

                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNM026P_GETRACK";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_RACK_CODE", OracleDbType.Varchar2).Value = rackcode;
                cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM026P_GetRack");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpGet, Route("SNM026P_GetPartCategory")]
        [Authorize]
        public IHttpActionResult SNM026P_GetPartCategory()
        {
            try
            {
                DataSet ds = new DataSet();
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNM026P_GETCAT";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("c_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM026P_GetPartCategory");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpPost, Route("SNM026P_Insert")]
        [Authorize]
        // [RunBatchGuard]
        public IHttpActionResult SNM026P_Insert([FromBody] dynamic pDataList)
        {
            try
            {
                DataSet ds = new DataSet();
                DataTable dt = new DataTable();
                var x = HttpContext.Current.Request.UserHostAddress.ToString();
                //IPAddress ipv4Addresses = Array.Find(Dns.GetHostEntry(string.Empty).AddressList, a => a.AddressFamily == AddressFamily.InterNetwork);
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNM026P_INSERT";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_PART_CATEGORY", OracleDbType.Varchar2).Value = pDataList.PART_CATEGORY;
                cmd.Parameters.Add("P_RACK_CODE", OracleDbType.Varchar2).Value = pDataList.RACK_CODE;
                cmd.Parameters.Add("P_RACK_GROUP_CODE", OracleDbType.Varchar2).Value = pDataList.RACK_GROUP_CODE;
                cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("P_LAST_UPD_PGM", OracleDbType.Varchar2).Value = "SNM026P";
                cmd.Parameters.Add("P_IP_ADDR", OracleDbType.Varchar2).Value = HttpContext.Current.Request.UserHostAddress.ToString();
                cmd.Parameters.Add("c_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM026P_Insert");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpPost, Route("SNM026P_Delete")]
        [Authorize]
        // [RunBatchGuard]
        public IHttpActionResult SNM026P_Delete([FromBody] dynamic pDataList)
        {
            try
            {
                DataSet ds = new DataSet();
                var x = HttpContext.Current.Request.UserHostAddress.ToString();
                //IPAddress ipv4Addresses = Array.Find(Dns.GetHostEntry(string.Empty).AddressList, a => a.AddressFamily == AddressFamily.InterNetwork);
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNM026P_DELETE";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_PART_CATEGORY", OracleDbType.Varchar2).Value = pDataList.PART_CATEGORY;
                cmd.Parameters.Add("P_RACK_CODE", OracleDbType.Varchar2).Value = pDataList.RACK_CODE;
                cmd.Parameters.Add("P_RACK_GROUP_CODE", OracleDbType.Varchar2).Value = pDataList.RACK_GROUP_CODE;
                cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("P_LAST_UPD_PGM", OracleDbType.Varchar2).Value = "SNM026P";
                cmd.Parameters.Add("P_IP_ADDR", OracleDbType.Varchar2).Value = HttpContext.Current.Request.UserHostAddress.ToString();
                cmd.Parameters.Add("c_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM026P_Delete");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpPost, Route("SNM026P_Update")]
        [Authorize]
        // [RunBatchGuard]
        public IHttpActionResult SNM026P_Update([FromBody] dynamic pDataList)
        {
            try
            {
                DataSet ds = new DataSet();
                DataTable dt = new DataTable();
                var x = HttpContext.Current.Request.UserHostAddress.ToString();
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNM026P_UPDATE";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_PART_CATEGORY", OracleDbType.Varchar2).Value = pDataList.PART_CATEGORY;
                cmd.Parameters.Add("P_RACK_CODE", OracleDbType.Varchar2).Value = pDataList.RACK_CODE;
                cmd.Parameters.Add("P_RACK_GROUP_CODE", OracleDbType.Varchar2).Value = pDataList.RACK_GROUP_CODE;
                cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("P_LAST_UPD_PGM", OracleDbType.Varchar2).Value = "SNM026P";
                cmd.Parameters.Add("P_IP_ADDR", OracleDbType.Varchar2).Value = HttpContext.Current.Request.UserHostAddress.ToString();
                cmd.Parameters.Add("c_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM026P_Update");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }
        #endregion

        #region SNSE184
        [HttpPost, Route("SNSE184_GetData")]
        [Authorize]
        public IHttpActionResult SNSE184_GetData([FromBody] dynamic pData)
        {
            try
            {
                DataSet ds = new DataSet();
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNSE184_GET_DATA";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_CURRENT_LOCATION_FROM", OracleDbType.Varchar2).Value = pData.CURRENT_LOCATION_FROM;
                cmd.Parameters.Add("P_CURRENT_LOCATION_TO", OracleDbType.Varchar2).Value = pData.CURRENT_LOCATION_TO;
                cmd.Parameters.Add("P_PART_FROM", OracleDbType.Varchar2).Value = pData.PART_FROM;
                cmd.Parameters.Add("P_PART_TO", OracleDbType.Varchar2).Value = pData.PART_TO;
                cmd.Parameters.Add("P_NEW_LOCATION_FROM", OracleDbType.Varchar2).Value = pData.NEW_LOCATION_FROM;
                cmd.Parameters.Add("P_NEW_LOCATION_TO", OracleDbType.Varchar2).Value = pData.NEW_LOCATION_TO;
                cmd.Parameters.Add("P_PRINT_DATE_FROM", OracleDbType.Varchar2).Value = pData.PRINT_DATE_FROM.ToString("dd-MM-yyyy");
                cmd.Parameters.Add("P_PRINT_DATE_TO", OracleDbType.Varchar2).Value = pData.PRINT_DATE_TO.ToString("dd-MM-yyyy");
                cmd.Parameters.Add("P_STATUS_NO", OracleDbType.Varchar2).Value = pData.STATUS_NO;
                cmd.Parameters.Add("P_UPDATE_FLAG", OracleDbType.Varchar2).Value = pData.UPDATE_FLAG;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNSE184_GetData");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }


        [HttpPost, Route("SNSE184_GetDataLog")]
        [Authorize]
        public IHttpActionResult SNSE184_GetDataLog([FromBody] dynamic pData)
        {
            try
            {

                DataSet ds = new DataSet();
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNSE184_GET_DATA_LOG";
                cmd.Parameters.Add("P_PARTS_NO", OracleDbType.Varchar2).Value = pData.PARTS_NO;
                cmd.Parameters.Add("P_PRINT_CODE", OracleDbType.Varchar2).Value = pData.PRINT_CODE;
                cmd.Parameters.Add("cReturn", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNSE184_GetDataLog");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpGet, Route("GetLocation/{location}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult GetLocation(string location, int noofshowrec)
        {
            try
            {
                DataSet ds = new DataSet();

                location = ismoUtil.escapeCharacter(location);

                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNSE184_RELOCATION";
                cmd.Parameters.Add("P_LOCATION_NO", OracleDbType.Varchar2).Value = location;
                cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "GetLocation");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpGet, Route("GetNewLocation/{location}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult GetNewLocation(string location, int noofshowrec)
        {
            try
            {
                DataSet ds = new DataSet();

                location = ismoUtil.escapeCharacter(location);

                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNSE184_NEW_LOCATION";
                cmd.Parameters.Add("P_LOCATION_NO", OracleDbType.Varchar2).Value = location;
                cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "GetNewLocation");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpGet, Route("GetPrintCode/{printcode}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult GetPrintCode(string printcode, int noofshowrec)
        {
            try
            {
                DataSet ds = new DataSet();

                printcode = ismoUtil.escapeCharacter(printcode);

                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNSE184_PRINT_CODE";
                cmd.Parameters.Add("P_PRINT_CODE", OracleDbType.Varchar2).Value = printcode;
                cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "GetPrintCode");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpPost, Route("SNSE184_Export")]
        public HttpResponseMessage SNSE184_Export(List<DataModel.SNSE184> dModel)
        {
            //DataTable dt = new DataTable();
            //string x = string.Empty;
            //string filename = "SNSE184.csv";
            //string floderLocation = "SNSE184";
            //dt = DTFM.ToDatatable<DataModel.SNSE184>(dModel);
            //x = DataService.WriteCSV(dt, filename, floderLocation, "SNSE184");
            //Controllers.SystemApiController response = new Controllers.SystemApiController();
            //var File = response.downloadFile(x.Substring(1), filename);
            //return File;

            DataTable dt = new DataTable();
            string x = string.Empty;
            string filename = "SNSE184.csv";
            string floderLocation = "SNSE184";
            dt.Columns.Add("colum1");

            dt.Rows.Add("ID;PO2C");
            dt.Rows.Add("B");
            dt.Rows.Add("C;X1;Y1;K\"Seq.\"");
            dt.Rows.Add("C;X2;Y1;K\"Print Date\"");
            dt.Rows.Add("C;X3;Y1;K\"Part No.\"");
            dt.Rows.Add("C;X4;Y1;K\"Part Name EN\"");
            dt.Rows.Add("C;X5;Y1;K\"Part Name TH\"");
            dt.Rows.Add("C;X6;Y1;K\"Loc Div\"");
            dt.Rows.Add("C;X7;Y1;K\"Current Location\"");
            dt.Rows.Add("C;X8;Y1;K\"New Location\"");
            dt.Rows.Add("C;X9;Y1;K\"Status No.\"");
            dt.Rows.Add("C;X10;Y1;K\"Update Flag\"");
            dt.Rows.Add("C;X11;Y1;K\"Relo QTY\"");
            dt.Rows.Add("C;X12;Y1;K\"Pick QTY\"");
            dt.Rows.Add("C;X13;Y1;K\"Case No.\"");
            dt.Rows.Add("C;X14;Y1;K\"Pick Date\"");
            dt.Rows.Add("C;X15;Y1;K\"Shelve QTY\"");
            dt.Rows.Add("C;X16;Y1;K\"Shelve Date\"");


            int countrow = 0;
            int itemno = 0;
            for (var i = 0; i < dModel.Count; i++)
            {
                countrow = i + 2;
                itemno = i + 1;
                dt.Rows.Add("C;X1;Y" + countrow + ";K" + '"' + dModel[i].SEQ + '"');
                dt.Rows.Add("C;X2;Y" + countrow + ";K" + '"' + dModel[i].PRINT_CODE + '"');
                dt.Rows.Add("C;X3;Y" + countrow + ";K" + '"' + dModel[i].PARTS_NO + '"');
                dt.Rows.Add("C;X4;Y" + countrow + ";K" + '"' + dModel[i].PART_NAME_EN + '"');
                dt.Rows.Add("C;X5;Y" + countrow + ";K" + '"' + dModel[i].PART_NAME_TH + '"');
                dt.Rows.Add("C;X6;Y" + countrow + ";K" + '"' + dModel[i].LOC_DIV + '"');
                dt.Rows.Add("C;X7;Y" + countrow + ";K" + '"' + dModel[i].LOCATION_NO + '"');
                dt.Rows.Add("C;X8;Y" + countrow + ";K" + '"' + dModel[i].NEW_LOCATION + '"');
                dt.Rows.Add("C;X9;Y" + countrow + ";K" + '"' + dModel[i].STATUS_CODE + '"');
                dt.Rows.Add("C;X10;Y" + countrow + ";K" + '"' + dModel[i].UPD_FLAG + '"');
                dt.Rows.Add("C;X11;Y" + countrow + ";K" + '"' + dModel[i].RELO_QTY + '"');
                dt.Rows.Add("C;X12;Y" + countrow + ";K" + '"' + dModel[i].PICK_QTY + '"');
                dt.Rows.Add("C;X13;Y" + countrow + ";K" + '"' + dModel[i].CASE_NO + '"');
                dt.Rows.Add("C;X14;Y" + countrow + ";K" + '"' + dModel[i].PICK_HT_DATE + '"');
                dt.Rows.Add("C;X15;Y" + countrow + ";K" + '"' + dModel[i].SHELVE_QTY + '"');
                dt.Rows.Add("C;X16;Y" + countrow + ";K" + '"' + dModel[i].SHELVE_HT_DATE + '"');
            }

            dt.Rows.Add("E");

            x = DataService.WriteCSVNoColumn(dt, filename, floderLocation);
            Controllers.SystemApiController response = new Controllers.SystemApiController();
            var File = response.downloadFile(x.Substring(1), filename);
            return File;
        }
        #endregion

        #region SNM109P
        [HttpGet, Route("SNM109P_Query/{prefix_part_no}")]
        [Authorize]
        public IHttpActionResult SNM109P_Query(string prefix_part_no)
        {

            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNM109P_QUERY";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_PREFIX_PART_NO", OracleDbType.Varchar2).Value = prefix_part_no == "null" ? (object)DBNull.Value : prefix_part_no;
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));
        }

        [HttpPost, Route("SNM109P_Save")]
        [Authorize]
        public IHttpActionResult SNM109P_Save([FromBody] dynamic[] pPrefixParts)
        {
            foreach (var prefixPart in pPrefixParts)
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNM109P_SAVE";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_PREFIX_PART_NO", OracleDbType.Varchar2).Value = prefixPart["PREFIX_PART_NO"];
                cmd.Parameters.Add("P_DESCRIPTION", OracleDbType.Varchar2).Value = prefixPart["DESCRIPTION"];
                cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);

                oOracledb.SqlQueryReturnValue(cmd);
            }


            return Ok();
        }


        [HttpPost, Route("SNM109P_Delete")]
        [Authorize]
        // [RunBatchGuard]
        public IHttpActionResult SNM109P_Delete([FromBody] dynamic[] pPrefixParts)
        {
            foreach (var prefixPart in pPrefixParts)
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNM109P_DELETE";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_PREFIX_PART_NO", OracleDbType.Varchar2).Value = prefixPart["PREFIX_PART_NO"];

                oOracledb.SqlQueryReturnValue(cmd);
            }

            return Ok();
        }
        [HttpPost, Route("SNM109P_Deletes")]
        [Authorize]
        public IHttpActionResult SNM109P_Deletes([FromBody] dynamic pPrefixParts)
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNM109P_DELETES";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_PREFIX_PART_NO", OracleDbType.Varchar2).Value = pPrefixParts.PREFIX_PART_NO.ToString();
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));
        }

        [HttpPost, Route("SNM109P_Insert")]
        [Authorize]
        // [RunBatchGuard]
        public IHttpActionResult SNM109P_Insert([FromBody] dynamic pPrefixParts)
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNM109P_INSERT";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_PREFIX_PART_NO", OracleDbType.Varchar2).Value = pPrefixParts.PREFIX_PART_NO.ToString();
            cmd.Parameters.Add("P_DESCRIPTION", OracleDbType.Varchar2).Value = pPrefixParts.PREFIX_DEXCRIPTION.ToString() == "null" ? (object)DBNull.Value : pPrefixParts.PREFIX_DEXCRIPTION.ToString();
            cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));
        }
        #endregion

        #region SNM033P

        [HttpGet, Route("SNM033P_GetData/{location_no?}")]
        [Authorize]
        public IHttpActionResult SNM033P_GetData(string location_no = null)
        {
            try
            {
                DataSet ds = new DataSet();

                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNM033P_GET_DATA";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_LOCATION_NO", OracleDbType.Varchar2).Value = location_no;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM033P_GetData");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpPost, Route("SNM033P_InsertLocation")]
        [Authorize]
        // [RunBatchGuard]
        public IHttpActionResult SNM033P_InsertLocation([FromBody] dynamic pDataList)
        {
            DataSet ds = new DataSet();
            DataTable dt = new DataTable();
            try
            {
                var IP_ADDR = HttpContext.Current.Request.UserHostAddress.ToString();
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNM033P_INSERT";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);

                cmd.Parameters.Add("P_LOCATION_NO", OracleDbType.Varchar2).Value = pDataList.LOCATION_NO.ToString();
                cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = pDataList.PART_NO.ToString();
                cmd.Parameters.Add("P_DIMENSION_MAX", OracleDbType.Varchar2).Value = pDataList.DIMENSION_MAX.ToString();
                cmd.Parameters.Add("P_DIMENSION_MID", OracleDbType.Varchar2).Value = pDataList.DIMENSION_MID.ToString();
                cmd.Parameters.Add("P_DIMENSION_MIN", OracleDbType.Varchar2).Value = pDataList.DIMENSION_MIN.ToString();
                cmd.Parameters.Add("P_RACK_CODE", OracleDbType.Varchar2).Value = pDataList.RACK_CODE.ToString();
                cmd.Parameters.Add("P_RACK_GROUP_CODE", OracleDbType.Varchar2).Value = pDataList.RACK_GROUP_CODE.ToString();
                cmd.Parameters.Add("P_SEQUENCE_NO", OracleDbType.Varchar2).Value = pDataList.SEQUENCE_NO.ToString();
                cmd.Parameters.Add("P_PART_CATEGORY", OracleDbType.Varchar2).Value = pDataList.PART_CATEGORY.ToString();
                cmd.Parameters.Add("P_LOCK_LOCATION", OracleDbType.Varchar2).Value = pDataList.LOCK_LOCATION.ToString();
                cmd.Parameters.Add("P_FLOOR_NO", OracleDbType.Varchar2).Value = pDataList.FLOOR_NO.ToString();
                cmd.Parameters.Add("P_MAX_WEIGHT", OracleDbType.Varchar2).Value = pDataList.MAX_WEIGHT.ToString();
                cmd.Parameters.Add("P_CAPACITY_QTY", OracleDbType.Varchar2).Value = pDataList.CAPACITY_QTY.ToString();
                cmd.Parameters.Add("P_SHELVE_QTY", OracleDbType.Varchar2).Value = pDataList.SHELVE_QTY.ToString();

                cmd.Parameters.Add("P_TEMP_LOCATION", OracleDbType.Varchar2).Value = pDataList.TEMP_LOCATION.ToString();

                cmd.Parameters.Add("P_DISTANCE_RECEIVE1", OracleDbType.Varchar2).Value = pDataList.DISTANCE_RECEIVE1.ToString();
                cmd.Parameters.Add("P_DISTANCE_RECEIVE2", OracleDbType.Varchar2).Value = pDataList.DISTANCE_RECEIVE2.ToString();
                cmd.Parameters.Add("P_DISTANCE_RECEIVE3", OracleDbType.Varchar2).Value = pDataList.DISTANCE_RECEIVE3.ToString();
                cmd.Parameters.Add("P_DISTANCE_DELIVERY1", OracleDbType.Varchar2).Value = pDataList.DISTANCE_DELIVERY1.ToString();
                cmd.Parameters.Add("P_DISTANCE_DELIVERY2", OracleDbType.Varchar2).Value = pDataList.DISTANCE_DELIVERY2.ToString();
                cmd.Parameters.Add("P_DISTANCE_DELIVERY3", OracleDbType.Varchar2).Value = pDataList.DISTANCE_DELIVERY3.ToString();

                cmd.Parameters.Add("P_ATTRIBUTE2", OracleDbType.Varchar2).Value = pDataList.ATTRIBUTE2.ToString();
                cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("P_IP_ADDR", OracleDbType.Varchar2).Value = IP_ADDR;
                cmd.Parameters.Add("P_LAST_UPD_PGM", OracleDbType.Varchar2).Value = "SNM033P";

                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM033P_InsertLocation");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpPost, Route("SNM033P_UpdateLocation")]
        [Authorize]
        // [RunBatchGuard]
        public IHttpActionResult SNM033P_UpdateLocation([FromBody] dynamic pDataList)
        {
            DataSet ds = new DataSet();
            DataTable dt = new DataTable();

            try
            {
                var IP_ADDR = HttpContext.Current.Request.UserHostAddress.ToString();
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNM033P_UPDATE";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_LOCATION_NO", OracleDbType.Varchar2).Value = pDataList.LOCATION_NO.ToString();
                cmd.Parameters.Add("P_DIMENSION_MAX", OracleDbType.Varchar2).Value = pDataList.DIMENSION_MAX.ToString();
                cmd.Parameters.Add("P_DIMENSION_MID", OracleDbType.Varchar2).Value = pDataList.DIMENSION_MID.ToString();
                cmd.Parameters.Add("P_DIMENSION_MIN", OracleDbType.Varchar2).Value = pDataList.DIMENSION_MIN.ToString();
                cmd.Parameters.Add("P_RACK_CODE", OracleDbType.Varchar2).Value = pDataList.RACK_CODE.ToString();
                cmd.Parameters.Add("P_RACK_GROUP_CODE", OracleDbType.Varchar2).Value = pDataList.RACK_GROUP_CODE.ToString();
                cmd.Parameters.Add("P_SEQUENCE_NO", OracleDbType.Varchar2).Value = pDataList.SEQUENCE_NO.ToString();
                cmd.Parameters.Add("P_PART_CATEGORY", OracleDbType.Varchar2).Value = pDataList.PART_CATEGORY.ToString();
                cmd.Parameters.Add("P_LOCK_LOCATION", OracleDbType.Varchar2).Value = pDataList.LOCK_LOCATION.ToString();
                cmd.Parameters.Add("P_FLOOR_NO", OracleDbType.Varchar2).Value = pDataList.FLOOR_NO.ToString();
                cmd.Parameters.Add("P_MAX_WEIGHT", OracleDbType.Varchar2).Value = pDataList.MAX_WEIGHT.ToString();
                cmd.Parameters.Add("P_CAPACITY_QTY", OracleDbType.Varchar2).Value = pDataList.CAPACITY_QTY.ToString();
                cmd.Parameters.Add("P_SHELVE_QTY", OracleDbType.Varchar2).Value = pDataList.SHELVE_QTY.ToString();
                cmd.Parameters.Add("P_TEMP_LOCATION", OracleDbType.Varchar2).Value = pDataList.TEMP_LOCATION.ToString();

                cmd.Parameters.Add("P_DISTANCE_RECEIVE1", OracleDbType.Varchar2).Value = pDataList.DISTANCE_RECEIVE1.ToString();
                cmd.Parameters.Add("P_DISTANCE_RECEIVE2", OracleDbType.Varchar2).Value = pDataList.DISTANCE_RECEIVE2.ToString();
                cmd.Parameters.Add("P_DISTANCE_RECEIVE3", OracleDbType.Varchar2).Value = pDataList.DISTANCE_RECEIVE3.ToString();
                cmd.Parameters.Add("P_DISTANCE_DELIVERY1", OracleDbType.Varchar2).Value = pDataList.DISTANCE_DELIVERY1.ToString();
                cmd.Parameters.Add("P_DISTANCE_DELIVERY2", OracleDbType.Varchar2).Value = pDataList.DISTANCE_DELIVERY2.ToString();
                cmd.Parameters.Add("P_DISTANCE_DELIVERY3", OracleDbType.Varchar2).Value = pDataList.DISTANCE_DELIVERY3.ToString();
                cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("P_ATTRIBUTE2", OracleDbType.Varchar2).Value = pDataList.ATTRIBUTE2.ToString();
                cmd.Parameters.Add("P_ATTRIBUTE5", OracleDbType.Varchar2).Value = pDataList.ATTRIBUTE5.ToString();
                cmd.Parameters.Add("P_IP_ADDR", OracleDbType.Varchar2).Value = IP_ADDR;
                cmd.Parameters.Add("P_LAST_UPD_PGM", OracleDbType.Varchar2).Value = "SNM033P";
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM033P_UpdateLocation");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpGet, Route("SNM033P_Delete/{location_no}")]
        [Authorize]
        // [RunBatchGuard]
        public IHttpActionResult SNM033P_Delete(string location_no)
        {

            DataSet ds = new DataSet();
            try
            {
                var IP_ADDR = HttpContext.Current.Request.UserHostAddress.ToString();
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNM033P_DELETE";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_LOCATOIN_NO", OracleDbType.Varchar2).Value = location_no;
                cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("P_IP_ADDR", OracleDbType.Varchar2).Value = IP_ADDR;
                cmd.Parameters.Add("P_LAST_UPD_PGM", OracleDbType.Varchar2).Value = "SNM033P";
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM033P_Delete");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }





        #endregion

        #region SNM108P
        [HttpPost, Route("SNM108P_GetData")]
        [Authorize]
        public IHttpActionResult SNM108P_GetData([FromBody] dynamic pParam)
        {

            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNM108P_GETDATA";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_CUSTOMER_CODE", OracleDbType.Varchar2).Value = pParam.CUSTOMER_CODE;
            cmd.Parameters.Add("P_HUB_CODE", OracleDbType.Varchar2).Value = pParam.HUB_CODE;
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));
        }

        [HttpPost, Route("SNM108P_Insert")]
        [Authorize]
        // [RunBatchGuard]
        public IHttpActionResult SNM108P_Insert([FromBody] dynamic pData)
        {
            DataSet ds = new DataSet();
            DataTable dt = new DataTable();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNM108P_INSERT";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_CUSTOMER_CODE", OracleDbType.Varchar2).Value = pData.CUSTOMER_CODE.ToString();
            cmd.Parameters.Add("P_BRANCH_CODE", OracleDbType.Varchar2).Value = pData.BRANCH_CODE.ToString();
            cmd.Parameters.Add("P_HUB_CODE", OracleDbType.Varchar2).Value = pData.HUB_CODE.ToString();
            cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
            cmd.Parameters.Add("P_LAST_UPD_PGM", OracleDbType.Varchar2).Value = "SNM108P";
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }


        [HttpPost, Route("SNM108P_Update")]
        [Authorize]
        // [RunBatchGuard]
        public IHttpActionResult SNM108P_Update([FromBody] dynamic pData)
        {
            DataSet ds = new DataSet();
            DataTable dt = new DataTable();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNM108P_UPDATE";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_CUSTOMER_CODE", OracleDbType.Varchar2).Value = pData.CUSTOMER_CODE.ToString();
            cmd.Parameters.Add("P_BRANCH_CODE", OracleDbType.Varchar2).Value = pData.BRANCH_CODE.ToString();
            cmd.Parameters.Add("P_HUB_CODE", OracleDbType.Varchar2).Value = pData.HUB_CODE.ToString();
            cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
            cmd.Parameters.Add("P_LAST_UPD_PGM", OracleDbType.Varchar2).Value = "SNM108P";
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }


        [HttpGet, Route("SNM108P_Validate/{Customer_Code}/{Branch_Code}")]
        [Authorize]
        public IHttpActionResult SNM108P_Validate(string Customer_Code, string Branch_Code)
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNM108P_VALIDATE";
            cmd.Parameters.Add("p_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_CUSTOMER_CODE", OracleDbType.Varchar2).Value = Customer_Code;
            cmd.Parameters.Add("P_BRANCH_CODE", OracleDbType.Varchar2).Value = Branch_Code;
            cmd.Parameters.Add("c_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpPost, Route("SNM108P_Delete")]
        [Authorize]
        // [RunBatchGuard]
        public IHttpActionResult SNM108P_Delete([FromBody] dynamic pData)
        {
            DataSet ds = new DataSet();
            DataTable dt = new DataTable();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNM108P_DELETE";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_CUSTOMER_CODE", OracleDbType.Varchar2).Value = pData["CUSTOMER_CODE"];
            cmd.Parameters.Add("P_BRANCH_CODE", OracleDbType.Varchar2).Value = pData["BRANCH_CODE"];
            cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
            cmd.Parameters.Add("P_LAST_UPD_PGM", OracleDbType.Varchar2).Value = "SNM108P";
            cmd.Parameters.Add("cReturn", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);


            return Json(DTFM.convertToList(ds));


        }

        [HttpGet, Route("GetCustomerAddHub/{customer}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult GetCustomerAddHub(string customer, int noofshowrec)
        {
            DataSet ds = new DataSet();

            customer = ismoUtil.escapeCharacter(customer);

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNM108P_GET_CUSTOMER";
            cmd.Parameters.Add("p_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_CUSTOMER_CODE", OracleDbType.Varchar2).Value = customer;
            cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
            cmd.Parameters.Add("c_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }
        #endregion

        #region SNPP999Z
        [HttpGet, Route("SNPP999Z_Query/{prefix_part_no}")]
        [Authorize]
        public IHttpActionResult SNPP999Z_Query(string strInvoiceNo)
        {

            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNM109P_QUERY";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = strInvoiceNo == "null" ? (object)DBNull.Value : strInvoiceNo;
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));
        }
        #endregion
        //start BF.
        #region SNSE037
        //Start BF. 10M3Y2020
        [HttpGet, Route("SNSE037_DocDate_Find/{strInvoiceDate}/{pShowRec}")]
        [Authorize]
        public IHttpActionResult SNSE037_DocDate_Find(string strInvoiceDate, int pShowRec)
        {

            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNPR037_GET_DOC_DATE";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_DOC_DATE", OracleDbType.Varchar2).Value = strInvoiceDate == "null" ? (object)DBNull.Value : strInvoiceDate;
            cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = pShowRec;
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpGet, Route("SNSE037_DocNo_Find/{strFindText}/{pShowRec}")]
        [Authorize]
        public IHttpActionResult SNSE037_DocNo_Find(string strFindText, int pShowRec)
        {

            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNPR037_GET_DOC_NO";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_FIND_TEXT", OracleDbType.Varchar2).Value = strFindText == "null" ? (object)DBNull.Value : strFindText;
            cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = pShowRec;
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpGet, Route("SNSE037_DocType_Find/{strFindText}/{pShowRec}")]
        [Authorize]
        public IHttpActionResult SNSE037_DocType_Find(string strFindText, int pShowRec)
        {

            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            //cmd.CommandText = "SP_NP_SNPR037_GET_DOC_DATE";
            cmd.CommandText = "SP_NP_SNPR037_GET_DOC_TYPE";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_FIND_TEXT", OracleDbType.Varchar2).Value = strFindText == "null" ? (object)DBNull.Value : strFindText;
            cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = pShowRec;
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }
        //End BF. 10M3Y2020
        #endregion

        #region SNSE039P

        //start BF. 25M02Y2020

        //[HttpGet, Route("SNSE039PInvoiceDateList/{InvoiceDate}/{noofshowrec}")]
        //[Authorize]
        //public IHttpActionResult SNSE039PInvoiceDateList(string InvoiceDate, int noofshowrec)
        //{
        //    DataSet ds = new DataSet();

        //    InvoiceDate = ismoUtil.escapeCharacter(InvoiceDate);

        //    try
        //    {
        //        OracleCommand cmd = new OracleCommand();
        //        cmd.CommandText = "SP_NP_SNSE039P_GET_DATE";
        //        cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
        //        cmd.Parameters.Add("P_INVOICE_DATE", OracleDbType.Varchar2).Value = InvoiceDate.ToUpper() == "NULL" ? (object)DBNull.Value : InvoiceDate;
        //        cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
        //        cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

        //        ds = oOracledb.SqlQueryDS_CMD(cmd);

        //        return Json(DTFM.convertToList(ds));
        //    }
        //    catch (Exception ex)
        //    {
        //        oOracledb.WriteLog("ErrorHandle", ex.Message, "SNSE039PInvoiceDateList");
        //        return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
        //    }
        //}

        [HttpPost, Route("SNSE039PInvoiceSeqList/{InvoiceSeq}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult SNSE039PInvoiceSeqList(string InvoiceSeq, int noofshowrec, [FromBody] dynamic pParam)
        {
            DataSet ds = new DataSet();
            var pData = pParam["DATA"];
            InvoiceSeq = ismoUtil.escapeCharacter(InvoiceSeq);

            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNSE039P_GET_SEQ_BY_DATE";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_INVOICE_DATE", OracleDbType.Varchar2).Value = pData["INVOICE_DATE"].ToString("dd-MM-yyyy");
                cmd.Parameters.Add("P_INVOICE_SEQ", OracleDbType.Varchar2).Value = InvoiceSeq.ToUpper() == "NULL" ? (object)DBNull.Value : InvoiceSeq;
                cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNSE039PInvoiceSeqList");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpPost, Route("SNSE039P_CheckDataReport")]
        [Authorize]
        public IHttpActionResult SNSE039P_CheckDataReport([FromBody] dynamic pParam)
        {
            DataSet ds = new DataSet();

            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNSE039R_P_A4_RPT";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_INVOICE_NO_FROM", OracleDbType.Varchar2).Value = pParam.BEGIN_INVOICE_NO;
                cmd.Parameters.Add("P_INVOICE_NO_TO", OracleDbType.Varchar2).Value = pParam.END_INVOICE_NO;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNSE039P_CheckDataReport");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpPost, Route("SNSE039P_SetPrintData")]
        [Authorize]
        public IHttpActionResult SNSE039P_SetPrintData([FromBody] dynamic pParam)
        {
            DataSet ds = new DataSet();

            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNSE039R_P_SET_PRINT";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_INVOICE_NO_FROM", OracleDbType.Varchar2).Value = pParam.BEGIN_INVOICE_NO;
                cmd.Parameters.Add("P_INVOICE_NO_TO", OracleDbType.Varchar2).Value = pParam.END_INVOICE_NO;
                cmd.Parameters.Add("P_PRINT_RECORD", OracleDbType.Int32).Direction = ParameterDirection.Output;

                cmd = oOracledb.SqlQueryReturnValue(cmd);
                int returnRecords;

                if (Int32.TryParse(cmd.Parameters["P_PRINT_RECORD"].Value.ToString(), out returnRecords))
                {
                    if (returnRecords > 0)
                    {
                        return Ok("Exists");
                    }
                    return Ok("No record");
                }

                return Ok("Unable to print");
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNSE039P_SetPrintData");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        //ends BF. 25M02Y2020
        #endregion

        #region SNSE054D_ZB
        //start BF. 4M03Y2020
        [HttpGet, Route("SNSE054D_ZB_PitkLotDate_Find_T/{strInvoiceDate}/{pShowRec}")]
        [Authorize]
        public IHttpActionResult SNSE054D_ZB_PitkLotDate_Find_T(string strInvoiceDate, int pShowRec)
        {

            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNSE054D_ZB_GETDATE_T";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_FIND_DATE", OracleDbType.Varchar2).Value = strInvoiceDate == "null" ? (object)DBNull.Value : strInvoiceDate;
            cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = pShowRec;
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }
        [HttpGet, Route("SNSE054D_ZB_PitkLotDate_Find_S/{strInvoiceDate}/{pShowRec}")]
        [Authorize]
        public IHttpActionResult SNSE054D_ZB_PitkLotDate_Find_S(string strInvoiceDate, int pShowRec)
        {

            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNSE054D_ZB_GETDATE_S";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_FIND_DATE", OracleDbType.Varchar2).Value = strInvoiceDate == "null" ? (object)DBNull.Value : strInvoiceDate;
            cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = pShowRec;
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpGet, Route("SNSE054D_ZB_SEQ_BY_DATE/{strInvoiceDate}/{strProcessType}")]
        [Authorize]
        public IHttpActionResult SNSE054D_ZB_SEQ_BY_DATE(string strInvoiceDate, string strProcessType)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNSE054D_ZB_GET_SEQ";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_PROCESS_TYPE", OracleDbType.Varchar2).Value = strProcessType == "null" ? (object)DBNull.Value : strProcessType.Trim();
            cmd.Parameters.Add("P_PICK_LOT_DATE", OracleDbType.Varchar2).Value = strInvoiceDate == "null" ? (object)DBNull.Value : strInvoiceDate.Trim();
            cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = 100;
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));
        }

        [HttpGet, Route("SNSE054D_ZB_CUST_BY_DATE_SEQ/{strInvoiceDate}/{strProcessType}/{strSeq}")]
        [Authorize]
        public IHttpActionResult SNSE054D_ZB_CUST_BY_DATE_SEQ(string strInvoiceDate, string strProcessType, string strSeq)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNSE054D_ZB_GET_CUST";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_PROCESS_TYPE", OracleDbType.Varchar2).Value = strProcessType == "null" ? (object)DBNull.Value : strProcessType.Trim();
            cmd.Parameters.Add("P_PICK_LOT_DATE", OracleDbType.Varchar2).Value = strInvoiceDate == "null" ? (object)DBNull.Value : strInvoiceDate.Trim();
            cmd.Parameters.Add("P_PICK_LOT_SEQ", OracleDbType.Varchar2).Value = strSeq == "null" ? (object)DBNull.Value : strSeq.Trim();
            cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = 100;
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));
        }

        [HttpGet, Route("SNSE054D_ZB_SAVE_TO_TEMP/{strInvoiceDate}/{strProcessType}/{strSeq}/{strCustomerCode}")]
        [Authorize]
        public IHttpActionResult SNSE054D_ZB_SAVE_TO_TEMP(string strInvoiceDate, string strProcessType, string strSeq, string strCustomerCode)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNSE054D_ZB_PRE_D_TO_RPT";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_PROCESS_TYPE", OracleDbType.Varchar2).Value = strProcessType == "null" ? (object)DBNull.Value : strProcessType.Trim();
            cmd.Parameters.Add("P_PICK_LOT_DATE", OracleDbType.Varchar2).Value = strInvoiceDate == "null" ? (object)DBNull.Value : strInvoiceDate.Trim();
            cmd.Parameters.Add("P_PICK_LOT_SEQ", OracleDbType.Varchar2).Value = strSeq == "null" ? (object)DBNull.Value : strSeq.Trim();
            cmd.Parameters.Add("P_CUSTOMER_CODE", OracleDbType.Varchar2).Value = strCustomerCode == "null" ? (object)DBNull.Value : strSeq.Trim();
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));
        }

        //End BF 4M03Y2020
        #endregion

        #region SNSE054D_Z
        //start BF. 26M02Y2020

        [HttpGet, Route("SNSE054D_Z_PitkLotDate_Find_E21/{strInvoiceDate}/{pShowRec}")]
        [Authorize]
        public IHttpActionResult SNSE054D_Z_PitkLotDate_Find_E21(string strInvoiceDate, int pShowRec)
        {

            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNSE054D_Z_GET_DATE_E21";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_FIND_DATE", OracleDbType.Varchar2).Value = strInvoiceDate == "null" ? (object)DBNull.Value : strInvoiceDate;
            cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = pShowRec;
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpGet, Route("SNSE054D_Z_PitkLotDate_Find_E5/{strInvoiceDate}/{pShowRec}")]
        [Authorize]
        public IHttpActionResult SNSE054D_Z_PitkLotDate_Find_E5(string strInvoiceDate, int pShowRec)
        {

            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNSE054D_Z_GET_DATE_E5";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_FIND_DATE", OracleDbType.Varchar2).Value = strInvoiceDate == "null" ? (object)DBNull.Value : strInvoiceDate;
            cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = pShowRec;
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpGet, Route("SNSE054D_Z_PitkLotDate_Find_R5/{strInvoiceDate}/{pShowRec}")]
        [Authorize]
        public IHttpActionResult SNSE054D_Z_PitkLotDate_Find_R5(string strInvoiceDate, int pShowRec)
        {

            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNSE054D_Z_GET_DATE_R5";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_FIND_DATE", OracleDbType.Varchar2).Value = strInvoiceDate == "null" ? (object)DBNull.Value : strInvoiceDate;
            cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = pShowRec;
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpGet, Route("SNSE054D_Z_PitkLotDate_Find_I3/{strInvoiceDate}/{pShowRec}")]
        [Authorize]
        public IHttpActionResult SNSE054D_Z_PitkLotDate_Find_I3(string strInvoiceDate, int pShowRec)
        {

            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNSE054D_Z_GET_DATE_I3";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_FIND_DATE", OracleDbType.Varchar2).Value = strInvoiceDate == "null" ? (object)DBNull.Value : strInvoiceDate;
            cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = pShowRec;
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpGet, Route("SNSE054D_Z_SEQ_BY_DATE/{strInvoiceDate}/{strProcessType}")]
        [Authorize]
        public IHttpActionResult SNSE054D_Z_SEQ_BY_DATE(string strInvoiceDate, string strProcessType)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNSE054D_Z_GET_SEQ";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_PROCESS_TYPE", OracleDbType.Varchar2).Value = strProcessType == "null" ? (object)DBNull.Value : strProcessType.Trim();
            cmd.Parameters.Add("P_PICK_LOT_DATE", OracleDbType.Varchar2).Value = strInvoiceDate == "null" ? (object)DBNull.Value : strInvoiceDate.Trim();
            cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = 100;
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));
        }

        [HttpGet, Route("SNSE054D_Z_CUST_BY_DATE_SEQ/{strInvoiceDate}/{strProcessType}/{strSeq}")]
        [Authorize]
        public IHttpActionResult SNSE054D_Z_CUST_BY_DATE_SEQ(string strInvoiceDate, string strProcessType, string strSeq)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNSE054D_Z_GET_CUST";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_PROCESS_TYPE", OracleDbType.Varchar2).Value = strProcessType == "null" ? (object)DBNull.Value : strProcessType.Trim();
            cmd.Parameters.Add("P_PICK_LOT_DATE", OracleDbType.Varchar2).Value = strInvoiceDate == "null" ? (object)DBNull.Value : strInvoiceDate.Trim();
            cmd.Parameters.Add("P_PICK_LOT_SEQ", OracleDbType.Varchar2).Value = strSeq == "null" ? (object)DBNull.Value : strSeq.Trim();
            cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = 100;
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));
        }

        [HttpGet, Route("SNSE054D_Z_SAVE_TO_TEMP/{strInvoiceDate}/{strProcessType}/{strSeq}/{strCustomerCode}")]
        [Authorize]
        public IHttpActionResult SNSE054D_Z_SAVE_TO_TEMP(string strInvoiceDate, string strProcessType, string strSeq, string strCustomerCode)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNSE054D_Z_PRE_D_TO_RPT";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_PROCESS_TYPE", OracleDbType.Varchar2).Value = strProcessType == "null" ? (object)DBNull.Value : strProcessType.Trim();
            cmd.Parameters.Add("P_PICK_LOT_DATE", OracleDbType.Varchar2).Value = strInvoiceDate == "null" ? (object)DBNull.Value : strInvoiceDate.Trim();
            cmd.Parameters.Add("P_PICK_LOT_SEQ", OracleDbType.Varchar2).Value = strSeq == "null" ? (object)DBNull.Value : strSeq.Trim();
            cmd.Parameters.Add("P_CUSTOMER_CODE", OracleDbType.Varchar2).Value = strCustomerCode == "null" ? (object)DBNull.Value : strCustomerCode.Trim();
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));
        }
        //end BF. 26M02Y2020
        #endregion


        #region SNSR041
        //start BF. 24M12Y2019
        [HttpGet, Route("SNSR041_FindCustomer/{strInvoiceDate}/{pShowRec}")]
        [Authorize]
        public IHttpActionResult SNSR041_FindCustomer(string strInvoiceDate, int pShowRec)
        {

            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNSR041_CUSTOMER";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_CUSTOMER_CODE", OracleDbType.Varchar2).Value = strInvoiceDate == "null" ? (object)DBNull.Value : strInvoiceDate;
            cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = pShowRec;
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpGet, Route("SNSR041_Customer_Info/{prefix_Customer_Code}")]
        [Authorize]
        public IHttpActionResult SNSR041_Customer_Info(string prefix_Customer_Code)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNSR041_CUST_INFO";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_CUSTOMER_CODE", OracleDbType.Varchar2).Value = prefix_Customer_Code == "null" ? (object)DBNull.Value : prefix_Customer_Code.ToString().Trim();
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor, ParameterDirection.Output);

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));
        }

        [HttpGet, Route("SNSR041_DocumentByCustomer/{prefix_Customer_Code}")]
        [Authorize]
        public IHttpActionResult SNSR041_DocumentByCustomer(string prefix_Customer_Code)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNSR041_DOC_NO";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_CUSTOMER_CODE", OracleDbType.Varchar2).Value = prefix_Customer_Code == "null" ? (object)DBNull.Value : prefix_Customer_Code.ToString().Trim();
            //cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16, 100, ParameterDirection.Input);

            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor, ParameterDirection.Output);

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));
        }
        #endregion

        #region SNSR040
        [HttpGet, Route("SNSR040_FindCustomer40/{strInvoiceDate}/{pShowRec}")]
        [Authorize]
        public IHttpActionResult SNSR040_FindCustomer40(string strInvoiceDate, int pShowRec)
        {

            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNSR040_CUSTOMER40";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_CUSTOMER_CODE", OracleDbType.Varchar2).Value = strInvoiceDate == "null" ? (object)DBNull.Value : strInvoiceDate;
            cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = pShowRec;
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }


        [HttpGet, Route("SNSR040_Customer_Info/{prefix_Customer_Code}")]
        [Authorize]
        public IHttpActionResult SNSR040_Customer_Info(string prefix_Customer_Code)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNSR040_CUST_INFO";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_CUSTOMER_CODE", OracleDbType.Varchar2).Value = prefix_Customer_Code == "null" ? (object)DBNull.Value : prefix_Customer_Code.ToString().Trim();
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor, ParameterDirection.Output);

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));
        }

        [HttpGet, Route("SNSR040_DocumentByCustomer/{prefix_Customer_Code}")]
        [Authorize]
        public IHttpActionResult SNSR040_DocumentByCustomer(string prefix_Customer_Code)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNSR040_DOC_NO";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_CUSTOMER_CODE", OracleDbType.Varchar2).Value = prefix_Customer_Code == "null" ? (object)DBNull.Value : prefix_Customer_Code.ToString().Trim();
            //cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16, 100, ParameterDirection.Input);

            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor, ParameterDirection.Output);

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));
        }

        [HttpPost, Route("SNSR040_SaveStickerBeforePrint")]
        public IHttpActionResult SNSR040_SaveStickerBeforePrint([FromBody] dynamic data)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            gSQL = "SP_NP_SNSR040_SAVE_STICKER";

            try
            {
                cmd.CommandText = gSQL;
                cmd.CommandType = CommandType.StoredProcedure;
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                var IP_ADDR = HttpContext.Current.Request.UserHostAddress.ToString();
                cmd.Parameters.Add("P_IP", OracleDbType.Varchar2).Value = IP_ADDR;
                cmd.Parameters.Add("P_CUSTOMER_CODE", OracleDbType.Varchar2).Value = data["CUSTOMER_CODE"].ToString();
                cmd.Parameters.Add("P_CUSTOMER_NAME", OracleDbType.Varchar2).Value = data["CUSTOMER_NAME"].ToString();
                cmd.Parameters.Add("P_CUSTOMER_AMPHUR", OracleDbType.Varchar2).Value = data["CUSTOMER_AMPHUR"].ToString();
                cmd.Parameters.Add("P_CUSTOMER_PROVINCE", OracleDbType.Varchar2).Value = data["CUSTOMER_PROVINCE"].ToString();
                cmd.Parameters.Add("P_BRANCH_CODE", OracleDbType.Varchar2).Value = data["BRANCH_CODE"].ToString();
                cmd.Parameters.Add("P_BRANCH_NAME", OracleDbType.Varchar2).Value = data["BRANCH_NAME"].ToString();
                cmd.Parameters.Add("P_CASHEER_NO", OracleDbType.Varchar2).Value = data["CASHEER_NO"].ToString();
                cmd.Parameters.Add("P_DOCUMENT_NO", OracleDbType.Varchar2).Value = data["DOCUMENT_NO"].ToString();
                cmd.Parameters.Add("P_C_TOTAL_PAGE", OracleDbType.Int32).Value = data["C_TOTAL_PAGE"];
                cmd.Parameters.Add("P_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor, ParameterDirection.Output);

                ds = oOracledb.SqlQueryDS_CMD(cmd);
            }
            catch (Exception ex)
            {
                System.Console.WriteLine("Exception: {0}", ex.ToString());
            }

            return Json(DTFM.convertToList(ds));
        }

        //For auto complete version
        [HttpPost, Route("SNSR040_GET_DOCUMENT/{prefix_Doc_No}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult SNSR040_GET_DOCUMENT(string prefix_Doc_No, int noofshowrec, [FromBody] dynamic pParam)
        {
            //For Document Autocomplete
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNSR040_DOC_NO";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_DOCUMENT_NO", OracleDbType.Varchar2).Value = prefix_Doc_No == "null" ? (object)DBNull.Value : prefix_Doc_No.ToString().Trim();
            cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16, noofshowrec, ParameterDirection.Input);
            //cmd.Parameters.Add("P_CUSTOMER_CODE", OracleDbType.Varchar2).Value = prefix_Doc_No == "null" ? (object)DBNull.Value : prefix_Doc_No.ToString().Trim();
            cmd.Parameters.Add("P_CUSTOMER_CODE", OracleDbType.Varchar2, pParam["CUSTOMER_CODE"], ParameterDirection.Input);
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor, ParameterDirection.Output);

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));
        }
        //ends BF. 24M12Y2019
        #endregion

        #region SNSE052

        //start BF. 15M03Y2020
        [HttpGet, Route("SNSE052_FindCustomer/{strInvoiceDate}/{pShowRec}")]
        [Authorize]
        public IHttpActionResult SNSE052_FindCustomer(string strInvoiceDate, int pShowRec)
        {

            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNSE052_GET_CUSTOMER";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_FIND_TEXT", OracleDbType.Varchar2).Value = strInvoiceDate == "null" ? (object)DBNull.Value : strInvoiceDate;
            cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = pShowRec;
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpPost, Route("SNSE052_DocumentByCustomer/{pOrderNo}/{pShowRec}")]
        [Authorize]
        public IHttpActionResult SNSE052_DocumentByCustomer(string pOrderNo, int pShowRec, [FromBody] dynamic pParams)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNSE052_GET_ORDERNO";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_CUSTOMER_CODE", OracleDbType.Varchar2).Value = pParams.CustomerCode.ToString().Trim();
            cmd.Parameters.Add("P_ORDER_NO", OracleDbType.Varchar2).Value = pOrderNo == "null" ? (object)DBNull.Value : pOrderNo;
            cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = pShowRec;

            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor, ParameterDirection.Output);

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));
        }


        [HttpPost, Route("SNSE052_SearchData")]
        [Authorize]
        public IHttpActionResult SNSE052_SearchData([FromBody] dynamic data)
        {
            string prefix_Customer_Code = data["CUSTOMER_CODE"].ToString();
            string prefix_Order_No = data["ORDER_NO"].ToString();
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNSE052_SCH_RESULT";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_CUSTOMER_CODE", OracleDbType.Varchar2).Value = prefix_Customer_Code == "null" ? (object)DBNull.Value : prefix_Customer_Code.ToString().Trim();
            cmd.Parameters.Add("P_ORDER_NO", OracleDbType.Varchar2).Value = prefix_Order_No == "null" ? (object)DBNull.Value : prefix_Order_No.ToString().Trim();
            //cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16, 100, ParameterDirection.Input);

            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor, ParameterDirection.Output);

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));
        }

        [HttpPost, Route("SNSE052_ClearOldData")]
        [Authorize]
        public IHttpActionResult SNSE052_ClearOldData([FromBody] dynamic data)
        {
            string strIP = data["pIP"].ToString();
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNSE052_CLEAR_ROW";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_IP", OracleDbType.Varchar2).Value = strIP == "null" ? (object)DBNull.Value : strIP.ToString().Trim();

            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor, ParameterDirection.Output);

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));
        }

        [HttpPost, Route("SNSE052_SaveRowSelect")]
        [Authorize]
        public IHttpActionResult SNSE052_SaveRowSelect([FromBody] dynamic data)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNSE052_SAVE_ROW";

            cmd.Parameters.Add("P_IP", OracleDbType.Varchar2).Value = data["pIP"].ToString().Trim() == "null" ? (object)DBNull.Value : data["pIP"].ToString().Trim();
            cmd.Parameters.Add("P_AUTO_PRINT", OracleDbType.Varchar2).Value = data["pAUTO_PRINT"].ToString().Trim() == "null" ? (object)DBNull.Value : data["pAUTO_PRINT"].ToString().Trim();
            cmd.Parameters.Add("P_SELECT", OracleDbType.Varchar2).Value = data["pSELECT"].ToString().Trim() == "null" ? (object)DBNull.Value : data["pSELECT"].ToString().Trim();

            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_CUSTOMER_CODE", OracleDbType.Varchar2).Value = data["CUSTOMER_CODE"].ToString().Trim() == "null" ? (object)DBNull.Value : data["CUSTOMER_CODE"].ToString().Trim();
            cmd.Parameters.Add("P_ORDER_NO", OracleDbType.Varchar2).Value = data["ORDER_NO"].ToString().Trim() == "null" ? (object)DBNull.Value : data["ORDER_NO"].ToString().Trim();
            cmd.Parameters.Add("P_ITEM_NO", OracleDbType.Varchar2).Value = data["ITEM_NO"].ToString().Trim() == "null" ? (object)DBNull.Value : data["ITEM_NO"].ToString().Trim();
            cmd.Parameters.Add("P_SUB_ITEM_NO", OracleDbType.Varchar2).Value = data["SUB_ITEM_NO"].ToString().Trim() == "null" ? (object)DBNull.Value : data["SUB_ITEM_NO"].ToString().Trim();
            cmd.Parameters.Add("P_INSTRUCTION_NO", OracleDbType.Varchar2).Value = data["INSTRUCTION_NO"].ToString().Trim() == "null" ? (object)DBNull.Value : data["INSTRUCTION_NO"].ToString().Trim();

            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor, ParameterDirection.Output);

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));
            //return Json(DTFM.convertToList("Done"));
        }

        [HttpPost, Route("SNSE052_SaveAllRow")]
        [Authorize]
        public IHttpActionResult SNSE052_SaveAllRow([FromBody] dynamic data)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNSE052_SAVE_ALL";

            cmd.Parameters.Add("P_IP", OracleDbType.Varchar2).Value = data["pIP"].ToString().Trim() == "null" ? (object)DBNull.Value : data["pIP"].ToString().Trim();
            cmd.Parameters.Add("P_AUTO_PRINT", OracleDbType.Varchar2).Value = data["pAUTO_PRINT"].ToString().Trim() == "null" ? (object)DBNull.Value : data["pAUTO_PRINT"].ToString().Trim();
            cmd.Parameters.Add("P_SELECT", OracleDbType.Varchar2).Value = data["pSELECT"].ToString().Trim() == "null" ? (object)DBNull.Value : data["pSELECT"].ToString().Trim();

            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_CUSTOMER_CODE", OracleDbType.Varchar2).Value = data["CUSTOMER_CODE"].ToString().Trim() == "null" ? (object)DBNull.Value : data["CUSTOMER_CODE"].ToString().Trim();
            cmd.Parameters.Add("P_ORDER_NO", OracleDbType.Varchar2).Value = data["ORDER_NO"].ToString().Trim() == "null" ? (object)DBNull.Value : data["ORDER_NO"].ToString().Trim();

            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor, ParameterDirection.Output);

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));
            //return Json(DTFM.convertToList("Done"));
        }
        //end BF

        #endregion



        //ends BF.



        #region SNPE013
        [HttpGet, Route("SNPE013_GetVendor/{vendorcode}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult SNPE013_GetVendor(string vendorcode, int noofshowrec)
        {
            DataSet ds = new DataSet();

            vendorcode = ismoUtil.escapeCharacter(vendorcode);

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNPE013_VENDOR_CODE";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = vendorcode != null && vendorcode == "null" ? "" : vendorcode;
            cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpPost, Route("SNPE013_GetInvoice/{invoiceNo}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult SNPE013_GetInvoice(string invoiceNo, int noofshowrec, [FromBody] dynamic oParams)
        {
            DataSet ds = new DataSet();

            invoiceNo = ismoUtil.escapeCharacter(invoiceNo);

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNPE013_INVOICE_NO";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = oParams.vendorCode;
            cmd.Parameters.Add("P_INOVICE_NO", OracleDbType.Varchar2).Value = invoiceNo != null && invoiceNo == "null" ? "" : invoiceNo;
            cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpGet, Route("SNPE013_GetData/{vendorCode}/{invoiceNo}/{invoiceDate}")]
        [Authorize]
        public IHttpActionResult SNPE013_GetData(string vendorCode, string invoiceNo, string invoiceDate)
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNPE013_GET_DATA";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = vendorCode;
            cmd.Parameters.Add("P_INOVICE_NO", OracleDbType.Varchar2).Value = ismoUtil.escapeCharacter(invoiceNo);
            cmd.Parameters.Add("P_INVOICE_DATE", OracleDbType.Date).Value = Convert.ToDateTime(invoiceDate);
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpPost, Route("SNPE013_SavetoShelve/{vendorCode}/{invoiceNo}/{statusCode}")]
        [Authorize]
        public IHttpActionResult SNPE013_SavetoShelve([FromBody] dynamic[] pDetails, string vendorCode, string invoiceNo, string statusCode)
        {
            if (pDetails.Length > 0)
            {
                OracleCommand cmd = new OracleCommand();
                foreach (var detail in pDetails)
                {
                    cmd = new OracleCommand();
                    cmd.CommandText = "SP_NP_SNPE013_SAVE_DETAIL";
                    cmd.Parameters.Add("P_PO_NO", OracleDbType.Varchar2).Value = detail["PO_NO"];
                    cmd.Parameters.Add("P_ITEM_NO", OracleDbType.Varchar2).Value = detail["ITEM_NO"];
                    cmd.Parameters.Add("P_SUB_ITEM_NO", OracleDbType.Varchar2).Value = detail["SUB_ITEM_NO"];
                    cmd.Parameters.Add("P_ACCEPT_PART_NO", OracleDbType.Varchar2).Value = detail["ACCEPT_PART_NO"];
                    cmd.Parameters.Add("P_QUANTITY", OracleDbType.Int16).Value = detail["ACCEPT_QTY"];
                    cmd.Parameters.Add("P_STATUS_CODE", OracleDbType.Varchar2).Value = detail["STATUS_CODE"];
                    cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);

                    oOracledb.SqlQueryReturnValue(cmd);
                }

                try
                {
                    cmd = new OracleCommand();
                    cmd.CommandText = "SP_NP_SNPE013_SAVE_TO_SHELVE";
                    cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                    cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = vendorCode;
                    cmd.Parameters.Add("P_INOVICE_NO", OracleDbType.Varchar2).Value = ismoUtil.escapeCharacter(invoiceNo);
                    cmd.Parameters.Add("P_STATUS_CODE", OracleDbType.Varchar2).Value = statusCode;
                    cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);

                    oOracledb.SqlQueryReturnValue(cmd);

                }
                catch (Exception ex)
                {
                    return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
                }

                return Json("Done");
            }

            return ResponseMessage(Request.CreateResponse(HttpStatusCode.NoContent, "No row to process."));
        }
        #endregion

        #region SNSE182

        [HttpGet, Route("SNSE182_Current_Loca_Find/{CurrentLoca}/{numberrecord}")]
        [Authorize]
        public IHttpActionResult SNSE182_Current_Loca_Find(string CurrentLoca, int numberrecord)
        {
            try
            {
                DataSet ds = new DataSet();

                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNSE182_CURRENTLO_FINE";
                cmd.Parameters.Add("P_CURRENT_LOCA", OracleDbType.Varchar2, CurrentLoca != null && CurrentLoca == "null" ? "" : CurrentLoca, ParameterDirection.Input);
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor, ParameterDirection.Output);

                ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNSE182_Current_Loca_Find");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpGet, Route("SNSE182_Parts_No_Find/{PartsNo}/{numberrecord}")]
        [Authorize]
        public IHttpActionResult SNSE182_Parts_No_Find(string PartsNo, int numberrecord)
        {
            try
            {
                DataSet ds = new DataSet();

                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNSE182_PART_NO_FINE";
                cmd.Parameters.Add("P_PARTS_NO", OracleDbType.Varchar2, PartsNo != null && PartsNo == "null" ? "" : PartsNo, ParameterDirection.Input);
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor, ParameterDirection.Output);

                ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNSE182_Parts_No_Find");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpGet, Route("SNSE182_New_Location_Find/{NewLacation}/{numberrecord}")]
        [Authorize]
        public IHttpActionResult SNSE182_New_Location_Find(string NewLacation, int numberrecord)
        {
            try
            {
                DataSet ds = new DataSet();

                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNSE182_NEW_LOCA_FINE";
                cmd.Parameters.Add("P_NEW_LOCATION", OracleDbType.Varchar2, NewLacation != null && NewLacation == "null" ? "" : NewLacation, ParameterDirection.Input);
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor, ParameterDirection.Output);

                ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNSE182_New_Location_Find");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpGet, Route("SNSE182_PrintDate_Find/{PrintDate}/{numberrecord}")]
        [Authorize]
        public IHttpActionResult SNSE182_PrintDate_Find(string PrintDate, int numberrecord)
        {
            try
            {
                DataSet ds = new DataSet();

                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNSE182_PRINT_DATE_FINE";
                cmd.Parameters.Add("P_PRINT_DATE", OracleDbType.Varchar2, PrintDate != null && PrintDate == "null" ? "" : PrintDate, ParameterDirection.Input);
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor, ParameterDirection.Output);

                ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNSE182_PrintDate_Find");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpPost, Route("SNSE182_GetRelocationParts")]
        [Authorize]
        public IHttpActionResult SNSE182_GetRelocationParts([FromBody] dynamic pData)
        {
            try
            {
                DataSet ds = new DataSet();
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNSE182_GET_RELOCA_PARTS";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_FROM_LOCATION_NO", OracleDbType.Varchar2).Value = pData.FROM_LOCATION_NO;
                cmd.Parameters.Add("P_TO_LOCATION_NO", OracleDbType.Varchar2).Value = pData.TO_LOCATION_NO;
                cmd.Parameters.Add("P_FROM_NEW_LOCATION", OracleDbType.Varchar2).Value = pData.FROM_NEW_LOCATION;
                cmd.Parameters.Add("P_TO_NEW_LOCATION", OracleDbType.Varchar2).Value = pData.TO_NEW_LOCATION;
                cmd.Parameters.Add("P_FROM_PARTS_NO", OracleDbType.Varchar2).Value = pData.FROM_PARTS_NO;
                cmd.Parameters.Add("P_TO_PARTS_NO", OracleDbType.Varchar2).Value = pData.TO_PARTS_NO;
                cmd.Parameters.Add("P_FROM_PRINT_DATE", OracleDbType.Varchar2).Value = pData.FROM_PRINT_CODE.ToString("dd-MM-yyyy");
                cmd.Parameters.Add("P_TO_PRINT_DATE", OracleDbType.Varchar2).Value = pData.TO_PRINT_CODE.ToString("dd-MM-yyyy");
                cmd.Parameters.Add("P_STATUS_CODE", OracleDbType.Varchar2).Value = pData.STATUS_CODE;
                cmd.Parameters.Add("P_UPD_FLAG", OracleDbType.Varchar2).Value = pData.UPD_FLAG;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNSE182_GetRelocationParts");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }


        [HttpPost, Route("SNSE182_GetRelocationLog")]
        [Authorize]
        public IHttpActionResult SNSE182_GetRelocationLog([FromBody] dynamic data)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            gSQL = "SP_NP_SNSE182_GET_RELOCA_LOG";

            try
            {
                cmd.CommandText = gSQL;
                cmd.CommandType = CommandType.StoredProcedure;
                cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = data.PARTS_NO.ToString();
                cmd.Parameters.Add("P_PRINT_CODE", OracleDbType.Varchar2).Value = data.PRINT_CODE.ToString();
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);
            }
            catch (Exception ex)
            {
                System.Console.WriteLine("Exception: {0}", ex.ToString());
            }

            return Json(DTFM.convertToList(ds));
        }

        [HttpPost, Route("SNSE182_ConfirmUpdateLocation")]
        [Authorize]
        [RunBatchGuard]
        public IHttpActionResult SNSE182_ConfirmUpdateLocation([FromBody] dynamic[] pPart)
        {
            OracleCommand cmd;
            foreach (var vPart in pPart)
            {
                try
                {
                    cmd = new OracleCommand();
                    cmd.CommandText = "SP_NP_SNSE182_CONFIRM_UPDATE";
                    cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                    cmd.Parameters.Add("P_PRINT_CODE", OracleDbType.Varchar2).Value = vPart["PRINT_CODE"].ToString();
                    cmd.Parameters.Add("P_PARTS_NO", OracleDbType.Varchar2).Value = vPart["PARTS_NO"].ToString();
                    cmd.Parameters.Add("P_NEW_LOCATION", OracleDbType.Varchar2).Value = vPart["NEW_LOCATION"].ToString();
                    cmd.Parameters.Add("P_UPD_FLAG", OracleDbType.Varchar2).Value = vPart["UPD_FLAG"].ToString();
                    cmd.Parameters.Add("P_IP_ADDRESS", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_IP_ADDRESS);
                    cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                }
                catch (Exception ex)
                {
                    oOracledb.WriteLog("ErrorHandle", ex.Message, "SNSE182_ConfirmUpdateLocation");
                    return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
                }

            }

            return Ok();
        }


        //[HttpPost, Route("SNSE182_GetRelocationParts_Export")]
        //[Authorize]
        //public HttpResponseMessage SNSE182_GetRelocationParts_Export([FromBody] dynamic data)
        //{
        //    DataSet ds = new DataSet();

        //    string xxx = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);

        //    OracleCommand cmd = new OracleCommand();
        //    cmd.CommandText = "SP_NP_SNSE182_EXP_RELOCA_PARTS";
        //    cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
        //    cmd.Parameters.Add("P_FROM_LOCATION_NO", OracleDbType.Varchar2).Value = data["FROM_LOCATION_NO"].ToString() == "" ? (object)DBNull.Value : data["FROM_LOCATION_NO"].ToString();
        //    cmd.Parameters.Add("P_TO_LOCATION_NO", OracleDbType.Varchar2).Value = data["TO_LOCATION_NO"].ToString() == "" ? (object)DBNull.Value : data["TO_LOCATION_NO"].ToString();
        //    cmd.Parameters.Add("P_FROM_NEW_LOCATION", OracleDbType.Varchar2).Value = data["FROM_NEW_LOCATION"].ToString() == "" ? (object)DBNull.Value : data["FROM_NEW_LOCATION"].ToString();
        //    cmd.Parameters.Add("P_TO_NEW_LOCATION", OracleDbType.Varchar2).Value = data["TO_NEW_LOCATION"].ToString() == "" ? (object)DBNull.Value : data["TO_NEW_LOCATION"].ToString();
        //    cmd.Parameters.Add("P_FROM_PARTS_NO", OracleDbType.Varchar2).Value = data["FROM_PARTS_NO"].ToString() == "" ? (object)DBNull.Value : data["FROM_PARTS_NO"].ToString();
        //    cmd.Parameters.Add("P_TO_PARTS_NO", OracleDbType.Varchar2).Value = data["TO_PARTS_NO"].ToString() == "" ? (object)DBNull.Value : data["TO_PARTS_NO"].ToString();
        //    cmd.Parameters.Add("P_FROM_PRINT_DATE", OracleDbType.Varchar2).Value = data["FROM_PRINT_CODE"].ToString() == "" ? (object)DBNull.Value : data["FROM_PRINT_CODE"].ToString();
        //    cmd.Parameters.Add("P_TO_PRINT_DATE", OracleDbType.Varchar2).Value = data["TO_PRINT_CODE"].ToString() == "" ? (object)DBNull.Value : data["TO_PRINT_CODE"].ToString();
        //    cmd.Parameters.Add("P_STATUS_CODE", OracleDbType.Varchar2).Value = data["STATUS_CODE"].ToString() == "" ? (object)DBNull.Value : data["STATUS_CODE"].ToString();
        //    cmd.Parameters.Add("P_UPD_FLAG", OracleDbType.Varchar2).Value = data["UPD_FLAG"].ToString() == "" ? (object)DBNull.Value : data["UPD_FLAG"].ToString();
        //    cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor, ParameterDirection.Output);

        //    ds = oOracledb.SqlQueryDS_CMD(cmd);


        //    string x = SNSE182_ReloParts_Export(ds.Tables[0], "SNSE182_Relocation_Parts.csv", "SNSE182");
        //    SystemApiController sys = new SystemApiController();
        //    var respons = sys.downloadFile(x.Substring(1), "SNSE182_Relocation_Parts.csv");
        //    return respons;

        //}

        //public static string SNSE182_ReloParts_Export(DataTable dt, string fileName, string FloderLocation)
        //{

        //    bool Succes = false;
        //    //DataTable dt = new DataTable();
        //    //dt = ds.Tables[0];
        //    string gLocation = "~/tempFile/" + FloderLocation + "/";
        //    string gWriteLocation = System.Web.HttpContext.Current.Server.MapPath(gLocation);

        //    FileInfo filePath = new FileInfo(gWriteLocation);
        //    filePath.Directory.Create();
        //    string gFileLocation = Path.Combine(gWriteLocation, fileName);
        //    string gReturnLocation = Path.Combine(gLocation, fileName);
        //    SystemApiController sys = new SystemApiController();
        //    try
        //    {
        //        StringBuilder sb = new StringBuilder();

        //        IEnumerable<string> columnNames = dt.Columns.Cast<DataColumn>().Select(column => column.ColumnName);
        //        sb.AppendLine(string.Join(",", columnNames));

        //        foreach (DataRow row in dt.Rows)
        //        {
        //            for (int i = 0; i < dt.Columns.Count; i++)
        //            {

        //                sb.Append(CsvEscape(row[i].ToString()));
        //                sb.Append(i == dt.Columns.Count - 1 ? "\n" : ",");
        //            }
        //        }

        //        File.WriteAllText(gFileLocation, sb.ToString());

        //        Succes = true;
        //    }
        //    catch (Exception ex)
        //    {
        //        Console.WriteLine(ex);
        //    }

        //    if (Succes)
        //    {
        //        return gReturnLocation;
        //    }
        //    else
        //    {

        //        return "";
        //    }

        //}

        //[HttpPost, Route("SNSE182_GetRelocationLog_Export")]
        //[Authorize]
        //public HttpResponseMessage GetBO_By_PartNo([FromBody] dynamic data)
        //{
        //    DataSet ds = new DataSet();

        //    OracleCommand cmd = new OracleCommand();
        //    cmd.CommandText = "SP_NP_SNSE182_EXP_RELOCA_LOG";
        //    cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = data.PartNO;
        //    cmd.Parameters.Add("P_PRINT_CODE", OracleDbType.Varchar2).Value = data.PrintCode;
        //    cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

        //    ds = oOracledb.SqlQueryDS_CMD(cmd);


        //    string x = SNSE182_ReloLog_Export(ds.Tables[0], "SNSE182_Relocation_Log.csv", "SNSE182");
        //    SystemApiController sys = new SystemApiController();
        //    var respons = sys.downloadFile(x.Substring(1), "SNSE182_Relocation_Log.csv");
        //    return respons;

        //}

        //public static string SNSE182_ReloLog_Export(DataTable dt, string fileName, string FloderLocation)
        //{

        //    bool Succes = false;
        //    //DataTable dt = new DataTable();
        //    //dt = ds.Tables[0];
        //    string gLocation = "~/tempFile/" + FloderLocation + "/";
        //    string gWriteLocation = System.Web.HttpContext.Current.Server.MapPath(gLocation);

        //    FileInfo filePath = new FileInfo(gWriteLocation);
        //    filePath.Directory.Create();
        //    string gFileLocation = Path.Combine(gWriteLocation, fileName);
        //    string gReturnLocation = Path.Combine(gLocation, fileName);
        //    SystemApiController sys = new SystemApiController();
        //    try
        //    {
        //        StringBuilder sb = new StringBuilder();

        //        IEnumerable<string> columnNames = dt.Columns.Cast<DataColumn>().Select(column => column.ColumnName);
        //        sb.AppendLine(string.Join(",", columnNames));

        //        foreach (DataRow row in dt.Rows)
        //        {
        //            for (int i = 0; i < dt.Columns.Count; i++)
        //            {

        //                sb.Append(CsvEscape(row[i].ToString()));
        //                sb.Append(i == dt.Columns.Count - 1 ? "\n" : ",");
        //            }
        //        }

        //        File.WriteAllText(gFileLocation, sb.ToString());

        //        Succes = true;
        //    }
        //    catch (Exception ex)
        //    {
        //        Console.WriteLine(ex);
        //    }

        //    if (Succes)
        //    {
        //        return gReturnLocation;
        //    }
        //    else
        //    {

        //        return "";
        //    }

        //}
        static string CsvEscape(string value)
        {
            if (value.Contains(","))
            {
                return "\"" + value.Replace("\"", "\"\"") + "\"";
            }
            return value;
        }

        #endregion

        #region SNPR029

        [HttpGet, Route("SNPR029_GetPart/{partNo}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult SNPR029_GetPart(string partNo, int noofshowrec)
        {
            DataSet ds = new DataSet();

            partNo = ismoUtil.escapeCharacter(partNo);

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNPR029_GETPART";
            cmd.Parameters.Add("p_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("p_PART_NO", OracleDbType.Varchar2).Value = partNo;
            cmd.Parameters.Add("p_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
            cmd.Parameters.Add("c_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        public IHttpActionResult SNPR029_DELETE()
        {
            var row = 0;
            string sql = "DELETE FROM TPM_SEQ_SNPR029";
            row = oOracledb.SqlExecute(sql);
            return Ok(row);
        }

        [HttpPost, Route("SNPR029_INSERT")]
        [Authorize]
        [RunBatchGuard]
        public IHttpActionResult SNPR029_INSERT([FromBody] dynamic[] pDataList)
        {
            DataSet ds = new DataSet();
            SNPR029_DELETE();
            foreach (var data in pDataList)
            {

                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNPR029_INSERT";
                cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = data["PART_NO"].ToString();
                cmd.Parameters.Add("P_QTY", OracleDbType.Varchar2).Value = data["QTY"].ToString();
                cmd.Parameters.Add("P_PRN", OracleDbType.Varchar2).Value = data["PRN"].ToString();
                ds = oOracledb.SqlQueryDS_CMD(cmd);

            }
            return Ok("DONE");
        }
        #endregion

        #region SNSE195

        [HttpGet, Route("SNSE195_Customer_Find/{Customer}/{numberrecord}")]
        [Authorize]
        public IHttpActionResult SNSE195_Customer_Find(string Customer, int numberrecord)
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNSE195_CUSTOMER_FINE";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_CUSTOMER_CODE", OracleDbType.Varchar2, Customer != null && Customer == "null" ? "" : Customer, ParameterDirection.Input);
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor, ParameterDirection.Output);

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpPost, Route("SNSE195_GetCustomerLabel")]
        [Authorize]
        public IHttpActionResult SNSE195_GetCustomerLabel([FromBody] dynamic data)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            gSQL = "SP_NP_SNSE195_CUS_LABEL_BKK";

            try
            {
                cmd.CommandText = gSQL;
                cmd.CommandType = CommandType.StoredProcedure;
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_CUSTOMER_CODE", OracleDbType.Varchar2).Value = data.CUSTOMER_CODE.ToString();
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);
            }
            catch (Exception ex)
            {
                System.Console.WriteLine("Exception: {0}", ex.ToString());
            }

            return Json(DTFM.convertToList(ds));
        }

        [HttpPost, Route("SNSE195_CustomerBKK_Save")]
        [Authorize]
        public IHttpActionResult SNSE195_CustomerBKK_Save([FromBody] dynamic data)
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNSE195_CUS_LABEL_SAVE";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_LABEL_NAME", OracleDbType.Varchar2).Value = data["LABEL_NAME"].ToString();
            cmd.Parameters.Add("P_ROUTE_CODE", OracleDbType.Varchar2).Value = data["ROUTE_CODE"].ToString();
            cmd.Parameters.Add("P_CUSTOMER_CODE", OracleDbType.Varchar2).Value = data["CUSTOMER_CODE"].ToString();
            cmd.Parameters.Add("P_BRANCH_CODE", OracleDbType.Varchar2).Value = data["BRANCH_CODE"].ToString();
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Ok("Done");
        }

        [HttpPost, Route("SNSE195_CustomerBKK_Add")]
        [Authorize]
        public IHttpActionResult SNSE195_CustomerBKK_Add([FromBody] dynamic data)
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNSE195_CUS_LABEL_ADD";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_CUSTOMER_CODE", OracleDbType.Varchar2).Value = data["CUSTOMER_CODE"].ToString();
            cmd.Parameters.Add("P_BRANCH_CODE", OracleDbType.Varchar2).Value = data["BRANCH_CODE"].ToString();
            cmd.Parameters.Add("P_LABEL_NAME", OracleDbType.Varchar2).Value = data["LABEL_NAME"].ToString();
            cmd.Parameters.Add("P_ROUTE_CODE", OracleDbType.Varchar2).Value = data["ROUTE_CODE"].ToString();
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Ok("Done");
        }

        [HttpPost, Route("SNSE195_GetCustomerLabel_Export")]
        [Authorize]
        public HttpResponseMessage SNSE195_GetCustomerLabel_Export([FromBody] dynamic data)
        {
            DataSet ds = new DataSet();
            DataTable dt = new DataTable();

            string xxx = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNSE195_EXP_CUS_BKK";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_CUSTOMER_CODE", OracleDbType.Varchar2).Value = data.CUSTOMER_CODE.ToString();
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            dt = ds.Tables[0];

            var json = JsonConvert.SerializeObject(dt);
            var List1 = JsonConvert.DeserializeObject<List<DataModel.SNSE195>>(json);
            HttpResponseMessage response = new HttpResponseMessage(HttpStatusCode.OK);
            string gLocation = "~/tempFile/" + "SNSE195" + "/";
            string gWriteLocation = System.Web.HttpContext.Current.Server.MapPath(gLocation);
            FileInfo filePath = new FileInfo(gWriteLocation);
            filePath.Directory.Create();
            string gFileLocation = Path.Combine(gWriteLocation, "SNSE195_CustomerLabel(BKK).xlsx");
            string gReturnLocation = Path.Combine(gLocation, "SNSE195_CustomerLabel(BKK).xlsx");
            var excel2 = List1.ToExcel(
            x => x
            .AddColumn("SEQ", z => z.SEQ)
            .AddColumn("CUSTOMER_CODE", z => z.CUSTOMER_CODE)
            .AddColumn("BRANCH_CODE", z => z.BRANCH_CODE)
            .AddColumn("LABEL_NAME", z => z.LABEL_NAME)
            .AddColumn("ROUTE_CODE", z => z.ROUTE_CODE)
            );
            byte[] excel = excel2;
            File.WriteAllBytes(gFileLocation, excel);
            string path = HttpContext.Current.Server.MapPath("~/" + gReturnLocation.Substring(1));
            if (!File.Exists(path))
            {
                return Request.CreateErrorResponse(HttpStatusCode.NotFound, "File not found.");
            }
            try
            {
                string mimeType = MimeMapping.GetMimeMapping("SNSE195_CustomerLabel(BKK).xlsx");
                StreamContent x = new StreamContent(new FileStream(path, FileMode.Open, FileAccess.Read));
                response.Content = x;
                response.Content.Headers.ContentType = new MediaTypeHeaderValue(mimeType);
                response.Content.Headers.ContentDisposition = new ContentDispositionHeaderValue("attachment");
                response.Content.Headers.ContentDisposition.FileName = "SNSE195_CustomerLabel(BKK).xlsx";
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNSE195_Download");
                return Request.CreateResponse(HttpStatusCode.BadRequest, ex);
            }
            return response;

            //string x = SNSE195_CustomerLabelBKK_Export(ds.Tables[0], "SNSE195_CustomerLabel(BKK).xlsx", "SNSE195");
            //SystemApiController sys = new SystemApiController();
            //var respons = sys.downloadFile(x.Substring(1), "SNSE195_CustomerLabel.xlsx");
            //return respons;

        }

        public static string SNSE195_CustomerLabelBKK_Export(DataTable dt, string fileName, string FloderLocation)
        {

            bool Succes = false;
            //DataTable dt = new DataTable();
            //dt = ds.Tables[0];
            string gLocation = "~/tempFile/" + FloderLocation + "/";
            string gWriteLocation = System.Web.HttpContext.Current.Server.MapPath(gLocation);

            FileInfo filePath = new FileInfo(gWriteLocation);
            filePath.Directory.Create();
            string gFileLocation = Path.Combine(gWriteLocation, fileName);
            string gReturnLocation = Path.Combine(gLocation, fileName);
            SystemApiController sys = new SystemApiController();
            try
            {
                StringBuilder sb = new StringBuilder();

                IEnumerable<string> columnNames = dt.Columns.Cast<DataColumn>().Select(column => column.ColumnName);
                sb.AppendLine(string.Join(",", columnNames));

                foreach (DataRow row in dt.Rows)
                {
                    for (int i = 0; i < dt.Columns.Count; i++)
                    {

                        sb.Append(CsvEscape(row[i].ToString()));
                        sb.Append(i == dt.Columns.Count - 1 ? "\n" : ",");
                    }
                }

                File.WriteAllText(gFileLocation, sb.ToString());

                Succes = true;
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex);
            }

            if (Succes)
            {
                return gReturnLocation;
            }
            else
            {

                return "";
            }

        }

        #endregion


        #region SNPR029_M

        [HttpGet, Route("SNPR029_M_GetPart/{partNo}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult SNPR029_M_GetPart(string partNo, int noofshowrec)
        {
            DataSet ds = new DataSet();

            partNo = ismoUtil.escapeCharacter(partNo);

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNPR029_GETPART";
            cmd.Parameters.Add("p_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("p_PART_NO", OracleDbType.Varchar2).Value = partNo;
            cmd.Parameters.Add("p_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
            cmd.Parameters.Add("c_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpGet, Route("SNPR029_M_Branch/{CustomerCode?}")]
        [Authorize]
        public IHttpActionResult SNPR029_M_Branch(string CustomerCode = null)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNPR029_M_GET_BRANCH";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_CUSTOMER_CODE", OracleDbType.Varchar2).Value = CustomerCode;
            cmd.Parameters.Add("c_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        public IHttpActionResult SNPR029_M_DELETE()
        {
            var row = 0;
            string sql = "DELETE FROM TPM_SEQ_SNPR029_M";
            row = oOracledb.SqlExecute(sql);
            return Ok(row);
        }

        [HttpPost, Route("SNPR029_M_INSERT")]
        [Authorize]
        [RunBatchGuard]
        public IHttpActionResult SNPR029_M_INSERT([FromBody] dynamic[] pDataList)
        {
            DataSet ds = new DataSet();
            SNPR029_M_DELETE();
            foreach (var data in pDataList)
            {

                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNPR029_M_INSERT";
                cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = data["PART_NO"].ToString();
                cmd.Parameters.Add("P_QTY", OracleDbType.Varchar2).Value = data["QTY"].ToString();
                cmd.Parameters.Add("P_PRN", OracleDbType.Varchar2).Value = data["PRN"].ToString();
                cmd.Parameters.Add("P_REMARK", OracleDbType.Varchar2).Value = data["REMARK"].ToString();
                ds = oOracledb.SqlQueryDS_CMD(cmd);

            }
            return Ok("DONE");
        }
        #endregion

        #region SNM102P


        [HttpPost, Route("SNM102P_UploadandGet")]
        [Authorize]
        public async Task<IHttpActionResult> SNM102P_UploadandGet(HttpRequestMessage request)
        {
            try




            {





                if (!request.Content.IsMimeMultipartContent())
                {
                    throw new HttpResponseException(HttpStatusCode.UnsupportedMediaType);
                }

                var reqParts = await request.Content.ReadAsMultipartAsync();

                string FullfileName = String.Concat("SNM102P", "-", DateTime.Now.ToString("yyyyMMddHHmm"), ".CSV");
                string outputLocation = "~/tempFile/" + "SNM102P" + "/";
                string outputPath = System.Web.HttpContext.Current.Server.MapPath(outputLocation);
                string fileLocation = String.Concat(outputPath, FullfileName);

                foreach (var file in reqParts.Contents)
                {

                    var buffer = await file.ReadAsByteArrayAsync();


                    DataService.SaveBytesToFileByLocation(buffer
                                                    , fileLocation
                                                    , fileLocation);
                }
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNM102P_DELETE_TEMP";
                cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                oOracledb.SqlQueryReturnValue(cmd);
                string Header = "PART_NO,PART_NAME,STICKER_PACKAGE,NET_WEIGHT,DIMENSION_MAX,DIMENSION_MID,DIMENSION_MIN";
                DataTable dt = DataService.ConvertCSVtoDataTable(fileLocation, Header);
                int count = 0;
                foreach (DataRow data in dt.Rows)
                {
                    count++;
                    cmd = new OracleCommand();
                    cmd.CommandText = "SP_NP_SNM102P_INSERT_TEMP";
                    cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = data["PART_NO"].ToString();
                    cmd.Parameters.Add("P_PART_NAME", OracleDbType.Varchar2).Value = data["PART_NAME"].ToString();
                    cmd.Parameters.Add("P_STICKER_PACKAGE", OracleDbType.Varchar2).Value = data["STICKER_PACKAGE"].ToString();
                    cmd.Parameters.Add("P_NET_WEIGHT", OracleDbType.Varchar2).Value = data["NET_WEIGHT"].ToString();
                    cmd.Parameters.Add("P_DIMENSION_MAX", OracleDbType.Varchar2).Value = data["DIMENSION_MAX"].ToString();
                    cmd.Parameters.Add("P_DIMENSION_MID", OracleDbType.Varchar2).Value = data["DIMENSION_MID"].ToString();
                    cmd.Parameters.Add("P_DIMENSION_MIN", OracleDbType.Varchar2).Value = data["DIMENSION_MIN"].ToString();
                    cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                    oOracledb.SqlQueryReturnValue(cmd);
                }
                DataSet ds = SNM102P_ValidateAndGet();
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM102P_UploadandGet");
                throw new HttpResponseException(HttpStatusCode.NotAcceptable);
            }
        }

        [HttpGet, Route("SNM102P_ValidateAndGet")]
        public DataSet SNM102P_ValidateAndGet()
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "sp_NP_SNM102P_VALIDATE_AND_GET";
            cmd.Parameters.Add("P_COM_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
            cmd.Parameters.Add("C_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return ds;
        }


        [HttpPost, Route("SNM102P_Update")]
        [Authorize]
        public IHttpActionResult SNM102P_Update([FromBody] dynamic[] pDataList)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd;

            try
            {
                foreach (var data in pDataList)
                {
                    cmd = new OracleCommand();
                    cmd.CommandText = "SP_NP_SNM102P_UPDATE";
                    cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                    cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = data["PART_NO"];
                    cmd.Parameters.Add("P_NET_WEIGHT", OracleDbType.Varchar2).Value = data["NET_WEIGHT"];
                    cmd.Parameters.Add("P_STICKER_PACKAGE", OracleDbType.Varchar2).Value = data["STICKER_PACKAGE"];
                    cmd.Parameters.Add("P_PART_SIZE_MAX", OracleDbType.Varchar2).Value = data["PART_SIZE_MAX"];
                    cmd.Parameters.Add("P_PART_SIZE_MID", OracleDbType.Varchar2).Value = data["PART_SIZE_MID"];
                    cmd.Parameters.Add("P_PART_SIZE_MIN", OracleDbType.Varchar2).Value = data["PART_SIZE_MIN"];
                    cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Int16).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                    cmd.Parameters.Add("P_LAST_UPD_PGM", OracleDbType.Varchar2).Value = "SNM102P";
                    ds = oOracledb.SqlQueryDS_CMD(cmd);
                }
                cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNM102P_UPDATE_PART_MASTER";
                cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Int16).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("P_IP_ADDR", OracleDbType.Varchar2).Value = HttpContext.Current.Request.UserHostAddress;
                cmd.Parameters.Add("P_LAST_UPD_PGM", OracleDbType.Varchar2).Value = "SNM102P";
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;


                ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM102P_Update");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.ExpectationFailed, ex.Message));
            }

        }
        #endregion



        #region SNSE202

        [HttpGet, Route("SNSE202_Get_Sugguestion_Header/{processDate}")]
        [Authorize]
        public IHttpActionResult SNSE202_Get_Sugguestion_Header(string processDate)
        {
            DataSet ds = new DataSet();

            processDate = ismoUtil.escapeCharacter(processDate);

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "sp_np_snse202_get_sugg_header";
            cmd.Parameters.Add("P_PROCESSDATE", OracleDbType.Varchar2).Value = processDate != "@@@" ? processDate : null;
            cmd.Parameters.Add("cReturn", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpGet, Route("SNSE202_Get_Sugguestion_Part/{processDate}")]
        [Authorize]
        public IHttpActionResult SNSE202_Get_Sugguestion_Part(string processDate)
        {
            DataSet ds = new DataSet();


            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "sp_np_snse202_get_sugg_part";
            cmd.Parameters.Add("P_PROCESSDATE", OracleDbType.Date).Value = Convert.ToDateTime(processDate);
            cmd.Parameters.Add("cSugguestionList", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            cmd.Parameters.Add("cPartExclue", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpPost, Route("SNSE202_Retrive_Incoming_Part")]
        [Authorize]
        public IHttpActionResult SNSE202_Retrive_Incoming_Part([FromBody] dynamic pData)
        {

            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNSE202_RETR_INCOM_PARTS";
            cmd.Parameters.Add("P_COM_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_PROCESS_DATE", OracleDbType.Date).Value = Convert.ToDateTime(pData.PROCESS_DATE);
            cmd.Parameters.Add("P_RANGE_NEW_PART", OracleDbType.Varchar2).Value = pData.RANGE_NEW_PART;
            cmd.Parameters.Add("P_RANGE_ETD_INCOMING", OracleDbType.Varchar2).Value = pData.RANGE_ETD_INCOMING;
            cmd.Parameters.Add("P_CREATE_BY", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
            cmd.Parameters.Add("P_LAST_UPD_PGM", OracleDbType.Varchar2).Value = "SNSE202";
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));
        }

        [HttpPost, Route("SNSE202_Confirm_Factor")]
        [Authorize]
        public IHttpActionResult SNSE202_Confirm_Factor([FromBody] dynamic pData)
        {

            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNSE202_CONFIRM_FACTOR";
            cmd.Parameters.Add("P_COM_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_PROCESS_DATE", OracleDbType.Date).Value = Convert.ToDateTime(pData.PROCESS_DATE);
            cmd.Parameters.Add("P_LAST_UPD_PGM", OracleDbType.Varchar2).Value = "SNSE202";
            cmd.Parameters.Add("P_LAST_UPD_BY", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));
        }

        [HttpPost, Route("SNSE202_Parts_Move")]
        [Authorize]
        public IHttpActionResult SNSE202_Parts_Move([FromBody] dynamic[] pData)
        {
            int ErrCount = 0;
            DataSet ds = new DataSet();
            foreach (var item in pData)
            {
                if (item.IS_CHECK != null)
                {
                    if (item.IS_CHECK.Value)
                    {
                        OracleCommand cmd = new OracleCommand();
                        cmd.CommandText = "SP_NP_SNSE202_PART_MOVE";
                        cmd.Parameters.Add("P_COM_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                        cmd.Parameters.Add("P_PROCESS_DATE", OracleDbType.Date).Value = Convert.ToDateTime(item.PROCESS_DATE);
                        cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = item.PART_NO;
                        cmd.Parameters.Add("P_LAST_UPD_PGM", OracleDbType.Varchar2).Value = "SNSE202";
                        cmd.Parameters.Add("P_LAST_UPD_BY", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                        cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                        ds = oOracledb.SqlQueryDS_CMD(cmd);
                        if (ds != null & ds.Tables.Count > 0 & ds.Tables[0].Rows.Count > 0)
                        {
                            if (ds.Tables[0].Rows[0]["STATUS"].ToString() != "DONE")
                            {
                                ErrCount++;
                            }
                        }
                    }
                }
            }
            if (ErrCount == 0)
            {
                return Json("DONE");
            }
            else
            {
                return Json("Error : " + ErrCount + " Record");
            }
        }

        [HttpPost, Route("SNSE202_Update_Dimension")]
        [Authorize]
        public IHttpActionResult SNSE202_Update_Dimension([FromBody] dynamic pData)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNSE202_UPDATE_DIMENSION";
            cmd.Parameters.Add("P_COM_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_PROCESS_DATE", OracleDbType.Date).Value = Convert.ToDateTime(pData.PROCESS_DATE);
            cmd.Parameters.Add("P_LAST_UPD_PGM", OracleDbType.Varchar2).Value = "SNSE202";
            cmd.Parameters.Add("P_LAST_UPD_BY", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));
        }

        [HttpPost, Route("Process_Suggestion")]
        [Authorize]
        public IHttpActionResult Process_Suggestion([FromBody] dynamic[] pData)
        {
            String CatList = "";
            foreach (var item in pData)
            {
                if (string.IsNullOrEmpty(Convert.ToString(item.ATTRIBUTE1)))
                {
                    if (item.ESTIMATE_CATEGORY == "1" || item.ESTIMATE_CATEGORY == "2" || item.ESTIMATE_CATEGORY == "3")
                    {
                        CatList = CatList.Contains("F") ? CatList : CatList + "F,";
                        continue;
                    }
                    if (item.ESTIMATE_CATEGORY == "4" || item.ESTIMATE_CATEGORY == "5")
                    {
                        CatList = CatList.Contains("M") ? CatList : CatList + "M,";
                        continue;
                    }
                    CatList = CatList.Contains("S") ? CatList : CatList + "S,"; ;
                }
            }
            if (CatList.Length > 0)
            {
                CatList = CatList.Substring(0, CatList.Length - 1);
                DataSet ds = new DataSet();
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNSE202_PROCESS_SUGGEST";
                cmd.Parameters.Add("P_COM_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_CATAEGORY_LIST", OracleDbType.Varchar2).Value = CatList;
                cmd.Parameters.Add("P_PROCESS_DATE", OracleDbType.Date).Value = Convert.ToDateTime(pData[0].PROCESS_DATE);
                cmd.Parameters.Add("P_LAST_UPD_PGM", OracleDbType.Varchar2).Value = "SNSE202";
                cmd.Parameters.Add("P_LAST_UPD_BY", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            else
            {
                return Json(new { STATUS = "DONE" });
            }


        }
        [HttpPost, Route("SNSE202_Export")]
        public HttpResponseMessage SNSE202_Export(List<DataModel.SNSE202> dModel)
        {
            DataTable dt = new DataTable();
            string x = string.Empty;
            string filename = "SNSE202.csv";
            string floderLocation = "SNSE202";
            //dt = DTFM.ToDatatable<DataModel.SNPE044>(dModel);


            dt.Columns.Add("Process Date");
            dt.Columns.Add("Part No.");
            dt.Columns.Add("Part Name");
            dt.Columns.Add("Incoming Q'ty");
            dt.Columns.Add("Group Average Demand");
            dt.Columns.Add("Estimate Stock");
            dt.Columns.Add("Estimate Category");
            dt.Columns.Add("Suggest Location No.");
            dt.Columns.Add("Message");

            for (var i = 0; i < dModel.Count; i++)
            {
                DataRow dr = dt.NewRow();
                dr[0] = dModel[i].PROCESS_DATE;
                dr[1] = dModel[i].PART_NO;
                dr[2] = dModel[i].PART_NO;
                dr[3] = dModel[i].INCOMING_QTY;
                dr[4] = dModel[i].AVERAGE_DEMAND;
                dr[5] = dModel[i].ESTIMATE_STOCK;
                dr[6] = dModel[i].ESTIMATE_CATEGORY;
                dr[7] = dModel[i].LOCATION_NO;
                dr[8] = dModel[i].ATTRIBUTE1;
                dt.Rows.Add(dr);

            }

            dt.Rows.Add("E");

            x = DataService.WriteCSV(dt, filename, floderLocation, "SNSE202");
            Controllers.SystemApiController response = new Controllers.SystemApiController();
            var File = response.downloadFile(x.Substring(1), filename);
            return File;
        }
        [HttpPost, Route("ConFirm_Location")]
        [Authorize]
        public IHttpActionResult ConFirm_Location([FromBody] dynamic[] pData)
        {
            String PartList = "";
            foreach (var item in pData)
            {
                if (Convert.ToBoolean(item.IS_CHECK))
                {
                    PartList = PartList + item.PART_NO + ",";
                }
            }
            if (PartList.Length > 0)
            {
                PartList = PartList.Substring(0, PartList.Length - 1);
                DataSet ds = new DataSet();
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNSE202_UPDATE_LOCATION";
                cmd.Parameters.Add("P_COM_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_PROCESS_DATE", OracleDbType.Date).Value = Convert.ToDateTime(pData[0].PROCESS_DATE);
                cmd.Parameters.Add("P_LAST_UPD_PGM", OracleDbType.Varchar2).Value = "SNSE202";
                cmd.Parameters.Add("P_LAST_UPD_BY", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("P_PART_LIST", OracleDbType.Varchar2).Value = PartList;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            else
            {
                return Json(new { STATUS = "NO_CHECK" });
            }


        }
        #endregion

        #region SNSE064_M2

        [HttpGet, Route("SNSE064_M2_REF_RO_NO/{returnRequestNo}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult SNSE064_M2_REF_RO_NO(string returnRequestNo, int noofshowrec)
        {
            DataSet ds = new DataSet();

            returnRequestNo = ismoUtil.escapeCharacter(returnRequestNo);

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNSE064_M2_REF_RO_NO";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_REF_RO_NO", OracleDbType.Varchar2).Value = returnRequestNo.ToUpper() == "NULL" ? (object)DBNull.Value : returnRequestNo;
            cmd.Parameters.Add("p_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpPost, Route("SNSE064_M2_Search")]
        [Authorize]
        public IHttpActionResult SNSE064_M2_Search([FromBody] dynamic param)
        {
            DataSet ds = new DataSet();

            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNSE064_M2_QUERY";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_REF_RO_NO", OracleDbType.Varchar2).Value = param.REF_RO_NO;
                cmd.Parameters.Add("P_CUSTOMER_CODE", OracleDbType.Varchar2).Value = param.CUSTOMER_CODE;
                cmd.Parameters.Add("P_REQUEST_DATE", OracleDbType.Varchar2).Value = param.REQUEST_DATE;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNSE064_M2_Search");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpGet, Route("SNSE064_M2_GetDetail/{returnRequestNo}")]
        [Authorize]
        public IHttpActionResult SNSE064_M2_GetDetail(string returnRequestNo)
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNSE064_M2_GET_DETAIL";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_REF_RO_NO", OracleDbType.Varchar2).Value = returnRequestNo;
            cmd.Parameters.Add("C_RETURN_H", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            cmd.Parameters.Add("C_RETURN_D", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        #endregion  1

        #region SNPE034

        [HttpGet, Route("SNPE034_GetDocList/{docno}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult SNPE034_GetDocList(string docno, int noofshowrec)
        {
            DataSet ds = new DataSet();

            docno = ismoUtil.escapeCharacter(docno);

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNPE034_DOC_LIST";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_DOCUMENT_NO", OracleDbType.Varchar2).Value = docno.ToUpper() == "NULL" ? (object)DBNull.Value : docno;
            cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));
        }


        [HttpGet, Route("SNPE034_GetInvList/{invoiceno}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult SNPE034_GetInvList(string invoiceno, int noofshowrec)
        {
            DataSet ds = new DataSet();

            invoiceno = ismoUtil.escapeCharacter(invoiceno);

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNPE034_INV_LIST";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = invoiceno.ToUpper() == "NULL" ? (object)DBNull.Value : invoiceno;
            cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));
        }


        [HttpPost, Route("SNPE034_GetDocumentList")]
        [Authorize]
        public IHttpActionResult SNPE034_GetDocumentList([FromBody] dynamic pData)
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNPE034_DOCUMENTS";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_DOCUMENT_NO", OracleDbType.Varchar2).Value = pData.DocumentNo;
            cmd.Parameters.Add("P_DOCUMENT_DATE", OracleDbType.Date).Value = pData.DocumentDate != null ? Convert.ToDateTime(pData.DocumentDate) : (Object)DBNull.Value;
            cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = pData.InvoiceNo;
            cmd.Parameters.Add("P_INVOICE_DATE", OracleDbType.Date).Value = pData.InvoiceDate != null ? Convert.ToDateTime(pData.InvoiceDate) : (Object)DBNull.Value;
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));
        }

        [HttpGet, Route("SNPE034_CheckDocument/{docno}")]
        [Authorize]
        public IHttpActionResult SNPE034_CheckDocument(string docno)
        {
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNPE034_CHECK_DOCUMENT";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_DOCUMENT_NO", OracleDbType.Varchar2).Value = docno;
            cmd.Parameters.Add("C_RETURN_HEAD", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            cmd.Parameters.Add("C_RETURN_DETAIL", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            DataSet ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }
        [HttpPost, Route("SNPE034_CheckDocument")]
        [Authorize]
        public IHttpActionResult SNPE034_CheckDocument([FromBody] dynamic pData)
        {
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNPE034_CHECK_DOC_BYINV";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pData.VendorCode;
            cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = pData.InvoiceNo;
            cmd.Parameters.Add("C_RETURN_HEAD", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            cmd.Parameters.Add("C_RETURN_DETAIL", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            DataSet ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpGet, Route("SNPE034_GetBasePrice/{partno}")]
        [Authorize]
        public IHttpActionResult SNPE034_GetBasePrice(string partno)
        {
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNPE034_GET_BASE_PRICE";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = partno;
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            cmd.Parameters.Add("C_RETURN2", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            DataSet ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpPost, Route("SNPE034_SaveDocument")]
        [Authorize]
        public IHttpActionResult SNPE034_SaveDocument([FromBody] dynamic[] pDetail)
        {
            int iCount = 0;
            OracleCommand cmd = new OracleCommand();

            if (pDetail.Length > 0)
            {

                //Run insert detail
                foreach (var detail in pDetail)
                {


                    iCount++;
                    cmd = new OracleCommand();
                    cmd.CommandText = "SP_NP_SNPE034_SAVE_DETAIL_TEMP";
                    cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = pDetail[0]["INVOICE_NO"];
                    cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pDetail[0]["VENDOR_CODE"];
                    cmd.Parameters.Add("P_ITEM_NO", OracleDbType.Int16).Value = iCount;
                    cmd.Parameters.Add("P_ACCEPT_PART_NO", OracleDbType.Varchar2).Value = detail["ACCEPT_PART_NO"];
                    cmd.Parameters.Add("P_QUANTITY", OracleDbType.Double).Value = detail["ITEM_QTY"];
                    cmd.Parameters.Add("P_UNIT_PRICE", OracleDbType.Double).Value = detail["UNIT_PRICE"];

                    cmd.Parameters.Add("P_EXP_CLEANRANCE_AMT_B", OracleDbType.Double).Value = detail["EXP_CLEANRANCE_AMT_B"];
                    cmd.Parameters.Add("P_EXP_OTHER_AMT_B", OracleDbType.Double).Value = detail["EXP_OTHER_AMT_B"];
                    cmd.Parameters.Add("P_INCOME_TAX", OracleDbType.Double).Value = detail["INCOME_TAX"];
                    cmd.Parameters.Add("P_EXCISE_TAX", OracleDbType.Double).Value = detail["EXCISE"];
                    cmd.Parameters.Add("P_INTERIOR_TAX", OracleDbType.Double).Value = detail["INTERIOR"];
                    cmd.Parameters.Add("P_DUTY_RATE", OracleDbType.Double).Value = detail["DUTY_RATE"];



                    cmd.Parameters.Add("P_CLEAR_DATA", OracleDbType.Varchar2).Value = iCount == 1 ? "Y" : "N";
                    cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);

                    oOracledb.SqlQueryReturnValue(cmd);

                }

                //Insert transaction
                cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNPE034_SAVE_TRANSACTION";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = pDetail[0]["INVOICE_NO"];
                cmd.Parameters.Add("P_INVOICE_DATE", OracleDbType.Date).Value = DateTime.Parse(pDetail[0]["INVOICE_DATE"].ToString());
                cmd.Parameters.Add("P_BL_AWB_DATE", OracleDbType.Date).Value = DateTime.Parse(pDetail[0]["BL_AWB_DATE"].ToString());


                cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pDetail[0]["VENDOR_CODE"];
                cmd.Parameters.Add("P_SENT_BY", OracleDbType.Varchar2).Value = pDetail[0]["SENT_BY"];
                cmd.Parameters.Add("P_ORDER_CLASS", OracleDbType.Varchar2).Value = pDetail[0]["ORDER_CLASS"];
                cmd.Parameters.Add("P_ORDER_TYPE", OracleDbType.Varchar2).Value = pDetail[0]["ORDER_TYPE"];

                cmd.Parameters.Add("P_EXP_CLEANRANCE_AMT_B", OracleDbType.Double).Value = pDetail[0]["TOTAL_EXP_CLEANRANCE_AMT_B"];
                cmd.Parameters.Add("P_EXP_OTHER_AMT_B", OracleDbType.Double).Value = pDetail[0]["TOTAL_EXP_OTHER_AMT_B"];
                cmd.Parameters.Add("P_INCOME_TAX", OracleDbType.Double).Value = pDetail[0]["TOTAL_INCOME_TAX"];

                cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("R_DOCUMENT_NO", OracleDbType.Varchar2, 50).Direction = ParameterDirection.Output;

                cmd = oOracledb.SqlQueryReturnValue(cmd);

                string documentNo = cmd.Parameters["R_DOCUMENT_NO"].Value.ToString();

                return Json(new { DOCUMENT_NO = documentNo });
            }

            return ResponseMessage(Request.CreateResponse(HttpStatusCode.BadRequest, "No row to process."));

        }

        [HttpPost, Route("SNPE034_DeleteDocument")]
        [Authorize]
        public IHttpActionResult SNPE034_DeleteDocument([FromBody] dynamic pData)
        {
            OracleCommand cmd = new OracleCommand();

            try
            {
                cmd.CommandText = "SP_NP_SNPE034_DELETE_DOC";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_DOCUMENT_NO", OracleDbType.Varchar2).Value = pData.DocumentNo;
                cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pData.VendorCode;
                cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = pData.InvoiceNo;
                cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);

                oOracledb.SqlQueryReturnValue(cmd);

                return Json("Done");
            }
            catch (OracleException ex)
            {
                string err_status = string.Empty;

                if (ex.Number == 20001)
                {
                    err_status = "INVOICE_ERROR";
                }
                else if (ex.Number == 20002)
                {
                    err_status = "CONFIRMED";
                }
                else
                {
                    err_status = "CONTACT";
                }

                return Ok(err_status);
            }
            catch (Exception ex)
            {
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.NotAcceptable, ex.Message));
            }
        }
        #endregion



        #region SNM110P
        [HttpGet, Route("SNM110P_GetCategory/{mainCategory}")]
        [Authorize]
        public IHttpActionResult SNM110P_GetCategory(string mainCategory)
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNM110P_GET_CATEGORY";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_MAIN_CATEGORY", OracleDbType.Varchar2).Value = mainCategory.ToUpper() == "NULL" ? (object)DBNull.Value : mainCategory;
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpGet, Route("SNM110P_GetOverlapLocation/{mainCategory}/{subCategory}/{fromLocation}/{toLocation}")]
        [Authorize]
        public IHttpActionResult SNM110P_GetOverlapLocation(string mainCategory, string subCategory, string fromLocation, string toLocation)
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNM110P_OVERLAP_LOCATION";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_MAIN_CATEGORY", OracleDbType.Varchar2).Value = mainCategory;
            cmd.Parameters.Add("P_SUB_CATEGORY", OracleDbType.Varchar2).Value = subCategory;
            cmd.Parameters.Add("P_FROM_LOCATION", OracleDbType.Varchar2).Value = fromLocation;
            cmd.Parameters.Add("P_TO_LOCATION", OracleDbType.Varchar2).Value = toLocation;
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }


        [HttpPost, Route("SNM110P_AddCategoryLocation/{mainCategory}/{subCategory}/{fromLocation}/{toLocation}")]
        [Authorize]
        public IHttpActionResult SNM110P_AddCategoryLocation(string mainCategory, string subCategory, string fromLocation, string toLocation)
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNM110P_ADD";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_MAIN_CATEGORY", OracleDbType.Varchar2).Value = mainCategory;
            cmd.Parameters.Add("P_SUB_CATEGORY", OracleDbType.Varchar2).Value = subCategory;
            cmd.Parameters.Add("P_FROM_LOCATION", OracleDbType.Varchar2).Value = fromLocation;
            cmd.Parameters.Add("P_TO_LOCATION", OracleDbType.Varchar2).Value = toLocation;
            cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }


        [HttpPost, Route("SNM110P_DeleteCategoryLocation/{mainCategory}/{subCategory}/{fromLocation}/{toLocation}")]
        [Authorize]
        // [RunBatchGuard]
        public IHttpActionResult SNM110P_DeleteCategoryLocation(string mainCategory, string subCategory, string fromLocation, string toLocation)
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNM110P_DELETE";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_MAIN_CATEGORY", OracleDbType.Varchar2).Value = mainCategory;
            cmd.Parameters.Add("P_SUB_CATEGORY", OracleDbType.Varchar2).Value = subCategory;
            cmd.Parameters.Add("P_FROM_LOCATION", OracleDbType.Varchar2).Value = fromLocation;
            cmd.Parameters.Add("P_TO_LOCATION", OracleDbType.Varchar2).Value = toLocation;
            cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }
        #endregion

        #region SNSD162

        [HttpGet, Route("SNSD162_GetPartNo/{part_no=null}/{noofshowrec= null}")]
        [Authorize]
        public IHttpActionResult SNSD162_GetPartNo(string part_no = null, string noofshowrec = null)
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNSD162_GET_PART";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = part_no != "null" ? part_no : "";
            cmd.Parameters.Add("c_return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }
        #endregion

        #region SNSE181

        [HttpPost, Route("SNSE181_UploadFiles")]
        [Authorize]
        public async Task<IHttpActionResult> SNSE181_UploadFiles(HttpRequestMessage request)
        {
            DataSet ds = new DataSet();
            if (!request.Content.IsMimeMultipartContent())
            {
                throw new HttpResponseException(HttpStatusCode.UnsupportedMediaType);
            }
            var reqParts = await request.Content.ReadAsMultipartAsync();
            try
            {
                foreach (var file in reqParts.Contents)
                {
                    var buffer = await file.ReadAsByteArrayAsync();
                    string gFileName = file.Headers.ContentDisposition.FileName.Trim('\"');
                    string gRootPath = System.Web.HttpContext.Current.Server.MapPath("~/tempFile/SNSD181/Process/");
                    if (!Directory.Exists(gRootPath))
                    {
                        Directory.CreateDirectory(gRootPath);
                    }
                    string gFileLocation = System.IO.Path.Combine(gRootPath, gFileName);
                    File.WriteAllBytes(gFileLocation, buffer);
                    ds.Tables.Add();
                    ds.Tables[0].Columns.Add("SEQ");
                    ds.Tables[0].Columns.Add("PRINT_DATE");
                    ds.Tables[0].Columns.Add("PARTS_NO");
                    ds.Tables[0].Columns.Add("LOCATION_NO");
                    ds.Tables[0].Columns.Add("NEW_LOCATION");
                    ds.Tables[0].Columns.Add("LOC_DIV");
                    ds.Tables[0].Columns.Add("RELO_QTY");
                    ds.Tables[0].Columns.Add("PICK_QTY");
                    ds.Tables[0].Columns.Add("CASE_NO");
                    ds.Tables[0].Columns.Add("PICK_DATE");
                    ds.Tables[0].Columns.Add("PICK_HT_DATE");
                    ds.Tables[0].Columns.Add("PICK_HT_TIME");
                    ds.Tables[0].Columns.Add("SHELVE_QTY");
                    ds.Tables[0].Columns.Add("SHELVE_DATE");
                    ds.Tables[0].Columns.Add("SHELVE_HT_DATE");
                    ds.Tables[0].Columns.Add("SHELVE_HT_TIME");
                    ds.Tables[0].Columns.Add("STATUS_CODE");
                    string line;
                    System.IO.StreamReader fileRd = new System.IO.StreamReader(gFileLocation);
                    try
                    {
                        int rowCount = 0;
                        while ((line = fileRd.ReadLine()) != null)
                        {
                            if (rowCount > 0)
                            {
                                string[] temp = line.Split(',');

                                OracleCommand cmd = new OracleCommand();
                                cmd.CommandText = "SP_NP_SNSE181_SAVE_LOG";
                                cmd.Parameters.Add("P_SEQ_NO", OracleDbType.Varchar2).Value = temp[0];
                                cmd.Parameters.Add("P_PRINT_CODE", OracleDbType.Varchar2).Value = temp[1];
                                cmd.Parameters.Add("P_PARTS_NO", OracleDbType.Varchar2).Value = temp[2];
                                cmd.Parameters.Add("P_LOCATION_NO", OracleDbType.Varchar2).Value = temp[3];
                                cmd.Parameters.Add("P_NEW_LOCATION", OracleDbType.Varchar2).Value = temp[4];
                                cmd.Parameters.Add("P_LOC_DIV", OracleDbType.Varchar2).Value = temp[5];
                                cmd.Parameters.Add("P_RELO_QTY", OracleDbType.Varchar2).Value = temp[6];
                                cmd.Parameters.Add("P_PICK_QTY", OracleDbType.Varchar2).Value = temp[7];
                                cmd.Parameters.Add("P_CASE_NO", OracleDbType.Varchar2).Value = temp[8];
                                if (temp[9].ToString() != "")
                                {
                                    cmd.Parameters.Add("P_PICK_DATE", OracleDbType.Date).Value = Convert.ToDateTime(temp[9]);
                                }
                                else
                                {
                                    cmd.Parameters.Add("P_PICK_DATE", OracleDbType.Date).Value = DBNull.Value;
                                }
                                cmd.Parameters.Add("P_PICK_HT_DATE", OracleDbType.Varchar2).Value = temp[10];
                                cmd.Parameters.Add("P_PICK_HT_TIME", OracleDbType.Varchar2).Value = temp[11];
                                cmd.Parameters.Add("P_SHELVE_QTY", OracleDbType.Varchar2).Value = temp[12];
                                if (temp[13].ToString() != "")
                                {
                                    cmd.Parameters.Add("P_SHELVE_DATE", OracleDbType.Date).Value = Convert.ToDateTime(temp[13]);// ;
                                }
                                else
                                {
                                    cmd.Parameters.Add("P_SHELVE_DATE", OracleDbType.Date).Value = DBNull.Value;
                                }
                                cmd.Parameters.Add("P_SHELVE_HT_DATE", OracleDbType.Varchar2).Value = temp[14];
                                cmd.Parameters.Add("P_SHELVE_HT_TIME", OracleDbType.Varchar2).Value = temp[15];
                                cmd.Parameters.Add("P_STATUS_CODE", OracleDbType.Varchar2).Value = temp[16];
                                cmd.Parameters.Add("P_CREATE_BY", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                                cmd.Parameters.Add("P_CREATE_PGM", OracleDbType.Varchar2).Value = "SNSE181";
                                cmd.Parameters.Add("P_FILE_NAME", OracleDbType.Varchar2).Value = gFileName.ToUpper().Replace(".CSV", "");
                                cmd.Parameters.Add("c_return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                                DataSet dsRes = oOracledb.SqlQueryDS_CMD(cmd);

                                if (dsRes != null)
                                {
                                    if (dsRes.Tables.Count > 0 && dsRes.Tables[0].Rows.Count > 0)
                                    {
                                        DataRow dr = ds.Tables[0].NewRow();
                                        dr["SEQ"] = rowCount;
                                        dr["PRINT_DATE"] = temp[1];
                                        dr["PARTS_NO"] = temp[2];
                                        dr["LOCATION_NO"] = temp[3];
                                        dr["NEW_LOCATION"] = temp[4];
                                        dr["LOC_DIV"] = temp[5];
                                        dr["RELO_QTY"] = temp[6];
                                        dr["PICK_QTY"] = temp[7];
                                        dr["CASE_NO"] = temp[8];
                                        dr["PICK_DATE"] = temp[9];
                                        dr["PICK_HT_DATE"] = temp[10];
                                        dr["PICK_HT_TIME"] = temp[11];
                                        dr["SHELVE_QTY"] = temp[12];
                                        dr["SHELVE_DATE"] = temp[13];
                                        dr["SHELVE_HT_DATE"] = temp[14];
                                        dr["SHELVE_HT_TIME"] = temp[15];
                                        dr["STATUS_CODE"] = temp[16];
                                        ds.Tables[0].Rows.Add(dr);
                                    }
                                }
                            }

                            rowCount++;
                        }
                        fileRd.Close();
                    }
                    catch (Exception)
                    {
                        fileRd.Close();

                    }
                }
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNSE181_UploadFiles");
                throw new HttpResponseException(HttpStatusCode.NotAcceptable);
            }
            return Json(DTFM.convertToList(ds));
        }

        [HttpPost, Route("SNSE181_UpdateUpload")]
        [Authorize]
        public IHttpActionResult SNSE181_UpdateUpload([FromBody] dynamic[] pdata)
        {
            DataSet ds = new DataSet();
            string strFileName = pdata[0]["CREATE_FILE_NAME"];
            foreach (var item in pdata)
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNSE181_SAVE_PART";
                cmd.Parameters.Add("P_SEQ_NO", OracleDbType.Varchar2).Value = item["SEQ"];
                cmd.Parameters.Add("P_PRINT_CODE", OracleDbType.Varchar2).Value = item["PRINT_DATE"];
                cmd.Parameters.Add("P_PARTS_NO", OracleDbType.Varchar2).Value = item["PARTS_NO"];
                cmd.Parameters.Add("P_LOCATION_NO", OracleDbType.Varchar2).Value = item["LOCATION_NO"];
                cmd.Parameters.Add("P_NEW_LOCATION", OracleDbType.Varchar2).Value = item["NEW_LOCATION"];
                cmd.Parameters.Add("P_LOC_DIV", OracleDbType.Varchar2).Value = item["LOC_DIV"];
                cmd.Parameters.Add("P_RELO_QTY", OracleDbType.Varchar2).Value = item["RELO_QTY"];
                cmd.Parameters.Add("P_PICK_QTY", OracleDbType.Varchar2).Value = item["PICK_QTY"];
                cmd.Parameters.Add("P_CASE_NO", OracleDbType.Varchar2).Value = item["CASE_NO"];
                if (item["PICK_DATE"].ToString() != "")
                {
                    cmd.Parameters.Add("P_PICK_DATE", OracleDbType.Date).Value = Convert.ToDateTime(item["PICK_DATE"]);
                }
                else
                {
                    cmd.Parameters.Add("P_PICK_DATE", OracleDbType.Date).Value = DBNull.Value;
                }
                cmd.Parameters.Add("P_PICK_HT_DATE", OracleDbType.Varchar2).Value = item["PICK_HT_DATE"];
                cmd.Parameters.Add("P_PICK_HT_TIME", OracleDbType.Varchar2).Value = item["PICK_HT_TIME"];
                cmd.Parameters.Add("P_SHELVE_QTY", OracleDbType.Varchar2).Value = item["SHELVE_QTY"];
                if (item["SHELVE_DATE"].ToString() != "")
                {
                    cmd.Parameters.Add("P_SHELVE_DATE", OracleDbType.Date).Value = Convert.ToDateTime(item["SHELVE_DATE"]);
                }
                else
                {
                    cmd.Parameters.Add("P_SHELVE_DATE", OracleDbType.Date).Value = DBNull.Value;
                }
                cmd.Parameters.Add("P_SHELVE_HT_DATE", OracleDbType.Varchar2).Value = item["SHELVE_HT_DATE"];
                cmd.Parameters.Add("P_SHELVE_HT_TIME", OracleDbType.Varchar2).Value = item["SHELVE_HT_TIME"];
                cmd.Parameters.Add("P_STATUS_CODE", OracleDbType.Varchar2).Value = item["STATUS_CODE"];
                cmd.Parameters.Add("P_CREATE_BY", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("P_CREATE_PGM", OracleDbType.Varchar2).Value = "SNSE181";
                cmd.Parameters.Add("P_CREATE_FILE_NAME", OracleDbType.Varchar2).Value = item["CREATE_FILE_NAME"];
                cmd.Parameters.Add("c_return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);
                if (ds.Tables[0].Rows[0][0].ToString() != "DONE")
                {
                    return Json(DTFM.convertToList(ds));
                }
            }

            if (ds.Tables[0].Rows[0][0].ToString() == "DONE")
            {
                string gRootPath = System.Web.HttpContext.Current.Server.MapPath("~/tempFile/SNSD181/Process/");
                string gRootback = System.Web.HttpContext.Current.Server.MapPath("~/tempFile/SNSD181/Backup/");
                if (!Directory.Exists(gRootback))
                {
                    Directory.CreateDirectory(gRootback);
                }
                if (File.Exists(gRootback + strFileName))
                    File.Delete(gRootback + strFileName);
                File.Move(gRootPath + strFileName, gRootback + strFileName.ToUpper().Replace(".CSV", "").Replace(".TSV", "") + DateTime.Now.ToString("yyyyMMddhhMMss") + ".CSV");
            }
            return Json(DTFM.convertToList(ds));
        }

        #endregion

        #region SNSE187

        [HttpGet, Route("SNSE187_GetLocation/{locationNo=null}/{noofshowrec=null}")]
        [Authorize]
        public IHttpActionResult SNSE187_GetLocation(string locationNo = null, string noofshowrec = null)
        {
            DataSet ds = new DataSet();

            locationNo = ismoUtil.escapeCharacter(locationNo);
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNSE187_GET_LOC";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_LOCATION_NO", OracleDbType.Varchar2).Value = locationNo == "null" ? "" : locationNo;
            cmd.Parameters.Add("c_return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpPost, Route("SNSE187_GetPart/{PartNo}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult SNSE187_GetPart(string PartNo, int noofshowrec, [FromBody] dynamic param)
        {
            DataSet ds = new DataSet();
            ////locationFrom = ismoUtil.escapeCharacter(locationFrom);
            ////locationTo = ismoUtil.escapeCharacter(locationTo);
            PartNo = ismoUtil.escapeCharacter(PartNo);
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNSE187_GET_PART";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_LOCATION_FROM", OracleDbType.Varchar2).Value = param.locationFrom == "null" ? "" : param.locationFrom;
            cmd.Parameters.Add("P_LOCATION_TO", OracleDbType.Varchar2).Value = param.locationTo == "null" ? "" : param.locationTo;
            cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = PartNo == "null" ? "" : PartNo;
            cmd.Parameters.Add("P_SHOW_NUMBER", OracleDbType.Int16).Value = noofshowrec;
            cmd.Parameters.Add("c_return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }


        [HttpGet, Route("SNSE187_GetPrint/{locationFrom=null}/{locationTo=null}/{PartFrom=null}/{PartTo=null}/{PritNo=null}/{noofshowrec=null}")]
        [Authorize]
        public IHttpActionResult SNSE187_GetPrint(string locationFrom = null, string locationTo = null, string PartFrom = null, string PartTo = null, string PritNo = null, string noofshowrec = null)
        {
            DataSet ds = new DataSet();
            locationFrom = ismoUtil.escapeCharacter(locationFrom);
            locationTo = ismoUtil.escapeCharacter(locationTo);
            PartFrom = ismoUtil.escapeCharacter(PartFrom);
            PartTo = ismoUtil.escapeCharacter(PartTo);
            PritNo = ismoUtil.escapeCharacter(PritNo);
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNSE187_GET_PRINT";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_LOCATION_FROM", OracleDbType.Varchar2).Value = locationFrom == "null" ? "" : locationFrom;
            cmd.Parameters.Add("P_LOCATION_TO", OracleDbType.Varchar2).Value = locationTo == "null" ? "" : locationTo;
            cmd.Parameters.Add("P_PART_NO_FROM", OracleDbType.Varchar2).Value = PartFrom == "null" ? "" : PartFrom;
            cmd.Parameters.Add("P_PART_NO_TO", OracleDbType.Varchar2).Value = PartTo == "null" ? "" : PartTo;
            cmd.Parameters.Add("P_PRINT_NO", OracleDbType.Varchar2).Value = PritNo == "null" ? "" : PritNo;
            cmd.Parameters.Add("c_return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpGet, Route("SNSE187_Search/{locationFrom=null}/{locationTo=null}/{PartFrom=null}/{PartTo=null}/{PrintFrom=null}/{PrintTo=null}")]
        [Authorize]
        public IHttpActionResult SNSE187_Search(string locationFrom, string locationTo, string PartFrom, string PartTo, string PrintFrom, string PrintTo)
        {
            DataSet ds = new DataSet();
            locationFrom = ismoUtil.escapeCharacter(locationFrom);
            locationTo = ismoUtil.escapeCharacter(locationTo);
            PartFrom = ismoUtil.escapeCharacter(PartFrom);
            PartTo = ismoUtil.escapeCharacter(PartTo);
            PrintFrom = ismoUtil.escapeCharacter(PrintFrom);
            PrintTo = ismoUtil.escapeCharacter(PrintTo);
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNSE187_GET_DATA";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_LOCATION_FROM", OracleDbType.Varchar2).Value = locationFrom == "null" ? "" : locationFrom;
            cmd.Parameters.Add("P_LOCATION_TO", OracleDbType.Varchar2).Value = locationTo == "null" ? "" : locationTo;
            cmd.Parameters.Add("P_PART_NO_FROM", OracleDbType.Varchar2).Value = PartFrom == "null" ? "" : PartFrom;
            cmd.Parameters.Add("P_PART_NO_TO", OracleDbType.Varchar2).Value = PartTo == "null" ? "" : PartTo;
            cmd.Parameters.Add("P_PRINT_FROM", OracleDbType.Varchar2).Value = PrintFrom == "null" ? "" : PrintFrom;
            cmd.Parameters.Add("P_PRINT_TO", OracleDbType.Varchar2).Value = PrintTo == "null" ? "" : PrintTo;
            cmd.Parameters.Add("c_return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }
        #endregion

        #region SNSE192

        [HttpPost, Route("SNSE192_UploadFiles")]
        [Authorize]
        public async Task<IHttpActionResult> SNSE192_UploadFiles(HttpRequestMessage request)
        {
            DataSet ds = new DataSet();
            if (!request.Content.IsMimeMultipartContent())
            {
                throw new HttpResponseException(HttpStatusCode.UnsupportedMediaType);
            }
            var reqParts = await request.Content.ReadAsMultipartAsync();
            try
            {
                foreach (var file in reqParts.Contents)
                {
                    var buffer = await file.ReadAsByteArrayAsync();
                    string gFileName = file.Headers.ContentDisposition.FileName.Trim('\"');
                    string gRootPath = System.Web.HttpContext.Current.Server.MapPath("~/tempFile/SNSD192/Process/");
                    if (!Directory.Exists(gRootPath))
                    {
                        Directory.CreateDirectory(gRootPath);
                    }
                    string gFileLocation = System.IO.Path.Combine(gRootPath, gFileName);
                    File.WriteAllBytes(gFileLocation, buffer);
                    ds.Tables.Add();
                    ds.Tables[0].Columns.Add("SEQ");
                    ds.Tables[0].Columns.Add("STAFF_ID");
                    ds.Tables[0].Columns.Add("STAFF_NAME");
                    ds.Tables[0].Columns.Add("JOB_ID");
                    ds.Tables[0].Columns.Add("JOB_NAME");
                    ds.Tables[0].Columns.Add("REF_NO");
                    ds.Tables[0].Columns.Add("REF_NAME");
                    ds.Tables[0].Columns.Add("PROCESS_DATE");
                    ds.Tables[0].Columns.Add("STATUS_CODE");
                    ds.Tables[0].Columns.Add("ERROR_MESSAGE");
                    string line;
                    System.IO.StreamReader fileRd = new System.IO.StreamReader(gFileLocation);
                    try
                    {
                        int rowCount = 0;
                        OracleCommand cmd = new OracleCommand();
                        cmd.CommandText = "SP_NP_SNSE192_CLEAR_HANDHELD";
                        cmd.Parameters.Add("c_return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                        DataSet dsc = oOracledb.SqlQueryDS_CMD(cmd);

                        while ((line = fileRd.ReadLine()) != null)
                        {
                            if (rowCount > 0)
                            {
                                string[] temp = line.Split(',');

                                cmd = new OracleCommand();
                                cmd.CommandText = "SP_NP_SNSE192_SAVE_HANDHELD";
                                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                                cmd.Parameters.Add("P_STAFF_ID", OracleDbType.Varchar2).Value = temp[1];
                                cmd.Parameters.Add("P_PROCESS_ID", OracleDbType.Varchar2).Value = temp[3];
                                cmd.Parameters.Add("P_REF_NO", OracleDbType.Varchar2).Value = temp[5];
                                if (temp[7].ToString() != "")
                                {
                                    cmd.Parameters.Add("P_PROCESS_DATE", OracleDbType.Date).Value = Convert.ToDateTime(temp[7]);
                                }
                                else
                                {
                                    cmd.Parameters.Add("P_PROCESS_DATE", OracleDbType.Date).Value = DBNull.Value;
                                }
                                cmd.Parameters.Add("P_STATUS_CODE", OracleDbType.Varchar2).Value = temp[8];
                                cmd.Parameters.Add("P_ERROR_MSG", OracleDbType.Varchar2).Value = temp[9];
                                cmd.Parameters.Add("P_FILE_NAME", OracleDbType.Varchar2).Value = temp[10];
                                cmd.Parameters.Add("P_PROCESS_TYPE", OracleDbType.Varchar2).Value = temp[11];
                                cmd.Parameters.Add("P_CREATE_BY", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                                cmd.Parameters.Add("P_CREATE_PGM", OracleDbType.Varchar2).Value = "SNSE192";
                                cmd.Parameters.Add("c_return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                                DataSet dsRes = oOracledb.SqlQueryDS_CMD(cmd);

                                if (dsRes != null)
                                {
                                    if (dsRes.Tables.Count > 0 && dsRes.Tables[0].Rows.Count > 0)
                                    {
                                        DataRow dr = ds.Tables[0].NewRow();
                                        dr["SEQ"] = rowCount;
                                        dr["STAFF_ID"] = temp[1];
                                        dr["STAFF_NAME"] = temp[2];
                                        dr["JOB_ID"] = temp[3];
                                        dr["JOB_NAME"] = temp[4];
                                        dr["REF_NO"] = temp[5];
                                        dr["REF_NAME"] = temp[6];
                                        dr["PROCESS_DATE"] = temp[7];
                                        dr["STATUS_CODE"] = temp[8];
                                        dr["ERROR_MESSAGE"] = temp[9];
                                        ds.Tables[0].Rows.Add(dr);
                                    }
                                }
                            }

                            rowCount++;
                        }
                        fileRd.Close();
                    }
                    catch (Exception)
                    {
                        fileRd.Close();

                    }
                }
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNSE192_UploadFiles");
                throw new HttpResponseException(HttpStatusCode.NotAcceptable);
            }
            return Json(DTFM.convertToList(ds));
        }

        [HttpPost, Route("SNSE192_UpdateUpload")]
        [Authorize]
        public IHttpActionResult SNSE192_UpdateUpload([FromBody] dynamic[] pdata)
        {
            DataSet ds = new DataSet();
            string strFileName = pdata[0]["CREATE_FILE_NAME"];
            foreach (var item in pdata)
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNSE192_SAVE_S_WOR";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_STAFF_ID", OracleDbType.Varchar2).Value = item["STAFF_ID"];
                cmd.Parameters.Add("P_PROCESS_ID", OracleDbType.Varchar2).Value = item["PROCESS_ID"];
                cmd.Parameters.Add("P_REF_NO", OracleDbType.Varchar2).Value = item["REF_NO"];
                if (item["PROCESS_DATE"].ToString() != "")
                {
                    cmd.Parameters.Add("P_PROCESS_DATE", OracleDbType.Date).Value = Convert.ToDateTime(item["PROCESS_DATE"]);
                }
                else
                {
                    cmd.Parameters.Add("P_PROCESS_DATE", OracleDbType.Date).Value = DBNull.Value;
                }
                cmd.Parameters.Add("P_STATUS_CODE", OracleDbType.Varchar2).Value = item["STATUS_CODE"];
                cmd.Parameters.Add("P_ERROR_MSG", OracleDbType.Varchar2).Value = item["ERROR_MSG"];
                cmd.Parameters.Add("P_PROCESS_TYPE", OracleDbType.Varchar2).Value = item["PROCESS_TYPE"];
                cmd.Parameters.Add("P_CREATE_BY", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("P_CREATE_PGM", OracleDbType.Varchar2).Value = "SNSE192";
                cmd.Parameters.Add("c_return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);
                if (ds.Tables[0].Rows[0][0].ToString() != "DONE")
                {
                    return Json(DTFM.convertToList(ds));
                }
            }

            if (ds.Tables[0].Rows[0][0].ToString() == "DONE")
            {
                string gRootPath = System.Web.HttpContext.Current.Server.MapPath("~/tempFile/SNSD192/Process/");
                string gRootback = System.Web.HttpContext.Current.Server.MapPath("~/tempFile/SNSD192/Backup/");
                if (!Directory.Exists(gRootback))
                {
                    Directory.CreateDirectory(gRootback);
                }
                if (File.Exists(gRootback + strFileName))
                    File.Delete(gRootback + strFileName);
                File.Move(gRootPath + strFileName, gRootback + strFileName.ToUpper().Replace(".CSV", "").Replace(".TSV", "") + DateTime.Now.ToString("yyyyMMddhhMMss") + ".CSV");
            }
            return Json(DTFM.convertToList(ds));
        }

        #endregion

        #region SNSE193

        [HttpGet, Route("SNSE193_GetStaffList/{StaffId=null}/{noofshowrec=null}")]
        [Authorize]
        public IHttpActionResult SNSE193_GetStaffList(string StaffId = null, string noofshowrec = null)
        {
            DataSet ds = new DataSet();

            StaffId = ismoUtil.escapeCharacter(StaffId);
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNSE193_GET_STAFF";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_STAFF_ID", OracleDbType.Varchar2).Value = StaffId == "null" ? "" : StaffId;
            cmd.Parameters.Add("c_return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpGet, Route("SNSE193_SearchStaffList/{StaffId=null}")]
        [Authorize]
        public IHttpActionResult SNSE193_SearchStaffList(string StaffId = null)
        {
            DataSet ds = new DataSet();

            StaffId = ismoUtil.escapeCharacter(StaffId);
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNSE193_SEARCH_STAFF";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_STAFF_ID", OracleDbType.Varchar2).Value = StaffId == "null" ? "" : StaffId;
            cmd.Parameters.Add("c_return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        #endregion

        #region SNSE194

        [HttpPost, Route("SNSE194_UploadFiles")]
        [Authorize]
        public async Task<IHttpActionResult> SNSE194_UploadFiles(HttpRequestMessage request)
        {
            DataSet ds = new DataSet();
            string gFileName = "";
            string gFileLocation = "";
            string line;
            if (!request.Content.IsMimeMultipartContent())
            {
                throw new HttpResponseException(HttpStatusCode.UnsupportedMediaType);
            }
            var reqParts = await request.Content.ReadAsMultipartAsync();
            try
            {
                foreach (var file in reqParts.Contents)
                {
                    var buffer = await file.ReadAsByteArrayAsync();
                    gFileName = file.Headers.ContentDisposition.FileName.Trim('\"');
                    string gRootPath = System.Web.HttpContext.Current.Server.MapPath("~/tempFile/SNSD194/Process/");
                    if (!Directory.Exists(gRootPath))
                    {
                        Directory.CreateDirectory(gRootPath);
                    }
                    gFileLocation = System.IO.Path.Combine(gRootPath, gFileName);
                    File.WriteAllBytes(gFileLocation, buffer);

                    System.IO.StreamReader fileRd = new System.IO.StreamReader(gFileLocation);
                    try
                    {
                        int rowCount = 0;
                        OracleCommand cmd = new OracleCommand();
                        cmd.CommandText = "SP_NP_SNSE194_CLEAR_HANDHELD";
                        cmd.Parameters.Add("c_return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                        DataSet dsc = oOracledb.SqlQueryDS_CMD(cmd);

                        while ((line = fileRd.ReadLine()) != null)
                        {
                            if (rowCount > 0)
                            {
                                string[] temp = line.Split(',');

                                cmd = new OracleCommand();
                                cmd.CommandText = "SP_NP_SNSE194_SAVE_HANDHELD";
                                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                                cmd.Parameters.Add("P_STAFF_ID", OracleDbType.Varchar2).Value = temp[1];
                                cmd.Parameters.Add("P_PROCESS_ID", OracleDbType.Varchar2).Value = temp[2];
                                cmd.Parameters.Add("P_REF_NO", OracleDbType.Varchar2).Value = temp[4];
                                if (temp[5].ToString() != "")
                                {
                                    cmd.Parameters.Add("P_PROCESS_DATE", OracleDbType.Date).Value = Convert.ToDateTime(temp[5]);
                                }
                                else
                                {
                                    cmd.Parameters.Add("P_PROCESS_DATE", OracleDbType.Date).Value = DBNull.Value;
                                }
                                cmd.Parameters.Add("P_FILE_NAME", OracleDbType.Varchar2).Value = gFileName;
                                cmd.Parameters.Add("P_CREATE_BY", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                                cmd.Parameters.Add("P_CREATE_PGM", OracleDbType.Varchar2).Value = "SNSE194";
                                cmd.Parameters.Add("c_return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                                DataSet dsRes = oOracledb.SqlQueryDS_CMD(cmd);
                            }

                            rowCount++;
                        }
                        fileRd.Close();
                    }
                    catch (Exception)
                    {
                        fileRd.Close();

                    }
                }
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNSE194_UploadFiles");
                throw new HttpResponseException(HttpStatusCode.NotAcceptable);
            }
            OracleCommand cmdr = new OracleCommand();
            cmdr.CommandText = "SP_NP_SNSE194_GET_HANDHELD";
            cmdr.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmdr.Parameters.Add("P_FILE_NAME", OracleDbType.Varchar2).Value = gFileName;
            cmdr.Parameters.Add("c_return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            DataSet dsr = oOracledb.SqlQueryDS_CMD(cmdr);
            dsr.Tables[0].Columns.Add("SEQ");
            dsr.Tables[0].Columns.Add("JOB_NAME");
            int i = 0;
            foreach (DataRow dr in dsr.Tables[0].Rows)
            {
                i++;
                dr["SEQ"] = i;


                int rowCount = 0;
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNSE194_CLEAR_HANDHELD";
                cmd.Parameters.Add("c_return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                DataSet dsc = oOracledb.SqlQueryDS_CMD(cmd);
                System.IO.StreamReader fileRd = new System.IO.StreamReader(gFileLocation);
                try
                {

                    while ((line = fileRd.ReadLine()) != null)
                    {
                        if (rowCount > 0)
                        {
                            string[] temp = line.Split(',');
                            if (dr["STAFF_ID"].ToString() == temp[1] && dr["JOB_ID"].ToString() == temp[2] && dr["REF_NO"].ToString() == temp[4])
                            {
                                dr["JOB_NAME"] = temp[3];
                            }
                        }
                        rowCount++;
                    }
                }
                catch (Exception)
                {

                }
                finally
                {
                    fileRd.Close();
                }
            }
            return Json(DTFM.convertToList(dsr));
        }

        [HttpPost, Route("SNSE194_UpdateUpload")]
        [Authorize]
        public IHttpActionResult SNSE194_UpdateUpload([FromBody] dynamic[] pdata)
        {

            string strFileName = pdata[0]["CREATE_FILE_NAME"];


            string gRootPath = System.Web.HttpContext.Current.Server.MapPath("~/tempFile/SNSD194/Process/");
            string gRootback = System.Web.HttpContext.Current.Server.MapPath("~/tempFile/SNSD194/Backup/");
            if (!Directory.Exists(gRootback))
            {
                Directory.CreateDirectory(gRootback);
            }
            if (File.Exists(gRootback + strFileName))
                File.Delete(gRootback + strFileName);
            if (System.IO.File.Exists(gRootPath + strFileName))
            {
                File.Move(gRootPath + strFileName, gRootback + strFileName.ToUpper().Replace(".CSV", "").Replace(".TSV", "") + DateTime.Now.ToString("yyyyMMddhhMMss") + ".CSV");
            }
            DataSet ds = new DataSet();
            ds.Tables.Add();
            ds.Tables[0].Columns.Add("STATUS");
            ds.Tables[0].Rows.Add(new Object[] { "DONE" });
            return Json(DTFM.convertToList(ds));
        }

        #endregion


        #region SNSE170

        [HttpPost, Route("SNSE170_GetData")]
        [Authorize]
        public IHttpActionResult SNSE170_GetData([FromBody] dynamic pDataList)
        {
            try
            {
                DataSet ds = new DataSet();
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNSE170_GET_DATA";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_CUSTOMER_CODE", OracleDbType.Varchar2).Value = pDataList["CUSTOMER_CODE"];
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNSE170_GetData");
                return Json(new { Status = "Error" });
            }
        }

        [HttpPost, Route("SNSE170_StandardWorking_Save")]
        [Authorize]
        [RunBatchGuard]
        public IHttpActionResult SNSE170_StandardWorking_Save([FromBody] dynamic pDataList)
        {
            DataSet ds = new DataSet();
            DataTable dt = new DataTable();
            var x = HttpContext.Current.Request.UserHostAddress.ToString();
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNSE170_UPDATE";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_CUSTOMER_CODE", OracleDbType.Varchar2).Value = pDataList["CUSTOMER_CODE"];
            cmd.Parameters.Add("P_PICKING_CARD", OracleDbType.Varchar2).Value = pDataList["PICKING_CARD"];
            cmd.Parameters.Add("P_DEPARTURE_SEA", OracleDbType.Varchar2).Value = pDataList["DEPARTURE_SEA"];
            cmd.Parameters.Add("P_LEADTIME_SEA", OracleDbType.Varchar2).Value = pDataList["LEADTIME_SEA"];
            cmd.Parameters.Add("P_LEADTIME_AIR", OracleDbType.Varchar2).Value = pDataList["LEADTIME_AIR"];
            cmd.Parameters.Add("P_SHIPMENT_SEA", OracleDbType.Varchar2).Value = pDataList["SHIPMENT_SEA"];
            cmd.Parameters.Add("P_SHIPMENT_AIR", OracleDbType.Varchar2).Value = pDataList["SHIPMENT_AIR"];
            cmd.Parameters.Add("P_CDD_STATUS", OracleDbType.Varchar2).Value = pDataList["CDD_STATUS"];
            cmd.Parameters.Add("P_CREATE_BY", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
            cmd.Parameters.Add("P_LAST_UPD_PGM", OracleDbType.Varchar2).Value = "SNSE170";
            cmd.Parameters.Add("P_LAST_UPD_BY", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
            cmd.Parameters.Add("P_LAST_IP_ADDR", OracleDbType.Varchar2).Value = HttpContext.Current.Request.UserHostAddress.ToString();
            cmd.Parameters.Add("C_RE", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpPost, Route("SNSE170_StandardWorking_Delete")]
        [Authorize]
        [RunBatchGuard]
        public IHttpActionResult SNSE170_StandardWorking_Delete([FromBody] dynamic pDataList)
        {
            DataSet ds = new DataSet();
            DataTable dt = new DataTable();
            var x = HttpContext.Current.Request.UserHostAddress.ToString();
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNSE170_DELETE";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_CUSTOMER_CODE", OracleDbType.Varchar2).Value = pDataList["CUSTOMER_CODE"];
            cmd.Parameters.Add("P_PICKING_CARD", OracleDbType.Varchar2).Value = pDataList["PICKING_CARD"];
            cmd.Parameters.Add("P_DEPARTURE_SEA", OracleDbType.Varchar2).Value = pDataList["DEPARTURE_SEA"];
            cmd.Parameters.Add("P_LEADTIME_SEA", OracleDbType.Varchar2).Value = pDataList["LEADTIME_SEA"];
            cmd.Parameters.Add("P_LEADTIME_AIR", OracleDbType.Varchar2).Value = pDataList["LEADTIME_AIR"];
            cmd.Parameters.Add("P_SHIPMENT_SEA", OracleDbType.Varchar2).Value = pDataList["SHIPMENT_SEA"];
            cmd.Parameters.Add("P_SHIPMENT_AIR", OracleDbType.Varchar2).Value = pDataList["SHIPMENT_AIR"];
            cmd.Parameters.Add("P_CDD_STATUS", OracleDbType.Varchar2).Value = pDataList["CDD_STATUS"];
            cmd.Parameters.Add("P_CREATE_BY", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
            cmd.Parameters.Add("P_LAST_UPD_PGM", OracleDbType.Varchar2).Value = "SNSE170";
            cmd.Parameters.Add("P_LAST_UPD_BY", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
            cmd.Parameters.Add("P_LAST_IP_ADDR", OracleDbType.Varchar2).Value = HttpContext.Current.Request.UserHostAddress.ToString();
            cmd.Parameters.Add("C_RE", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpGet, Route("GetCustomerCodeSTD/{CustomerCode}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult GetCustomerCodeSTD(string CustomerCode, string noofshowrec)
        {
            try
            {
                DataSet ds = new DataSet();
                CustomerCode = ismoUtil.escapeCharacter(CustomerCode);
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNSE170_CUSTOMER";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2, DataService.GetIdentity(User, Cons.SS_COMPANY_CODE), ParameterDirection.Input);
                cmd.Parameters.Add("P_CUSTOMER_CODE", OracleDbType.Varchar2).Value = CustomerCode.ToUpper() == "NULL" ? (object)DBNull.Value : CustomerCode;
                cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor, ParameterDirection.Output);

                ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "GetCustomerCodeSTD");
                return Json(new { Status = "Error" });
            }
        }


        [HttpPost, Route("SNSE170_StandardWorking_GenDepartureDay")]
        [Authorize]
        public IHttpActionResult SNSE170_StandardWorking_GenDepartureDay([FromBody] dynamic pDataList)
        {
            DataSet ds = new DataSet();

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNSE170_GEN_DEPARTURE";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_CUSTOMER_CODE", OracleDbType.Varchar2).Value = pDataList["CUSTOMER_CODE"];
            cmd.Parameters.Add("P_TO_YEAR", OracleDbType.Varchar2).Value = pDataList["TO_YEAR"];
            cmd.Parameters.Add("P_CREATE_BY", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
            cmd.Parameters.Add("P_LAST_UPD_PGM", OracleDbType.Varchar2).Value = "SNSE170";
            cmd.Parameters.Add("P_LAST_UPD_BY", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
            cmd.Parameters.Add("C_RE", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        #endregion

        #region SNSE171

        [HttpPost, Route("SNSE171_GetPickingCard")]
        [Authorize]
        public IHttpActionResult SNSE171_GetPickingCard([FromBody] dynamic pParams)
        {
            DataSet ds = new DataSet();

            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNSE171_GET_PICKING_CARD";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_CUSTOMER_CODE", OracleDbType.Varchar2).Value = pParams.CUSTOMER_CODE;
                cmd.Parameters.Add("P_PROCESS_YEAR", OracleDbType.Varchar2).Value = pParams.PROCESS_YEAR;
                cmd.Parameters.Add("P_PROCESS_MONTH", OracleDbType.Varchar2).Value = pParams.PROCESS_MONTH;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNSE171_GetPickingCard");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpPost, Route("SNSE171_GetData")]
        [Authorize]
        public IHttpActionResult SNSE171_GetData([FromBody] dynamic pDataList)
        {
            try
            {
                DataSet ds = new DataSet();
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNSE171_CUSTOMER_PC";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_CUSTOMER_CODE", OracleDbType.Varchar2).Value = (pDataList["CUSTOMER_CODE"] != null && pDataList["CUSTOMER_CODE"] == "null" ? "" : pDataList["CUSTOMER_CODE"]);
                cmd.Parameters.Add("P_PROCESS_YEAR", OracleDbType.Varchar2).Value = (pDataList["PROCESS_YEAR"] != null && pDataList["PROCESS_YEAR"] == "null" ? "" : pDataList["PROCESS_YEAR"]);
                cmd.Parameters.Add("P_PROCESS_MONTH", OracleDbType.Varchar2).Value = (pDataList["PROCESS_MONTH"] != null && pDataList["PROCESS_MONTH"] == "null" ? "" : pDataList["PROCESS_MONTH"]);
                cmd.Parameters.Add("P_ISSUE_PICKING_CARD", OracleDbType.Varchar2).Value = (pDataList["ISSUE_PICKING_CARD"] != null && pDataList["ISSUE_PICKING_CARD"] == "null" ? "" : pDataList["ISSUE_PICKING_CARD"]);
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNSE171_GetData");
                return Json(new { Status = "Error" });
            }
        }







        [HttpGet, Route("SNSE171_GetCalendar/{ProcessYear}/{ProcessMonth}")]
        [Authorize]
        public IHttpActionResult SNSE171_GetCalendar(string ProcessYear, string ProcessMonth)
        {
            try
            {
                DataSet ds = new DataSet();
                ProcessYear = ismoUtil.escapeCharacter(ProcessYear);
                ProcessMonth = ismoUtil.escapeCharacter(ProcessMonth);
                OracleCommand cmd = new OracleCommand();

                cmd.CommandText = "SP_NP_SNSE171_DAY_TYPE";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_PROCESS_YEAR", OracleDbType.Varchar2).Value = ProcessYear;
                cmd.Parameters.Add("P_PROCESS_MONTH", OracleDbType.Varchar2).Value = ProcessMonth;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNSE171_GetCalendar");
                return Json(new { Status = "Error" });
            }
        }

        [HttpPost, Route("SNSE171_GetCalendarWKP")]
        [Authorize]
        public IHttpActionResult SNSE171_GetCalendarWKP([FromBody] dynamic pDataList)
        {
            try
            {
                DataSet ds = new DataSet();
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNSE171_CALENDAR_WKP";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_CUSTOMER_CODE", OracleDbType.Varchar2).Value = (pDataList["CUSTOMER_CODE"]);
                cmd.Parameters.Add("P_MONTH", OracleDbType.Varchar2).Value = (pDataList["PROCESS_MONTH"]);
                cmd.Parameters.Add("P_YEAR", OracleDbType.Varchar2).Value = (pDataList["PROCESS_YEAR"]);
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNSE171_GetCalendarWKP");
                return Json(new { Status = "Error" });
            }
        }

        [HttpPost, Route("SNSE171_PickingCard_Save")]
        [Authorize]
        [RunBatchGuard]
        public IHttpActionResult SNSE171_PickingCard_Save([FromBody] dynamic[] pDataList)
        {
            DataSet ds = new DataSet();
            DataTable dt = new DataTable();

            foreach (var data in pDataList)
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNSE171_UPDATE";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_CUSTOMER_CODE", OracleDbType.Varchar2).Value = data["CUSTOMER_CODE"];
                cmd.Parameters.Add("P_PROCESS_YEAR", OracleDbType.Varchar2).Value = data["PROCESS_YEAR"];
                cmd.Parameters.Add("P_PROCESS_MONTH", OracleDbType.Varchar2).Value = data["PROCESS_MONTH"];
                cmd.Parameters.Add("P_ISSUE_PICKING_CARD", OracleDbType.Varchar2).Value = data["ISSUE_PICKING_CARD"];
                cmd.Parameters.Add("P_WEEK1", OracleDbType.Varchar2).Value = data["WEEK1"];
                cmd.Parameters.Add("P_WEEK2", OracleDbType.Varchar2).Value = data["WEEK2"];
                cmd.Parameters.Add("P_WEEK3", OracleDbType.Varchar2).Value = data["WEEK3"];
                cmd.Parameters.Add("P_WEEK4", OracleDbType.Varchar2).Value = data["WEEK4"];
                cmd.Parameters.Add("P_WEEK5", OracleDbType.Varchar2).Value = data["WEEK5"];
                cmd.Parameters.Add("P_CIPCD", OracleDbType.Varchar2).Value = data["CIPCD"];
                cmd.Parameters.Add("P_CREATE_BY", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("P_LAST_UPD_PGM", OracleDbType.Varchar2).Value = "SNSE171";
                cmd.Parameters.Add("P_LAST_UPD_BY", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("C_RE", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);
            }
            return Json(DTFM.convertToList(ds));
        }


        [HttpPost, Route("SNSE171_CreateIssuePicking")]
        [Authorize]
        public IHttpActionResult SNSE171_CreateIssuePicking([FromBody] dynamic[] pDataList)
        {
            DataSet ds = new DataSet();
            DataTable dt = new DataTable();

            foreach (var data in pDataList)
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNSE171_GEN_PICKING_CARD";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_CUSTOMER_CODE", OracleDbType.Varchar2).Value = data["CUSTOMER_CODE"];
                cmd.Parameters.Add("P_PROCESS_YEAR", OracleDbType.Varchar2).Value = data["PROCESS_YEAR"];
                cmd.Parameters.Add("P_PROCESS_MONTH", OracleDbType.Varchar2).Value = data["PROCESS_MONTH"];
                cmd.Parameters.Add("P_CREATE_BY", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("P_LAST_UPD_PGM", OracleDbType.Varchar2).Value = "SNSE171";
                cmd.Parameters.Add("P_LAST_UPD_BY", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("C_RE", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);
            }
            return Json(DTFM.convertToList(ds));
        }

        [HttpPost, Route("SNSE171_AddProcessYear")]
        [Authorize]
        public IHttpActionResult SNSE171_AddProcessYear([FromBody] dynamic pData)
        {
            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNSE171_ADD_PROCESS_YEAR";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_CUSTOMER_CODE", OracleDbType.Varchar2).Value = pData["CUSTOMER_CODE"];
                cmd.Parameters.Add("P_PROCESS_YEAR", OracleDbType.Varchar2).Value = pData["PROCESS_YEAR"];
                cmd.Parameters.Add("P_OLD_PROCESS_YEAR", OracleDbType.Varchar2).Value = pData["OLD_PROCESS_YEAR"];
                cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);

                oOracledb.SqlQueryReturnValue(cmd);

                return Ok("Done");
            }
            catch (OracleException ex)
            {
                if (ex.Number == 20001)
                {
                    return Ok("Unable to insert.");
                }
                else if (ex.Number == 20002)
                {
                    return Ok("Please setup picking card day.");
                }
                else if (ex.Number == 20003)
                {
                    return Ok("Process year already exists.");
                }

                throw (ex);
            }
            catch (Exception ex)
            {
                throw (ex);
            }
        }
        #endregion


        #region SNSE157

        [HttpGet, Route("SNSE157_GetData")]
        [Authorize]
        public IHttpActionResult SNSE157_GetData()
        {
            try
            {
                DataSet ds = new DataSet();
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNSE157_GET_DATA";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNSE157_GetData");
                return Json(new { Status = "Error" });
            }
        }

        [HttpPost, Route("SNSE157_UpdateData")]
        [Authorize]
        [RunBatchGuard]
        public IHttpActionResult SNSE157_UpdateData([FromBody] dynamic pDataList)
        {

            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNSE157_UPDATE";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_WH_SHELVE", OracleDbType.Int64).Value = pDataList["WH_SHELVE"];
            cmd.Parameters.Add("P_WH_RECEIVING", OracleDbType.Int64).Value = pDataList["WH_RECEIVING"];
            cmd.Parameters.Add("P_WH_ALLOCATE", OracleDbType.Int64).Value = pDataList["WH_ALLOCATE"];
            cmd.Parameters.Add("P_WH_PICKING", OracleDbType.Int64).Value = pDataList["WH_PICKING"];
            cmd.Parameters.Add("P_TOTAL_WH", OracleDbType.Int64).Value = pDataList["TOTAL_WH"];
            cmd.Parameters.Add("P_EXP_RECEIVING", OracleDbType.Int64).Value = pDataList["EXP_RECEIVING"];
            cmd.Parameters.Add("P_EXP_PACKING", OracleDbType.Int64).Value = pDataList["EXP_PACKING"];
            cmd.Parameters.Add("P_EXP_PRE_INV", OracleDbType.Int64).Value = pDataList["EXP_PRE_INV"];
            cmd.Parameters.Add("P_EXP_BOOKING", OracleDbType.Int64).Value = pDataList["EXP_BOOKING"];
            cmd.Parameters.Add("P_EXP_INVOICE", OracleDbType.Int64).Value = pDataList["EXP_INVOICE"];
            cmd.Parameters.Add("P_EXP_LOADING", OracleDbType.Int64).Value = pDataList["EXP_LOADING"];
            cmd.Parameters.Add("P_TOTAL_EXP", OracleDbType.Int64).Value = pDataList["TOTAL_EXP"];
            cmd.Parameters.Add("P_TOTAL_ALL", OracleDbType.Int64).Value = pDataList["TOTAL_ALL"];
            cmd.Parameters.Add("P_LAST_UPD_PGM", OracleDbType.Varchar2).Value = "SNSE157";
            cmd.Parameters.Add("P_LAST_UPD_BY", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            return Json(DTFM.convertToList(ds));
        }


        #endregion

        #region SNPE015_P


        [HttpPost, Route("SNPE015_P_GetVendorCode/{vendorcode}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult SNPE015_P_GetVendorCode(string vendorcode, int noofshowrec, [FromBody] dynamic pParams)
        {
            DataSet ds = new DataSet();

            vendorcode = ismoUtil.escapeCharacter(vendorcode);

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNPE015_P_VENDOR_CODE";
            cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = vendorcode != null && vendorcode == "null" ? "" : vendorcode;
            cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
            cmd.Parameters.Add("P_INV_TYPE", OracleDbType.Varchar2).Value = pParams["INV_TYPE"];
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpPost, Route("SNPE015_P_GetInvList/{invoiceno}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult SNPE015_P_GetInvList(string invoiceno, int noofshowrec, [FromBody] dynamic pParams)
        {
            try
            {
                DataSet ds = new DataSet();

                invoiceno = ismoUtil.escapeCharacter(invoiceno.ToUpper());

                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNPE015_P_GET_INV";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = invoiceno.ToUpper() == "NULL" ? (object)DBNull.Value : invoiceno;
                cmd.Parameters.Add("P_INVOICE_STATUS", OracleDbType.Varchar2).Value = pParams["INVOICE_STATUS"];
                cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE015_P_GetInvList");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }



        [HttpPost, Route("SNPE015_R_GetPre_ReceivingList/{docno}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult SNPE015_R_GetPre_ReceivingList(string docno, int noofshowrec, [FromBody] dynamic pParams)
        {
            try
            {
                DataSet ds = new DataSet();

                docno = ismoUtil.escapeCharacter(docno);

                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNPE015_R_GET_PRE_REV";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_DOC_NO", OracleDbType.Varchar2).Value = docno.ToUpper() == "NULL" ? (object)DBNull.Value : docno;
                cmd.Parameters.Add("P_INVOICE_STATUS", OracleDbType.Varchar2).Value = pParams["INVOICE_STATUS"];
                cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE015_R_GetPre_ReceivingList");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }



        [HttpPost, Route("SNPE015_P_GetData")]
        [Authorize]
        public IHttpActionResult SNPE015_P_GetData([FromBody] dynamic pData)
        {
            try
            {

                OracleCommand cmd = new OracleCommand();

                cmd.CommandText = "SP_NP_SNPE015_P_GET_LIST";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pData["VENDOR_CODE"];
                cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = pData["INVOICE_NO"];
                cmd.Parameters.Add("P_INVOICE_DATE", OracleDbType.Date).Value = pData["INVOICE_DATE"] != null ? Convert.ToDateTime(pData["INVOICE_DATE"].ToString()) : (object)DBNull.Value;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                DataSet ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE015_P_GetData");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }

        }

        [HttpPost, Route("SNPE015_P_GetInvoiceDetail")]
        [Authorize]
        public IHttpActionResult SNPE015_P_GetInvoiceDetail([FromBody] dynamic pData)
        {
            try
            {
                OracleCommand cmd = new OracleCommand();

                cmd.CommandText = "SP_NP_SNPE015_P_GET_DETAIL";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pData["VENDOR_CODE"];
                cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = pData["INVOICE_NO"];
                cmd.Parameters.Add("C_RETURN_H", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                cmd.Parameters.Add("C_RETURN_D", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                DataSet ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE015_P_GetInvoiceDetail");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }

        }

        [HttpPost, Route("SNPE015_P_CheckDuplicateInvoice")]
        [Authorize]
        public IHttpActionResult SNPE015_P_CheckDuplicateInvoice([FromBody] dynamic pData)
        {
            try
            {
                OracleCommand cmd = new OracleCommand();

                cmd.CommandText = "SP_NP_SNPE015_P_CHECK_DUP";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pData["VENDOR_CODE"];
                cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = pData["INVOICE_NO"];
                cmd.Parameters.Add("P_INVOICE_DATE", OracleDbType.Date).Value = pData["INVOICE_DATE"];

                DataSet ds = oOracledb.SqlQueryDS_CMD(cmd);

            }
            catch (OracleException ex)
            {
                if (ex.Number == 20001)
                {
                    return Ok("Failed");
                }

                throw (ex);
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE015_P_CheckDuplicateInvoice");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }

            return Ok("Done");
        }

        [HttpPost, Route("SNPE015_P_CheckPOByPartNo")]
        [Authorize]
        public IHttpActionResult SNPE015_P_CheckPOByPartNo([FromBody] dynamic pData)
        {
            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNPE015_P_CHECK_PO";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pData["VENDOR_CODE"];
                cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = pData["PART_NO"];
                cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = pData["INVOICE_NO"];
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                DataSet ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE015_P_CheckPOByPartNo");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpPost, Route("SNPE015_P_CheckWOPartNo")]
        [Authorize]
        public IHttpActionResult SNPE015_P_CheckWOPartNo([FromBody] dynamic pData)
        {
            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNPE015_P_CHECK_WO";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pData["VENDOR_CODE"];
                cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = pData["PART_NO"];
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                DataSet ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE015_P_CheckWOPartNo");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }


        [HttpPost, Route("SNPE015_P_Save")]
        [Authorize]
        [RunBatchGuard]
        public IHttpActionResult SNPE015_P_Save([FromBody] dynamic pData)
        {
            OracleCommand cmd;
            DataSet ds;
            DataTable dtHeader, dtDetail;
            string gGUID, gDocNo;

            List<dynamic> partList = new List<dynamic>(pData.PART_LIST);
            int partCount = 0;

            //Insert to pre-receive
            try
            {

                cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNPE015_P_DEL_TEMP";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = pData["INVOICE_NO"];
                cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pData["VENDOR_CODE"];

                cmd = oOracledb.SqlQueryReturnValue(cmd);

                foreach (var part in partList)
                {
                    partCount++;

                    cmd = new OracleCommand();
                    cmd.CommandText = "SP_NP_SNPE015_P_INS_TEMP";
                    cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                    cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = pData["INVOICE_NO"];
                    cmd.Parameters.Add("P_INVOICE_DATE", OracleDbType.Date).Value = Convert.ToDateTime(pData["INVOICE_DATE"]);
                    cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pData["VENDOR_CODE"];
                    cmd.Parameters.Add("P_RNO", OracleDbType.Decimal).Value = partCount;
                    cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = part["ACCEPT_PART_NO"];
                    cmd.Parameters.Add("P_UNIT_TYPE", OracleDbType.Varchar2).Value = part["UNIT_TYPE"];
                    cmd.Parameters.Add("P_QTY", OracleDbType.Decimal).Value = part["QTY"];
                    cmd.Parameters.Add("P_PO_NO", OracleDbType.Varchar2).Value = part["PO_NO"];
                    cmd.Parameters.Add("P_ITEM_NO", OracleDbType.Decimal).Value = part["ITEM_NO"];
                    cmd.Parameters.Add("P_SUB_ITEM_NO", OracleDbType.Varchar2).Value = part["SUB_ITEM_NO"];
                    cmd.Parameters.Add("P_PO_CLASS", OracleDbType.Varchar2).Value = part["ORDER_CLASS"];
                    cmd.Parameters.Add("P_ORDER_TYPE", OracleDbType.Varchar2).Value = part["ORDER_TYPE"];
                    cmd.Parameters.Add("P_RECEIVE_PACKAGE", OracleDbType.Decimal).Value = part["RECEIVE_PACKAGE"];
                    cmd.Parameters.Add("P_PENDING_TYPE", OracleDbType.Varchar2).Value = part["PENDING_TYPE"];

                    oOracledb.SqlQueryReturnValue(cmd);
                }

                cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNPE015_P_SAVE";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_INVOICE_TYPE", OracleDbType.Varchar2).Value = pData["INVOICE_TYPE"];
                cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = pData["INVOICE_NO"];
                cmd.Parameters.Add("P_INVOICE_DATE", OracleDbType.Date).Value = Convert.ToDateTime(pData["INVOICE_DATE"]);
                cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pData["VENDOR_CODE"];
                cmd.Parameters.Add("P_RECEIVE_DATE", OracleDbType.Date).Value = pData["ATTRIBUTE1"];
                cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("R_GUID", OracleDbType.Varchar2, 32).Direction = ParameterDirection.Output;
                cmd.Parameters.Add("R_DOC_NO", OracleDbType.Varchar2, 20).Direction = ParameterDirection.Output;

                cmd = oOracledb.SqlQueryReturnValue(cmd);

                gGUID = cmd.Parameters["R_GUID"].Value.ToString();
                gDocNo = cmd.Parameters["R_DOC_NO"].Value.ToString();

            }
            catch (Exception ex)
            {

                if (ex.Message.IndexOf("Found invoice") > 0)
                {
                    return Json(new { Result = "Duplicate invoice", DocNo = "" });
                }
                else
                {
                    oOracledb.WriteLog("ErrorHandle", ex.Message, "SNSE015_P_Save");
                    return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
                }


            }

            //Update key to pre-receive
            try
            {
                cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNPE015_P_GET_REC_DETAIL";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pData["VENDOR_CODE"];
                cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = pData["INVOICE_NO"];
                cmd.Parameters.Add("C_RETURN_H", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                cmd.Parameters.Add("C_RETURN_D", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);

                dtHeader = ds.Tables[0];
                dtDetail = ds.Tables[1];

                ReceiveTokenService receiveToken = new ReceiveTokenService();
                string tokenH = receiveToken.GenerateKeyHeader(gGUID, dtHeader);

                //Update Header
                cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNPE015_P_UPD_KEY_H";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = pData["INVOICE_NO"];
                cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pData["VENDOR_CODE"];
                cmd.Parameters.Add("P_KEY", OracleDbType.Varchar2).Value = tokenH;
                cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);

                oOracledb.SqlQueryReturnValue(cmd);

                //Update Detail
                foreach (DataRow dataDetail in dtDetail.Rows)
                {
                    string tokenD = receiveToken.GenerateKeyDetail(gGUID, dtHeader, dataDetail);

                    cmd = new OracleCommand();
                    cmd.CommandText = "SP_NP_SNPE015_P_UPD_KEY_D";
                    cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                    cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = pData["INVOICE_NO"];
                    cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pData["VENDOR_CODE"];
                    cmd.Parameters.Add("P_SEQ", OracleDbType.Decimal).Value = dataDetail["SEQ"];
                    cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = dataDetail["PART_NO"];
                    cmd.Parameters.Add("P_KEY", OracleDbType.Varchar2).Value = tokenD;
                    cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);

                    oOracledb.SqlQueryReturnValue(cmd);

                }


            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNSE015_P_Save");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }

            return Json(new { Result = "Done", DocNo = gDocNo });

        }

        [HttpPost, Route("SNPE015_P_Cancel")]
        [Authorize]
        [RunBatchGuard]
        public IHttpActionResult SNPE015_P_Cancel([FromBody] dynamic pData)
        {
            try
            {
                OracleCommand cmd = new OracleCommand();

                cmd.CommandText = "SP_NP_SNPE015_P_CANCEL";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pData["VENDOR_CODE"];
                cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = pData["INVOICE_NO"];
                cmd.Parameters.Add("P_PRE_RECEIVE_DOC_NO", OracleDbType.Varchar2).Value = pData["PRE_RECEIVE_DOC_NO"];
                cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);

                oOracledb.SqlQueryReturnValue(cmd);

                return Ok();
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE015_P_Cancel");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpPost, Route("SNPE015_P_PendingComplete")]
        [Authorize]
        public IHttpActionResult SNPE015_P_PendingComplete([FromBody] dynamic pData)
        {
            try
            {
                OracleCommand cmd = new OracleCommand();

                dynamic pDataHeader = pData.header;
                List<dynamic> pPendingPO = new List<dynamic>(pData.pendingPO);

                foreach(var pendingPO in pPendingPO)
                {
                    cmd = new OracleCommand();
                    cmd.CommandText = "SP_NP_SNPE015_P_PENDING_PO_UPD";
                    cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                    cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pDataHeader["VENDOR_CODE"];
                    cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = pDataHeader["INVOICE_NO"];
                    cmd.Parameters.Add("P_PRE_RECEIVE_DOC_NO", OracleDbType.Varchar2).Value = pDataHeader["PRE_RECEIVE_DOC_NO"];
                    cmd.Parameters.Add("P_TRAN_ITEM_NO", OracleDbType.Decimal).Value = pendingPO["TRAN_ITEM_NO"];
                    cmd.Parameters.Add("P_PO_NO", OracleDbType.Varchar2).Value = pendingPO["PO_NO"];
                    cmd.Parameters.Add("P_ITEM_NO", OracleDbType.Decimal).Value = pendingPO["ITEM_NO"];
                    cmd.Parameters.Add("P_SUB_ITEM_NO", OracleDbType.Varchar2).Value = pendingPO["SUB_ITEM_NO"];
                    cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);

                    oOracledb.SqlExecute_CMD(cmd);
                }

                cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNPE015_P_PENDING_COMPLETE";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pDataHeader["VENDOR_CODE"];
                cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = pDataHeader["INVOICE_NO"];
                cmd.Parameters.Add("P_PRE_RECEIVE_DOC_NO", OracleDbType.Varchar2).Value = pDataHeader["PRE_RECEIVE_DOC_NO"];
                cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);

                oOracledb.SqlExecute_CMD(cmd);

                return Ok("Done");
            }
            catch (OracleException ex)
            {
                if (ex.Number == 20008) return Ok("Cannot found item.");
                if (ex.Number == 20009) return Ok("Cannot found PO.");
                if (ex.Number == 20010) return Ok("Unmatch Qty.");
                if (ex.Number == 20011) return Ok("Used PO.");

                throw (ex);
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE015_P_PendingComplete");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        #endregion

        #region SNPE015_R


        [HttpPost, Route("SNPE015_R_GetDocNoList")]
        [Authorize]
        public IHttpActionResult SNPE015_R_GetDocNoList([FromBody] dynamic pData)
        {
            try
            {
                OracleCommand cmd = new OracleCommand();

                cmd.CommandText = "SP_NP_SNPE015_P_GET_LIST";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pData["VENDOR_CODE"];
                cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = pData["INVOICE_NO"];
                cmd.Parameters.Add("P_INVOICE_DATE", OracleDbType.Date).Value = pData["INVOICE_DATE"] != null ? Convert.ToDateTime(pData["INVOICE_DATE"].ToString()) : (object)DBNull.Value;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                DataSet ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE015_R_GetDocNoList");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }

        }

        [HttpPost, Route("SNPE015_R_GetDetailByItem")]
        [Authorize]
        public IHttpActionResult SNPE015_R_GetDetailByItem([FromBody] dynamic pData)
        {
            try
            {
                OracleCommand cmd = new OracleCommand();

                cmd.CommandText = "SP_NP_SNPE015_R_GET_SCAN_D";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pData["VENDOR_CODE"];
                cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = pData["INVOICE_NO"];
                cmd.Parameters.Add("P_SEQ", OracleDbType.Decimal).Value = pData["SEQ"];
                cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = pData["PART_NO"];
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                DataSet ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE015_R_GetDetailByItem");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpPost, Route("SNPE015_R_WEB_GetInvoiceDetail")]
        [Authorize]
        public IHttpActionResult SNPE015_R_WEB_GetInvoiceDetail([FromBody] dynamic pData)
        {
            try
            {
                OracleCommand cmd = new OracleCommand();

                cmd.CommandText = "SP_NP_SNPE015_R_WEB_GET_DETAIL";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pData["VENDOR_CODE"];
                cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = pData["INVOICE_NO"];
                cmd.Parameters.Add("C_RETURN_H", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                cmd.Parameters.Add("C_RETURN_D", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                cmd.Parameters.Add("C_RETURN_I", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                DataSet ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE015_R_WEB_GetInvoiceDetail");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }

        }


        [HttpGet, Route("SNPE015_R_GetInvList/{invoiceno}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult SNPE015_R_GetInvList(string invoiceno, int noofshowrec)
        {
            try
            {
                DataSet ds = new DataSet();

                invoiceno = ismoUtil.escapeCharacter(invoiceno);

                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNPE015_R_GET_INV";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = invoiceno.ToUpper() == "NULL" ? (object)DBNull.Value : invoiceno;
                cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE015_R_GetInvList");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpPost, Route("SNPE015_R_GetData")]
        [Authorize]
        public IHttpActionResult SNPE015_R_GetData([FromBody] dynamic pData)
        {
            try
            {
                OracleCommand cmd = new OracleCommand();

                cmd.CommandText = "SP_NP_SNPE015_R_GET_LIST";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_DOC_DATE_FROM", OracleDbType.Date).Value = pData["DOCUMENT_DATE_FROM"] != null ? Convert.ToDateTime(pData["DOCUMENT_DATE_FROM"].ToString()) : (object)DBNull.Value;
                cmd.Parameters.Add("P_DOC_DATE_TO", OracleDbType.Date).Value = pData["DOCUMENT_DATE_TO"] != null ? Convert.ToDateTime(pData["DOCUMENT_DATE_TO"].ToString()) : (object)DBNull.Value;
                cmd.Parameters.Add("P_PRE_RECEIVING_NO", OracleDbType.Varchar2).Value = pData["PRE_RECEIVE_DOC_NO"];
                cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pData["VENDOR_CODE"];
                cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = pData["INVOICE_NO"];

                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                DataSet ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE015_R_GetData");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }

        }


        [HttpPost, Route("SNPE015_R_SaveDocument")]
        [Authorize]
        [RunBatchGuard]
        public IHttpActionResult SNPE015_R_SaveDocument([FromBody] dynamic pData)
        {
            try
            {
                int iCount = 0;
                OracleCommand cmd = new OracleCommand();

                List<dynamic> partList = new List<dynamic>(pData.PART_LIST);

                cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNPE015_R_DELETE_TEMP";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pData["VENDOR_CODE"];
                cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = pData["INVOICE_NO"];

                oOracledb.SqlQueryReturnValue(cmd);

                if (partList.Count > 0)
                {

                    //Run insert detail
                    foreach (var part in partList)
                    {
                        iCount++;

                        cmd = new OracleCommand();
                        cmd.CommandText = "SP_NP_SNPE015_R_SAVE_TEMP";
                        cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                        cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pData["VENDOR_CODE"];
                        cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = pData["INVOICE_NO"];
                        cmd.Parameters.Add("P_SEQ", OracleDbType.Int16).Value = part["SEQ"];
                        cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = part["PART_NO"];
                        cmd.Parameters.Add("P_QTY", OracleDbType.Double).Value = part["QTY"];
                        cmd.Parameters.Add("P_RECEIVE_FLAG", OracleDbType.Varchar2).Value = part["RECEIVE_FLAG"];
                        cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);

                        oOracledb.SqlQueryReturnValue(cmd);

                    }

                    //Insert transaction
                    cmd = new OracleCommand();
                    cmd.CommandText = "SP_NP_SNPE015_R_SAVE";
                    cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                    cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pData["VENDOR_CODE"];
                    cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = pData["INVOICE_NO"];
                    cmd.Parameters.Add("P_MANUAL_RECEIVE", OracleDbType.Varchar2).Value = pData["MANUAL_RECEIVE"] ?? "N";
                    cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                    cmd.Parameters.Add("R_DOCUMENT_NO", OracleDbType.Varchar2, 20).Direction = ParameterDirection.Output;

                    cmd = oOracledb.SqlQueryReturnValue(cmd);

                    string documentNo = cmd.Parameters["R_DOCUMENT_NO"].Value.ToString();

                    return Json(new { Result = "Done", DocumentNo = documentNo });
                }

                return ResponseMessage(Request.CreateResponse(HttpStatusCode.BadRequest, "No row to process."));

            }
            catch (OracleException ex)
            {
                if (ex.Number == 20001)
                {
                    oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE015_R_SaveDocument");
                    return Json(new { Result = "Fail", Message = "Cannot confirm invoice: items are not equally." });
                }
                else if (ex.Number == 20002)
                {
                    oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE015_R_SaveDocument");
                    return Json(new { Result = "Fail", Message = "Cannot confirm invoice: status code." });
                }
                else
                {
                    throw (ex);
                }

            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE015_R_SaveDocument");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }

        }

        #endregion


        #region SNPE015_S

        [HttpPost, Route("SNPE015_S_GetData")]
        [Authorize]
        public IHttpActionResult SNPE015_S_GetData([FromBody] dynamic pData)
        {
            try
            {
                OracleCommand cmd = new OracleCommand();

                cmd.CommandText = "SP_NP_SNPE015_S_GET_LIST";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_DOC_DATE_FROM", OracleDbType.Date).Value = pData["DOCUMENT_DATE_FROM"] != null ? Convert.ToDateTime(pData["DOCUMENT_DATE_FROM"].ToString()) : (object)DBNull.Value;
                cmd.Parameters.Add("P_DOC_DATE_TO", OracleDbType.Date).Value = pData["DOCUMENT_DATE_TO"] != null ? Convert.ToDateTime(pData["DOCUMENT_DATE_TO"].ToString()) : (object)DBNull.Value;
                cmd.Parameters.Add("P_PRE_RECEIVING_NO", OracleDbType.Varchar2).Value = pData["PRE_RECEIVING_NO"];
                cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pData["VENDOR_CODE"];
                cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = pData["INVOICE_NO"];

                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                DataSet ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE015_S_GetData");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }

        }


        [HttpPost, Route("SNPE015_S_GetInvoiceDetail")]
        [Authorize]
        public IHttpActionResult SNPE015_S_GetInvoiceDetail([FromBody] dynamic pData)
        {
            try
            {
                OracleCommand cmd = new OracleCommand();

                cmd.CommandText = "SP_NP_SNPE015_S_GET_DETAIL";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pData["VENDOR_CODE"];
                cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = pData["INVOICE_NO"];
                cmd.Parameters.Add("C_RETURN_H", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                cmd.Parameters.Add("C_RETURN_D", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                cmd.Parameters.Add("C_RETURN_L", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                DataSet ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE015_S_GetInvoiceDetail");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpPost, Route("SNPE015_S_SaveDocument")]
        [Authorize]
        [RunBatchGuard]
        public IHttpActionResult SNPE015_S_SaveDocument([FromBody] dynamic pData)
        {
            try
            {
                int iCount = 0;
                OracleCommand cmd = new OracleCommand();

                List<dynamic> partList = new List<dynamic>(pData.PART_LIST);

                cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNPE015_S_DELETE_TEMP";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pData["VENDOR_CODE"];
                cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = pData["INVOICE_NO"];
                cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);

                cmd = oOracledb.SqlQueryReturnValue(cmd);

                //Run insert detail
                foreach (var part in partList)
                {
                    iCount++;

                    cmd = new OracleCommand();
                    cmd.CommandText = "SP_NP_SNPE015_S_SAVE_TEMP";
                    cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                    cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pData["VENDOR_CODE"];
                    cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = pData["INVOICE_NO"];
                    cmd.Parameters.Add("P_SEQ", OracleDbType.Int16).Value = part["SEQ"];
                    cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = part["PART_NO"];
                    cmd.Parameters.Add("P_QTY", OracleDbType.Double).Value = part["QTY"];
                    cmd.Parameters.Add("P_SHELVE_FLAG", OracleDbType.Varchar2).Value = part["SHELVE_FLAG"];
                    cmd.Parameters.Add("P_LOCATION", OracleDbType.Varchar2).Value = part["LOCATION"];
                    cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);

                    oOracledb.SqlQueryReturnValue(cmd);

                }

                //Insert transaction
                cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNPE015_S_SAVE";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pData["VENDOR_CODE"];
                cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = pData["INVOICE_NO"];
                cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);

                cmd = oOracledb.SqlQueryReturnValue(cmd);

                return Json(new { Result = "Done" });

            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE015_S_SaveDocument");
                return Json(new { Result = "Fail", Message = ex.Message });
                //return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }

        }

        [HttpGet, Route("SNPE015_S_GetReceivingList/{docno}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult SNPE015_S_GetReceivingList(string docno, int noofshowrec)
        {
            try
            {
                DataSet ds = new DataSet();

                docno = ismoUtil.escapeCharacter(docno);

                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNPE015_S_GET_REV_NO";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_DOC_NO", OracleDbType.Varchar2).Value = docno.ToUpper() == "NULL" ? (object)DBNull.Value : docno;
                cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE015_S_GetReceivingList");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }



        [HttpPost, Route("SNPE015_W_GetData")]
        [Authorize]
        public IHttpActionResult SNPE015_W_GetData([FromBody] dynamic pData)
        {
            try
            {
                OracleCommand cmd = new OracleCommand();

                cmd.CommandText = "SP_NP_SNPE015_W_GET_LIST";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_DOC_DATE_FROM", OracleDbType.Date).Value = pData["DOCUMENT_DATE_FROM"] != null ? Convert.ToDateTime(pData["DOCUMENT_DATE_FROM"].ToString()) : (object)DBNull.Value;
                cmd.Parameters.Add("P_DOC_DATE_TO", OracleDbType.Date).Value = pData["DOCUMENT_DATE_TO"] != null ? Convert.ToDateTime(pData["DOCUMENT_DATE_TO"].ToString()) : (object)DBNull.Value;
                cmd.Parameters.Add("P_PRE_RECEIVING_NO", OracleDbType.Varchar2).Value = pData["PRE_RECEIVING_NO"];
                cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pData["VENDOR_CODE"];
                cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = pData["INVOICE_NO"];

                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                DataSet ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE015_W_GetData");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }

        }


        [HttpPost, Route("SNPE015_W_GetData_Comfirmed")]
        [Authorize]
        public IHttpActionResult SNPE015_W_GetData_Comfirmed([FromBody] dynamic pData)
        {
            try
            {
                OracleCommand cmd = new OracleCommand();

                cmd.CommandText = "SP_NP_SNPE015_W_GET_CONFIRM";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_DOC_DATE_FROM", OracleDbType.Date).Value = pData["DOCUMENT_DATE_FROM"] != null ? Convert.ToDateTime(pData["DOCUMENT_DATE_FROM"].ToString()) : (object)DBNull.Value;
                cmd.Parameters.Add("P_DOC_DATE_TO", OracleDbType.Date).Value = pData["DOCUMENT_DATE_TO"] != null ? Convert.ToDateTime(pData["DOCUMENT_DATE_TO"].ToString()) : (object)DBNull.Value;
                cmd.Parameters.Add("P_RECEIVE_DOC_NO", OracleDbType.Varchar2).Value = pData["RECEIVE_DOC_NO"];
                cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pData["VENDOR_CODE"];
                cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = pData["INVOICE_NO"];

                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                DataSet ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE015_W_GetData_Comfirmed");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }

        }


        [HttpPost, Route("SNPE015_W_GetData_OH")]
        [Authorize]
        public IHttpActionResult SNPE015_W_GetData_OH([FromBody] dynamic pData)
        {
            try
            {
                OracleCommand cmd = new OracleCommand();

                cmd.CommandText = "SP_NP_SNPE015_W_GET_OH";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_DOC_DATE_FROM", OracleDbType.Date).Value = pData["DOCUMENT_DATE_FROM"] != null ? Convert.ToDateTime(pData["DOCUMENT_DATE_FROM"].ToString()) : (object)DBNull.Value;
                cmd.Parameters.Add("P_DOC_DATE_TO", OracleDbType.Date).Value = pData["DOCUMENT_DATE_TO"] != null ? Convert.ToDateTime(pData["DOCUMENT_DATE_TO"].ToString()) : (object)DBNull.Value;
                cmd.Parameters.Add("P_RECEIVE_DOC_NO", OracleDbType.Varchar2).Value = pData["RECEIVE_DOC_NO"];
                cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pData["VENDOR_CODE"];
                cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = pData["INVOICE_NO"];

                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                DataSet ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE015_W_GetData_OH");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }

        }

        [HttpPost, Route("SNPE015_W_Cancel")]
        [Authorize]
        [RunBatchGuard]
        public IHttpActionResult SNPE015_W_Cancel([FromBody] dynamic pData)
        {
            OracleCommand cmd = new OracleCommand();

            try
            {
                cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNPE015_W_CANCEL";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pData["VENDOR_CODE"];
                cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = pData["INVOICE_NO"];
                cmd.Parameters.Add("P_PRE_RECEIVE_DOC_NO", OracleDbType.Varchar2).Value = pData["PRE_RECEIVE_DOC_NO"];
                cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);

                oOracledb.SqlQueryReturnValue(cmd);

                return Json(new { Result = "Done" });
            }
            catch (OracleException ex)
            {
                if (ex.Number == 20001)
                {
                    oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE015_W_Cancel");
                    return Json(new { Result = "Fail", Message = "Cannot cancel invoice: No receive data found." });
                }
                else if (ex.Number == 20002)
                {
                    oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE015_W_Cancel");
                    return Json(new { Result = "Fail", Message = "Cannot cancel invoice: Invalid document type." });
                }
                else if (ex.Number == 20003)
                {
                    oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE015_W_Cancel");
                    return Json(new { Result = "Fail", Message = "Cannot cancel invoice: No document data found." });
                }

                throw (ex);
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE015_W_Cancel");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }


        [HttpPost, Route("SNPE015_W_ConfirmShelve")]
        [Authorize]
        [RunBatchGuard, DateControlGuard]
        public IHttpActionResult SNPE015_W_ConfirmShelve([FromBody] dynamic pData)
        {
            OracleCommand cmd = new OracleCommand();

            try
            {
                //Insert transaction
                cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNPE015_W_CONFIRM_SHELVE";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pData["VENDOR_CODE"];
                cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = pData["INVOICE_NO"];
                cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);


                cmd.Parameters.Add("R_DOCUMENT_NO", OracleDbType.Varchar2, 50).Direction = ParameterDirection.Output;

                cmd = oOracledb.SqlQueryReturnValue(cmd);

                string documentNo = cmd.Parameters["R_DOCUMENT_NO"].Value.ToString();

                return Json(new { DOCUMENT_NO = documentNo });

            }
            catch (OracleException ex)
            {
                if (ex.Number == 20001)
                {
                    oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE015_W_ConfirmShelve");
                    return Json(new { Result = "Fail", Message = "Cannot shelve invoice: items are not equally." });
                }
                else if (ex.Number == 20002)
                {
                    oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE015_W_ConfirmShelve");
                    return Json(new { Result = "Fail", Message = "Cannot shelve invoice: status code." });
                }
                else if (ex.Number == 20003)
                {
                    oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE015_W_ConfirmShelve");
                    return Json(new { Result = "Fail", Message = "Cannot shelve invoice: non-received." });
                }
                else if (ex.Number == 20004)
                {
                    oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE015_W_ConfirmShelve");
                    return Json(new { Result = "Fail", Message = "Cannot shelve invoice: PENDING." });
                }
                else
                {
                    throw (ex);
                }

            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE015_W_ConfirmShelve");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }


        }


        [HttpPost, Route("SNPE015_W_Update_PO")]
        [Authorize]
        [RunBatchGuard]
        public IHttpActionResult SNPE015_W_Update_PO([FromBody] dynamic pData)
        {
            OracleCommand cmd;
            string gDocNo;

            List<dynamic> partList = new List<dynamic>(pData.PART_LIST);
            int partCount = 0;

            //Insert to pre-receive
            try
            {

                cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNPE015_P_DEL_TEMP";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = pData["INVOICE_NO"];
                cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pData["VENDOR_CODE"];

                cmd = oOracledb.SqlQueryReturnValue(cmd);

                foreach (var part in partList)
                {
                    partCount++;

                    cmd = new OracleCommand();
                    cmd.CommandText = "SP_NP_SNPE015_P_INS_TEMP";
                    cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                    cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = pData["INVOICE_NO"];
                    cmd.Parameters.Add("P_INVOICE_DATE", OracleDbType.Date).Value = Convert.ToDateTime(pData["INVOICE_DATE"]);
                    cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pData["VENDOR_CODE"];
                    cmd.Parameters.Add("P_RNO", OracleDbType.Decimal).Value = part["ITEM"]; // Note item mean current order
                    cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = part["ACCEPT_PART_NO"];
                    cmd.Parameters.Add("P_UNIT_TYPE", OracleDbType.Varchar2).Value = part["UNIT_TYPE"];
                    cmd.Parameters.Add("P_QTY", OracleDbType.Decimal).Value = part["QTY"];
                    cmd.Parameters.Add("P_PO_NO", OracleDbType.Varchar2).Value = part["PO_NO"];
                    cmd.Parameters.Add("P_ITEM_NO", OracleDbType.Decimal).Value = part["ITEM_NO"];
                    cmd.Parameters.Add("P_SUB_ITEM_NO", OracleDbType.Varchar2).Value = part["SUB_ITEM_NO"];
                    cmd.Parameters.Add("P_PO_CLASS", OracleDbType.Varchar2).Value = part["ORDER_CLASS"];
                    cmd.Parameters.Add("P_ORDER_TYPE", OracleDbType.Varchar2).Value = part["ORDER_TYPE"];

                    oOracledb.SqlQueryReturnValue(cmd);
                }

                cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNPE015_W_UPDATE_PO";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_INVOICE_TYPE", OracleDbType.Varchar2).Value = pData["INVOICE_TYPE"];
                cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = pData["INVOICE_NO"];
                cmd.Parameters.Add("P_INVOICE_DATE", OracleDbType.Date).Value = Convert.ToDateTime(pData["INVOICE_DATE"]);
                cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pData["VENDOR_CODE"];
                cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("P_GUID", OracleDbType.Varchar2).Value = pData["GUID"];
                cmd.Parameters.Add("R_DOC_NO", OracleDbType.Varchar2, 20).Direction = ParameterDirection.Output;

                cmd = oOracledb.SqlQueryReturnValue(cmd);

                gDocNo = cmd.Parameters["R_DOC_NO"].Value.ToString();

            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNSE015_P_Save");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }

            return Json(new { Result = "Done", DocNo = gDocNo });

        }

        [HttpPost, Route("SNPE015_W_Update_Invoice")]
        [Authorize]
        [RunBatchGuard]
        public IHttpActionResult SNPE015_W_Update_Invoice([FromBody] dynamic pData)
        {
            OracleCommand cmd;

            //Insert to pre-receive
            try
            {

                cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNPE015_W_UPDATE_INVOICE";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_INVOICE_TYPE", OracleDbType.Varchar2).Value = pData["INVOICE_TYPE"];
                cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = pData["INVOICE_NO"];
                cmd.Parameters.Add("P_INVOICE_DATE", OracleDbType.Date).Value = Convert.ToDateTime(pData["INVOICE_DATE"]);
                cmd.Parameters.Add("P_UPDATE_INVOICE_NO", OracleDbType.Varchar2).Value = pData["UPDATE_INVOICE_NO"];
                cmd.Parameters.Add("P_UPDATE_INVOICE_DATE", OracleDbType.Date).Value = Convert.ToDateTime(pData["UPDATE_INVOICE_DATE"]);
                cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pData["VENDOR_CODE"];
                cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("P_GUID", OracleDbType.Varchar2).Value = pData["GUID"];
                cmd.Parameters.Add("R_STATUS", OracleDbType.Varchar2, 20).Direction = ParameterDirection.Output;

                cmd = oOracledb.SqlQueryReturnValue(cmd);

            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE015_W_Update_Invoice");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }

            return Json(new { Result = "Done" });

        }


        [HttpPost, Route("SNPE015_W_Update_Invoice_Date")]
        [Authorize]
        [RunBatchGuard]
        public IHttpActionResult SNPE015_W_Update_Invoice_Date([FromBody] dynamic pData)
        {
            OracleCommand cmd;

            //Insert to pre-receive
            try
            {

                cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNPE015_W_UPD_INV_DATE";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = pData["INVOICE_NO"];
                cmd.Parameters.Add("P_INVOICE_DATE", OracleDbType.Date).Value = Convert.ToDateTime(pData["INVOICE_DATE"]);
                cmd.Parameters.Add("P_UPDATE_INVOICE_NO", OracleDbType.Varchar2).Value = pData["UPDATE_INVOICE_NO"];
                cmd.Parameters.Add("P_UPDATE_INVOICE_DATE", OracleDbType.Date).Value = Convert.ToDateTime(pData["UPDATE_INVOICE_DATE"]);
                cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pData["VENDOR_CODE"];
                cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("P_GUID", OracleDbType.Varchar2).Value = pData["GUID"];
                cmd.Parameters.Add("R_STATUS", OracleDbType.Varchar2, 20).Direction = ParameterDirection.Output;

                cmd = oOracledb.SqlQueryReturnValue(cmd);

            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE015_W_Update_Invoice");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }

            return Json(new { Result = "Done" });

        }


        #endregion

        #region SNPE047
        [HttpPost, Route("SNPE047_GetList")]
        [Authorize]
        public IHttpActionResult SNPE047_GetList([FromBody] dynamic pParam)
        {
            try
            {
                DataSet ds = new DataSet();
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNPE047_GET_LIST";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_DOC_DATE_FROM", OracleDbType.Date).Value = pParam["DOCUMENT_DATE_FROM"] != null ? Convert.ToDateTime(pParam["DOCUMENT_DATE_FROM"].ToString()) : (object)DBNull.Value;
                cmd.Parameters.Add("P_DOC_DATE_TO", OracleDbType.Date).Value = pParam["DOCUMENT_DATE_TO"] != null ? Convert.ToDateTime(pParam["DOCUMENT_DATE_TO"].ToString()) : (object)DBNull.Value;
                cmd.Parameters.Add("P_PRE_RECEIVING_NO", OracleDbType.Varchar2).Value = pParam["PRE_RECEIVING_NO"];
                cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pParam["VENDOR_CODE"];
                cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = pParam["INVOICE_NO"];
                cmd.Parameters.Add("P_INVOICE_STATUS", OracleDbType.Varchar2).Value = "S";
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE047_GetList");
                return Json(new { Status = "Error" });

            }
        }
        [HttpPost, Route("SNPE047_GetList_Confirmed")]
        [Authorize]
        public IHttpActionResult SNPE047_GetList_Confirmed([FromBody] dynamic pParam)
        {
            try
            {
                DataSet ds = new DataSet();
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNPE047_GET_LIST";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_DOC_DATE_FROM", OracleDbType.Date).Value = pParam["DOCUMENT_DATE_FROM"] != null ? Convert.ToDateTime(pParam["DOCUMENT_DATE_FROM"].ToString()) : (object)DBNull.Value;
                cmd.Parameters.Add("P_DOC_DATE_TO", OracleDbType.Date).Value = pParam["DOCUMENT_DATE_TO"] != null ? Convert.ToDateTime(pParam["DOCUMENT_DATE_TO"].ToString()) : (object)DBNull.Value;
                cmd.Parameters.Add("P_PRE_RECEIVING_NO", OracleDbType.Varchar2).Value = pParam["PRE_RECEIVING_NO"];
                cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pParam["VENDOR_CODE"];
                cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = pParam["INVOICE_NO"];
                cmd.Parameters.Add("P_INVOICE_STATUS", OracleDbType.Varchar2).Value = "55";
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE047_GetList");
                return Json(new { Status = "Error" });

            }
        }
        [HttpPost, Route("SNPE047_GetList_OH")]
        [Authorize]
        public IHttpActionResult SNPE047_GetList_OH([FromBody] dynamic pParam)
        {
            try
            {
                DataSet ds = new DataSet();
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNPE047_GET_LIST";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_DOC_DATE_FROM", OracleDbType.Date).Value = pParam["DOCUMENT_DATE_FROM"] != null ? Convert.ToDateTime(pParam["DOCUMENT_DATE_FROM"].ToString()) : (object)DBNull.Value;
                cmd.Parameters.Add("P_DOC_DATE_TO", OracleDbType.Date).Value = pParam["DOCUMENT_DATE_TO"] != null ? Convert.ToDateTime(pParam["DOCUMENT_DATE_TO"].ToString()) : (object)DBNull.Value;
                cmd.Parameters.Add("P_PRE_RECEIVING_NO", OracleDbType.Varchar2).Value = pParam["PRE_RECEIVING_NO"];
                cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pParam["VENDOR_CODE"];
                cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = pParam["INVOICE_NO"];
                cmd.Parameters.Add("P_INVOICE_STATUS", OracleDbType.Varchar2).Value = "60";
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE047_GetList");
                return Json(new { Status = "Error" });

            }
        }

        [HttpPost, Route("SNPE047_GetDetail")]
        [Authorize]
        public IHttpActionResult SNPE047_GetDetail([FromBody] dynamic pParam)
        {
            try
            {
                DataSet ds = new DataSet();
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNPE047_GET_DETAIL";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = pParam["INVOICE_NO"];
                cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pParam["VENDOR_CODE"];
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE047_GetDetail");
                return Json(new { Status = "Error" });
            }
        }

        [HttpPost, Route("SNPE047_Save")]
        [Authorize]
        [RunBatchGuard, DateControlGuard]
        public IHttpActionResult SNPE047_Save([FromBody] dynamic pData)
        {


            int iCount = 0;
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();

            var partList = new List<dynamic>(pData.PART_LIST);

            if (partList.Count > 0)
            {

                cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNPE047_DELETE_TEMP";
                cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = pData["INVOICE_NO"];
                cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pData["VENDOR_CODE"];

                oOracledb.SqlQueryReturnValue(cmd);

                foreach (var item in pData.PART_LIST)
                {
                    iCount++;
                    cmd = new OracleCommand();
                    cmd.CommandText = "SP_NP_SNPE047_SAVE_TEMP";
                    cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = pData["INVOICE_NO"];
                    cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pData["VENDOR_CODE"];
                    cmd.Parameters.Add("P_ORDER_NO", OracleDbType.Varchar2).Value = item["ORDER_NO"];
                    cmd.Parameters.Add("P_ORDER_ITEM_NO", OracleDbType.Int16).Value = item["ORDER_ITEM_NO"];
                    cmd.Parameters.Add("P_ORDER_SUB_ITEM_NO", OracleDbType.Varchar2).Value = item["ORDER_SUB_ITEM_NO"];
                    cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = item["PART_NO"];
                    cmd.Parameters.Add("P_QTY", OracleDbType.Double).Value = item["QTY"];
                    cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);

                    oOracledb.SqlQueryReturnValue(cmd);
                }

                //Insert transaction
                try
                {
                    cmd = new OracleCommand();
                    cmd.CommandText = "SP_NP_SNPE047_SAVE_TRANS";
                    cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                    cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = pData.INVOICE_NO;
                    cmd.Parameters.Add("P_INVOICE_DATE", OracleDbType.Date).Value = (pData._INVOICE_DATE != null) ? Convert.ToDateTime(pData._INVOICE_DATE) : null;
                    cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pData.VENDOR_CODE;
                    cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                    cmd.Parameters.Add("R_DOCUMENT_NO", OracleDbType.Varchar2, 50).Direction = ParameterDirection.Output;

                    cmd = oOracledb.SqlQueryReturnValue(cmd);

                    string documentNo = cmd.Parameters["R_DOCUMENT_NO"].Value.ToString();

                    return Json(new { result = "Done", DOCUMENT_NO = documentNo });
                }
                catch (OracleException ex)
                {
                    if (ex.Number == 20001)
                    {
                        return Json(new { result = "Fail", MESSAGE = oOracledb.GetErrorMessage(ex) });
                    }

                    throw;
                }
                catch (Exception ex)
                {
                    oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE047_Save");
                    return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
                }

            }

            return ResponseMessage(Request.CreateResponse(HttpStatusCode.BadRequest, "No row to process."));
        }

        [HttpPost, Route("SNPE047_Cancel_Invoice")]
        [Authorize]
        [RunBatchGuard]
        public IHttpActionResult SNPE047_Cancel_Invoice([FromBody] dynamic pData)
        {
            try
            {
                DataSet ds = new DataSet();
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNPE047_CANCEL_INV";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pData.VENDOR_CODE;
                cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = pData.INVOICE_NO;
                cmd.Parameters.Add("P_PRE_RECEIVE_DOC_NO", OracleDbType.Varchar2).Value = pData.PRE_RECEIVE_DOC_NO;
                cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                ds = oOracledb.SqlQueryDS_CMD(cmd);


                return Json(new { result = "Done" });
            }
            catch (OracleException ex)
            {

                if (ex.Number == 20001)
                {
                    return Json(new { result = "Fail", message = oOracledb.GetErrorMessage(ex) });
                }

                throw (ex);
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE047_Cancel_Invoice");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.NotAcceptable, ex.Message));
            }

        }

        [HttpPost, Route("SNPE047_Cancel")]
        [Authorize]
        [RunBatchGuard, DateControlGuard]
        public IHttpActionResult SNPE047_Cancel([FromBody] dynamic pData)
        {
            try
            {
                DataSet ds = new DataSet();
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNPE047_CANCEL";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_DOCUMENT_NO", OracleDbType.Varchar2).Value = pData.DOCUMENT_NO;
                cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(new { result = "Done" });
            }
            catch (OracleException ex)
            {

                if (ex.Number == 20001)
                {
                    return Json(new { result = "Fail", message = oOracledb.GetErrorMessage(ex) });
                }

                throw (ex);
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE047_P_Cancel");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.NotAcceptable, ex.Message));
            }

        }
        #endregion


        #region SNPE047P

        [HttpGet, Route("SNPE047P_GetDoc/{DocNo=null}/{NoOfShowRecords=null}")]
        [Authorize]
        public IHttpActionResult SNPE047P_GetDoc(string DocNo = null, string NoOfShowRecords = null)
        {
            try
            {
                DataSet ds = new DataSet();
                DocNo = ismoUtil.escapeCharacter(DocNo);
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNPE047_P_GET_DOC";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_DOCUMEN_NO", OracleDbType.Varchar2).Value = DocNo != "null" ? DocNo : "";
                cmd.Parameters.Add("P_DOCUMEN_TYPE", OracleDbType.Varchar2).Value = "RI";
                cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = NoOfShowRecords;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE047_P_GetDoc");
                return Json(new { Status = "Error" });

            }
        }

        [HttpGet, Route("SNPE047P_GetVendor/{VendorCode=null}/{NoOfShowRecords=null}")]
        [Authorize]
        public IHttpActionResult SNPE047P_GetVendor(string VendorCode = null, string NoOfShowRecords = null)
        {
            try
            {
                DataSet ds = new DataSet();
                VendorCode = ismoUtil.escapeCharacter(VendorCode);
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNPE047_P_GET_VENDOR";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = VendorCode != "null" ? VendorCode : "";
                cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = NoOfShowRecords;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE047_P_GetVendor");
                return Json(new { Status = "Error" });

            }
        }

        [HttpPost, Route("SNPE047P_GetInv/{InvNo}/{NoOfShowRecords}")]
        [Authorize]
        public IHttpActionResult SNPE047P_GetInv(string InvNo, string NoOfShowRecords, [FromBody] dynamic pData)
        {
            try
            {
                DataSet ds = new DataSet();
                InvNo = ismoUtil.escapeCharacter(InvNo);
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNPE047_P_GET_INV";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_INV_NO", OracleDbType.Varchar2).Value = InvNo != "null" ? InvNo : "";
                cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pData.VENDOR_CODE != "null" ? pData.VENDOR_CODE : "";
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE047P_GetInv");
                return Json(new { Status = "Error" });

            }
        }

        //[HttpPost, Route("SNPE047P_GetInvP")]
        //[Authorize]
        //public IHttpActionResult SNPE047P_GetInvP([FromBody] dynamic pData)
        //{
        //    try
        //    {
        //        DataSet ds = new DataSet();

        //        OracleCommand cmd = new OracleCommand();
        //        cmd.CommandText = "SP_NP_SNPE047P_GET_INV";
        //        cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
        //        cmd.Parameters.Add("P_INV_NO", OracleDbType.Varchar2).Value = pData.REF_INV_NO != "null" ? pData.REF_INV_NO : "";
        //        cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pData.VENDOR_CODE != "null" ? pData.VENDOR_CODE : "";
        //        cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
        //        ds = oOracledb.SqlQueryDS_CMD(cmd);
        //        return Json(DTFM.convertToList(ds));
        //    }
        //    catch (Exception ex)
        //    {
        //        return Json(new { Status = "Error" });

        //    }
        //}

        [HttpPost, Route("SNPE047P_GetList")]
        [Authorize]
        public IHttpActionResult SNPE047P_GetList([FromBody] dynamic pParam)
        {
            try
            {
                DataSet ds = new DataSet();
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNPE047_P_GET_DOC_LIST";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_DOCUMENT_NO", OracleDbType.Varchar2).Value = pParam["DOCUMENT_NO"];
                cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pParam["VENDOR_CODE"];
                cmd.Parameters.Add("P_REF_INV_NO", OracleDbType.Varchar2).Value = pParam["INVOICE_NO"];
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE047P_GetList");
                return Json(new { Status = "Error" });

            }
        }

        [HttpPost, Route("SNPE047P_GetPart/{PartNo}/{NoOfShowRecords}")]
        [Authorize]
        public IHttpActionResult SNPE047P_GetPart(string PartNo, string NoOfShowRecords, [FromBody] dynamic pData)
        {
            try
            {
                DataSet ds = new DataSet();
                PartNo = ismoUtil.escapeCharacter(PartNo);
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNPE047_P_GET_PART";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_INV_NO", OracleDbType.Varchar2).Value = pData["REF_INV_NO"].Value;
                cmd.Parameters.Add("P_DOCUMENT_NO", OracleDbType.Varchar2).Value = (object)DBNull.Value;
                cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = PartNo != "null" ? PartNo : (object)DBNull.Value;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE047P_GetPart");
                return Json(new { Status = "Error" });

            }
        }

        [HttpPost, Route("SNPE047P_GetPart_M/{PartNo}/{NoOfShowRecords}")]
        [Authorize]
        public IHttpActionResult SNPE047P_GetPart_M(string PartNo, string NoOfShowRecords, [FromBody] dynamic pData)
        {
            try
            {
                DataSet ds = new DataSet();
                PartNo = ismoUtil.escapeCharacter(PartNo);
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNPE047_P_GET_PART_M";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = PartNo != "null" ? PartNo : (object)DBNull.Value;
                cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = pData["INVOICE_NO"];
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE047P_GetPart_M");
                return Json(new { Status = "Error" });

            }
        }

        [HttpPost, Route("SNPE047P_GetPart_M2/{PartNo}/{NoOfShowRecords}")]
        [Authorize]
        public IHttpActionResult SNPE047P_GetPart_M2(string PartNo, string NoOfShowRecords, [FromBody] dynamic pData)
        {
            try
            {
                DataSet ds = new DataSet();
                PartNo = ismoUtil.escapeCharacter(PartNo);
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNPE047_P_GET_PART_M2";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = PartNo != "null" ? PartNo : (object)DBNull.Value;
                cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = pData["INVOICE_NO"];
                cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pData["VENDOR_CODE"];
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE047P_GetPart_M2");
                return Json(new { Status = "Error" });

            }
        }


        [HttpGet, Route("SNPE047P_CheckPo/{vendor}/{invoice}/{part}")]
        [Authorize]
        public IHttpActionResult SNPE047P_CheckPo(string vendor, string invoice, string part)
        {
            try
            {
                DataSet ds = new DataSet();

                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNPE047_P_GET_PART_M";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = part;
                cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = invoice;
                cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = vendor;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE047P_CheckPo");
                return Json(new { Status = "Error" });

            }
        }

        [HttpPost, Route("SNPE047P_GetDetail")]
        [Authorize]
        public IHttpActionResult SNPE047P_GetDetail([FromBody] dynamic pData)
        {
            try
            {
                DataSet ds = new DataSet();
                OracleCommand cmd = new OracleCommand();

                cmd.CommandText = "SP_NP_SNPE047_P_GET_PART";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_INV_NO", OracleDbType.Varchar2).Value = pData["INVOICE_NO"];
                cmd.Parameters.Add("P_DOCUMENT_NO", OracleDbType.Varchar2).Value = pData["DOCUMENT_NO"];
                cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = "ALL";
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE047_P_GetPart");
                return Json(new { Status = "Error" });

            }
        }



        [HttpPost, Route("SNPE047P_Save")]
        [Authorize]
        public IHttpActionResult SNPE047P_Save([FromBody] dynamic pData)
        {


            int iCount = 0;
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();

            var partList = new List<dynamic>(pData.PART_LIST);

            if (partList.Count > 0)
            {
                foreach (var item in pData.PART_LIST)
                {
                    if (item.EDIT == "EDIT")
                    {
                        iCount++;
                        cmd = new OracleCommand();
                        cmd.CommandText = "SP_NP_SNPE047_P_SAVE_DET_TMP";
                        cmd.Parameters.Add("P_PO_NO", OracleDbType.Varchar2).Value = item["PO_NO"];
                        cmd.Parameters.Add("P_ITEM_NO", OracleDbType.Int16).Value = item["ITEM_NO"];
                        cmd.Parameters.Add("P_SUB_ITEM_NO", OracleDbType.Varchar2).Value = item["SUB_ITEM_NO"];
                        cmd.Parameters.Add("P_ACCEPT_PART_NO", OracleDbType.Varchar2).Value = item["ACCEPT_PART_NO"];
                        cmd.Parameters.Add("P_ORDER_PART_NO", OracleDbType.Varchar2).Value = item["ORDER_PART_NO"];
                        cmd.Parameters.Add("P_QUANTITY", OracleDbType.Double).Value = item["QUANTITY"];
                        cmd.Parameters.Add("P_REMARK_FLAG", OracleDbType.Varchar2).Value = item["REMARK_FLAG"] ?? "N";
                        cmd.Parameters.Add("P_CLEAR_DATA", OracleDbType.Varchar2).Value = iCount == 1 ? "Y" : "N";
                        cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);

                        oOracledb.SqlQueryReturnValue(cmd);
                    }
                }

                //Insert transaction
                try
                {
                    cmd = new OracleCommand();
                    cmd.CommandText = "SP_NP_SNPE047_P_SAVE_TRANS";
                    cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                    cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = pData.REF_INV_NO;
                    cmd.Parameters.Add("P_INVOICE_DATE", OracleDbType.Date).Value = (pData._REF_INV_DATE != null) ? Convert.ToDateTime(pData._REF_INV_DATE) : null;
                    cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pData.VENDOR_CODE;
                    cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                    cmd.Parameters.Add("R_DOCUMENT_NO", OracleDbType.Varchar2, 50).Direction = ParameterDirection.Output;
                    cmd.Parameters.Add("R_STATUS", OracleDbType.Varchar2, 50).Direction = ParameterDirection.Output;

                    cmd = oOracledb.SqlQueryReturnValue(cmd);

                    string documentNo = cmd.Parameters["R_DOCUMENT_NO"].Value.ToString();
                    string status = cmd.Parameters["R_STATUS"].Value.ToString();

                    return Json(new { DOCUMENT_NO = documentNo, STATUS = status });
                }
                catch (OracleException ex)
                {
                    if (ex.Number == 20001)
                    {
                        return Json(new { STATUS = "Error", MESSAGE = oOracledb.GetErrorMessage(ex) });
                    }

                    throw;
                }
                catch (Exception ex)
                {
                    oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE047_P_Save");
                    return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
                }

            }

            return ResponseMessage(Request.CreateResponse(HttpStatusCode.BadRequest, "No row to process."));
        }

        [HttpPost, Route("SNPE047P_Cancel")]
        [Authorize]
        public IHttpActionResult SNPE047P_Cancel([FromBody] dynamic pData)
        {
            try
            {
                DataSet ds = new DataSet();
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNPE047_P_CANCEL";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_DOCUMENT_NO", OracleDbType.Varchar2).Value = pData.DOCUMENT_NO != "null" ? pData.DOCUMENT_NO : DBNull.Value;
                cmd.Parameters.Add("P_LAST_UPD_PGM", OracleDbType.Varchar2).Value = pData.LAST_UPD_PGM != "null" ? pData.LAST_UPD_PGM : DBNull.Value;
                cmd.Parameters.Add("P_LAST_UPD_BY", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("C_RE", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);

                string status_text = ds.Tables[0].Rows[0]["STATUS"].ToString();
                return Ok(status_text);
            }
            catch (OracleException ex)
            {
                string err_status = string.Empty;

                if (ex.Number == 20002)
                {
                    err_status = "CONFIRMED";
                }
                else
                {
                    err_status = "CONTACT";
                }

                return Ok(err_status);
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE047_P_Cancel");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.NotAcceptable, ex.Message));
            }

        }


        #endregion

        #region SNPE047I

        [HttpGet, Route("SNPE047_I_GetDoc/{DocNo=null}/{NoOfShowRecords=null}")]
        [Authorize]
        public IHttpActionResult SNPE047_I_GetDoc(string DocNo = null, string NoOfShowRecords = null)
        {
            try
            {
                DataSet ds = new DataSet();
                DocNo = ismoUtil.escapeCharacter(DocNo);
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNPE047_I_GET_DOC";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_DOCUMEN_NO", OracleDbType.Varchar2).Value = DocNo != "null" ? DocNo : "";
                cmd.Parameters.Add("P_DOCUMEN_TYPE", OracleDbType.Varchar2).Value = "RI";
                cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = NoOfShowRecords;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE047_I_GetDoc");
                return Json(new { Status = "Error" });
            }
        }
        [HttpGet, Route("SNPE047_I_GetVendor/{VendorCode=null}/{NoOfShowRecords=null}")]
        [Authorize]
        public IHttpActionResult SNPE047_I_GetVendor(string VendorCode = null, string NoOfShowRecords = null)
        {
            try
            {
                DataSet ds = new DataSet();
                VendorCode = ismoUtil.escapeCharacter(VendorCode);
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNPE047_I_GET_VENDOR";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = VendorCode != "null" ? VendorCode : "";
                cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = NoOfShowRecords;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE047_I_GetVendor");
                return Json(new { Status = "Error" });
            }
        }
        [HttpPost, Route("SNPE047_I_GetInv/{InvNo}/{NoOfShowRecords}")]
        [Authorize]
        public IHttpActionResult SNPE047_I_GetInv(string InvNo, string NoOfShowRecords, [FromBody] dynamic pData)
        {
            try
            {
                DataSet ds = new DataSet();
                InvNo = ismoUtil.escapeCharacter(InvNo);
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNPE047_I_GET_INV";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_INV_NO", OracleDbType.Varchar2).Value = InvNo != "null" ? InvNo : "";
                cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pData.VENDOR_CODE;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE047_I_GetInv");
                return Json(new { Status = "Error" });
            }
        }

        [HttpPost, Route("SNPE047_I_GetDetail")]
        [Authorize]
        public IHttpActionResult SNPE047_I_GetDetail([FromBody] dynamic pParam)
        {
            try
            {
                DataSet ds = new DataSet();
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNPE047_I_GET_DETAIL";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = pParam["INVOICE_NO"];
                cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pParam["VENDOR_CODE"];
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE047_I_GetInv");
                return Json(new { Status = "Error" });
            }
        }

        [HttpPost, Route("SNPE047_I_GetList")]
        [Authorize]
        public IHttpActionResult SNPE047_I_GetList([FromBody] dynamic pParam)
        {
            try
            {
                DataSet ds = new DataSet();
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNPE047_I_GET_DOC_LIST";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_DOCUMENT_NO", OracleDbType.Varchar2).Value = pParam["DOCUMENT_NO"];
                cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pParam["VENDOR_CODE"];
                cmd.Parameters.Add("P_REF_INV_NO", OracleDbType.Varchar2).Value = pParam["INVOICE_NO"];
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE047_I_GetList");
                return Json(new { Status = "Error" });
            }
        }
        [HttpPost, Route("SNPE047_I_GetPart/{InvNo}/{NoOfShowRecords}")]
        [Authorize]
        public IHttpActionResult SNPE047_I_GetPart(string InvNo, string NoOfShowRecords, [FromBody] dynamic pData)
        {
            try
            {
                DataSet ds = new DataSet();
                InvNo = ismoUtil.escapeCharacter(InvNo);
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNPE047_I_GET_PART";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_INV_NO", OracleDbType.Varchar2).Value = pData["REF_INV_NO"].Value;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE047_I_GetPart");
                return Json(new { Status = "Error" });
            }
        }
        [HttpPost, Route("SNPE047_I_Save")]
        [Authorize]
        public IHttpActionResult SNPE047_I_Save([FromBody] dynamic pData)
        {
            try
            {
                DataSet ds = new DataSet();
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNPE047_I_SAVE_TRANS";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = pData.REF_INV_NO;
                cmd.Parameters.Add("P_INVOICE_DATE", OracleDbType.Date).Value = (pData._REF_INV_DATE != null) ? Convert.ToDateTime(pData._REF_INV_DATE) : null;
                cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pData.VENDOR_CODE;
                cmd.Parameters.Add("P_REMARK_FLAG", OracleDbType.Varchar2).Value = pData.REMARK_FLAG ?? "N";
                cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("R_DOCUMENT_NO", OracleDbType.Varchar2, 50).Direction = ParameterDirection.Output;
                cmd.Parameters.Add("R_STATUS", OracleDbType.Varchar2, 50).Direction = ParameterDirection.Output;

                cmd = oOracledb.SqlQueryReturnValue(cmd);

                string documentNo = cmd.Parameters["R_DOCUMENT_NO"].Value.ToString();
                string status = cmd.Parameters["R_STATUS"].Value.ToString();

                return Json(new { DOCUMENT_NO = documentNo, STATUS = status });
            }
            catch (OracleException ex)
            {
                if (ex.Number == 20001)
                {
                    return Json(new { STATUS = "Error", MESSAGE = oOracledb.GetErrorMessage(ex) });
                }

                throw;
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE047_I_Save");
                return Json(new { STATUS = "Error" });
            }
        }
        [HttpPost, Route("SNPE047_I_Cancel")]
        [Authorize]
        public IHttpActionResult SNPE047_I_Cancel([FromBody] dynamic pData)
        {
            try
            {
                DataSet ds = new DataSet();
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNPE047_I_CANCEL";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_DOCUMENT_NO", OracleDbType.Varchar2).Value = pData.DOCUMENT_NO != "null" ? pData.DOCUMENT_NO : DBNull.Value;
                cmd.Parameters.Add("P_LAST_UPD_PGM", OracleDbType.Varchar2).Value = pData.LAST_UPD_PGM != "null" ? pData.LAST_UPD_PGM : DBNull.Value;
                cmd.Parameters.Add("P_LAST_UPD_BY", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("C_RE", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);
                string status_text = ds.Tables[0].Rows[0]["STATUS"].ToString();
                return Ok(status_text);
            }
            catch (OracleException ex)
            {
                string err_status = string.Empty;
                if (ex.Number == 20002)
                {
                    err_status = "CONFIRMED";
                }
                else
                {
                    err_status = "CONTACT";
                }
                return Ok(err_status);
            }
            catch (Exception ex)
            {
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.NotAcceptable, ex.Message));
            }
        }
        #endregion

        #region SNPE047C
        [HttpGet, Route("SNPE047C_GetDoc/{DocNo=null}/{NoOfShowRecords=null}")]
        [Authorize]
        public IHttpActionResult SNPE047C_GetDoc(string DocNo = null, string NoOfShowRecords = null)
        {
            try
            {
                DataSet ds = new DataSet();
                DocNo = ismoUtil.escapeCharacter(DocNo);
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNPE047_C_GET_DOC";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_DOCUMEN_NO", OracleDbType.Varchar2).Value = DocNo != "null" ? DocNo : "";
                cmd.Parameters.Add("P_DOCUMEN_TYPE", OracleDbType.Varchar2).Value = "RI";
                cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = NoOfShowRecords;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE047_C_GetDoc");
                return Json(new { Status = "Error" });
            }
        }
        [HttpGet, Route("SNPE047C_GetVendor/{VendorCode=null}/{NoOfShowRecords=null}")]
        [Authorize]
        public IHttpActionResult SNPE047C_GetVendor(string VendorCode = null, string NoOfShowRecords = null)
        {
            try
            {
                DataSet ds = new DataSet();
                VendorCode = ismoUtil.escapeCharacter(VendorCode);
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNPE047_C_GET_VENDOR";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = VendorCode != "null" ? VendorCode : "";
                cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = NoOfShowRecords;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE047C_GetVendor");
                return Json(new { Status = "Error" });
            }
        }
        [HttpPost, Route("SNPE047C_GetInv/{InvNo}/{NoOfShowRecords}")]
        [Authorize]
        public IHttpActionResult SNPE047C_GetInv(string InvNo, string NoOfShowRecords, [FromBody] dynamic pData)
        {
            try
            {
                DataSet ds = new DataSet();
                InvNo = ismoUtil.escapeCharacter(InvNo);
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNPE047_C_GET_INV";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_INV_NO", OracleDbType.Varchar2).Value = InvNo != "null" ? InvNo : "";
                cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pData.VENDOR_CODE != "null" ? pData.VENDOR_CODE : "";
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE047C_GetInv");
                return Json(new { Status = "Error" });
            }
        }

        [HttpPost, Route("SNPE047C_GetList")]
        [Authorize]
        public IHttpActionResult SNPE047C_GetList([FromBody] dynamic pParam)
        {
            try
            {
                DataSet ds = new DataSet();
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNPE047_C_GET_DOC_LIST";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_DOCUMENT_NO", OracleDbType.Varchar2).Value = pParam["DOCUMENT_NO"];
                cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pParam["VENDOR_CODE"];
                cmd.Parameters.Add("P_REF_INV_NO", OracleDbType.Varchar2).Value = pParam["INVOICE_NO"];
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE047C_GetList");
                return Json(new { Status = "Error" });
            }
        }
        [HttpPost, Route("SNPE047C_GetCase/{CaseNo}/{NoOfShowRecords}")]
        [Authorize]
        public IHttpActionResult SNPE047C_GetCase(string CaseNo, string NoOfShowRecords, [FromBody] dynamic pData)
        {
            try
            {
                DataSet ds = new DataSet();
                CaseNo = ismoUtil.escapeCharacter(CaseNo);
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNPE047_C_GET_CASE";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_INV_NO", OracleDbType.Varchar2).Value = pData["REF_INV_NO"].Value;
                cmd.Parameters.Add("P_CASE_NO", OracleDbType.Varchar2).Value = CaseNo != "null" ? CaseNo : (object)DBNull.Value;
                cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pData["VENDOR_CODE"].Value;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE047C_GetCase");
                return Json(new { Status = "Error" });
            }
        }
        [HttpGet, Route("SNPE047C_GetCaseG/{documentNo}/{invoNo}")]
        [Authorize]
        public IHttpActionResult SNPE047C_GetCaseG(string documentNo, string invoNo)
        {
            try
            {
                DataSet ds = new DataSet();
                documentNo = ismoUtil.escapeCharacter(documentNo);
                invoNo = ismoUtil.escapeCharacter(invoNo);
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNPE047_C_GET_CASE_RES";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_INV_NO", OracleDbType.Varchar2).Value = invoNo;
                cmd.Parameters.Add("P_DOCUMENT_NO", OracleDbType.Varchar2).Value = documentNo;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE047C_GetCaseG");
                return Json(new { Status = "Error" });
            }
        }
        [HttpGet, Route("SNPE047C_GetDiffCost/{invoice}/{case_no}/{vendor}")]
        [Authorize]
        public IHttpActionResult SNPE047C_GetDiffCost(string invoice, string case_no, string vendor)
        {
            try
            {
                DataSet ds = new DataSet();
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNPE047_C_GET_DIFF";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_INV_NO", OracleDbType.Varchar2).Value = invoice;
                cmd.Parameters.Add("P_CASE_NO", OracleDbType.Varchar2).Value = case_no;
                cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = vendor;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE047C_GetDiffCost");
                return Json(new { Status = "Error" });
            }
        }
        [HttpGet, Route("SNPE047C_GetPart/{InvNo}")]
        [Authorize]
        public IHttpActionResult SNPE047C_GetPart(string InvNo, string DocNo)
        {
            try
            {
                DataSet ds = new DataSet();
                InvNo = ismoUtil.escapeCharacter(InvNo);
                DocNo = ismoUtil.escapeCharacter(DocNo);
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNPE047_C_GET_PART";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_INV_NO", OracleDbType.Varchar2).Value = InvNo;
                cmd.Parameters.Add("P_DOCUMENT_NO", OracleDbType.Varchar2).Value = DocNo;
                cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = null;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE047C_GetPart");
                return Json(new { Status = "Error" });
            }
        }

        [HttpPost, Route("SNPE047C_Save")]
        [Authorize]
        public IHttpActionResult SNPE047C_Save([FromBody] dynamic pParam)
        {
            int iCount = 0;
            OracleCommand cmd = new OracleCommand();
            foreach (var detail in pParam.CASE_LIST)
            {
                if (detail.EDIT != null && detail.EDIT == "DEL")
                {
                    iCount++;
                    cmd = new OracleCommand();
                    cmd.CommandText = "SP_NP_SNPE047_C_SAVE_CASE_TEMP";
                    cmd.Parameters.Add("P_ITEM_QTY", OracleDbType.Int32).Value = detail["ITEM_QTY"];
                    cmd.Parameters.Add("P_INV_NO", OracleDbType.Varchar2).Value = null;
                    cmd.Parameters.Add("P_CASE_NO", OracleDbType.Varchar2).Value = detail["CASE_NO"];
                    cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = null;
                    cmd.Parameters.Add("P_REMARK_FLAG", OracleDbType.Varchar2).Value = detail["REMARK_FLAG"] ?? "N";
                    cmd.Parameters.Add("P_CLEAR_DATA", OracleDbType.Varchar2).Value = iCount == 1 ? "Y" : "N";
                    cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                    oOracledb.SqlQueryReturnValue(cmd);
                }
            }
            //Insert transaction
            try
            {
                cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNPE047_C_SAVE_TRANS";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = pParam.REF_INV_NO;
                cmd.Parameters.Add("P_INVOICE_DATE", OracleDbType.Date).Value = (pParam._REF_INV_DATE != null) ? Convert.ToDateTime(pParam._REF_INV_DATE) : null;
                cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pParam.VENDOR_CODE;
                cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("R_DOCUMENT_NO", OracleDbType.Varchar2, 50).Direction = ParameterDirection.Output;
                cmd.Parameters.Add("R_STATUS", OracleDbType.Varchar2, 50).Direction = ParameterDirection.Output;

                cmd = oOracledb.SqlQueryReturnValue(cmd);

                string documentNo = cmd.Parameters["R_DOCUMENT_NO"].Value.ToString();
                string status = cmd.Parameters["R_STATUS"].Value.ToString();

                return Json(new { DOCUMENT_NO = documentNo, STATUS = status });
            }
            catch (OracleException ex)
            {
                if (ex.Number == 20001)
                {
                    return Json(new { STATUS = "Error", MESSAGE = oOracledb.GetErrorMessage(ex) });
                }

                throw;
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE047C_Save");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }
        [HttpPost, Route("SNPE047C_Cancel")]
        [Authorize]
        public IHttpActionResult SNPE047C_Cancel([FromBody] dynamic pData)
        {
            try
            {
                DataSet ds = new DataSet();
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNPE047_C_CANCEL";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_DOCUMENT_NO", OracleDbType.Varchar2).Value = pData.DOCUMENT_NO != "null" ? pData.DOCUMENT_NO : DBNull.Value;
                cmd.Parameters.Add("P_LAST_UPD_PGM", OracleDbType.Varchar2).Value = pData.LAST_UPD_PGM != "null" ? pData.LAST_UPD_PGM : DBNull.Value;
                cmd.Parameters.Add("P_LAST_UPD_BY", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("C_RE", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE047C_Cancel");
                return Json(new { Status = "Error" });
            }
        }
        #endregion

        #region SNPE046_

        [HttpPost, Route("SNPE046_P_GetInvList/{invoiceno}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult SNPE046_P_GetInvList(string invoiceno, int noofshowrec, [FromBody] dynamic pParams)
        {
            try
            {
                DataSet ds = new DataSet();

                invoiceno = ismoUtil.escapeCharacter(invoiceno);

                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNPE046_P_GET_INV";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = invoiceno.ToUpper() == "NULL" ? (object)DBNull.Value : invoiceno;
                cmd.Parameters.Add("P_INVOICE_STATUS", OracleDbType.Varchar2).Value = pParams["INVOICE_STATUS"];
                cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE046_P_GetInvList");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }


        [HttpPost, Route("SNPE046_P_GetExistInvoice/{invoiceno}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult SNPE046_P_GetExistInvoice(string invoiceno, string noofshowrec, [FromBody] dynamic pParams)
        {
            try
            {
                DataSet ds = new DataSet();

                invoiceno = ismoUtil.escapeCharacter(invoiceno);

                OracleCommand cmd = new OracleCommand();

                cmd.CommandText = "SP_NP_SNPE046_P_GET_INVOICE_L";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pParams["VENDOR_CODE"];
                cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = invoiceno.ToUpper() == "NULL" ? (object)DBNull.Value : invoiceno;

                cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE046_P_GetInvList");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpPost, Route("SNPE046_P_ValidateInvoice")]
        [Authorize]
        public IHttpActionResult SNPE046_P_ValidateInvoice([FromBody] dynamic pData)
        {
            try
            {
                OracleCommand cmd = new OracleCommand();

                cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNPE046_P_VALIDATE";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pData["VENDOR_CODE"];
                cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = pData["INVOICE_NO"];
                cmd.Parameters.Add("R_STATUS", OracleDbType.Varchar2, 50).Direction = ParameterDirection.Output;
                cmd.Parameters.Add("R_MESSAGE", OracleDbType.Varchar2, 150).Direction = ParameterDirection.Output;

                cmd = oOracledb.SqlQueryReturnValue(cmd);
                string r_status = cmd.Parameters["R_STATUS"].Value.ToString();
                string r_msg = cmd.Parameters["R_MESSAGE"].Value.ToString();


                return Json(new { STATUS = r_status, MESSAGE = r_msg });
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE046_P_ValidateInvoice");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }

        }

        [HttpPost, Route("SNPE046_P_GetInvoiceDetail")]
        [Authorize]
        public IHttpActionResult SNPE046_P_GetInvoiceDetail([FromBody] dynamic pData)
        {
            try
            {
                OracleCommand cmd = new OracleCommand();

                cmd.CommandText = "SP_NP_SNPE046_P_GET_DETAIL";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pData["VENDOR_CODE"];
                cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = pData["INVOICE_NO"];
                cmd.Parameters.Add("C_RETURN_H", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                cmd.Parameters.Add("C_RETURN_D", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                DataSet ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE046_P_GetInvoiceDetail");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }

        }

        [HttpPost, Route("SNPE046_R_GetData_Import")]
        [Authorize]
        public IHttpActionResult SNPE046_R_GetData_Import([FromBody] dynamic pData)
        {
            try
            {
                OracleCommand cmd = new OracleCommand();

                cmd.CommandText = "SP_NP_SNPE046_R_GET_LIST";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_DOC_DATE_FROM", OracleDbType.Date).Value = pData["DOCUMENT_DATE_FROM"] != null ? Convert.ToDateTime(pData["DOCUMENT_DATE_FROM"].ToString()) : (object)DBNull.Value;
                cmd.Parameters.Add("P_DOC_DATE_TO", OracleDbType.Date).Value = pData["DOCUMENT_DATE_TO"] != null ? Convert.ToDateTime(pData["DOCUMENT_DATE_TO"].ToString()) : (object)DBNull.Value;
                cmd.Parameters.Add("P_PRE_RECEIVING_NO", OracleDbType.Varchar2).Value = pData["PRE_RECEIVING_NO"];
                cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pData["VENDOR_CODE"];
                cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = pData["INVOICE_NO"];

                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                DataSet ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE046_R_GetData");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }

        }


        [HttpPost, Route("SNPE046_P_GetData")]
        [Authorize]
        public IHttpActionResult SNPE046_P_GetData([FromBody] dynamic pData)
        {
            try
            {

                OracleCommand cmd = new OracleCommand();

                cmd.CommandText = "SP_NP_SNPE046_P_GET_LIST";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pData["VENDOR_CODE"];
                cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = pData["INVOICE_NO"];
                cmd.Parameters.Add("P_INVOICE_DATE", OracleDbType.Date).Value = pData["INVOICE_DATE"] != null ? Convert.ToDateTime(pData["INVOICE_DATE"].ToString()) : (object)DBNull.Value;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                DataSet ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE046_P_GetData");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }

        }

        [HttpPost, Route("SNPE046_R_GetPre_ReceivingList/{docno}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult SNPE046_R_GetPre_ReceivingList(string docno, int noofshowrec, [FromBody] dynamic pParams)
        {
            try
            {
                DataSet ds = new DataSet();

                docno = ismoUtil.escapeCharacter(docno);

                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNPE046_R_GET_PRE_REV";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_DOC_NO", OracleDbType.Varchar2).Value = docno.ToUpper() == "NULL" ? (object)DBNull.Value : docno;
                cmd.Parameters.Add("P_INVOICE_STATUS", OracleDbType.Varchar2).Value = pParams["INVOICE_STATUS"];
                cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE046_R_GetPre_ReceivingList");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpPost, Route("SNPE046_S_GetData")]
        [Authorize]
        public IHttpActionResult SNPE046_S_GetData([FromBody] dynamic pData)
        {
            try
            {
                OracleCommand cmd = new OracleCommand();

                cmd.CommandText = "SP_NP_SNPE046_S_GET_LIST";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_DOC_DATE_FROM", OracleDbType.Date).Value = pData["DOCUMENT_DATE_FROM"] != null ? Convert.ToDateTime(pData["DOCUMENT_DATE_FROM"].ToString()) : (object)DBNull.Value;
                cmd.Parameters.Add("P_DOC_DATE_TO", OracleDbType.Date).Value = pData["DOCUMENT_DATE_TO"] != null ? Convert.ToDateTime(pData["DOCUMENT_DATE_TO"].ToString()) : (object)DBNull.Value;
                cmd.Parameters.Add("P_PRE_RECEIVING_NO", OracleDbType.Varchar2).Value = pData["PRE_RECEIVING_NO"];
                cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pData["VENDOR_CODE"];
                cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = pData["INVOICE_NO"];

                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                DataSet ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE046_S_GetData");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }

        }

        [HttpPost, Route("SNPE046_W_GetData")]
        [Authorize]
        public IHttpActionResult SNPE046_W_GetData([FromBody] dynamic pData)
        {
            try
            {
                OracleCommand cmd = new OracleCommand();

                cmd.CommandText = "SP_NP_SNPE046_W_GET_LIST";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_DOC_DATE_FROM", OracleDbType.Date).Value = pData["DOCUMENT_DATE_FROM"] != null ? Convert.ToDateTime(pData["DOCUMENT_DATE_FROM"].ToString()) : (object)DBNull.Value;
                cmd.Parameters.Add("P_DOC_DATE_TO", OracleDbType.Date).Value = pData["DOCUMENT_DATE_TO"] != null ? Convert.ToDateTime(pData["DOCUMENT_DATE_TO"].ToString()) : (object)DBNull.Value;
                cmd.Parameters.Add("P_PRE_RECEIVING_NO", OracleDbType.Varchar2).Value = pData["PRE_RECEIVING_NO"];
                cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pData["VENDOR_CODE"];
                cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = pData["INVOICE_NO"];

                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                DataSet ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE046_W_GetData");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }

        }

        [HttpPost, Route("SNPE046_W_ConfirmShelve")]
        [Authorize]
        public IHttpActionResult SNPE046_W_ConfirmShelve([FromBody] dynamic pData)
        {
            OracleCommand cmd = new OracleCommand();

            try
            {
                //Insert transaction
                cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNPE046_W_CONFIRM_SHELVE";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pData["VENDOR_CODE"];
                cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = pData["INVOICE_NO"];
                cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);


                cmd.Parameters.Add("R_DOCUMENT_NO", OracleDbType.Varchar2, 50).Direction = ParameterDirection.Output;

                cmd = oOracledb.SqlQueryReturnValue(cmd);

                string documentNo = cmd.Parameters["R_DOCUMENT_NO"].Value.ToString();

                return Json(new { DOCUMENT_NO = documentNo });

            }
            catch (OracleException ex)
            {
                if (ex.Number == 20001)
                {
                    oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE046_W_ConfirmShelve");
                    return Json(new { Result = "Fail", Message = "Cannot shelve invoice: items are not equally." });
                }
                else if (ex.Number == 20002)
                {
                    oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE046_W_ConfirmShelve");
                    return Json(new { Result = "Fail", Message = "Cannot shelve invoice: status code." });
                }
                else if (ex.Number == 20003)
                {
                    oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE046_W_ConfirmShelve");
                    return Json(new { Result = "Fail", Message = "Cannot shelve invoice: non-received." });
                }
                else
                {
                    throw (ex);
                }

            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNPE046_W_ConfirmShelve");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }


        }


        #endregion

        #region SNWR001
        [HttpPost, Route("SNWR001_InsertTemp")]
        [Authorize]
        public IHttpActionResult SNWR001_InsertTemp([FromBody] dynamic[] pDataList)
        {
            int iCount = 0;
            DataSet ds = new DataSet();
            DataTable dt = new DataTable();
            OracleCommand cmd;
            try
            {
                cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR001_DEL_TEMP";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_LAST_UPD_BY", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                oOracledb.SqlQueryReturnValue(cmd);
                foreach (var data in pDataList)
                {
                    iCount++;
                    cmd = new OracleCommand();
                    cmd.CommandText = "SP_NP_SNWR001_INS_TEMP";
                    cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                    cmd.Parameters.Add("P_LOCATION_NO", OracleDbType.Varchar2).Value = data.LOCATION_NO;
                    cmd.Parameters.Add("P_SEQ", OracleDbType.Int16).Value = iCount;
                    cmd.Parameters.Add("P_LAST_UPD_BY", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                    cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                    ds = oOracledb.SqlQueryDS_CMD(cmd);
                }
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR001_InsertTemp");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpGet, Route("SNWR001_GetLocation/{locationNo=null}/{noofshowrec=null}")]
        [Authorize]
        public IHttpActionResult SNWR001_GetLocation(string locationNo = null, string noofshowrec = null)
        {
            DataSet ds = new DataSet();

            locationNo = ismoUtil.escapeCharacter(locationNo);
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNWR001_GET_LOC";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_LOCATION_NO", OracleDbType.Varchar2).Value = locationNo == "null" ? "" : locationNo;
            cmd.Parameters.Add("c_return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpPost, Route("SNWR001_GetPart/{PartNo}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult SNWR001_GetPart(string PartNo, int noofshowrec, [FromBody] dynamic param)
        {
            DataSet ds = new DataSet();
            ////locationFrom = ismoUtil.escapeCharacter(locationFrom);
            ////locationTo = ismoUtil.escapeCharacter(locationTo);
            PartNo = ismoUtil.escapeCharacter(PartNo);
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNWR001_GET_PART";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_LOCATION_FROM", OracleDbType.Varchar2).Value = param.locationFrom == "null" ? "" : param.locationFrom;
            cmd.Parameters.Add("P_LOCATION_TO", OracleDbType.Varchar2).Value = param.locationTo == "null" ? "" : param.locationTo;
            cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = PartNo == "null" ? "" : PartNo;
            cmd.Parameters.Add("P_SHOW_NUMBER", OracleDbType.Int16).Value = noofshowrec;
            cmd.Parameters.Add("c_return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }


        [HttpGet, Route("SNWR001_GetPrint/{locationFrom=null}/{locationTo=null}/{PartFrom=null}/{PartTo=null}/{PritNo=null}/{noofshowrec=null}")]
        [Authorize]
        public IHttpActionResult SNWR001_GetPrint(string locationFrom = null, string locationTo = null, string PartFrom = null, string PartTo = null, string PritNo = null, string noofshowrec = null)
        {
            DataSet ds = new DataSet();
            locationFrom = ismoUtil.escapeCharacter(locationFrom);
            locationTo = ismoUtil.escapeCharacter(locationTo);
            PartFrom = ismoUtil.escapeCharacter(PartFrom);
            PartTo = ismoUtil.escapeCharacter(PartTo);
            PritNo = ismoUtil.escapeCharacter(PritNo);
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNWR001_GET_PRINT";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_LOCATION_FROM", OracleDbType.Varchar2).Value = locationFrom == "null" ? "" : locationFrom;
            cmd.Parameters.Add("P_LOCATION_TO", OracleDbType.Varchar2).Value = locationTo == "null" ? "" : locationTo;
            cmd.Parameters.Add("P_PART_NO_FROM", OracleDbType.Varchar2).Value = PartFrom == "null" ? "" : PartFrom;
            cmd.Parameters.Add("P_PART_NO_TO", OracleDbType.Varchar2).Value = PartTo == "null" ? "" : PartTo;
            cmd.Parameters.Add("P_PRINT_NO", OracleDbType.Varchar2).Value = PritNo == "null" ? "" : PritNo;
            cmd.Parameters.Add("c_return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpGet, Route("SNWR001_Search/{locationFrom=null}/{locationTo=null}/{PartFrom=null}/{PartTo=null}")]
        [Authorize]
        public IHttpActionResult SNWR001_Search(string locationFrom, string locationTo, string PartFrom, string PartTo)
        {
            DataSet ds = new DataSet();

            try
            {
                locationFrom = ismoUtil.escapeCharacter(locationFrom);
                locationTo = ismoUtil.escapeCharacter(locationTo);
                PartFrom = ismoUtil.escapeCharacter(PartFrom);
                PartTo = ismoUtil.escapeCharacter(PartTo);

                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR001_GET_DATA";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_LOCATION_FROM", OracleDbType.Varchar2).Value = locationFrom == "null" ? "" : locationFrom;
                cmd.Parameters.Add("P_LOCATION_TO", OracleDbType.Varchar2).Value = locationTo == "null" ? "" : locationTo;
                cmd.Parameters.Add("P_PART_NO_FROM", OracleDbType.Varchar2).Value = PartFrom == "null" ? "" : PartFrom;
                cmd.Parameters.Add("P_PART_NO_TO", OracleDbType.Varchar2).Value = PartTo == "null" ? "" : PartTo;

                cmd.Parameters.Add("c_return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));

            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR001_Search");
                return Json(new { Status = "Error" });
            }
        }


        #endregion

        #region SNWR002


        [HttpGet, Route("SNWR002_GetPartNonLocation/{partNo}")]
        [Authorize]
        public IHttpActionResult SNWR002_GetPartNonLocation(string partNo)
        {
            DataSet ds = new DataSet();
            try
            {
                partNo = ismoUtil.escapeCharacter(partNo);

                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR002_GET_PART_NOLO";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = partNo;
                cmd.Parameters.Add("C_RETURN1", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));

            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR002_GetPartNonLocation");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpGet, Route("SNWR002_GetPONonLocation")]
        [Authorize]
        public IHttpActionResult SNWR002_GetPONonLocation()
        {
            DataSet ds = new DataSet();
            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR002_GET_PO_NOLO";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_USER_ID", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("C_RETURN1", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                cmd.Parameters.Add("C_RETURN2", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                cmd.Parameters.Add("C_RETURN3", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));

            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR002_GetPONonLocation");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpPost, Route("SNWR002_GetIncomingPart")]
        [Authorize]
        public IHttpActionResult SNWR002_GetIncomingPart([FromBody] dynamic pDataList)
        {
            DataSet ds = new DataSet();
            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR002_GET_INCOM_PART";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_RANGE_NEW_PART", OracleDbType.Int16).Value = pDataList.COMING_IN_DAY.ToString();
                cmd.Parameters.Add("P_RANGE_ETD_INCOMING", OracleDbType.Int16).Value = pDataList.ETD_DAY.ToString();
                cmd.Parameters.Add("P_USER_ID", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));

            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR002_GetIncomingPart");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpPost, Route("SNWR002_ProcessSuggest")]
        [Authorize]
        public IHttpActionResult SNWR002_ProcessSuggest([FromBody] dynamic pDataList)
        {
            DataSet ds = new DataSet();
            DataTable dt = new DataTable();

            try
            {
                var IP_ADDR = HttpContext.Current.Request.UserHostAddress.ToString();
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR002_PROCESS_SUGGEST";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);

                cmd.Parameters.Add("P_DIMENSION_MARGIN_RATE", OracleDbType.Varchar2).Value = pDataList.M3_MAGIN_RATE.ToString();
                cmd.Parameters.Add("P_DIMENSION_WEIGHT_RATE", OracleDbType.Varchar2).Value = pDataList.WEIGHT_MAGIN_RATE.ToString();

                cmd.Parameters.Add("P_USER_ID", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR002_ProcessSuggest");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }


        //[HttpGet, Route("SNWR002_GetLocationNonPart/{pPartNo=null}/{pPartCat=null}/{PartFrom=null}/{PartTo=null}")]
        //[Authorize]
        //public IHttpActionResult SNWR002_GetLocationNonPart(string pPartNo, string pPartCat, string PartFrom, string PartTo)
        //{
        //    DataSet ds = new DataSet();
        //    try
        //    {
        //        pPartNo = ismoUtil.escapeCharacter(pPartNo);
        //        pPartCat = ismoUtil.escapeCharacter(pPartCat);

        //        OracleCommand cmd = new OracleCommand();
        //        cmd.CommandText = "SP_NP_SNWR002_GET_LOC_NOPART";
        //        cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
        //        cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = pPartNo == "null" ? "" : pPartNo;
        //        cmd.Parameters.Add("P_PART_CATEGORY", OracleDbType.Varchar2).Value = pPartCat == "null" ? "" : pPartCat;

        //        cmd.Parameters.Add("C_RETURN1", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
        //        cmd.Parameters.Add("C_RETURN2", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
        //        cmd.Parameters.Add("C_RETURN3", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
        //        cmd.Parameters.Add("C_RETURN4", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
        //        ds = oOracledb.SqlQueryDS_CMD(cmd);

        //        return Json(DTFM.convertToList(ds));

        //    }
        //    catch (Exception ex)
        //    {
        //        oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR002_GetPartNonLocation");
        //        return Json(new { Status = "Error" });
        //    }
        //}


        [HttpPost, Route("SNWR002_GetLocationSuggest")]
        [Authorize]
        public IHttpActionResult SNWR002_GetLocationSuggest([FromBody] dynamic pDataList)


        //[HttpGet, Route("SNWR002_GetLocationSuggest/{pPartNo=null}/{pPartCat=null}/{pLocationNo=null}/{PartTo=null}")]
        //[Authorize]
        //public IHttpActionResult SNWR002_GetLocationSuggest(string pPartNo, string pPartCat, string pLocationNo, string PartTo)
        //
        {
            DataSet ds = new DataSet();
            try
            {


                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR002_GET_LOCATION_SUG";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = pDataList.PART_NO == "null" ? (object)DBNull.Value : pDataList.PART_NO;
                cmd.Parameters.Add("P_PART_CATEGORY", OracleDbType.Varchar2).Value = pDataList.PART_CATEGORY.ToString() == "null" ? (object)DBNull.Value : pDataList.PART_CATEGORY.ToString();
                cmd.Parameters.Add("P_LOCATION_NO", OracleDbType.Varchar2).Value = pDataList.LOCATION_NO == "null" ? (object)DBNull.Value : pDataList.LOCATION_NO;
                //   PartNo != "null" ? PartNo : (object)DBNull.Value;
                cmd.Parameters.Add("C_RETURN1", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                cmd.Parameters.Add("C_RETURN2", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                cmd.Parameters.Add("C_RETURN3", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                cmd.Parameters.Add("C_RETURN4", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                cmd.Parameters.Add("C_RETURN5", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                cmd.Parameters.Add("C_RETURN6", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));

            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR002_GetLocationSuggest");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }



        [HttpPost, Route("SNWR002_UpdateLocation")]
        [Authorize]
        [RunBatchGuard]
        public IHttpActionResult SNWR002_UpdateLocation([FromBody] dynamic pDataList)
        {
            DataSet ds = new DataSet();
            DataTable dt = new DataTable();

            try
            {
                var IP_ADDR = HttpContext.Current.Request.UserHostAddress.ToString();
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR002_UPDATE";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_LOCATION_NO", OracleDbType.Varchar2).Value = pDataList.LOCATION_NO.ToString();
                cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = pDataList.PART_NO.ToString();
                cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("P_IP_ADDR", OracleDbType.Varchar2).Value = IP_ADDR;
                cmd.Parameters.Add("P_LAST_UPD_PGM", OracleDbType.Varchar2).Value = "SNWR002";
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM033P_UpdateLocation");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        #endregion

        #region SNWR003
        [HttpPost, Route("SNWR003_GetPre_ReceivingList/{docno}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult SNWR003_GetPre_ReceivingList(string docno, int noofshowrec, [FromBody] dynamic pParams)
        {
            try
            {
                DataSet ds = new DataSet();

                docno = ismoUtil.escapeCharacter(docno);

                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR003_R_GET_PRE_REV";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_DOC_NO", OracleDbType.Varchar2).Value = docno.ToUpper() == "NULL" ? (object)DBNull.Value : docno;
                // cmd.Parameters.Add("P_INVOICE_STATUS", OracleDbType.Varchar2).Value = pParams["INVOICE_STATUS"];
                cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR003_GetPre_ReceivingList");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpPost, Route("SNWR003_P_GetInvList/{invoiceno}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult SNWR003_P_GetInvList(string invoiceno, int noofshowrec, [FromBody] dynamic pParams)
        {
            try
            {
                DataSet ds = new DataSet();

                invoiceno = ismoUtil.escapeCharacter(invoiceno);

                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR003_P_GET_INV";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = invoiceno.ToUpper() == "NULL" ? (object)DBNull.Value : invoiceno;
                //  cmd.Parameters.Add("P_INVOICE_STATUS", OracleDbType.Varchar2).Value = pParams["INVOICE_STATUS"];
                cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR003_P_GetInvList");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpPost, Route("SNWR003_GetData")]
        [Authorize]
        public IHttpActionResult SNWR003_GetData([FromBody] dynamic pData)
        {
            try
            {
                OracleCommand cmd = new OracleCommand();

                cmd.CommandText = "SP_NP_SNWR003_GET_LIST";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_DOC_DATE_FROM", OracleDbType.Date).Value = pData["DOCUMENT_DATE_FROM"] != null ? Convert.ToDateTime(pData["DOCUMENT_DATE_FROM"].ToString()) : (object)DBNull.Value;
                cmd.Parameters.Add("P_DOC_DATE_TO", OracleDbType.Date).Value = pData["DOCUMENT_DATE_TO"] != null ? Convert.ToDateTime(pData["DOCUMENT_DATE_TO"].ToString()) : (object)DBNull.Value;
                cmd.Parameters.Add("P_PRE_RECEIVING_NO", OracleDbType.Varchar2).Value = pData["PRE_RECEIVING_NO"];
                cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pData["VENDOR_CODE"];
                cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = pData["INVOICE_NO"];

                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                DataSet ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR003_GetData");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }

        }



        [HttpPost, Route("SNWR003_GetDataByPart")]
        [Authorize]
        public IHttpActionResult SNWR003_GetDataByPart([FromBody] dynamic pData)
        {
            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR003_GET_LIST_BY_PART";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = pData["PART_NO"];
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                DataSet ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR003_GetDataByPart");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }

        }


        [HttpPost, Route("SNWR003_GetInvoiceDetail")]
        [Authorize]
        public IHttpActionResult SNWR003_GetInvoiceDetail([FromBody] dynamic pData)
        {
            try
            {
                OracleCommand cmd = new OracleCommand();

                cmd.CommandText = "SP_NP_SNWR003_GET_DETAIL";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pData["VENDOR_CODE"];
                cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = pData["INVOICE_NO"];
                cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = pData["PART_NO"];
                cmd.Parameters.Add("C_RETURN_H", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                cmd.Parameters.Add("C_RETURN_D", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                cmd.Parameters.Add("C_RETURN_I", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                DataSet ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR003_GetInvoiceDetail");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }

        }


        [HttpGet, Route("SNWR004_GetReLocationList")]
        [Authorize]
        public IHttpActionResult SNWR004_GetReLocationList()
        {
            DataSet ds = new DataSet();
            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR004_RE_LOCATION_LIST";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_USER_ID", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("C_RETURN1", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                cmd.Parameters.Add("C_RETURN2", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                cmd.Parameters.Add("C_RETURN3", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                cmd.Parameters.Add("C_RETURN4", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));

            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR004_GetReLocationList");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpGet, Route("SNWR004_GetReLocationStatus")]
        [Authorize]
        public IHttpActionResult SNWR004_GetReLocationStatus()
        {
            DataSet ds = new DataSet();
            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR004_RE_LOCATION_ST";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_USER_ID", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));

            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR004_GetReLocationStatus");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpGet, Route("SNWR004_GetReLocationL1/{location?}")]
        [Authorize]
        public IHttpActionResult SNWR004_GetReLocationL1(string location = null)
        {
            DataSet ds = new DataSet();
            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR004_RE_LOCATION_L1";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_LOCATION_NO", OracleDbType.Varchar2).Value = location;
                cmd.Parameters.Add("P_USER_ID", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));

            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR004_GetReLocationL1");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpGet, Route("SNWR004_GetReLocationL2")]
        [Authorize]
        public IHttpActionResult SNWR004_GetReLocationL2()
        {
            DataSet ds = new DataSet();
            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR004_RE_LOCATION_L2";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_USER_ID", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));

            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR004_GetReLocationL2");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }


        [HttpGet, Route("SNWR004_GetReLocationL3")]
        [Authorize]
        public IHttpActionResult SNWR004_GetReLocationL3()
        {
            DataSet ds = new DataSet();
            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR004_RE_LOCATION_L3";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_USER_ID", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));

            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR004_GetReLocationL3");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }



        [HttpGet, Route("SNWR004_GetReLocationL4")]
        [Authorize]
        public IHttpActionResult SNWR004_GetReLocationL4()
        {
            DataSet ds = new DataSet();
            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR004_RE_LOCATION_L4";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_USER_ID", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));

            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR004_GetReLocationL4");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }
        [HttpPost, Route("SNWR004_GetReLocationL5")]
        [Authorize]
        public IHttpActionResult SNWR004_GetReLocationL5([FromBody] dynamic pParam)
        {
            DataSet ds = new DataSet();
            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR004_RE_LOCATION_L5";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_USER_ID", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("P_LOCATION_NO", OracleDbType.Varchar2).Value = pParam.LOCATION_NO;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));

            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR004_GetReLocationL5");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }


        [HttpPost, Route("SNWR004_GetLocationSuggest")]
        [Authorize]
        public IHttpActionResult SNWR004_GetLocationSuggest([FromBody] dynamic pDataList)
        {
            //    [HttpGet, Route("SNWR004_GetLocationSuggest/{pPartNo=null}/{pPartCat=null}/{pLocationNo=null}/{PartTo=null}")]
            //[Authorize]
            //public IHttpActionResult SNWR004_GetLocationSuggest(string pPartNo, string pPartCat, string pLocationNo, string PartTo)  
            DataSet ds = new DataSet();
            try
            {
                //pPartNo = ismoUtil.escapeCharacter(pPartNo);
                //pPartCat = ismoUtil.escapeCharacter(pPartCat);
                //pLocationNo = ismoUtil.escapeCharacter(pLocationNo);

                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR004_GET_LOCATION_SUG";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = pDataList.PART_NO;
                cmd.Parameters.Add("P_PART_CATEGORY", OracleDbType.Varchar2).Value = pDataList.PART_CATEGORY;
                cmd.Parameters.Add("P_LOCATION_NO", OracleDbType.Varchar2).Value = pDataList.LOCATION_NO;

                cmd.Parameters.Add("C_RETURN1", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                cmd.Parameters.Add("C_RETURN2", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                cmd.Parameters.Add("C_RETURN3", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                cmd.Parameters.Add("C_RETURN4", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                cmd.Parameters.Add("C_RETURN5", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));

            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR004_GetLocationSuggest");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }



        [HttpPost, Route("SNWR004_ReLocation")]
        [Authorize]
        [RunBatchGuard]
        public IHttpActionResult SNWR004_ReLocation([FromBody] dynamic pDataList)
        {
            DataSet ds = new DataSet();

            try
            {
                var IP_ADDR = HttpContext.Current.Request.UserHostAddress.ToString();
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR004_UPDATE";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_LOCATION_NO_OLD", OracleDbType.Varchar2).Value = pDataList.LOCATION_NO_OLD.ToString();
                cmd.Parameters.Add("P_LOCATION_NO", OracleDbType.Varchar2).Value = pDataList.LOCATION_NO.ToString();

                cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = pDataList.PART_NO.ToString();
                cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("P_IP_ADDR", OracleDbType.Varchar2).Value = IP_ADDR;
                cmd.Parameters.Add("P_LAST_UPD_PGM", OracleDbType.Varchar2).Value = "SNWR004";
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM033P_UpdateLocation");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }


        [HttpPost, Route("SNWR004_ConfirmReLocation")]
        [Authorize]
        public IHttpActionResult SNWR004_ConfirmReLocation([FromBody] dynamic pDataList)
        {
            DataSet ds = new DataSet();

            try
            {
                var IP_ADDR = HttpContext.Current.Request.UserHostAddress.ToString();
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR004_CONFIRM";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_LOCATION_NO_OLD", OracleDbType.Varchar2).Value = pDataList.LOCATION_NO_OLD.ToString();
                cmd.Parameters.Add("P_LOCATION_NO", OracleDbType.Varchar2).Value = pDataList.LOCATION_NO.ToString();

                cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = pDataList.PART_NO.ToString();
                cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("P_IP_ADDR", OracleDbType.Varchar2).Value = IP_ADDR;
                cmd.Parameters.Add("P_LAST_UPD_PGM", OracleDbType.Varchar2).Value = "SNWR004";
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM033P_UpdateLocation");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }
        [HttpGet, Route("SNWR004_GetTempLocation/{location}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult SNWR004_GetTempLocation(string location, int noofshowrec)
        {
            DataSet ds = new DataSet();
            location = ismoUtil.escapeCharacter(location);
            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR004_GET_TEMP_LOCAT";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_LOCATION_NO", OracleDbType.Varchar2).Value = location.ToUpper() == "NULL" ? (object)DBNull.Value : location; ;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR004_GetTempLocation");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }
        [HttpPost, Route("SNWR004_UploadFile")]
        [Authorize]
        public async Task<IHttpActionResult> SNWR004_UploadFile(HttpRequestMessage request)
        {
            if (!request.Content.IsMimeMultipartContent())
            {
                throw new HttpResponseException(HttpStatusCode.UnsupportedMediaType);
            }
            var reqParts = await request.Content.ReadAsMultipartAsync();

            try
            {
                DataSet ds = new DataSet();
                DataTable dt = new DataTable();
                string USER_ID = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                var file = reqParts.Contents[0];

                var buffer = await file.ReadAsByteArrayAsync();
                string gFileName = file.Headers.ContentDisposition.FileName.Trim('\"');
                string name = Path.GetFileNameWithoutExtension(gFileName);
                string ext = Path.GetExtension(gFileName);
                string gFileNameExtend = String.Concat(name, '_', USER_ID, ext);
                string gRootPath = ConfigurationManager.AppSettings["RootSharedPath"].ToString();
                string gUploadLication = System.IO.Path.Combine(gRootPath, "tempFile/SNWR004");
                string gFileLocation = System.IO.Path.Combine(gUploadLication, gFileName);

                DataService.SaveBytesToFileByLocation(buffer
                                                , gUploadLication
                                                , gFileLocation);

                SystemApiController sys = new SystemApiController();
                //dt = sys.ReadDataExcel(gFileLocation);
                dt = SNWR004_ValidateData(gFileLocation);
                return Json(DTFM.convertToList(dt));

            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR004_UploadFile");
                throw new HttpResponseException(HttpStatusCode.NotAcceptable);
            }

            throw new Exception("Something wrong");

        }


        public DataTable SNWR004_ValidateData(string filelocation)
        {
            DataTable dt = new DataTable();
            SystemApiController sys = new SystemApiController();
            dt = sys.ReadDataExcel(filelocation);
            dt.Columns.Add("SEQ");
            dt.Columns.Add("MSG");
            dt.Columns.Add("ERR_FLAG");
            Hashtable hTable = new Hashtable();
            int iCount = 0;

            foreach (DataRow row in dt.Rows)
            {

                OracleCommand cmd = new OracleCommand();
                if (!string.IsNullOrEmpty(row["NEW_LOCATION"].ToString()))
                {
                    iCount++;

                    row["SEQ"] = iCount;
                    row["ERR_FLAG"] = "N";
                    if (row["NEW_LOCATION"].ToString().Length > 10)
                    {
                        row["MSG"] = "Location No cannot mare than 10 charactor";
                        row["ERR_FLAG"] = "Y";
                    }


                    if (hTable.Contains(row["NEW_LOCATION"].ToString().Trim()))
                    {
                        //row["SEQ"] = iCount;
                        row["MSG"] = "Duplicate Location No at Seq " + hTable[row["NEW_LOCATION"]];
                        row["ERR_FLAG"] = "Y";
                    }
                    else
                    {
                        hTable.Add(row["NEW_LOCATION"].ToString().Trim(), iCount);
                    }

                }
            }

            return dt;
        }


        [HttpPost, Route("SNWR004_SaveByUpload")]
        [Authorize]
        public IHttpActionResult SNWR004_SaveByUpload([FromBody] dynamic data)
        {

            DataSet ds = new DataSet();
            DataTable dt = new DataTable();

            OracleCommand cmd = new OracleCommand();
            int iCount = 0;
            try
            {
                var IP_ADDR = HttpContext.Current.Request.UserHostAddress.ToString();
                foreach (dynamic d in data.DETAIL)
                {
                    iCount++;
                    cmd = new OracleCommand();
                    cmd.CommandText = "SP_NP_SNWR004_SAVE_TEMP";
                    cmd.Parameters.Add("P_FORMER_LOC", OracleDbType.Varchar2).Value = d["FORMER_LOCATION"];
                    cmd.Parameters.Add("P_PART_NUMBER", OracleDbType.Varchar2).Value = d["PART_NO"];
                    cmd.Parameters.Add("P_NEW_LOC", OracleDbType.Varchar2).Value = d["NEW_LOCATION"];
                    cmd.Parameters.Add("P_TOTAL_OH", OracleDbType.Varchar2).Value = d["TOTAL_OH"];
                    cmd.Parameters.Add("P_STATUS", OracleDbType.Varchar2).Value = d["STATUS"];
                    cmd.Parameters.Add("P_CREATE_BY", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                    cmd.Parameters.Add("P_IP_ADDR", OracleDbType.Varchar2).Value = IP_ADDR;
                    cmd.Parameters.Add("P_CLEAR_DATA", OracleDbType.Varchar2).Value = iCount == 1 ? "Y" : "N";
                    cmd = oOracledb.SqlQueryReturnValue(cmd);
                }
                cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR004_SAVE_BY_UPLOAD";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("P_IP", OracleDbType.Varchar2).Value = IP_ADDR;
                cmd.Parameters.Add("R_STATUS", OracleDbType.Varchar2, 50).Direction = ParameterDirection.Output;
                cmd.Parameters.Add("R_MESSAGE", OracleDbType.Varchar2, 50).Direction = ParameterDirection.Output;

                cmd = oOracledb.SqlQueryReturnValue(cmd);
                string r_status = cmd.Parameters["R_STATUS"].Value.ToString();
                string r_msg = cmd.Parameters["R_MESSAGE"].Value.ToString();

                if (r_status != "DONE")
                {
                    oOracledb.WriteLog("ErrorHandle", r_msg, "SNWR004_SaveByUpload");
                }

                return Json(new { STATUS = "DONE", MESSAGE = "COMPLETE" });
            }
            catch (Exception ex)
            {
                //--- Roll back ---
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR004_SaveByUpload");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }

            //return Json(data);
        }
        #endregion

        #region SNWR005

        [HttpPost, Route("SNWR005_GetPicking")]
        [Authorize]
        public IHttpActionResult SNWR005_GetPicking([FromBody] dynamic pData)
        {
            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR005_GET_PICKING";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_CUSTOMER_CODE", OracleDbType.Varchar2).Value = pData["CUSTOMER_CODE"];
                cmd.Parameters.Add("P_BRANCH_CODE", OracleDbType.Varchar2).Value = pData["BRANCH_CODE"];
                cmd.Parameters.Add("P_ORDER_TYPE", OracleDbType.Varchar2).Value = pData["ORDER_TYPE"];
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                DataSet ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR005_GetPicking");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }

        }

        [HttpPost, Route("SNWR005_GeneratePicking")]
        [Authorize]
        public IHttpActionResult SNWR005_GeneratePicking([FromBody] dynamic pData)
        {
            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR005_GEN_PICKING";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_USER_ID", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("P_ORDER_TYPE", OracleDbType.Varchar2).Value = pData.orderType;
                cmd.Parameters.Add("P_ZONE", OracleDbType.Varchar2).Value = pData.zone;
                if (pData.class4 == true)
                {
                    cmd.Parameters.Add("P_CLASS", OracleDbType.Varchar2).Value = "1";
                }
                else
                {
                    cmd.Parameters.Add("P_CLASS", OracleDbType.Varchar2).Value = "0";
                }

                cmd.Parameters.Add("R_STATUS", OracleDbType.Varchar2, 50).Direction = ParameterDirection.Output;
                cmd.Parameters.Add("R_PICKING_LIST_FROM", OracleDbType.Varchar2, 20).Direction = ParameterDirection.Output;
                cmd.Parameters.Add("R_PICKING_LIST_TO", OracleDbType.Varchar2, 20).Direction = ParameterDirection.Output;

                cmd = oOracledb.SqlQueryReturnValue(cmd);

                string result = result = cmd.Parameters["R_STATUS"].Value.ToString();
                string pickingListFrom = cmd.Parameters["R_PICKING_LIST_FROM"].Value.ToString();
                string pickingListTo = cmd.Parameters["R_PICKING_LIST_TO"].Value.ToString();

                return Ok(new { result = result, pickingListFrom = pickingListFrom, pickingListTo = pickingListTo });
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR005_GeneratePicking");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }

        }

        [HttpPost, Route("SNWR005_GeneratePicking_kit")]
        [Authorize]
        public IHttpActionResult SNWR005_GeneratePicking_kit([FromBody] dynamic pData)
        {
            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR005_GEN_PICKING_KIT";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_USER_ID", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("P_ORDER_TYPE", OracleDbType.Varchar2).Value = pData.orderType;
                cmd.Parameters.Add("P_ZONE", OracleDbType.Varchar2).Value = pData.zone;
                if (pData.class4 == true)
                {
                    cmd.Parameters.Add("P_CLASS", OracleDbType.Varchar2).Value = "1";
                }
                else
                {
                    cmd.Parameters.Add("P_CLASS", OracleDbType.Varchar2).Value = "0";
                }
                cmd.Parameters.Add("R_STATUS", OracleDbType.Varchar2, 50).Direction = ParameterDirection.Output;
                cmd.Parameters.Add("R_PICKING_LIST_FROM", OracleDbType.Varchar2, 20).Direction = ParameterDirection.Output;
                cmd.Parameters.Add("R_PICKING_LIST_TO", OracleDbType.Varchar2, 20).Direction = ParameterDirection.Output;
                cmd = oOracledb.SqlQueryReturnValue(cmd);
                string result = result = cmd.Parameters["R_STATUS"].Value.ToString();
                string pickingListFrom = cmd.Parameters["R_PICKING_LIST_FROM"].Value.ToString();
                string pickingListTo = cmd.Parameters["R_PICKING_LIST_TO"].Value.ToString();
                return Ok(new { result = result, pickingListFrom = pickingListFrom, pickingListTo = pickingListTo });
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR005_GeneratePicking");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }
        [HttpPost, Route("SNWR005_GetPickingList")]
        [Authorize]
        public IHttpActionResult SNWR005_GetPickingList([FromBody] dynamic pData)
        {
            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR005_GET_PICKING_LIST";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_PICKING_LIST", OracleDbType.Varchar2).Value = pData["PICKING_LIST_NO"];
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                DataSet ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR005_GeneratePicking");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }

        }




        [HttpPost, Route("SNWR005_GetSearchCust/{cusID}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult SNWR005_GetSearchCust(string cusID, int noofshowrec, [FromBody] dynamic pParam)
        {
            DataSet ds = new DataSet();
            var pData = pParam["DATA"];
            cusID = ismoUtil.escapeCharacter(cusID);

            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR005_GET_CUSTOMER";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_CUSTOMER_CODE", OracleDbType.Varchar2).Value = cusID.ToUpper() == "NULL" ? (object)DBNull.Value : cusID;
                cmd.Parameters.Add("P_ORDER_TYPE", OracleDbType.Varchar2).Value = pData.ORDER_TYPE;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR005_GetSearchCust");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }


        [HttpPost, Route("SNWR005_GetBranchCode/{branchCode}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult SNWR005_GetBranchCode(string branchCode, int noofshowrec, [FromBody] dynamic pParam)
        {
            DataSet ds = new DataSet();
            var pData = pParam["DATA"];
            branchCode = ismoUtil.escapeCharacter(branchCode);

            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR005_BRANCH_CODE";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_CUSTOMER_CODE", OracleDbType.Varchar2).Value = pData.CUSTOMER_CODE;
                cmd.Parameters.Add("P_BRANCH_CODE", OracleDbType.Varchar2).Value = branchCode.ToUpper() == "NULL" ? (object)DBNull.Value : branchCode;
                cmd.Parameters.Add("P_ORDER_TYPE", OracleDbType.Varchar2).Value = pData.ORDER_TYPE;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR005_GetBranchCode");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }



        [HttpPost, Route("SNWR005_PrintPicking")]
        [Authorize]
        public IHttpActionResult SNWR005_PrintPicking([FromBody] dynamic[] dataList)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            string gPickingListNo = "";
            string gTracking = "";
            try
            {
                cmd.CommandText = "SP_NP_SNWR005_NEW_PICKING_LIST_NO";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("R_STATUS", OracleDbType.Varchar2, 50).Direction = ParameterDirection.Output;
                cmd.Parameters.Add("R_MESSAGE", OracleDbType.Varchar2, 500).Direction = ParameterDirection.Output;

                cmd = oOracledb.SqlQueryReturnValue(cmd);
                string r_status = cmd.Parameters["R_STATUS"].Value.ToString();
                string r_msg = cmd.Parameters["R_MESSAGE"].Value.ToString();

                if (r_status == "DONE")
                {
                    gPickingListNo = r_msg;
                }
                else
                {
                    oOracledb.WriteLog("ErrorHandle", r_msg, "SNWR005_PrintPicking");
                    //return Ok("Error : " + r_msg);
                    return Json(new { STATUS = r_status, MESSAGE = r_msg });
                }


            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR005_PrintPicking");
                // return Ok("Error : " + ex.Message);
                return Json(new { STATUS = "ERROR", MESSAGE = ex.Message });
            }

            try
            {
                foreach (var data in dataList)
                {
                    cmd = new OracleCommand();
                    cmd.CommandText = "SP_NP_SNWR005_SAVE_PRINT";
                    cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                    cmd.Parameters.Add("P_PICKING_LIST_NO", OracleDbType.Varchar2).Value = gPickingListNo;
                    cmd.Parameters.Add("P_CUSTOMER_CODE", OracleDbType.Varchar2).Value = data.CUSTOMER_CODE;
                    cmd.Parameters.Add("P_BRANCH_CODE", OracleDbType.Varchar2).Value = data.BRANCH_CODE;
                    cmd.Parameters.Add("P_ORDER_NO", OracleDbType.Varchar2).Value = data.ORDER_NO;
                    cmd.Parameters.Add("P_ACCEPT_PART_NO", OracleDbType.Varchar2).Value = data.ACCEPT_PART_NO;
                    cmd.Parameters.Add("P_INSTRUCTION_NO", OracleDbType.Varchar2).Value = data.INSTRUCTION_NO;

                    cmd.Parameters.Add("P_USER_ID", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                    cmd.Parameters.Add("R_STATUS", OracleDbType.Varchar2, 50).Direction = ParameterDirection.Output;
                    cmd.Parameters.Add("R_MESSAGE", OracleDbType.Varchar2, 500).Direction = ParameterDirection.Output;
                    gTracking = data.INSTRUCTION_NO;

                    cmd = oOracledb.SqlQueryReturnValue(cmd);
                    string r_status = cmd.Parameters["R_STATUS"].Value.ToString();
                    string r_msg = cmd.Parameters["R_MESSAGE"].Value.ToString();

                    if (r_status != "DONE")
                    {
                        oOracledb.WriteLog("ErrorHandle", r_msg, "SNWR005_PrintPicking");
                        //return Ok("Error : " + r_msg);
                        return Json(new { STATUS = r_status, MESSAGE = r_msg });
                    }

                };

            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", "Instruction no. : " + gTracking + " - " + ex.Message, "SNWR005_PrintPicking");

                return Json(new { STATUS = "ERROR", MESSAGE = ex.Message });
            }


            try
            {
                cmd = new OracleCommand();

                cmd.CommandText = "SP_NP_SNWR005_SAVE_HEADER";

                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_PICKING_LIST_NO", OracleDbType.Varchar2).Value = gPickingListNo;
                cmd.Parameters.Add("P_CUSTOMER_CODE", OracleDbType.Varchar2).Value = dataList[0].CUSTOMER_CODE;
                cmd.Parameters.Add("P_BRANCH_CODE", OracleDbType.Varchar2).Value = dataList[0].BRANCH_CODE;

                cmd.Parameters.Add("P_USER_ID", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("R_STATUS", OracleDbType.Varchar2, 50).Direction = ParameterDirection.Output;
                cmd.Parameters.Add("R_MESSAGE", OracleDbType.Varchar2, 500).Direction = ParameterDirection.Output;

                cmd = oOracledb.SqlQueryReturnValue(cmd);
                string r_status = cmd.Parameters["R_STATUS"].Value.ToString();
                string r_msg = cmd.Parameters["R_MESSAGE"].Value.ToString();

                if (r_status != "DONE")
                {
                    oOracledb.WriteLog("ErrorHandle", r_msg, "SNWR005_PrintPicking");
                    return Json(new { STATUS = r_status, MESSAGE = r_msg });
                }
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", "Instruction no. : " + gTracking + " - " + ex.Message, "SNWR005_PrintPicking");
                return Json(new { STATUS = "ERROR", MESSAGE = ex.Message });
            }

            return Json(new { STATUS = "DONE", MESSAGE = gPickingListNo });
        }
        #endregion

        #region SNWR006
        [HttpPost, Route("SNWR006_getPickListNo/{pickListNo}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult SNWR006_getPickListNo(string pickListNo, int noofshowrec, [FromBody] dynamic pParam)
        {
            DataSet ds = new DataSet();
            pickListNo = ismoUtil.escapeCharacter(pickListNo);
            var pData = pParam["DATA"];

            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR006_GET_PICKING_LIST";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_PICK_LIST_NO", OracleDbType.Varchar2).Value = pickListNo.ToUpper() == "NULL" ? (object)DBNull.Value : pickListNo;
                cmd.Parameters.Add("P_CUSTOMER_CODE", OracleDbType.Varchar2).Value = pData.CUSTOMER_CODE;
                cmd.Parameters.Add("P_BRANCH_CODE", OracleDbType.Varchar2).Value = pData.BRANCH_CODE;
                cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR006_getPickListNo");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }
        [HttpPost, Route("SNWR006_GetCustCode/{cusID}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult SNWR006_GetCustCode(string cusID, int noofshowrec, [FromBody] dynamic pParam)
        {
            DataSet ds = new DataSet();
            var pData = pParam["DATA"];
            cusID = ismoUtil.escapeCharacter(cusID);
            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR006_CUSTOMER_CODE";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_CUSTOMER_CODE", OracleDbType.Varchar2).Value = cusID.ToUpper() == "NULL" ? (object)DBNull.Value : cusID;
                cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR006_GetCustCode");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }
        [HttpPost, Route("SNWR006_GetBranchCode/{branchCode}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult SNWR006_GetBranchCode(string branchCode, int noofshowrec, [FromBody] dynamic pParam)
        {
            DataSet ds = new DataSet();
            var pData = pParam["DATA"];
            branchCode = ismoUtil.escapeCharacter(branchCode);
            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR006_BRANCH_CODE";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_CUSTOMER_CODE", OracleDbType.Varchar2).Value = pData.CUSTOMER_CODE;
                cmd.Parameters.Add("P_BRANCH_CODE", OracleDbType.Varchar2).Value = branchCode.ToUpper() == "NULL" ? (object)DBNull.Value : branchCode;
                cmd.Parameters.Add("P_SHOW_REC", OracleDbType.Int16).Value = noofshowrec;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR006_GetBranchCode");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }
        [HttpPost, Route("SNWR006_GetPickingHeader")]
        [Authorize]
        public IHttpActionResult SNWR006_GetPickingHeader([FromBody] dynamic pData)
        {
            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR006_GET_PICKING_HEADER";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_PICK_LIST_NO", OracleDbType.Varchar2).Value = pData["PICKING_LIST_NO"];
                cmd.Parameters.Add("P_CUSTOMER_CODE", OracleDbType.Varchar2).Value = pData["CUSTOMER_CODE"];
                cmd.Parameters.Add("P_BRANCH_CODE", OracleDbType.Varchar2).Value = pData["BRANCH_CODE"];
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                DataSet ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR006_GetPickingHeader");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }

        }


        [HttpPost, Route("SNWR006_GetPickingDetail")]
        [Authorize]
        public IHttpActionResult SNWR006_GetPickingDetail([FromBody] dynamic pData)
        {
            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR006_GET_PICKING_DETAIL";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_PICK_LIST_NO", OracleDbType.Varchar2).Value = pData["PICKING_LIST_NO"];
                cmd.Parameters.Add("P_CUSTOMER_CODE", OracleDbType.Varchar2).Value = pData["CUSTOMER_CODE"];
                cmd.Parameters.Add("P_BRANCH_CODE", OracleDbType.Varchar2).Value = pData["BRANCH_CODE"];
                cmd.Parameters.Add("C_RETURN1", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                cmd.Parameters.Add("C_RETURN2", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                DataSet ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR006_GetPickingDetail");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }
        [HttpPost, Route("SNWR006_Save")]
        [Authorize]
        public IHttpActionResult SNWR006_Save([FromBody] dynamic[] pDataList)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd;
            try
            {
                foreach (var data in pDataList)
                {
                    cmd = new OracleCommand();
                    cmd.CommandText = "SP_NP_SNWR006_SAVE";
                    cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                    cmd.Parameters.Add("P_PICK_LIST_NO", OracleDbType.Varchar2).Value = data.PICKING_LIST_NO;
                    cmd.Parameters.Add("P_PICK_LOT_DATE", OracleDbType.Date).Value = data.PICK_LOT_DATE == null ? (object)DBNull.Value : Convert.ToDateTime(data.PICK_LOT_DATE);
                    cmd.Parameters.Add("P_CUSTOMER_CODE", OracleDbType.Varchar2).Value = data.CUSTOMER_CODE;
                    cmd.Parameters.Add("P_BRANCH_CODE", OracleDbType.Varchar2).Value = data.BRANCH_CODE;
                    cmd.Parameters.Add("P_ORDER_NO", OracleDbType.Varchar2).Value = data.ORDER_NO;
                    cmd.Parameters.Add("P_ITEM_NO", OracleDbType.Varchar2).Value = data.ITEM_NO;
                    cmd.Parameters.Add("P_SUB_ITEM_NO", OracleDbType.Varchar2).Value = data.SUB_ITEM_NO;
                    cmd.Parameters.Add("P_ACCEPT_PART_NO", OracleDbType.Varchar2).Value = data.ACCEPT_PART_NO;
                    cmd.Parameters.Add("P_LAST_UPD_BY", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                    cmd.Parameters.Add("R_STATUS", OracleDbType.Varchar2, 50).Direction = ParameterDirection.Output;
                    cmd.Parameters.Add("R_MESSAGE", OracleDbType.Varchar2, 500).Direction = ParameterDirection.Output;
                    cmd = oOracledb.SqlQueryReturnValue(cmd);
                    string r_status = cmd.Parameters["R_STATUS"].Value.ToString();
                    string r_msg = cmd.Parameters["R_MESSAGE"].Value.ToString();
                    if (r_status != "DONE")
                    {
                        oOracledb.WriteLog("ErrorHandle", r_msg, "SNWR006_Save");
                        return Json(new { STATUS = r_status, MESSAGE = r_msg });
                    }
                    ds = oOracledb.SqlQueryDS_CMD(cmd);
                }
                SYSCore.SignalR.HubData.GetPickedStatic();
                SYSCore.SignalR.HubData.GetPickedStaticCust();
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR006_Save");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.ExpectationFailed, ex.Message));
            }
            return Json(new { STATUS = "DONE" });
        }
        #endregion

        #region SNWR007

        [HttpGet, Route("SNWR007_GetReasonCode/{reasoncode}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult GetReasonCodeByJobType(string reasoncode, int noofshowrec)
        {
            DataSet ds = new DataSet();

            reasoncode = ismoUtil.escapeCharacter(reasoncode);

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNWR007_REASON_CODE";
            cmd.Parameters.Add("p_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_REASON_CODE", OracleDbType.Varchar2).Value = reasoncode.ToUpper() == "NULL" ? (object)DBNull.Value : reasoncode;
            cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
            cmd.Parameters.Add("c_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }
        [HttpGet, Route("SNWR007_GetIncompleteList")]
        [Authorize]
        public IHttpActionResult SNWR007_GetIncompleteList()
        {
            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR007_GET_LIST";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                DataSet ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR007_GetIncompleteList");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpPost, Route("SNWR007_Submit/{reasonCode}")]
        [Authorize]
        public IHttpActionResult SNWR007_Submit([FromBody] dynamic pData, string reasonCode)
        {
            OracleCommand cmd = new OracleCommand();
            List<dynamic> dataList = new List<dynamic>(pData.data);

            try
            {
                string submitId = DateTime.Now.ToString("yyyyMMddHHmmss");
                foreach (dynamic data in dataList)
                {
                    cmd = new OracleCommand();
                    cmd.CommandText = "SP_NP_SNWR007_SUBMIT_DETAIL";
                    cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                    cmd.Parameters.Add("P_INSTRUCTION_NO", OracleDbType.Varchar2).Value = data.INSTRUCTION_NO;
                    cmd.Parameters.Add("P_CUSTOMER_CODE", OracleDbType.Varchar2).Value = data.CUSTOMER_CODE;
                    cmd.Parameters.Add("P_BRANCH_CODE", OracleDbType.Varchar2).Value = data.BRANCH_CODE;
                    cmd.Parameters.Add("P_ORDER_NO", OracleDbType.Varchar2).Value = data.ORDER_NO;
                    cmd.Parameters.Add("P_ITEM_NO", OracleDbType.Int32).Value = data.ITEM_NO;
                    cmd.Parameters.Add("P_SUB_ITEM_NO", OracleDbType.Varchar2).Value = data.SUB_ITEM_NO;
                    cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = data.PART_NO;
                    cmd.Parameters.Add("P_QTY", OracleDbType.Int32).Value = data.QTY;
                    cmd.Parameters.Add("P_PARTIAL_NO", OracleDbType.Int32).Value = data.PARTIAL_NO;
                    cmd.Parameters.Add("P_REASON_CODE", OracleDbType.Varchar2).Value = reasonCode;
                    cmd.Parameters.Add("P_REMARKS", OracleDbType.Varchar2).Value = pData.remarks;
                    cmd.Parameters.Add("P_SUBMIT_ID", OracleDbType.Varchar2).Value = submitId;
                    cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);

                    oOracledb.SqlExecute_CMD(cmd);
                }

                cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR007_PROCESS_SUBMIT";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_SUBMIT_ID", OracleDbType.Varchar2).Value = submitId;
                cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);

                oOracledb.SqlExecute_CMD(cmd);

                return Ok("Done");
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR007_Submit");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpPost, Route("SNWR007_ReturnItems")]
        [Authorize]
        public IHttpActionResult SNWR007_ReturnItems([FromBody] dynamic[] pDataList)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd;
            try
            {
                foreach (var data in pDataList)
                {
                    cmd = new OracleCommand();
                    cmd.CommandText = "SP_NP_SNWR007_RETURN";
                    cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                    cmd.Parameters.Add("P_INSTRUCTION_NO", OracleDbType.Varchar2).Value = data.INSTRUCTION_NO;
                    cmd.Parameters.Add("P_CUSTOMER_CODE", OracleDbType.Varchar2).Value = data.CUSTOMER_CODE;
                    cmd.Parameters.Add("P_BRANCH_CODE", OracleDbType.Varchar2).Value = data.BRANCH_CODE;
                    cmd.Parameters.Add("P_ORDER_NO", OracleDbType.Varchar2).Value = data.ORDER_NO;
                    cmd.Parameters.Add("P_ITEM_NO", OracleDbType.Int32).Value = data.ITEM_NO;
                    cmd.Parameters.Add("P_SUB_ITEM_NO", OracleDbType.Varchar2).Value = data.SUB_ITEM_NO;
                    cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = data.PART_NO;
                    cmd.Parameters.Add("P_QTY", OracleDbType.Int32).Value = data.QTY;
                    cmd.Parameters.Add("P_PARTIAL_NO", OracleDbType.Int32).Value = data.PARTIAL_NO;
                    cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);

                    oOracledb.SqlQueryReturnValue(cmd);
                }

                return Ok("Done");
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR007_ReturnItems");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.ExpectationFailed, ex.Message));
            }
        }
        #endregion

        #region SNWR007_M
        [HttpGet, Route("SNWR007_GetSubmitList")]
        [Authorize]
        public IHttpActionResult SNWR007_GetSubmitList()
        {
            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR007_GET_SUBMIT_LIST";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                DataSet ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR007_GetIncompleteList");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpPost, Route("SNWR007_ProcessApprove/{refDocNo}")]
        [Authorize]
        public IHttpActionResult SNWR007_ProcessApprove([FromBody] dynamic pData, string refDocNo)
        {
            OracleCommand cmd = new OracleCommand();

            try
            {
                cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR007_PROCESS_APPROVE";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_SUSPEND_NO", OracleDbType.Varchar2).Value = refDocNo;
                cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);

                oOracledb.SqlExecute_CMD(cmd);

                return Ok("Done");
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR007_ProcessApprove");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }
        #endregion

        #region SNWR007_A
        [HttpGet, Route("SNWR007_GetApproveList")]
        [Authorize]
        public IHttpActionResult SNWR007_GetApproveList()
        {
            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR007_GET_APPROVE_LIST";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                DataSet ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR007_GetApproveList");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }        

        [HttpGet, Route("SNWR007_GetSubmitDetail/{refDocNo}")]
        [Authorize]
        public IHttpActionResult SNWR007_GetSubmitDetail(string refDocNo)
        {
            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR007_GET_SUBMIT_DETAIL";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_SUSPEND_NO", OracleDbType.Varchar2).Value = refDocNo;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                DataSet ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR007_GetSubmitDetail");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpPost, Route("SNWR007_ProcessSuspend/{refDocNo}")]
        [Authorize]
        public IHttpActionResult SNWR007_ProcessSuspend([FromBody] dynamic pData, string refDocNo)
        {
            OracleCommand cmd = new OracleCommand();

            try
            {
                cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR007_PROCESS_SUSPEND";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_SUSPEND_NO", OracleDbType.Varchar2).Value = refDocNo;
                cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);

                oOracledb.SqlExecute_CMD(cmd);

                return Ok("Done");
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR007_ProcessSuspend");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        #endregion

        #region SNWR008
        [HttpGet, Route("SNWR008_getPickListNo/{pickListNo}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult SNWR008_getPickListNo(string pickListNo, int noofshowrec)
        {
            DataSet ds = new DataSet();
            pickListNo = ismoUtil.escapeCharacter(pickListNo);

            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR008_GET_PICKING_LIST";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_PICK_LIST_NO", OracleDbType.Varchar2).Value = pickListNo.ToUpper() == "NULL" ? (object)DBNull.Value : pickListNo;
                cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR008_getPickListNo");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpGet, Route("SNWR008_GetCustomerCode/{customerCode}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult SNWR008_GetCustomerCode(string customerCode, int noofshowrec)
        {
            DataSet ds = new DataSet();
            customerCode = ismoUtil.escapeCharacter(customerCode);
            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR008_GET_CUST_CODE";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_CUSTOMER_CODE", OracleDbType.Varchar2).Value = customerCode.ToUpper() == "NULL" ? (object)DBNull.Value : customerCode;
                cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR008_GetCustomerCode");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }
        [HttpPost, Route("SNWR008_GetOrderNo/{orderNo}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult SNWR008_GetOrderNo(string orderNo, int noofshowrec, [FromBody] dynamic pParam)
        {
            DataSet ds = new DataSet();
            orderNo = ismoUtil.escapeCharacter(orderNo);
            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR008_ORDER_NO";
                cmd.Parameters.Add("p_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_CUSTOMER_CODE", OracleDbType.Varchar2).Value = pParam["CUSTOMER_CODE"];
                cmd.Parameters.Add("P_BRANCH_CODE", OracleDbType.Varchar2).Value = pParam["BRANCH_CODE"];
                cmd.Parameters.Add("P_ORDER_NO", OracleDbType.Varchar2).Value = orderNo.ToUpper() == "NULL" ? (object)DBNull.Value : orderNo;
                cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR008_GetOrderNo");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }
        [HttpPost, Route("SNWR008_GetData")]
        [Authorize]
        public IHttpActionResult SNWR008_GetData([FromBody] dynamic pParam)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            try
            {
                cmd.CommandText = "SP_NP_SNWR008_GET_DATA";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_CUSTOMER_CODE", OracleDbType.Varchar2).Value = pParam.CUSTOMER_CODE;
                cmd.Parameters.Add("P_BRANCH_CODE", OracleDbType.Varchar2).Value = pParam.BRANCH_CODE;
                cmd.Parameters.Add("P_PICKING_LIST_NO", OracleDbType.Varchar2).Value = pParam.PICKING_LIST_NO;
                //cmd.Parameters.Add("P_ORDER_TYPE", OracleDbType.Varchar2).Value = pParam.ORDER_TYPE;
                //cmd.Parameters.Add("P_PART_ZONE", OracleDbType.Varchar2).Value = pParam.PART_ZONE;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR008_getData");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }
        [HttpPost, Route("SNWR008_GetPickLotSeq/{PickLotSeq}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult SNWR008_GetPickLotSeq(string PickLotSeq, int noofshowrec, [FromBody] dynamic pParam)
        {
            DataSet ds = new DataSet();
            PickLotSeq = ismoUtil.escapeCharacter(PickLotSeq);
            var pData = pParam["DATA"];
            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR008_GET_PICK_SEQ";
                cmd.Parameters.Add("p_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_CUSTOMER_CODE", OracleDbType.Varchar2).Value = pData.CUSTOMER_CODE;
                cmd.Parameters.Add("P_ORDER_CLASS", OracleDbType.Varchar2).Value = pData.ORDER_CLASS;
                cmd.Parameters.Add("P_PICK_LOT_DATE", OracleDbType.Date).Value = pData.PICK_LOT_DATE;
                cmd.Parameters.Add("P_PICK_LOT_SEQ", OracleDbType.Varchar2).Value = PickLotSeq.ToUpper() == "NULL" ? (object)DBNull.Value : PickLotSeq;
                cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR008_GetPickLotSeq");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpGet, Route("SNWR008_GetAvailableCase/{caseGroup}/{caseNo}")]
        [Authorize]
        public IHttpActionResult SNWR008_GetAvailableCase(string caseGroup, string caseNo)
        {
            DataSet ds = new DataSet();

            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR008_GET_AVAILABLE_CASE";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_CASE_GROUP", OracleDbType.Varchar2).Value = caseGroup;
                cmd.Parameters.Add("P_CASE_NO", OracleDbType.Varchar2).Value = caseNo;
                cmd.Parameters.Add("R_PRINT_DATE", OracleDbType.Varchar2, 24).Direction = ParameterDirection.Output;

                cmd = oOracledb.SqlQueryReturnValue(cmd);

                String printDate = cmd.Parameters["R_PRINT_DATE"].Value.ToString();
                return Json(new { Result = "Done", CaseNo = caseNo, PrintDate = printDate });
            }
            catch (OracleException ex)
            {
                if (ex.Number == 20001)
                {
                    return Json(new { Result = "Failed", Message = "Unavailable case number." });
                }

                throw (ex);
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR008_getPickListNo");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpPost, Route("SNWR008_IssueInvoice")]
        [Authorize]
        public IHttpActionResult SNWR008_IssueInvoice([FromBody] dynamic[] pDataList)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd;
            try
            {
                cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR008_DEL_TEMP";
                cmd.Parameters.Add("P_USER_ID", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                oOracledb.SqlQueryReturnValue(cmd);
                int i = 0;
                string customerCode = "";
                foreach (var data in pDataList)
                {
                    i = i + 1;
                    customerCode = data.CUSTOMER_CODE;

                    cmd = new OracleCommand();
                    cmd.CommandText = "SP_NP_SNWR008_INSERT_TEMP";
                    cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                    cmd.Parameters.Add("P_CUSTOMER_CODE", OracleDbType.Varchar2).Value = data.CUSTOMER_CODE;
                    cmd.Parameters.Add("P_BRANCH_CODE", OracleDbType.Varchar2).Value = data.BRANCH_CODE;
                    cmd.Parameters.Add("P_ORDER_CLASS", OracleDbType.Varchar2).Value = data.ORDER_CLASS;
                    cmd.Parameters.Add("P_ORDER_NO", OracleDbType.Varchar2).Value = data.ORDER_NO;
                    cmd.Parameters.Add("P_ACCEPT_PART_NO", OracleDbType.Varchar2).Value = data.ACCEPT_PART_NO;
                    cmd.Parameters.Add("P_ORDER_PART_NO", OracleDbType.Varchar2).Value = data.ORDER_PART_NO;
                    cmd.Parameters.Add("P_ITEM_NO", OracleDbType.Varchar2).Value = data.ITEM_NO;
                    cmd.Parameters.Add("P_SUB_ITEM_NO", OracleDbType.Varchar2).Value = data.SUB_ITEM_NO;
                    cmd.Parameters.Add("P_DELIVERY_CODE", OracleDbType.Varchar2).Value = data.DELIVERY_CODE;
                    cmd.Parameters.Add("P_PICK_LOT_DATE", OracleDbType.Date).Value = data.PICK_LOT_DATE;
                    cmd.Parameters.Add("P_PICK_LOT_SEQ", OracleDbType.Varchar2).Value = data.PICK_LOT_SEQ;
                    cmd.Parameters.Add("P_INSTRUCTION_NO", OracleDbType.Varchar2).Value = data.INSTRUCTION_NO;
                    cmd.Parameters.Add("P_QTY", OracleDbType.Int32).Value = data.QTY;
                    cmd.Parameters.Add("P_CASE_NO", OracleDbType.Varchar2).Value = data.CASE_NO;
                    cmd.Parameters.Add("P_CASE_DATE", OracleDbType.Date).Value = Convert.ToDateTime(data.CASE_DATE);
                    cmd.Parameters.Add("P_CASE_TYPE", OracleDbType.Varchar2).Value = data.CASE_TYPE;
                    cmd.Parameters.Add("P_LAST_UPD_BY", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                    ds = oOracledb.SqlQueryDS_CMD(cmd);
                }

                if (i > 0)
                {
                    cmd = new OracleCommand();
                    cmd.CommandText = "PK_NP_SNWR008_INVOICE.ISSUE_INVOICES";
                    cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                    cmd.Parameters.Add("P_CUSTOMER_CODE", OracleDbType.Varchar2).Value = customerCode;
                    cmd.Parameters.Add("P_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                    cmd.Parameters.Add("R_INVOICE_NO_FROM", OracleDbType.Varchar2, 20).Direction = ParameterDirection.Output;
                    cmd.Parameters.Add("R_INVOICE_NO_TO", OracleDbType.Varchar2, 20).Direction = ParameterDirection.Output;
                    cmd = oOracledb.SqlQueryReturnValue(cmd);

                    string invoiceNoFrom = cmd.Parameters["R_INVOICE_NO_FROM"].Value.ToString();
                    string invoiceNoTo = cmd.Parameters["R_INVOICE_NO_TO"].Value.ToString();

                    return Ok(new { status = "Done", invoiceNoFrom = invoiceNoFrom, invoiceNoTo = invoiceNoTo });
                }
                else
                {
                    return Ok(new { status = "Fail", message = "No data to be processed." });
                }
            }
            catch (OracleException oex)
            {
                string err_massage = string.Empty;
                if (oex.Number == 20002)
                {
                    err_massage = "Someone is issue invoive, please try again later!";
                }
                else
                {
                    err_massage = "Found an error, please contract support team";
                }
                return Ok(new { status = "Fail", massage = err_massage, err_code = oex.Number });
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR008_IssueInvoice");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.ExpectationFailed, ex.Message));
            }
        }

        [HttpGet, Route("SNWR008_GetPartConf/{partNo}")]
        [Authorize]
        public IHttpActionResult SNWR008_GetPartConf(string partNo)
        {
            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR008_GET_PART_CONF";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = partNo;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                DataSet ds = oOracledb.SqlQueryDS_CMD(cmd);
                DataTable dt = ds.Tables[0];

                return Json(DTFM.convertToList(dt));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR008_GetPartConf");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }
        #endregion
        #region SNWR009

        [HttpPost, Route("SNWR009_GetDaily")]
        [Authorize]
        public IHttpActionResult SNWR009_GetDaily([FromBody] dynamic pDataList)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            try
            {
                cmd.CommandText = "SP_NP_SNWR009_DAILY";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_START_DATE", OracleDbType.Date).Value = pDataList.START_DATE;
                cmd.Parameters.Add("P_END_DATE", OracleDbType.Date).Value = pDataList.END_DATE;
                cmd.Parameters.Add("P_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_ID);
                //cmd.Parameters.Add("P_PICKING_LIST_NO", OracleDbType.Varchar2).Value = pParam.PICKING_LIST_NO;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR009_GetDaily");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpPost, Route("SNWR009_GetDailyChart")]
        [Authorize]
        public IHttpActionResult SNWR009_GetDailyChart([FromBody] dynamic pDataList)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            try
            {
                cmd.CommandText = "SP_NP_SNWR009_DAILY_CHART";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_START_DATE", OracleDbType.Varchar2).Value = pDataList.START_DATE;
                cmd.Parameters.Add("P_END_DATE", OracleDbType.Varchar2).Value = pDataList.END_DATE;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR009_GetDaily");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }
        [HttpPost, Route("SNWR009_GetPerformance")]
        [Authorize]
        public IHttpActionResult SNWR009_GetPerformance([FromBody] dynamic pDataList)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            try
            {
                cmd.CommandText = "SP_NP_SNWR009_GET_PERFORMANCE";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_ID);
                cmd.Parameters.Add("P_VIEW_DATE", OracleDbType.Date).Value = pDataList.VIEW_DATE;
                //cmd.Parameters.Add("P_PIC", OracleDbType.Varchar2).Value = pDataList.PIC;
                //cmd.Parameters.Add("P_START_DATE", OracleDbType.Date).Value = pDataList.VIEW_DATE;
                //cmd.Parameters.Add("P_END_DATE", OracleDbType.Date).Value = pDataList.VIEW_DATE;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR009_GetPerformance");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpPost, Route("SNWR009_GetTimeUsagePartReceive")]
        [Authorize]
        public IHttpActionResult SNWR009_GetTimeUsagePartReceive([FromBody] dynamic pDataList)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            try
            {
                cmd.CommandText = "SP_NP_SNWR009_GET_TIME_USAGE_PART_RECEIVE";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_ID);
                cmd.Parameters.Add("P_PIC", OracleDbType.Varchar2).Value = pDataList.PIC_RECEIVE;
                cmd.Parameters.Add("P_VIEW_DATE", OracleDbType.Date).Value = pDataList.VIEW_DATE;
                //cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = pDataList.PART_NO;
                //cmd.Parameters.Add("P_START_DATE", OracleDbType.Date).Value = pDataList.VIEW_DATE;
                //cmd.Parameters.Add("P_END_DATE", OracleDbType.Date).Value = pDataList.VIEW_DATE;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR009_GetTimeUsagePartReceive");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpPost, Route("SNWR009_GetTimeUsagePartShelve")]
        [Authorize]
        public IHttpActionResult SNWR009_GetTimeUsagePartShelve([FromBody] dynamic pDataList)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            try
            {
                cmd.CommandText = "SP_NP_SNWR009_GET_TIME_USAGE_PART";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_ID);
                cmd.Parameters.Add("P_PIC", OracleDbType.Varchar2).Value = pDataList.PIC_RECEIVE;
                cmd.Parameters.Add("P_VIEW_DATE", OracleDbType.Date).Value = pDataList.VIEW_DATE;
                //cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = pDataList.PART_NO;
                //cmd.Parameters.Add("P_START_DATE", OracleDbType.Date).Value = pDataList.VIEW_DATE;
                //cmd.Parameters.Add("P_END_DATE", OracleDbType.Date).Value = pDataList.VIEW_DATE;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR009_GetTimeUsagePart");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpPost, Route("SNWR009_GetTimeUsageInvoice")]
        [Authorize]
        public IHttpActionResult SNWR009_GetTimeUsageInvoice([FromBody] dynamic pDataList)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            try
            {
                cmd.CommandText = "SP_NP_SNWR009_GET_TIME_USAGE_INVOICE";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_ID);
                cmd.Parameters.Add("P_PIC", OracleDbType.Varchar2).Value = pDataList.PIC_RECEIVE;
                cmd.Parameters.Add("P_VIEW_DATE", OracleDbType.Date).Value = pDataList.VIEW_DATE;
                //cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = pDataList.INVOICE_NO;
                //cmd.Parameters.Add("P_START_DATE", OracleDbType.Date).Value = pDataList.VIEW_DATE;
                //cmd.Parameters.Add("P_END_DATE", OracleDbType.Date).Value = pDataList.VIEW_DATE;
                //cmd.Parameters.Add("P_PICKING_LIST_NO", OracleDbType.Varchar2).Value = pParam.PICKING_LIST_NO;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR009_GetTimeUsageInvoice");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }


        [HttpPost, Route("SNWR009_GetReceiveMonitor")]
        [Authorize]
        public IHttpActionResult SNWR009_GetReceiveMonitor([FromBody] dynamic pDataList)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            try
            {
                cmd.CommandText = "SP_NP_SNWR009_RECEIVE_MONITOR_R";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                //cmd.Parameters.Add("P_START_DATE", OracleDbType.Date).Value = pDataList.START_DATE;
                //cmd.Parameters.Add("P_END_DATE", OracleDbType.Date).Value = pDataList.END_DATE;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR009_GetReceiveMonitor");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }


        [HttpPost, Route("SNWR009_GetReceiveMonitorPlus")]
        [Authorize]
        public IHttpActionResult SNWR009_GetReceiveMonitorPlus([FromBody] dynamic pDataList)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            try
            {
                cmd.CommandText = "SP_NP_SNWR009_RECEIVE_MONITOR_S_PLUS";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                //cmd.Parameters.Add("P_START_DATE", OracleDbType.Date).Value = pDataList.START_DATE;
                //cmd.Parameters.Add("P_END_DATE", OracleDbType.Date).Value = pDataList.END_DATE;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR009_GetReceiveMonitorPlus");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        #endregion

        #region SNWR016
        [HttpGet, Route("SNWR016_getPickListNo/{pickListNo}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult SNWR016_getPickListNo(string pickListNo, int noofshowrec)
        {
            DataSet ds = new DataSet();
            pickListNo = ismoUtil.escapeCharacter(pickListNo);
            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR016_GET_PICK_LIST_NO";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_PICK_LIST_NO", OracleDbType.Varchar2).Value = pickListNo.ToUpper() == "NULL" ? (object)DBNull.Value : pickListNo;
                cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR016_getPickListNo");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpPost, Route("SNWR016_GetDataPick")]
        [Authorize]
        public IHttpActionResult SNWR016_GetDataPick([FromBody] dynamic pData)
        {
            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR016_GET_DATA_PICK";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_PICK_LIST_NO", OracleDbType.Varchar2).Value = pData.PICKING_LIST_NO;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                DataSet ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR016_GetDataPick");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

  

        [HttpPost, Route("SNWR016_GetPickByCustInComplete")]
        [Authorize]
        public IHttpActionResult SNWR016_GetPickByCustInComplete([FromBody] dynamic pData)
        {
            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR016_GET_PICK_BY_CUST";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_START_DATE", OracleDbType.Date).Value = pData.START_DATE;
                cmd.Parameters.Add("P_END_DATE", OracleDbType.Date).Value = pData.END_DATE;
                cmd.Parameters.Add("P_COMPLETE_FLAG", OracleDbType.Varchar2).Value = "N";
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                DataSet ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR016_GetPickByCustInComplete");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpPost, Route("SNWR016_GetPickByCustPicking")]
        [Authorize]
        public IHttpActionResult SNWR016_GetPickByCustPicking([FromBody] dynamic pData)
        {
            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR016_GET_PICK_BY_CUST";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_START_DATE", OracleDbType.Date).Value = pData.START_DATE;
                cmd.Parameters.Add("P_END_DATE", OracleDbType.Date).Value = pData.END_DATE;
                cmd.Parameters.Add("P_COMPLETE_FLAG", OracleDbType.Varchar2).Value = "L";
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                DataSet ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR016_GetPickByCustPicking");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpPost, Route("SNWR016_GetPickByCustComplete")]
        [Authorize]
        public IHttpActionResult SNWR016_GetPickByCustComplete([FromBody] dynamic pData)
        {
            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR016_GET_PICK_BY_CUST";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_START_DATE", OracleDbType.Date).Value = pData.START_DATE;
                cmd.Parameters.Add("P_END_DATE", OracleDbType.Date).Value = pData.END_DATE;
                cmd.Parameters.Add("P_COMPLETE_FLAG", OracleDbType.Varchar2).Value = "P";
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                DataSet ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR016_GetPickByCustComplete");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }


        

        [HttpPost, Route("SNWR016_GetPickInComplete")]
        [Authorize]
        public IHttpActionResult SNWR016_GetPickInComplete([FromBody] dynamic pData)
        {
            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR016_GET_PICK_BY_PICKER";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_START_DATE", OracleDbType.Date).Value = pData.START_DATE;
                cmd.Parameters.Add("P_END_DATE", OracleDbType.Date).Value = pData.END_DATE;
                cmd.Parameters.Add("P_PICK_STATUS", OracleDbType.Varchar2).Value = "N";
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                DataSet ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR016_GetPickInComplete");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }


        [HttpPost, Route("SNWR016_GetPickOnPicking")]
        [Authorize]
        public IHttpActionResult SNWR016_GetPickOnPicking([FromBody] dynamic pData)
        {
            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR016_GET_PICK_BY_PICKER";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_START_DATE", OracleDbType.Date).Value = pData.START_DATE;
                cmd.Parameters.Add("P_END_DATE", OracleDbType.Date).Value = pData.END_DATE;
                cmd.Parameters.Add("P_PICK_STATUS", OracleDbType.Varchar2).Value = "L";
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                DataSet ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR016_GetPickOnPicking");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpPost, Route("SNWR016_GetPickComplete")]
        [Authorize]
        public IHttpActionResult SNWR016_GetPickComplete([FromBody] dynamic pData)
        {
            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR016_GET_PICK_BY_PICKER";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_START_DATE", OracleDbType.Date).Value = pData.START_DATE;
                cmd.Parameters.Add("P_END_DATE", OracleDbType.Date).Value = pData.END_DATE;
                cmd.Parameters.Add("P_PICK_STATUS", OracleDbType.Varchar2).Value = "P";
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                DataSet ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR016_GetPickComplete");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpPost, Route("SNWR016_GetDataDetail")]
        [Authorize]
        public IHttpActionResult SNWR016_GetDataDetail([FromBody] dynamic pData)
        {
            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR016_GET_DATA_DETAIL";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_PICK_LIST_NO", OracleDbType.Varchar2).Value = pData.PICKING_LIST_NO;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                DataSet ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR016_GetDataDetail");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpPost, Route("SNWR016_GetDataDetailByCust")]
        [Authorize]
        public IHttpActionResult SNWR016_GetDataDetailByCust([FromBody] dynamic pData)
        {
            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR016_GET_DETAIL_BY_CUST";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_CREATE_DATE", OracleDbType.Date).Value = pData.CREATE_DATE;
                cmd.Parameters.Add("P_CUSTOMER_CODE", OracleDbType.Varchar2).Value = pData.CUSTOMER_CODE;
                cmd.Parameters.Add("P_BRANCH_CODE", OracleDbType.Varchar2).Value = pData.BRANCH_CODE;
                cmd.Parameters.Add("P_ORDER_TYPE", OracleDbType.Varchar2).Value = pData.ORDER_TYPE;
                cmd.Parameters.Add("P_COMPLETE_FLAG", OracleDbType.Varchar2).Value = pData.COMPLETE_FLAG;

                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                DataSet ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR016_GetDataDetailByCust");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }


        [HttpPost, Route("SNWR016_GetDataDetailByPicker")]
        [Authorize]
        public IHttpActionResult SNWR016_GetDataDetailByPicker([FromBody] dynamic pData)
        {
            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR016_GET_DETAIL_BY_PICKER";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_CREATE_DATE", OracleDbType.Date).Value = pData.CREATE_DATE;
                cmd.Parameters.Add("P_PICK_BY", OracleDbType.Varchar2).Value = pData.PICK_BY;
                cmd.Parameters.Add("P_ORDER_TYPE", OracleDbType.Varchar2).Value = pData.ORDER_TYPE;
                cmd.Parameters.Add("P_COMPLETE_FLAG", OracleDbType.Varchar2).Value = pData.COMPLETE_FLAG;

                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                DataSet ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR016_GetDataDetailByPicker");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }


        [HttpPost, Route("SNWR016_GetDataCheck")]
        [Authorize]
        public IHttpActionResult SNWR016_GetDataCheck([FromBody] dynamic pData)
        {
            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR016_GET_DATA_CHECK";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_PICK_LIST_NO", OracleDbType.Varchar2).Value = pData.PICKING_LIST_NO;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                DataSet ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR016_GetDataCheck");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }


        [HttpPost, Route("SNWR016_GetDataPack")]
        [Authorize]
        public IHttpActionResult SNWR016_GetDataPack([FromBody] dynamic pData)
        {
            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR016_GET_PACK";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                DataSet ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR016_GetDataCheck");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpPost, Route("SNWR016_GetDataInvoice")]
        [Authorize]
        public IHttpActionResult SNWR016_GetDataInvoice([FromBody] dynamic pData)
        {
            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR016_GET_INVOICE_LIST";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_START_DATE", OracleDbType.Date).Value = pData.START_DATE;
                cmd.Parameters.Add("P_END_DATE", OracleDbType.Date).Value = pData.END_DATE;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                DataSet ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR016_GetDataInvoice");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }


        [HttpPost, Route("SNWR016_GetPackedDetail")]
        [Authorize]
        public IHttpActionResult SNWR016_GetPackedDetail([FromBody] dynamic pData)
        {
            try
            {
                DataSet ds = new DataSet();

                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR016_GET_ALL_CASE_CUST";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_CUSTOMER_CODE", OracleDbType.Varchar2).Value = pData.CUSTOMER_CODE;
                cmd.Parameters.Add("P_BRANCH_CODE", OracleDbType.Varchar2).Value = pData.BRANCH_CODE;
                cmd.Parameters.Add("P_ORDER_TYPE", OracleDbType.Varchar2).Value = pData.ORDER_TYPE;

                cmd.Parameters.Add("C_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR016_GetPackedDetail");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        #endregion
        [HttpPost, Route("PrintLabelBKK")]
        public async Task<HttpResponseMessage> PrintLabelBKK([FromBody] dynamic pParams)
        {
            try
            {

                string reportPrefix = pParams.ReportPrefix.ToString();
                string reportSuffix = pParams.ReportSuffix.ToString();


                //  this.global.GoToReport("PMS_RPT_WH_SNSR041_OUM", {
                //    P_CUSTOMER_CODE: this.ListDataReportCondition.CUSTOMER_CODE,
                //    P_CASHEER_NO: this.ListDataReportCondition.CASHEER_NO,
                //    P_DOCUMENT_NO: this.ListDataReportCondition.DOCUMENT_NO,
                //    P_TOTAL_PAGE: this.ListDataReportCondition.C_TOTAL_PAGE

                string dateFormat = DateTime.Now.ToString("yyyyMMddHHmmss");
                string reportType = "PDF";
                string fileName = String.Concat(reportPrefix, dateFormat, reportSuffix);
                string processPath = String.Concat(ConfigurationManager.AppSettings["DefaultReportOutputPath"], "PrintLabelBKK", "/");

                string reportName = "PMS_RPT_WH_SNSR041_OUM";
                List<ParameterValue> reportParams = new List<ParameterValue>();
                reportParams.Add(new ParameterValue { Label = "P_CUSTOMER_CODE", Name = "P_CUSTOMER_CODE", Value = pParams.CUSTOMER_CODE });
                reportParams.Add(new ParameterValue { Label = "P_CASHEER_NO", Name = "P_CASHEER_NO", Value = pParams.CASHEER_NO });
                reportParams.Add(new ParameterValue { Label = "P_DOCUMENT_NO", Name = "P_DOCUMENT_NO", Value = pParams.DOCUMENT_NO });
                reportParams.Add(new ParameterValue { Label = "P_TOTAL_PAGE", Name = "P_TOTAL_PAGE", Value = pParams.TOTAL_PAGE });

                //Render reports
                //ReportImageResult reportResult = await ReportServices.RenderReportAsImage(reportName, reportParams);

                byte[] bytes = await SYSCore.aControl.ReportServices.GenerateReportAsBytes(reportName, reportType, reportParams, fileName, processPath);
                Stream stream = new MemoryStream(bytes);


                HttpResponseMessage response = new HttpResponseMessage(HttpStatusCode.OK);
                response.Content = new StreamContent(stream);
                response.Content.Headers.ContentDisposition = new System.Net.Http.Headers.ContentDispositionHeaderValue("attachment");
                response.Content.Headers.ContentDisposition.FileName = fileName;
                response.Content.Headers.ContentType = new MediaTypeHeaderValue("application/pdf");

                return response;
            }
            catch (Exception ex)
            {
                return new HttpResponseMessage(HttpStatusCode.BadRequest);
                //return ResponseMessage(Request.CreateResponse(HttpStatusCode.BadRequest, ex.Message));
            }
        }

        [HttpPost, Route("PrintLabelUpCountry")]
        public async Task<HttpResponseMessage> PrintLabelUpCountry([FromBody] dynamic pParams)
        {
            try
            {

                string reportPrefix = pParams.ReportPrefix.ToString();
                string reportSuffix = pParams.ReportSuffix.ToString();

                //this.global.GoToReport("PMS_RPT_WH_SNSR040_PIK", {
                //  P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
                //  P_IP: this.global.GetTokenDetail("ssIPAddress"),
                //  P_CUSTOMER_CODE: this.ListDataReportCondition.CUSTOMER_CODE,
                //  P_BRANCH_CODE: this.ListDataReportCondition.BRANCH_CODE,
                //  P_CASHEER_NO: this.ListDataReportCondition.CASHEER_NO,
                //  P_DOCUMENT_NO: this.ListDataReportCondition.DOCUMENT_NO


                string dateFormat = DateTime.Now.ToString("yyyyMMddHHmmss");
                string reportType = "PDF";
                string fileName = String.Concat(reportPrefix, dateFormat, reportSuffix);
                string processPath = String.Concat(ConfigurationManager.AppSettings["DefaultReportOutputPath"], "PrintLabelUpCountry", "/");

                string reportName = "PMS_RPT_WH_SNSR040_PIK";
                List<ParameterValue> reportParams = new List<ParameterValue>();
                reportParams.Add(new ParameterValue { Label = "P_CUSTOMER_CODE", Name = "P_CUSTOMER_CODE", Value = pParams.CUSTOMER_CODE });

                reportParams.Add(new ParameterValue { Label = "P_IP", Name = "P_IP", Value = pParams.IP });
                reportParams.Add(new ParameterValue { Label = "P_CUSTOMER_CODE", Name = "P_CUSTOMER_CODE", Value = pParams.CUSTOMER_CODE });
                reportParams.Add(new ParameterValue { Label = "P_BRANCH_CODE", Name = "P_BRANCH_CODE", Value = pParams.BRANCH_CODE });

                reportParams.Add(new ParameterValue { Label = "P_CASHEER_NO", Name = "P_CASHEER_NO", Value = pParams.CASHEER_NO });
                reportParams.Add(new ParameterValue { Label = "P_DOCUMENT_NO", Name = "P_DOCUMENT_NO", Value = pParams.DOCUMENT_NO });


                //Render reports
                //ReportImageResult reportResult = await ReportServices.RenderReportAsImage(reportName, reportParams);

                byte[] bytes = await SYSCore.aControl.ReportServices.GenerateReportAsBytes(reportName, reportType, reportParams, fileName, processPath);
                Stream stream = new MemoryStream(bytes);


                HttpResponseMessage response = new HttpResponseMessage(HttpStatusCode.OK);
                response.Content = new StreamContent(stream);
                response.Content.Headers.ContentDisposition = new System.Net.Http.Headers.ContentDispositionHeaderValue("attachment");
                response.Content.Headers.ContentDisposition.FileName = fileName;
                response.Content.Headers.ContentType = new MediaTypeHeaderValue("application/pdf");

                return response;
            }
            catch (Exception ex)
            {
                return new HttpResponseMessage(HttpStatusCode.BadRequest);
                //return ResponseMessage(Request.CreateResponse(HttpStatusCode.BadRequest, ex.Message));
            }
        }

        #region SNWR015
        [HttpPost, Route("SNWR015_CheckDuplicateInvoice")]
        [Authorize]
        public IHttpActionResult SNWR015_CheckDuplicateInvoice([FromBody] dynamic pData)
        {
            try
            {
                OracleCommand cmd = new OracleCommand();

                cmd.CommandText = "SP_NP_SNWR015_CHECK_DUP";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pData["VENDOR_CODE"];
                cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = pData["INVOICE_NO"];
                cmd.Parameters.Add("P_INVOICE_DATE", OracleDbType.Date).Value = pData["INVOICE_DATE"];

                DataSet ds = oOracledb.SqlQueryDS_CMD(cmd);

            }
            catch (OracleException ex)
            {
                if (ex.Number == 20001)
                {
                    return Ok("Failed");
                }

                throw (ex);
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR015_CheckDuplicateInvoice");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }

            return Ok("Done");
        }

        [HttpPost, Route("SNWR015_CheckWOPartNo")]
        [Authorize]
        public IHttpActionResult SNWR015_CheckWOPartNo([FromBody] dynamic pData)
        {
            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR015_CHECK_WO";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pData["VENDOR_CODE"];
                cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = pData["PART_NO"];
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                DataSet ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR015_CheckWOPartNo");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpPost, Route("SNWR015_GetData")]
        [Authorize]
        public IHttpActionResult SNWR015_GetData([FromBody] dynamic pData)
        {
            try
            {

                OracleCommand cmd = new OracleCommand();

                cmd.CommandText = "SP_NP_SNWR015_GET_LIST";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pData["VENDOR_CODE"];
                cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = pData["INVOICE_NO"];
                cmd.Parameters.Add("P_INVOICE_DATE", OracleDbType.Date).Value = pData["INVOICE_DATE"] != null ? Convert.ToDateTime(pData["INVOICE_DATE"].ToString()) : (object)DBNull.Value;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                DataSet ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR015_GetData");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }

        }

        [HttpPost, Route("SNWR015_GetInvoiceDetail")]
        [Authorize]
        public IHttpActionResult SNWR015_GetInvoiceDetail([FromBody] dynamic pData)
        {
            try
            {
                OracleCommand cmd = new OracleCommand();

                cmd.CommandText = "SP_NP_SNWR015_GET_DETAIL";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pData["VENDOR_CODE"];
                cmd.Parameters.Add("P_INVOICE_TYPE", OracleDbType.Varchar2).Value = pData["INVOICE_TYPE"];
                cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = pData["INVOICE_NO"];
                cmd.Parameters.Add("P_INVOICE_DATE", OracleDbType.Date).Value = Convert.ToDateTime(pData["INVOICE_DATE"]);
                cmd.Parameters.Add("C_RETURN_H", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                cmd.Parameters.Add("C_RETURN_D", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                DataSet ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR015_GetInvoiceDetail");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }

        }

        [HttpPost, Route("SNWR015_Save")]
        [Authorize]
        public IHttpActionResult SNWR015_Save([FromBody] dynamic pData)
        {
            OracleCommand cmd;
            string gDocNo;

            List<dynamic> partList = new List<dynamic>(pData.PART_LIST);
            int partCount = 0;

            //Insert to pre-receive
            try
            {

                cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR015_DEL_TEMP";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = pData["INVOICE_NO"];
                cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pData["VENDOR_CODE"];

                cmd = oOracledb.SqlQueryReturnValue(cmd);

                foreach (var part in partList)
                {
                    partCount++;

                    cmd = new OracleCommand();
                    cmd.CommandText = "SP_NP_SNWR015_INS_TEMP";
                    cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                    cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = pData["INVOICE_NO"];
                    cmd.Parameters.Add("P_INVOICE_DATE", OracleDbType.Date).Value = Convert.ToDateTime(pData["INVOICE_DATE"]);
                    cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pData["VENDOR_CODE"];
                    cmd.Parameters.Add("P_RNO", OracleDbType.Decimal).Value = partCount;
                    cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = part["ACCEPT_PART_NO"];
                    cmd.Parameters.Add("P_QTY", OracleDbType.Decimal).Value = part["QTY"];
                    cmd.Parameters.Add("P_RECEIVE_PACKAGE", OracleDbType.Decimal).Value = part["RECEIVE_PACKAGE"];

                    oOracledb.SqlQueryReturnValue(cmd);
                }

                cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR015_SAVE";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = pData["INVOICE_NO"];
                cmd.Parameters.Add("P_INVOICE_TYPE", OracleDbType.Varchar2).Value = pData["INVOICE_TYPE"];
                cmd.Parameters.Add("P_INVOICE_DATE", OracleDbType.Date).Value = Convert.ToDateTime(pData["INVOICE_DATE"]);
                cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pData["VENDOR_CODE"];
                cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("R_DOC_NO", OracleDbType.Varchar2, 20).Direction = ParameterDirection.Output;

                cmd = oOracledb.SqlQueryReturnValue(cmd);

                gDocNo = cmd.Parameters["R_DOC_NO"].Value.ToString();

            }
            catch (Exception ex)
            {

                if (ex.Message.IndexOf("Found invoice") > 0)
                {
                    return Json(new { Result = "Duplicate invoice", DocNo = "" });
                }
                else
                {
                    oOracledb.WriteLog("ErrorHandle", ex.Message, "SNSE015_P_Save");
                    return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
                }


            }

            return Json(new { Result = "Done", DocNo = gDocNo });

        }

        [HttpPost, Route("SNWR015_Cancel")]
        [Authorize]
        public IHttpActionResult SNWR015_Cancel([FromBody] dynamic pData)
        {
            try
            {
                OracleCommand cmd = new OracleCommand();

                cmd.CommandText = "SP_NP_SNWR015_CANCEL";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pData["VENDOR_CODE"];
                cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = pData["INVOICE_NO"];
                cmd.Parameters.Add("P_PRE_RECEIVE_DOC_NO", OracleDbType.Varchar2).Value = pData["PRE_RECEIVE_DOC_NO"];
                cmd.Parameters.Add("P_INVOICE_TYPE", OracleDbType.Varchar2).Value = pData["INVOICE_TYPE"];
                cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);

                oOracledb.SqlQueryReturnValue(cmd);

                return Ok();
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR015_Cancel");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpPost, Route("SNWR015_MapInvoice")]
        [Authorize]
        public IHttpActionResult SNWR015_MapInvoice([FromBody] dynamic pData)
        {
            try
            {
                OracleCommand cmd = new OracleCommand();

                cmd.CommandText = "SP_NP_SNWR015_MAP_INVOICE";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_PRE_RECEIVE_DOC_NO", OracleDbType.Varchar2).Value = pData["PRE_RECEIVE_DOC_NO"];
                cmd.Parameters.Add("P_RECEIVE_DATE", OracleDbType.Date).Value = pData["RECEIVE_DATE"] == null ? DBNull.Value : Convert.ToDateTime(pData["RECEIVE_DATE"]);
                cmd.Parameters.Add("P_RECEIVE_DOC_NO", OracleDbType.Varchar2).Value = pData["RECEIVE_DOC_NO"];
                cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                oOracledb.SqlQueryReturnValue(cmd);

                return Ok();
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR015_MapInvoice");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }
        #endregion SNWR015

        #region SNWR015_RO

        [HttpPost, Route("SNWR015_RO_GetData")]
        [Authorize]
        public IHttpActionResult SNWR015_RO_GetData([FromBody] dynamic pData)
        {
            try
            {

                OracleCommand cmd = new OracleCommand();

                cmd.CommandText = "SP_NP_SNWR015_RO_GET_LIST";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = pData["VENDOR_CODE"];
                cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = pData["INVOICE_NO"];
                cmd.Parameters.Add("P_INVOICE_DATE", OracleDbType.Date).Value = pData["INVOICE_DATE"] != null ? Convert.ToDateTime(pData["INVOICE_DATE"].ToString()) : (object)DBNull.Value;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                DataSet ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));

                //DataTable dt = ds.Tables[0];
                //dt = dt.AsEnumerable().Where(x => x.Field<string>("INVOICE_TYPE") == "TEMP").CopyToDataTable();
                //return Json(DTFM.convertToList(dt));

            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR015_RO_GetData");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }

        }



        #endregion
        #region SNWR018
        [HttpPost, Route("SNWR018_UpdateInvoiceTime")]
        [Authorize]
        public IHttpActionResult SNWR018_UpdateInvoiceTime([FromBody] dynamic pData)
        {
            string returnMessage;
            string status;
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNWR018_UPD_INVOICE";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = pData.INVOICE_NO;
            cmd.Parameters.Add("P_LAST_UPD_BY", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            DataSet ds = oOracledb.SqlQueryDS_CMD(cmd);
            DataTable dtProcessStatus = ds.Tables[0];
            returnMessage = dtProcessStatus.Rows[0]["MESSAGE"].ToString();
            status = dtProcessStatus.Rows[0]["STATUS"].ToString();
            if (status == "FAIL")
            {
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, returnMessage));
            }
            else if (status == "DONE")
            {
                return Ok(new { STATUS = "DONE" });
            }
            return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, "Something wrong in process."));
        }
        #endregion

        [HttpPost, Route("SNWR019_INIT")]
        [Authorize]
        public IHttpActionResult SNWR019_CreateCheckStockInit([FromBody] dynamic data)
        {
            try
            {
                DataSet ds = new DataSet();

                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR019_INIT";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_CHECK_DATE", OracleDbType.Date).Value = data["CHECK_DATE"];
                cmd.Parameters.Add("P_CHECK_TYPE", OracleDbType.Varchar2).Value = data["CHECK_TYPE"];
                cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR019_CreateCheckStockInit");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpPost, Route("SNWR019_GetData")]
        [Authorize]
        public IHttpActionResult SNWR019_GetData([FromBody] dynamic data)
        {
            try
            {
                DataSet ds = new DataSet();

                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR019_GET_DATA";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_CHECK_DATE", OracleDbType.Date).Value = data["CHECK_DATE"] == null ? DBNull.Value : Convert.ToDateTime(data["CHECK_DATE"]);
                cmd.Parameters.Add("P_CHECK_TYPE", OracleDbType.Varchar2).Value = data["CHECK_TYPE"];
                cmd.Parameters.Add("C_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR019_GetData");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpPost, Route("SNWR019_Save/{pHeaderId}")]
        [Authorize]
        public IHttpActionResult SNWR019_Save(string pHeaderId, [FromBody] dynamic[] pData)
        {
            try
            {

                OracleCommand cmd = new OracleCommand();

                cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR019_DELETE_TEMP";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_HEADER_ID", OracleDbType.Int32).Value = Convert.ToInt32(pHeaderId);
                cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                oOracledb.SqlExecute_CMD(cmd);

                foreach (var data in pData)
                {
                    cmd = new OracleCommand();
                    cmd.CommandText = "SP_NP_SNWR019_INSERT_TEMP";
                    cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                    cmd.Parameters.Add("P_HEADER_ID", OracleDbType.Int32).Value = Convert.ToInt32(pHeaderId);
                    cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = data["PART_NO"];
                    cmd.Parameters.Add("P_COUNT_QTY", OracleDbType.Int32).Value = data["COUNT_QTY"];
                    cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                    oOracledb.SqlExecute_CMD(cmd);
                }

                cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR019_SAVE";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_HEADER_ID", OracleDbType.Int32).Value = Convert.ToInt32(pHeaderId);
                cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);

                oOracledb.SqlExecute_CMD(cmd);

                return Ok("Done");
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR019_Save");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpGet, Route("SNWR019_GetData_ByID/{headerId}")]
        [Authorize]
        public IHttpActionResult SNWR019_GetData_ByID(int headerId)
        {
            try
            {
                DataSet ds = new DataSet();

                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR019_GET_DATA_BY_ID";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_HEADER_ID", OracleDbType.Int16).Value = headerId;
                cmd.Parameters.Add("C_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR019_GetData_ByID");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpPost, Route("SNWR019_Send")]
        [Authorize]
        public IHttpActionResult SNWR019_Send([FromBody] dynamic data)
        {
            try
            {
                DataSet ds = new DataSet();

                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR019_SEND";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_HEADER_ID", OracleDbType.Int16).Value = data["HEADER_ID"];
                cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);

                oOracledb.SqlExecute_CMD(cmd);

                return Ok("Done");
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR019_Send");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpPost, Route("SNWR019_Submit")]
        [Authorize]
        public IHttpActionResult SNWR019_Submit([FromBody] dynamic data)
        {
            try
            {
                DataSet ds = new DataSet();

                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR019_SUBMIT";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_HEADER_ID", OracleDbType.Int16).Value = data["HEADER_ID"];
                cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);

                oOracledb.SqlExecute_CMD(cmd);

                return Ok("Done");
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR019_Submit");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpPost, Route("SNWR019_A_GetData")]
        [Authorize]
        public IHttpActionResult SNWR019_A_GetData([FromBody] dynamic data)
        {
            try
            {
                DataSet ds = new DataSet();

                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR019_A_GET_DATA";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_CHECK_DATE", OracleDbType.Date).Value = data["CHECK_DATE"] == null ? DBNull.Value : Convert.ToDateTime(data["CHECK_DATE"]);
                cmd.Parameters.Add("P_CHECK_TYPE", OracleDbType.Varchar2).Value = data["CHECK_TYPE"];
                cmd.Parameters.Add("C_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR019_A_GetData");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpPost, Route("SNWR019_Confirm/{headerId}")]
        [Authorize]
        public IHttpActionResult SNWR019_Confirm(int headerId, [FromBody] dynamic data)
        {
            try
            {
                DataSet ds = new DataSet();

                foreach (var d in data)
                {
                    OracleCommand cmd = new OracleCommand();
                    cmd.CommandText = "SP_NP_SNWR019_CONFIRM";
                    cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                    cmd.Parameters.Add("P_HEADER_ID", OracleDbType.Int16).Value = headerId;
                    cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = d["PART_NO"];
                    cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);

                    oOracledb.SqlExecute_CMD(cmd);
                }

                return Ok("Done");
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR019_CONFIRM");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }
        [HttpPost, Route("SNWR019P_UploadExcel/{pHeaderId}")]
        [Authorize]
        public async Task<IHttpActionResult> SNM105P_UploadExcel(HttpRequestMessage request, string pHeaderId)
        {
            if (!request.Content.IsMimeMultipartContent())
            {
                oOracledb.WriteLog("ErrorHandle", "UnsupportedMediaType", "SNWR019P_UploadExcel");
                throw new HttpResponseException(HttpStatusCode.UnsupportedMediaType);
            }
            var reqParts = await request.Content.ReadAsMultipartAsync();
            try
            {
                var file = reqParts.Contents[0];
                var buffer = await file.ReadAsByteArrayAsync();

                MemoryStream stream = new MemoryStream(buffer);
                DataTable dt = new DataTable();
                SystemApiController sys = new SystemApiController();
                dt = sys.ReadDataExcel(stream);

                OracleCommand cmd;

                cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR019_DELETE_TEMP";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_HEADER_ID", OracleDbType.Int32).Value = Convert.ToInt32(pHeaderId);
                cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                oOracledb.SqlExecute_CMD(cmd);


                foreach (DataRow data in dt.Rows)
                {
                    cmd = new OracleCommand();
                    cmd.CommandText = "SP_NP_SNWR019_INSERT_TEMP";
                    cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                    cmd.Parameters.Add("P_HEADER_ID", OracleDbType.Int32).Value = Convert.ToInt32(pHeaderId);
                    cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = data["PART_NO"];
                    cmd.Parameters.Add("P_COUNT_QTY", OracleDbType.Int32).Value = data["COUNT_QTY"];
                    cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                    oOracledb.SqlExecute_CMD(cmd);
                }

                cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR019_VALIDATE";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_HEADER_ID", OracleDbType.Int32).Value = Convert.ToInt32(pHeaderId);
                cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                DataSet ds = oOracledb.SqlQueryDS_CMD(cmd);
                DataTable validationResult = ds.Tables[0];

                return Json(DTFM.convertToList(validationResult));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR019P_UploadExcel");
                throw new HttpResponseException(HttpStatusCode.NotAcceptable);
            }
            throw new Exception("Something wrong");
        }

        [HttpGet, Route("SNWR019_GetPartNo/{partNo}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult SNWR019_GetPartNo(string partNo, int noofshowrec)
        {
            DataSet ds = new DataSet();

            partNo = ismoUtil.escapeCharacter(partNo);

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "sp_NP_SNWR019_GET_PART";
            cmd.Parameters.Add("p_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("p_PART_NO", OracleDbType.Varchar2).Value = (partNo != null && partNo == "null" ? "" : partNo);
            cmd.Parameters.Add("p_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
            cmd.Parameters.Add("c_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);

            return Json(DTFM.convertToList(ds));
        }

        [HttpPost, Route("SNWR017_Print_Case_Number")]
        [Authorize]
        public IHttpActionResult SNWR017_Print_Case_Number([FromBody] dynamic data)
        {
            try
            {
                OracleCommand cmd = new OracleCommand();

                int printNo = data["PRINT_NUMBER"];
                int iCount = 0;
                string caseNoFrom = String.Empty;
                string caseNoTo = String.Empty;

                for (int i = 0; i < printNo; i++)
                {
                    iCount++;

                    cmd = new OracleCommand();
                    cmd.CommandText = "SP_NP_CASE_RUNNING_NEXT_VAL";
                    cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                    cmd.Parameters.Add("P_CASE_GROUP", OracleDbType.Varchar2).Value = "DOMESTIC";
                    cmd.Parameters.Add("P_UPDATE_PGM", OracleDbType.Varchar2).Value = "SNWR017";
                    cmd.Parameters.Add("R_CASE_NO", OracleDbType.Varchar2, 6).Direction = ParameterDirection.Output;

                    cmd = oOracledb.SqlQueryReturnValue(cmd);

                    if (iCount == 1)
                    {
                        caseNoFrom = cmd.Parameters["R_CASE_NO"].Value.ToString();
                    }

                    caseNoTo = cmd.Parameters["R_CASE_NO"].Value.ToString();
                }

                return Json(new { Result = "Done", CaseNoFrom = caseNoFrom, CaseNoTo = caseNoTo });
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR017_Print_Case_Number");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpPost, Route("SNWR017_Get_Case_Number")]
        [Authorize]
        public IHttpActionResult SNWR017_Get_Case_Number([FromBody] dynamic data)
        {
            try
            {
                DataSet ds = new DataSet();

                OracleCommand cmd = new OracleCommand();
                cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_GET_CASE_RUNNING_NUMBER";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_CASE_GROUP", OracleDbType.Varchar2).Value = "DOMESTIC";
                cmd.Parameters.Add("P_CASE_NO", OracleDbType.Varchar2).Value = data["CASE_NO"];
                cmd.Parameters.Add("C_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR017_Print_Case_Number");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpPost, Route("SNM141_Get_Data")]
        [Authorize]
        public IHttpActionResult SNM141_Get_Data([FromBody] dynamic pData)
        {
            try
            {
                DataSet ds = new DataSet();

                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNM141_GET_DATA";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = pData["PART_NO"];
                cmd.Parameters.Add("C_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM141_Get_Data");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpPost, Route("SNM141_Insert")]
        [Authorize]
        public IHttpActionResult SNM141_Insert([FromBody] dynamic pData)
        {
            try
            {
                DataSet ds = new DataSet();

                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNM141_INSERT";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = pData["PART_NO"];
                cmd.Parameters.Add("P_PACKAGE_QTY", OracleDbType.Varchar2).Value = pData["PACKAGE_QTY"];
                cmd.Parameters.Add("P_LAST_UPD_PGM", OracleDbType.Varchar2).Value = "SNM141";
                cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("C_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM141_Insert");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpPost, Route("SNM141_Update")]
        [Authorize]
        public IHttpActionResult SNM141_Update([FromBody] dynamic pData)
        {
            try
            {
                DataSet ds = new DataSet();

                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNM141_UPDATE";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = pData["PART_NO"];
                cmd.Parameters.Add("P_PACKAGE_QTY", OracleDbType.Varchar2).Value = pData["PACKAGE_QTY"];
                cmd.Parameters.Add("P_LAST_UPD_PGM", OracleDbType.Varchar2).Value = "SNM141";
                cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("C_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM141_Update");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }


        [HttpPost, Route("SNM142_Get_Data")]
        [Authorize]
        public IHttpActionResult SNM142_Get_Data([FromBody] dynamic pData)
        {
            try
            {
                DataSet ds = new DataSet();

                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNM142_GET_DATA";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = pData["PART_NO"];
                cmd.Parameters.Add("C_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM142_Get_Data");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpPost, Route("SNM142_Insert")]
        [Authorize]
        public IHttpActionResult SNM142_Insert([FromBody] dynamic pData)
        {
            try
            {
                DataSet ds = new DataSet();

                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNM142_INSERT";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = pData["PART_NO"];
                cmd.Parameters.Add("P_LAST_UPD_PGM", OracleDbType.Varchar2).Value = "SNM141";
                cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("C_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM142_Insert");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpPost, Route("SNM142_Delete")]
        [Authorize]
        public IHttpActionResult SNM142_Delete([FromBody] dynamic pData)
        {
            try
            {
                DataSet ds = new DataSet();

                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNM142_DELETE";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = pData["PART_NO"];
                cmd.Parameters.Add("C_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM142_Delete");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        #region SNWR010
        [HttpGet, Route("SNWR010_GetBKKDeliveryList")]
        [Authorize]
        public IHttpActionResult SNWR010_GetBKKDeliveryList()
        {
            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR010_DELIVERY_LIST_BKK";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("C_RETURN_1", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                cmd.Parameters.Add("C_RETURN_2", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                DataSet ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR010_GetBKKDeliveryList");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpGet, Route("SNWR010_GetTempDeliveryList")]
        [Authorize]
        public IHttpActionResult SNWR010_GetTempDeliveryList()
        {
            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR010_DELIVERY_LIST_TEMP";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("C_RETURN_1", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                cmd.Parameters.Add("C_RETURN_2", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                DataSet ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR010_GetBKKDeliveryList");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpPost, Route("SNWR010_SaveUnSentList")]
        [Authorize]
        public IHttpActionResult SNWR010_SaveUnSentList([FromBody] dynamic[] pList)
        {
            try
            {
                OracleCommand cmd;

                foreach (var item in pList)
                {
                    cmd = new OracleCommand();
                    cmd.CommandText = "SP_NP_SNWR010_HH_UNSENT_SAVE";
                    cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                    cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = item.INVOICE_NO;
                    cmd.Parameters.Add("P_CASE_NO", OracleDbType.Varchar2).Value = item.CASE_NO;
                    cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);

                    oOracledb.SqlExecute_CMD(cmd);
                }

                return Ok();
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR010_SaveUnSentList");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpPost, Route("SNWR010_SaveSentList")]
        [Authorize]
        public IHttpActionResult SNWR010_SaveSentList([FromBody] dynamic[] pList)
        {
            try
            {
                OracleCommand cmd;

                foreach (var item in pList)
                {
                    cmd = new OracleCommand();
                    cmd.CommandText = "SP_NP_SNWR010_HH_SENT_SAVE";
                    cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                    cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = item.INVOICE_NO;
                    cmd.Parameters.Add("P_CASE_NO", OracleDbType.Varchar2).Value = item.CASE_NO;
                    cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);

                    oOracledb.SqlExecute_CMD(cmd);
                }

                return Ok();
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR010_SaveSentList");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpPost, Route("SNWR010_SaveTempRouteList/{routeNo}")]
        [Authorize]
        public IHttpActionResult SNWR010_SaveTempRouteList(string routeNo, [FromBody] dynamic pData)
        {
            try
            {
                List<dynamic> selectedList = new List<dynamic>(pData.selectedList);
                OracleCommand cmd;

                cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR010_DEL_ROUTE_TEMP";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_ROUTE_NO", OracleDbType.Varchar2).Value = routeNo;
                cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                oOracledb.SqlExecute_CMD(cmd);

                foreach (var item in selectedList)
                {
                    cmd = new OracleCommand();
                    cmd.CommandText = "SP_NP_SNWR010_SAVE_ROUTE_TEMP";
                    cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                    cmd.Parameters.Add("P_ROUTE_NO", OracleDbType.Varchar2).Value = routeNo;
                    cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = item.INVOICE_NO;
                    cmd.Parameters.Add("P_CASE_NO", OracleDbType.Varchar2).Value = item.CASE_NO;
                    cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                    oOracledb.SqlExecute_CMD(cmd);
                }

                cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR010_SAVE_ROUTE";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_ROUTE_NO", OracleDbType.Int32).Value = routeNo;
                cmd.Parameters.Add("P_CAR_NO", OracleDbType.Varchar2).Value = pData.CAR_NO;
                cmd.Parameters.Add("P_LICENSE_NO", OracleDbType.Varchar2).Value = pData.LICENSE_NO;
                cmd.Parameters.Add("P_DRIVER_NAME", OracleDbType.Varchar2).Value = pData.DRIVER_NAME;
                cmd.Parameters.Add("P_CAR_TYPE", OracleDbType.Varchar2).Value = pData.CAR_TYPE;
                cmd.Parameters.Add("P_DRIVER_TEL", OracleDbType.Varchar2).Value = pData.DRIVER_TEL;
                cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                oOracledb.SqlExecute_CMD(cmd);

                return Ok();
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR010_SaveTempRouteList");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpPost, Route("SNWR010_ConfirmBKK")]
        public IHttpActionResult SNWR010_ConfirmBKK()
        {
            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR010_CONFIRM_DELIVERY_BKK";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);

                oOracledb.SqlExecute_CMD(cmd);

                return Ok();
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR010_ConfirmBKK");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }


        [HttpGet, Route("SNWR010_GetPDIDeliveryList")]
        [Authorize]
        public IHttpActionResult SNWR010_GetPDIDeliveryList()
        {
            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR010_DELIVERY_LIST_PDI";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("C_RETURN_1", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                cmd.Parameters.Add("C_RETURN_2", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                DataSet ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR010_GetBKKDeliveryList");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpPost, Route("SNWR010_ConfirmPDI")]
        public IHttpActionResult SNWR010_ConfirmPDI()
        {
            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR010_CONFIRM_DELIVERY_PDI";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);

                oOracledb.SqlExecute_CMD(cmd);

                return Ok();
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR010_ConfirmPDI");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpPost, Route("SNWR010_UploadFile")]
        [Authorize]
        public async Task<IHttpActionResult> SNWR010_UploadFile(HttpRequestMessage request)
        {
            try
            {
                if (!request.Content.IsMimeMultipartContent())
                {
                    throw new HttpResponseException(HttpStatusCode.UnsupportedMediaType);
                }
                var reqParts = await request.Content.ReadAsMultipartAsync();
                byte[] buffer = null;
                foreach (var file in reqParts.Contents)
                {
                    buffer = file.ReadAsByteArrayAsync().Result;
                }
                MemoryStream stream = new MemoryStream(buffer);
                DataTable dt = new DataTable();
                SystemApiController sys = new SystemApiController();
                dt = sys.ReadDataExcel(stream);

                OracleCommand cmd;
                String uploadId = DateTime.Now.ToString("yyyyMMddHHmmss");

                foreach (DataRow row in dt.Rows)
                {
                    cmd = new OracleCommand();
                    cmd.CommandText = "SP_NP_SNWR010_UPLOAD_DELIVERY";
                    cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                    cmd.Parameters.Add("P_DOCUMENT_NO", OracleDbType.Varchar2).Value = row["Document No."];
                    cmd.Parameters.Add("P_PACKAGE_NO", OracleDbType.Varchar2).Value = row["Package No."];
                    cmd.Parameters.Add("P_CASE_NO", OracleDbType.Varchar2).Value = row["Box No."];
                    cmd.Parameters.Add("P_CASE_TYPE", OracleDbType.Varchar2).Value = row["Unit Name"];
                    cmd.Parameters.Add("P_CUSTOMER_CODE", OracleDbType.Varchar2).Value = row["Dealer Code"];
                    cmd.Parameters.Add("P_BRANCH_CODE", OracleDbType.Varchar2).Value = row["Branch Code"];
                    cmd.Parameters.Add("P_DATE", OracleDbType.Varchar2).Value = row["Date"];
                    cmd.Parameters.Add("P_TIME", OracleDbType.Varchar2).Value = row["Time"];
                    cmd.Parameters.Add("P_USER", OracleDbType.Varchar2).Value = row["User"];
                    cmd.Parameters.Add("P_UPLOAD_ID", OracleDbType.Varchar2).Value = uploadId;

                    oOracledb.SqlExecute_CMD(cmd);
                }

                cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR010_GET_UPLOAD";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_UPLOAD_ID", OracleDbType.Varchar2).Value = uploadId;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                DataSet ds = oOracledb.SqlQueryDS_CMD(cmd);
                DataTable deliveryList = ds.Tables[0];

                return Json(DTFM.convertToList(deliveryList));

            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR010_UploadFile");
                throw new HttpResponseException(HttpStatusCode.NotAcceptable);
            }

            throw new Exception("Something wrong");

        }

        [HttpGet, Route("SNWR010_GetRoute/{routeType}")]
        [Authorize]
        public IHttpActionResult SNWR010_GetRoute(string routeType)
        {
            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR010_DELIVERY_ROUTE";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_ROUTE_TYPE", OracleDbType.Varchar2).Value = routeType;
                cmd.Parameters.Add("C_RETURN_ROUTE", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                cmd.Parameters.Add("C_RETURN_CAR", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                DataSet ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR010_GetRoute");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpGet, Route("SNWR010_GetBKKCustomers")]
        [Authorize]
        public IHttpActionResult SNWR010_GetBKKCustomers()
        {
            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR010_BKK_CUSTOMER";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                DataSet ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds.Tables[0]));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR010_GetBKKCustomers");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpGet, Route("SNWR010_GetPDICustomers")]
        [Authorize]
        public IHttpActionResult SNWR010_GetPDICustomers()
        {
            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR010_PDI_CUSTOMER";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                DataSet ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds.Tables[0]));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR010_GetPDICustomers");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpPost, Route("SNWR010_SaveRoute")]
        [Authorize]
        public IHttpActionResult SNWR010_SaveRoute([FromBody] dynamic pData)
        {
            OracleCommand cmd;
            try
            {
                List<dynamic> routes = new List<dynamic>(pData.routes);
                List<dynamic> customers = new List<dynamic>(pData.customers);


                foreach (var data in routes)
                {
                    cmd = new OracleCommand();
                    cmd.CommandText = "SP_NP_SNWR010_SAVE_ROUTE";
                    cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                    cmd.Parameters.Add("P_ROUTE_NO", OracleDbType.Int32).Value = data.ROUTE_NO;
                    cmd.Parameters.Add("P_CAR_NO", OracleDbType.Varchar2).Value = data.CAR_NO;
                    cmd.Parameters.Add("P_LICENSE_NO", OracleDbType.Varchar2).Value = data.LICENSE_NO;
                    cmd.Parameters.Add("P_DRIVER_NAME", OracleDbType.Varchar2).Value = data.DRIVER_NAME;
                    cmd.Parameters.Add("P_CAR_TYPE", OracleDbType.Varchar2).Value = data.CAR_TYPE;
                    cmd.Parameters.Add("P_DRIVER_TEL", OracleDbType.Varchar2).Value = data.DRIVER_TEL;
                    cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                    oOracledb.SqlExecute_CMD(cmd);
                }

                foreach (var data in customers)
                {
                    cmd = new OracleCommand();
                    cmd.CommandText = "SP_NP_SNWR010_SAVE_CUSTOMER";
                    cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                    cmd.Parameters.Add("P_ROUTE_NO", OracleDbType.Int32).Value = data.ROUTE_NO == null ? DBNull.Value : data.ROUTE_NO;
                    cmd.Parameters.Add("P_CUSTOMER_CODE", OracleDbType.Varchar2).Value = data.CUSTOMER_CODE;
                    cmd.Parameters.Add("P_BRANCH_CODE", OracleDbType.Varchar2).Value = data.BRANCH_CODE;
                    cmd.Parameters.Add("P_DELIVERY_TIME", OracleDbType.Varchar2).Value = data.DELIVERY_TIME;
                    cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                    oOracledb.SqlExecute_CMD(cmd);
                }

                return Ok("Done");
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SavePackedData");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.ExpectationFailed, ex.Message));
            }
        }
        #endregion

        #region SNWR021
        [HttpGet, Route("SNWR021_GetData")]
        [Authorize]
        public IHttpActionResult SNWR021_GetData()
        {
            DataSet ds = new DataSet();

            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR021_GET_DATA";
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR021_GetData");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpPost, Route("SNWR021_UpdateStatus")]
        [Authorize]
        [RunBatchGuard]
        public IHttpActionResult SNWR021_UpdateStatus([FromBody] dynamic pParams)
        {
            try
            {
                DataSet ds = new DataSet();

                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR021_UPDATE";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_CONFIG_VALUE", OracleDbType.Varchar2).Value = pParams.CONFIG_VALUE;
                cmd.Parameters.Add("P_LAST_UPD_BY", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("P_LAST_UPD_PGM", OracleDbType.Varchar2).Value = "SNWR021";
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));

            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR021_Save");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }
        #endregion

        #region SNWR022
        [HttpGet, Route("SNWR022_GetPickListNo/{pickListNo}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult SNWR022_GetPickListNo(string pickListNo, int noofshowrec)
        {
            DataSet ds = new DataSet();
            pickListNo = ismoUtil.escapeCharacter(pickListNo);

            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR022_GET_PICKING_LIST";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_PICK_LIST_NO", OracleDbType.Varchar2).Value = pickListNo.ToUpper() == "NULL" ? (object)DBNull.Value : pickListNo;
                cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR022_GetPickListNo");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }


        [HttpPost, Route("SNWR022_IssueCase")]
        [Authorize]
        public IHttpActionResult SNWR022_IssueCase([FromBody] dynamic[] pDataList)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd;
            try
            {
                //cmd = new OracleCommand();
                //cmd.CommandText = "SP_NP_SNWR022_DEL_TEMP";
                //cmd.Parameters.Add("P_USER_ID", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                //oOracledb.SqlQueryReturnValue(cmd);
                List<string> caseList = new List<string>();
                foreach (var data in pDataList)
                {
                    if (!caseList.Contains(data.CASE_NO.ToString()))
                    {
                        caseList.Add(data.CASE_NO.ToString());
                        cmd = new OracleCommand();
                        cmd.CommandText = "SP_NP_SNWR022_DELETE_CASE";
                        cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                        cmd.Parameters.Add("P_CUSTOMER_CODE", OracleDbType.Varchar2).Value = data.CUSTOMER_CODE;
                        cmd.Parameters.Add("P_BRANCH_CODE", OracleDbType.Varchar2).Value = data.BRANCH_CODE;
                        cmd.Parameters.Add("P_CASE_NO", OracleDbType.Varchar2).Value = data.CASE_NO;
                        oOracledb.SqlExecute_CMD(cmd);
                    }
                }
                int i = 0;
                string customerCode = "";
                foreach (var data in pDataList)
                {
                    i = i + 1;
                    customerCode = data.CUSTOMER_CODE;

                    cmd = new OracleCommand();
                    cmd.CommandText = "SP_NP_SNWR022_INSERT_TEMP";
                    cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                    cmd.Parameters.Add("P_CUSTOMER_CODE", OracleDbType.Varchar2).Value = data.CUSTOMER_CODE;
                    cmd.Parameters.Add("P_BRANCH_CODE", OracleDbType.Varchar2).Value = data.BRANCH_CODE;
                    cmd.Parameters.Add("P_ORDER_CLASS", OracleDbType.Varchar2).Value = data.ORDER_CLASS;
                    cmd.Parameters.Add("P_ORDER_TYPE", OracleDbType.Varchar2).Value = data.ORDER_TYPE;
                    cmd.Parameters.Add("P_ORDER_NO", OracleDbType.Varchar2).Value = data.ORDER_NO;
                    cmd.Parameters.Add("P_ACCEPT_PART_NO", OracleDbType.Varchar2).Value = data.ACCEPT_PART_NO;
                    cmd.Parameters.Add("P_ORDER_PART_NO", OracleDbType.Varchar2).Value = data.ORDER_PART_NO;
                    cmd.Parameters.Add("P_ITEM_NO", OracleDbType.Varchar2).Value = data.ITEM_NO;
                    cmd.Parameters.Add("P_SUB_ITEM_NO", OracleDbType.Varchar2).Value = data.SUB_ITEM_NO;
                    cmd.Parameters.Add("P_DELIVERY_CODE", OracleDbType.Varchar2).Value = data.DELIVERY_CODE;
                    cmd.Parameters.Add("P_PICK_LOT_DATE", OracleDbType.Date).Value = data.PICK_LOT_DATE;
                    cmd.Parameters.Add("P_PICK_LOT_SEQ", OracleDbType.Varchar2).Value = data.PICK_LOT_SEQ;
                    cmd.Parameters.Add("P_INSTRUCTION_NO", OracleDbType.Varchar2).Value = data.INSTRUCTION_NO;
                    cmd.Parameters.Add("P_QTY", OracleDbType.Int32).Value = data.QTY;
                    cmd.Parameters.Add("P_UNIT_PRICE", OracleDbType.Double).Value = data.UNIT_PRICE;
                    cmd.Parameters.Add("P_CASE_NO", OracleDbType.Varchar2).Value = data.CASE_NO;
                    cmd.Parameters.Add("P_CASE_DATE", OracleDbType.Date).Value = Convert.ToDateTime(data.CASE_DATE);
                    cmd.Parameters.Add("P_CASE_TYPE", OracleDbType.Varchar2).Value = data.CASE_TYPE;
                    cmd.Parameters.Add("P_LAST_UPD_BY", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                    ds = oOracledb.SqlQueryDS_CMD(cmd);
                }

                return Ok(new { status = "Done" });
            }
            catch (OracleException oex)
            {
                string err_massage = string.Empty;
                if (oex.Number == 20002)
                {
                    err_massage = "Someone is issue invoive, please try again later!";
                }
                else
                {
                    err_massage = "Found an error, please contract support team";
                }
                return Ok(new { status = "Fail", massage = err_massage, err_code = oex.Number });
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR022_IssueCase");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.ExpectationFailed, ex.Message));
            }
        }


        [HttpGet, Route("SNWR022_GetAvailableCase/{caseGroup}/{caseNo}")]
        [Authorize]
        public IHttpActionResult SNWR022_GetAvailableCase(string caseGroup, string caseNo)
        {
            DataSet ds = new DataSet();

            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR022_GET_AVAILABLE_CASE";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_CASE_GROUP", OracleDbType.Varchar2).Value = caseGroup;
                cmd.Parameters.Add("P_CASE_NO", OracleDbType.Varchar2).Value = caseNo;
                cmd.Parameters.Add("R_PRINT_DATE", OracleDbType.Varchar2, 24).Direction = ParameterDirection.Output;

                cmd = oOracledb.SqlQueryReturnValue(cmd);

                String printDate = cmd.Parameters["R_PRINT_DATE"].Value.ToString();
                return Json(new { Result = "Done", CaseNo = caseNo, PrintDate = printDate });
            }
            catch (OracleException ex)
            {
                if (ex.Number == 20001)
                {
                    return Json(new { Result = "Failed", Message = "Unavailable case number." });

                }
                else if (ex.Number == 20002)
                {
                    return Json(new { Result = "Exist", Message = "Case is exist, do you want to unpack." });

                }
                else
                {
                    throw (ex);
                }


            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR022_getPickListNo");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }


        [HttpGet, Route("SNWR022_GetCaseInfo/{caseNo}")]
        [Authorize]
        public IHttpActionResult SNWR022_GetCaseInfo(string caseNo)
        {
            DataSet ds = new DataSet();
            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR022_GET_Case_Info";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_CASE_NO", OracleDbType.Varchar2).Value = caseNo;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR022_GetCaseInfo");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        #endregion


        #region SNWR023
        [HttpGet, Route("SNWR023_GetPickListNo/{pickListNo}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult SNWR023_GetPickListNo(string pickListNo, int noofshowrec)
        {
            DataSet ds = new DataSet();
            pickListNo = ismoUtil.escapeCharacter(pickListNo);

            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR023_GET_PICKING_LIST";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_PICK_LIST_NO", OracleDbType.Varchar2).Value = pickListNo.ToUpper() == "NULL" ? (object)DBNull.Value : pickListNo;
                cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR023_GetPickListNo");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpPost, Route("SNWR023_GetOrderNo/{orderNo}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult SNWR023_GetOrderNo(string orderNo, int noofshowrec, [FromBody] dynamic pParam)
        {
            DataSet ds = new DataSet();
            orderNo = ismoUtil.escapeCharacter(orderNo);
            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR023_ORDER_NO";
                cmd.Parameters.Add("p_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_CUSTOMER_CODE", OracleDbType.Varchar2).Value = pParam["CUSTOMER_CODE"];
                cmd.Parameters.Add("P_BRANCH_CODE", OracleDbType.Varchar2).Value = pParam["BRANCH_CODE"];
                cmd.Parameters.Add("P_ORDER_NO", OracleDbType.Varchar2).Value = orderNo.ToUpper() == "NULL" ? (object)DBNull.Value : orderNo;
                cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR023_GetOrderNo");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpPost, Route("SNWR023_GetData")]
        [Authorize]
        public IHttpActionResult SNWR023_GetData([FromBody] dynamic pParam)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            try
            {
                cmd.CommandText = "SP_NP_SNWR023_GET_DATA";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_CUSTOMER_CODE", OracleDbType.Varchar2).Value = pParam.CUSTOMER_CODE;
                cmd.Parameters.Add("P_BRANCH_CODE", OracleDbType.Varchar2).Value = pParam.BRANCH_CODE;
                cmd.Parameters.Add("P_PICKING_LIST_NO", OracleDbType.Varchar2).Value = pParam.PICKING_LIST_NO;
                //cmd.Parameters.Add("P_ORDER_TYPE", OracleDbType.Varchar2).Value = pParam.ORDER_TYPE;
                //cmd.Parameters.Add("P_PART_ZONE", OracleDbType.Varchar2).Value = pParam.PART_ZONE;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR023_GetData");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpPost, Route("SNWR023_GetCaseAll")]
        [Authorize]
        public IHttpActionResult SNWR023_GetCaseAll([FromBody] dynamic pData)
        {
            try
            {
                DataSet ds = new DataSet();

                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR023_GET_ALL_CASE_CUST";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_PACK_BY", OracleDbType.Varchar2).Value = pData.PACK_BY;
                cmd.Parameters.Add("P_CUSTOMER_CODE", OracleDbType.Varchar2).Value = pData.CUSTOMER_CODE;
                cmd.Parameters.Add("P_BRANCH_CODE", OracleDbType.Varchar2).Value = pData.BRANCH_CODE;
                cmd.Parameters.Add("P_ORDER_TYPE", OracleDbType.Varchar2).Value = pData.ORDER_TYPE;

                cmd.Parameters.Add("C_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

                ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR023_GetCaseAll");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }


        [HttpPost, Route("SNWR023_GetPack")]
        [Authorize]
        public IHttpActionResult SNWR023_GetPack([FromBody] dynamic pData)
        {
            try
            {
                DataSet ds = new DataSet();

                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR023_GET_PACK";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("C_Return1", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                cmd.Parameters.Add("C_Return2", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                cmd.Parameters.Add("C_Return3", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                cmd.Parameters.Add("C_Return4", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                cmd.Parameters.Add("C_Return5", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR023_GetPack");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }



        [HttpPost, Route("SNWR023_HoldCase")]
        [Authorize]
        public IHttpActionResult SNWR023_HoldCase([FromBody] dynamic pData)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd;
            try
            {
                cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR023_UPDATE_CASE_STATUS";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_CASE_NO", OracleDbType.Varchar2).Value = pData.caseNo;
                cmd.Parameters.Add("P_CASE_STATUS", OracleDbType.Varchar2).Value = "H";
                cmd = oOracledb.SqlQueryReturnValue(cmd);

                return Ok(new { status = "Done"});


            }
            catch (OracleException oex)
            {
                string err_massage = string.Empty;
                if (oex.Number == 20002)
                {
                    err_massage = "Someone is issue invoive, please try again later!";
                }
                else
                {
                    err_massage = "Found an error, please contract support team";
                }
                oOracledb.WriteLog("ErrorHandle", oex.Message, "SNWR023_HoldCase");
                return Ok(new { status = "Fail", massage = err_massage, err_code = oex.Number });
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR023_HoldCase");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.ExpectationFailed, ex.Message));
            }
        }

        [HttpPost, Route("SNWR023_ActiveCase")]
        [Authorize]
        public IHttpActionResult SNWR023_ActiveCase([FromBody] dynamic pData)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd;
            try
            {
                cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR023_UPDATE_CASE_STATUS";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_CASE_NO", OracleDbType.Varchar2).Value = pData.caseNo;
                cmd.Parameters.Add("P_CASE_STATUS", OracleDbType.Varchar2).Value = "A";
                cmd = oOracledb.SqlQueryReturnValue(cmd);

                return Ok(new { status = "Done" });


            }
            catch (OracleException oex)
            {
                string err_massage = string.Empty;
                if (oex.Number == 20002)
                {
                    err_massage = "Someone is issue invoive, please try again later!";
                }
                else
                {
                    err_massage = "Found an error, please contract support team";
                }
                oOracledb.WriteLog("ErrorHandle", oex.Message, "SNWR023_ActiveCase");
                return Ok(new { status = "Fail", massage = err_massage, err_code = oex.Number });
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR023_ActiveCase");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.ExpectationFailed, ex.Message));
            }
        }


        [HttpPost, Route("SNWR023_IssueInvoice/{packBy}")]
        [Authorize]
        public IHttpActionResult SNWR023_IssueInvoice([FromBody] dynamic[] pDataList, string packBy)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd;
            try
            {
                cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR023_DEL_TEMP";
                cmd.Parameters.Add("P_USER_ID", OracleDbType.Varchar2).Value = packBy;
                oOracledb.SqlQueryReturnValue(cmd);
                int i = 0;
                string customerCode = "";
                foreach (var data in pDataList)
                {
                    if (data.CASE_STATUS != "H")
                    {
                        i = i + 1;
                        customerCode = data.CUSTOMER_CODE;

                        cmd = new OracleCommand();
                        cmd.CommandText = "SP_NP_SNWR023_INSERT_TEMP";
                        cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                        cmd.Parameters.Add("P_CUSTOMER_CODE", OracleDbType.Varchar2).Value = data.CUSTOMER_CODE;
                        cmd.Parameters.Add("P_BRANCH_CODE", OracleDbType.Varchar2).Value = data.BRANCH_CODE;
                        cmd.Parameters.Add("P_ORDER_TYPE", OracleDbType.Varchar2).Value = data.ORDER_TYPE;
                        cmd.Parameters.Add("P_ORDER_CLASS", OracleDbType.Varchar2).Value = data.ORDER_CLASS;
                        cmd.Parameters.Add("P_ORDER_NO", OracleDbType.Varchar2).Value = data.ORDER_NO;
                        cmd.Parameters.Add("P_ACCEPT_PART_NO", OracleDbType.Varchar2).Value = data.ACCEPT_PART_NO;
                        cmd.Parameters.Add("P_ORDER_PART_NO", OracleDbType.Varchar2).Value = data.ORDER_PART_NO;
                        cmd.Parameters.Add("P_ITEM_NO", OracleDbType.Varchar2).Value = data.ITEM_NO;
                        cmd.Parameters.Add("P_SUB_ITEM_NO", OracleDbType.Varchar2).Value = data.SUB_ITEM_NO;
                        cmd.Parameters.Add("P_DELIVERY_CODE", OracleDbType.Varchar2).Value = data.DELIVERY_CODE;
                        cmd.Parameters.Add("P_PICK_LOT_DATE", OracleDbType.Date).Value = data.PICK_LOT_DATE;
                        cmd.Parameters.Add("P_PICK_LOT_SEQ", OracleDbType.Varchar2).Value = data.PICK_LOT_SEQ;
                        cmd.Parameters.Add("P_INSTRUCTION_NO", OracleDbType.Varchar2).Value = data.INSTRUCTION_NO;
                        cmd.Parameters.Add("P_QTY", OracleDbType.Int32).Value = data.QTY;
                        cmd.Parameters.Add("P_CASE_NO", OracleDbType.Varchar2).Value = data.CASE_NO;
                        cmd.Parameters.Add("P_CASE_DATE", OracleDbType.Date).Value = Convert.ToDateTime(data.CASE_DATE);
                        cmd.Parameters.Add("P_CASE_TYPE", OracleDbType.Varchar2).Value = data.CASE_TYPE;
                        cmd.Parameters.Add("P_PACK_BY", OracleDbType.Varchar2).Value = packBy;
                        ds = oOracledb.SqlQueryDS_CMD(cmd);

                    }
                
                }

                if (i > 0)
                {
                    cmd = new OracleCommand();
                    cmd.CommandText = "PK_NP_SNWR023_INVOICE.ISSUE_INVOICES";
                    cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                    cmd.Parameters.Add("P_CUSTOMER_CODE", OracleDbType.Varchar2).Value = customerCode;
                    cmd.Parameters.Add("P_USER", OracleDbType.Varchar2).Value = packBy;
                    cmd.Parameters.Add("R_INVOICE_NO_FROM", OracleDbType.Varchar2, 20).Direction = ParameterDirection.Output;
                    cmd.Parameters.Add("R_INVOICE_NO_TO", OracleDbType.Varchar2, 20).Direction = ParameterDirection.Output;
                    cmd = oOracledb.SqlQueryReturnValue(cmd);

                    string invoiceNoFrom = cmd.Parameters["R_INVOICE_NO_FROM"].Value.ToString();
                    string invoiceNoTo = cmd.Parameters["R_INVOICE_NO_TO"].Value.ToString();

                    return Ok(new { status = "Done", invoiceNoFrom = invoiceNoFrom, invoiceNoTo = invoiceNoTo });
                }
                else
                {
                    return Ok(new { status = "Fail", message = "No data to be processed." });
                }

            }
            catch (OracleException oex)
            {
                string err_massage = string.Empty;
                if (oex.Number == 20002)
                {
                    err_massage = "Someone is issue invoive, please try again later!";
                }
                else
                {
                    err_massage = "Found an error, please contract support team";
                }
                oOracledb.WriteLog("ErrorHandle", oex.Message, "SNWR023_IssueInvoice");
                return Ok(new { status = "Fail", massage = err_massage, err_code = oex.Number });
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR023_IssueInvoice");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.ExpectationFailed, ex.Message));
            }
        }


        [HttpPost, Route("SNWR023_IssueInvoiceKit/{packBy}")]
        [Authorize]
        public IHttpActionResult SNWR023_IssueInvoiceKit([FromBody] dynamic[] pDataList, string packBy)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd;
            try
            {
                cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR023_DEL_TEMP";
                cmd.Parameters.Add("P_USER_ID", OracleDbType.Varchar2).Value = packBy;
                oOracledb.SqlQueryReturnValue(cmd);
                int i = 0;
                string customerCode = "";
                foreach (var data in pDataList)
                {
                    if (data.CASE_STATUS != "H")
                    {
                        i = i + 1;
                        customerCode = data.CUSTOMER_CODE;
                        cmd = new OracleCommand();
                        cmd.CommandText = "SP_NP_SNWR023_INSERT_TEMP";
                        cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                        cmd.Parameters.Add("P_CUSTOMER_CODE", OracleDbType.Varchar2).Value = data.CUSTOMER_CODE;
                        cmd.Parameters.Add("P_BRANCH_CODE", OracleDbType.Varchar2).Value = data.BRANCH_CODE;
                        cmd.Parameters.Add("P_ORDER_TYPE", OracleDbType.Varchar2).Value = data.ORDER_TYPE;
                        cmd.Parameters.Add("P_ORDER_CLASS", OracleDbType.Varchar2).Value = data.ORDER_CLASS;
                        cmd.Parameters.Add("P_ORDER_NO", OracleDbType.Varchar2).Value = data.ORDER_NO;
                        cmd.Parameters.Add("P_ACCEPT_PART_NO", OracleDbType.Varchar2).Value = data.ACCEPT_PART_NO;
                        cmd.Parameters.Add("P_ORDER_PART_NO", OracleDbType.Varchar2).Value = data.ORDER_PART_NO;
                        cmd.Parameters.Add("P_ITEM_NO", OracleDbType.Varchar2).Value = data.ITEM_NO;
                        cmd.Parameters.Add("P_SUB_ITEM_NO", OracleDbType.Varchar2).Value = data.SUB_ITEM_NO;
                        cmd.Parameters.Add("P_DELIVERY_CODE", OracleDbType.Varchar2).Value = data.DELIVERY_CODE;
                        cmd.Parameters.Add("P_PICK_LOT_DATE", OracleDbType.Date).Value = data.PICK_LOT_DATE;
                        cmd.Parameters.Add("P_PICK_LOT_SEQ", OracleDbType.Varchar2).Value = data.PICK_LOT_SEQ;
                        cmd.Parameters.Add("P_INSTRUCTION_NO", OracleDbType.Varchar2).Value = data.INSTRUCTION_NO;
                        cmd.Parameters.Add("P_QTY", OracleDbType.Int32).Value = data.QTY;
                        cmd.Parameters.Add("P_CASE_NO", OracleDbType.Varchar2).Value = data.CASE_NO;
                        cmd.Parameters.Add("P_CASE_DATE", OracleDbType.Date).Value = Convert.ToDateTime(data.CASE_DATE);
                        cmd.Parameters.Add("P_CASE_TYPE", OracleDbType.Varchar2).Value = data.CASE_TYPE;
                        cmd.Parameters.Add("P_PACK_BY", OracleDbType.Varchar2).Value = packBy;
                        ds = oOracledb.SqlQueryDS_CMD(cmd);
                    }
                }
                if (i > 0)
                {
                    cmd = new OracleCommand();
                    cmd.CommandText = "PK_NP_SNWR023_INVOICE_KIT.ISSUE_INVOICES";
                    cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                    cmd.Parameters.Add("P_CUSTOMER_CODE", OracleDbType.Varchar2).Value = customerCode;
                    cmd.Parameters.Add("P_USER", OracleDbType.Varchar2).Value = packBy;
                    cmd.Parameters.Add("R_INVOICE_NO_FROM", OracleDbType.Varchar2, 20).Direction = ParameterDirection.Output;
                    cmd.Parameters.Add("R_INVOICE_NO_TO", OracleDbType.Varchar2, 20).Direction = ParameterDirection.Output;
                    cmd = oOracledb.SqlQueryReturnValue(cmd);
                    string invoiceNoFrom = cmd.Parameters["R_INVOICE_NO_FROM"].Value.ToString();
                    string invoiceNoTo = cmd.Parameters["R_INVOICE_NO_TO"].Value.ToString();
                    return Ok(new { status = "Done", invoiceNoFrom = invoiceNoFrom, invoiceNoTo = invoiceNoTo });
                }
                else
                {
                    return Ok(new { status = "Fail", message = "No data to be processed." });
                }
            }
            catch (OracleException oex)
            {
                string err_massage = string.Empty;
                if (oex.Number == 20002)
                {
                    err_massage = "Someone is issue invoive, please try again later!";
                }
                else
                {
                    err_massage = "Found an error, please contract support team";
                }
                oOracledb.WriteLog("ErrorHandle", oex.Message, "SNWR023_IssueInvoice");
                return Ok(new { status = "Fail", massage = err_massage, err_code = oex.Number });
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR023_IssueInvoice");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.ExpectationFailed, ex.Message));
            }
        }
        [HttpGet, Route("SNWR023_GetAvailableCase/{caseGroup}/{caseNo}")]
        [Authorize]
        public IHttpActionResult SNWR023_GetAvailableCase(string caseGroup, string caseNo)
        {
            DataSet ds = new DataSet();

            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR023_GET_AVAILABLE_CASE";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_CASE_GROUP", OracleDbType.Varchar2).Value = caseGroup;
                cmd.Parameters.Add("P_CASE_NO", OracleDbType.Varchar2).Value = caseNo;
                cmd.Parameters.Add("R_PRINT_DATE", OracleDbType.Varchar2, 24).Direction = ParameterDirection.Output;

                cmd = oOracledb.SqlQueryReturnValue(cmd);

                String printDate = cmd.Parameters["R_PRINT_DATE"].Value.ToString();
                return Json(new { Result = "Done", CaseNo = caseNo, PrintDate = printDate });
            }
            catch (OracleException ex)
            {
                if (ex.Number == 20001)
                {
                    return Json(new { Result = "Failed", Message = "Unavailable case number." });
                }

                throw (ex);
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR023_GetAvailableCase");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpPost, Route("SNWR023_GetPickLotSeq/{PickLotSeq}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult SNWR023_GetPickLotSeq(string PickLotSeq, int noofshowrec, [FromBody] dynamic pParam)
        {
            DataSet ds = new DataSet();
            PickLotSeq = ismoUtil.escapeCharacter(PickLotSeq);
            var pData = pParam["DATA"];
            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNWR023_GET_PICK_SEQ";
                cmd.Parameters.Add("p_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_CUSTOMER_CODE", OracleDbType.Varchar2).Value = pData.CUSTOMER_CODE;
                cmd.Parameters.Add("P_ORDER_CLASS", OracleDbType.Varchar2).Value = pData.ORDER_CLASS;
                cmd.Parameters.Add("P_PICK_LOT_DATE", OracleDbType.Date).Value = pData.PICK_LOT_DATE;
                cmd.Parameters.Add("P_PICK_LOT_SEQ", OracleDbType.Varchar2).Value = PickLotSeq.ToUpper() == "NULL" ? (object)DBNull.Value : PickLotSeq;
                cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = noofshowrec;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR023_GetPickLotSeq");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }


        [HttpPost, Route("SNWR023_GetInvoiceList")]
        [Authorize]
        public IHttpActionResult SNWR023_GetInvoiceList([FromBody] dynamic pParam)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            try
            {
                cmd.CommandText = "SP_NP_SNWR023_GET_INVOICE_LIST";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR023_GetInvoiceList");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpPost, Route("SNWR023_GetInvoiceDetail")]
        [Authorize]
        public IHttpActionResult SNWR023_GetInvoiceDetail([FromBody] dynamic pParam)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            try
            {
                cmd.CommandText = "SP_NP_SNWR023_GET_INVOICE_DETAIL";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_DOCUMENT_NO", OracleDbType.Varchar2).Value = pParam.DOCUMENT_NO;
                cmd.Parameters.Add("P_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR023_GetInvoiceDetail");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }


        [HttpPost, Route("PrintInvoice")]
        public async Task<HttpResponseMessage> PrintInvoice([FromBody] dynamic pParams)
        {
            try
            {
                string reportPrefix = pParams.ReportPrefix.ToString();
                string reportSuffix = pParams.ReportSuffix.ToString();


                string dateFormat = DateTime.Now.ToString("yyyyMMddHHmmss");
                string reportType = "PDF";
                string fileName = String.Concat(reportPrefix, dateFormat, reportSuffix);
                string processPath = String.Concat(ConfigurationManager.AppSettings["DefaultReportOutputPath"], "PrintDO", "/");

                string reportName = "PMS_RPT_WMS_SNWR008_INVOICE";
                List<ParameterValue> reportParams = new List<ParameterValue>();
                reportParams.Add(new ParameterValue { Label = "P_COMPANY_CODE", Name = "P_COMPANY_CODE", Value = pParams.P_COMPANY_CODE });
                reportParams.Add(new ParameterValue { Label = "P_INVOICE_NO_FROM", Name = "P_INVOICE_NO_FROM", Value = pParams.P_INVOICE_NO_FROM });
                reportParams.Add(new ParameterValue { Label = "P_INVOICE_NO_TO", Name = "P_INVOICE_NO_TO", Value = pParams.P_INVOICE_NO_TO });

                byte[] bytes = await SYSCore.aControl.ReportServices.GenerateReportAsBytes(reportName, reportType, reportParams, fileName, processPath);
                Stream stream = new MemoryStream(bytes);


                HttpResponseMessage response = new HttpResponseMessage(HttpStatusCode.OK);
                response.Content = new StreamContent(stream);
                response.Content.Headers.ContentDisposition = new System.Net.Http.Headers.ContentDispositionHeaderValue("attachment");
                response.Content.Headers.ContentDisposition.FileName = fileName;
                response.Content.Headers.ContentType = new MediaTypeHeaderValue("application/pdf");

                return response;
            }
            catch (Exception ex)
            {
                return new HttpResponseMessage(HttpStatusCode.BadRequest);
            }
        }

        #endregion


        [HttpPost, Route("SNWR024_GetInvoiceForPrint")]
        [Authorize]
        public IHttpActionResult SNWR024_GetInvoiceForPrint([FromBody] dynamic pParam)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            try
            {
                cmd.CommandText = "SP_NP_SNWR024_GET_INVOICE_LIST";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("R_INVOICE_NO_FROM", OracleDbType.Varchar2, 20).Direction = ParameterDirection.Output;
                cmd.Parameters.Add("R_INVOICE_NO_TO", OracleDbType.Varchar2, 20).Direction = ParameterDirection.Output;
                cmd = oOracledb.SqlQueryReturnValue(cmd);

                string invoiceNoFrom = cmd.Parameters["R_INVOICE_NO_FROM"].Value.ToString();
                string invoiceNoTo = cmd.Parameters["R_INVOICE_NO_TO"].Value.ToString();

                return Ok(new { status = "Done", invoiceNoFrom = invoiceNoFrom, invoiceNoTo = invoiceNoTo });
              
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR024_GetInvoiceForPrint");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpPost, Route("SNWR024_GetInvoiceLast")]
        [Authorize]
        public IHttpActionResult SNWR024_GetInvoiceLast([FromBody] dynamic pParam)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            try
            {
                cmd.CommandText = "SP_NP_SNWR024_GET_INVOICE_LAST";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
               // cmd.Parameters.Add("P_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNWR024_GetInvoiceLast");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }


        [HttpPost, Route("PrintDeliveryLabel")]
        public async Task<HttpResponseMessage> PrintDeliveryLabel([FromBody] dynamic pParams)
        {
            try
            {
                string reportPrefix = pParams.ReportPrefix.ToString();
                string reportSuffix = pParams.ReportSuffix.ToString();


                string dateFormat = DateTime.Now.ToString("yyyyMMddHHmmss");
                string reportType = "PDF";
                string fileName = String.Concat(reportPrefix, dateFormat, reportSuffix);
                string processPath = String.Concat(ConfigurationManager.AppSettings["DefaultReportOutputPath"], "PrintDeliveryLabel", "/");

                string reportName = "PMS_RPT_WMS_SNWR023_DELIVERY";
                List<ParameterValue> reportParams = new List<ParameterValue>();
                reportParams.Add(new ParameterValue { Label = "P_COMPANY_CODE", Name = "P_COMPANY_CODE", Value = pParams.P_COMPANY_CODE });
                reportParams.Add(new ParameterValue { Label = "P_INVOICE_NO_FROM", Name = "P_INVOICE_NO_FROM", Value = pParams.P_INVOICE_NO_FROM });
                reportParams.Add(new ParameterValue { Label = "P_INVOICE_NO_TO", Name = "P_INVOICE_NO_TO", Value = pParams.P_INVOICE_NO_TO });

                byte[] bytes = await SYSCore.aControl.ReportServices.GenerateReportAsBytes(reportName, reportType, reportParams, fileName, processPath);
                Stream stream = new MemoryStream(bytes);


                HttpResponseMessage response = new HttpResponseMessage(HttpStatusCode.OK);
                response.Content = new StreamContent(stream);
                response.Content.Headers.ContentDisposition = new System.Net.Http.Headers.ContentDispositionHeaderValue("attachment");
                response.Content.Headers.ContentDisposition.FileName = fileName;
                response.Content.Headers.ContentType = new MediaTypeHeaderValue("application/pdf");

                return response;
            }
            catch (Exception ex)
            {
                return new HttpResponseMessage(HttpStatusCode.BadRequest);
            }
        }

    }

}
